=== modified file 'Makefile.am'
--- Makefile.am	2010-02-12 01:44:42 +0000
+++ Makefile.am	2010-03-23 08:23:32 +0000
@@ -40,13 +40,15 @@
 DIST_SUBDIRS = ${SUBDIRS} tests
 
 BUILT_SOURCES=		drizzled/configmake.h
-EXTRA_DIST=		config/config.rpath m4/gnulib-cache.m4 \
-			config/autorun.sh Doxyfile \
-			config/pandora_vc_revinfo \
-			extra/run_cpplint.sh  \
-			extra/cpplint.py \
-			extra/clean_source.sh \
-			config/make-lint.py
+EXTRA_DIST= \
+	    Doxyfile \
+	    config/config.rpath \
+	    config/make-lint.py \
+	    config/pandora_vc_revinfo \
+	    extra/clean_source.sh \
+	    extra/cpplint.py \
+	    extra/run_cpplint.sh  \
+	    m4/gnulib-cache.m4
 
 
 CLEANFILES=		${BUILT_SOURCES}

=== modified file 'client/drizzle.cc'
--- client/drizzle.cc	2010-03-26 11:10:37 +0000
+++ client/drizzle.cc	2010-03-26 19:25:23 +0000
@@ -89,7 +89,7 @@
 #  endif /* !defined(HAVE_READLINE_H) */
 char *cmdline = NULL;
 #else /* !defined(HAVE_READLINE_READLINE_H) */
-  /* no readline */
+/* no readline */
 #  error Readline Required
 #endif /* HAVE_LIBREADLINE */
 
@@ -103,11 +103,11 @@
 extern int write_history ();
 extern int read_history ();
 #  endif /* defined(HAVE_READLINE_HISTORY_H) */
-    /* no history */
+/* no history */
 #endif /* HAVE_READLINE_HISTORY */
 
 /**
- Make the old readline interface look like the new one.
+  Make the old readline interface look like the new one.
 */
 #ifndef HAVE_RL_COMPLETION
 typedef char **rl_completion_func_t(const char *, int, int);
@@ -176,18 +176,18 @@
 static drizzle_st drizzle;      /* The library handle */
 static drizzle_con_st con;      /* The connection */
 static bool ignore_errors= false, quick= false,
-  connected= false, opt_raw_data= false, unbuffered= false,
-  output_tables= false, opt_rehash= true, skip_updates= false,
-  safe_updates= false, one_database= false,
-  opt_compress= false, opt_shutdown= false, opt_ping= false,
-  vertical= false, line_numbers= true, column_names= true,
-  opt_nopager= true, opt_outfile= false, named_cmds= false,
-  tty_password= false, opt_nobeep= false, opt_reconnect= true,
-  default_charset_used= false, opt_secure_auth= false,
-  default_pager_set= false, opt_sigint_ignore= false,
-  auto_vertical_output= false,
-  show_warnings= false, executing_query= false, interrupted_query= false,
-  opt_mysql= false;
+            connected= false, opt_raw_data= false, unbuffered= false,
+            output_tables= false, opt_rehash= true, skip_updates= false,
+            safe_updates= false, one_database= false,
+            opt_compress= false, opt_shutdown= false, opt_ping= false,
+            vertical= false, line_numbers= true, column_names= true,
+            opt_nopager= true, opt_outfile= false, named_cmds= false,
+            tty_password= false, opt_nobeep= false, opt_reconnect= true,
+            default_charset_used= false, opt_secure_auth= false,
+            default_pager_set= false, opt_sigint_ignore= false,
+            auto_vertical_output= false,
+            show_warnings= false, executing_query= false, interrupted_query= false,
+            opt_mysql= false;
 static uint32_t  show_progress_size= 0;
 static bool column_types_flag;
 static bool preserve_comments= false;
@@ -195,7 +195,7 @@
 static int verbose= 0, opt_silent= 0, opt_local_infile= 0;
 static drizzle_capabilities_t connect_flag= DRIZZLE_CAPABILITIES_NONE;
 static char *current_host, *current_db, *current_user= NULL,
-  *opt_password= NULL, *delimiter_str= NULL, *current_prompt= NULL;
+            *opt_password= NULL, *delimiter_str= NULL, *current_prompt= NULL;
 static char *histfile;
 static char *histfile_tmp;
 static string *glob_buffer;
@@ -209,7 +209,7 @@
 // TODO: Need to i18n these
 static const char *day_names[]= {"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
 static const char *month_names[]= {"Jan","Feb","Mar","Apr","May","Jun","Jul",
-                                  "Aug","Sep","Oct","Nov","Dec"};
+  "Aug","Sep","Oct","Nov","Dec"};
 static char default_pager[FN_REFLEN];
 static char pager[FN_REFLEN], outfile[FN_REFLEN];
 static FILE *PAGER, *OUTFILE;
@@ -234,16 +234,16 @@
 /* The names of functions that actually do the manipulation. */
 static int get_options(int argc,char **argv);
 static int com_quit(string *str,const char*),
-  com_go(string *str,const char*), com_ego(string *str,const char*),
-  com_print(string *str,const char*),
-  com_help(string *str,const char*), com_clear(string *str,const char*),
-  com_connect(string *str,const char*), com_status(string *str,const char*),
-  com_use(string *str,const char*), com_source(string *str, const char*),
-  com_rehash(string *str, const char*), com_tee(string *str, const char*),
-  com_notee(string *str, const char*),
-  com_prompt(string *str, const char*), com_delimiter(string *str, const char*),
-  com_warnings(string *str, const char*), com_nowarnings(string *str, const char*),
-  com_nopager(string *str, const char*), com_pager(string *str, const char*);
+           com_go(string *str,const char*), com_ego(string *str,const char*),
+           com_print(string *str,const char*),
+           com_help(string *str,const char*), com_clear(string *str,const char*),
+           com_connect(string *str,const char*), com_status(string *str,const char*),
+           com_use(string *str,const char*), com_source(string *str, const char*),
+           com_rehash(string *str, const char*), com_tee(string *str, const char*),
+           com_notee(string *str, const char*),
+           com_prompt(string *str, const char*), com_delimiter(string *str, const char*),
+           com_warnings(string *str, const char*), com_nowarnings(string *str, const char*),
+           com_nopager(string *str, const char*), com_pager(string *str, const char*);
 
 static int read_and_execute(bool interactive);
 static int sql_connect(char *host,char *database,char *user,char *password,
@@ -266,7 +266,7 @@
 static const char * strcont(register const char *str, register const char *set);
 
 /* A structure which contains information on the commands this program
-   can understand. */
+  can understand. */
 typedef struct {
   const char *name;        /* User printable name of the function. */
   char cmd_char;        /* msql command character */
@@ -1027,9 +1027,9 @@
   Shutdown the server that we are currently connected to.
 
   @retval
-    true success
+  true success
   @retval
-    false failure
+  false failure
 */
 static bool server_shutdown(void)
 {
@@ -1073,9 +1073,9 @@
   Ping the server that we are currently connected to.
 
   @retval
-    true success
+  true success
   @retval
-    false failure
+  false failure
 */
 static bool server_ping(void)
 {
@@ -1110,15 +1110,15 @@
   Execute command(s) specified by the user.
 
   @param error  error status of command execution.
-                If an error had occurred, this variable will be set
-                to 1 whereas on success, it shall be set to 0. This
-                value will be supplied to the exit() function used
-                by the caller.
+  If an error had occurred, this variable will be set
+  to 1 whereas on success, it shall be set to 0. This
+  value will be supplied to the exit() function used
+  by the caller.
 
   @retval
-    false no commands were executed
+  false no commands were executed
   @retval
-    true  at least one command was executed
+  true  at least one command was executed
 */
 static bool execute_commands(int *error)
 {
@@ -1156,7 +1156,7 @@
   default_prompt= strdup(getenv("DRIZZLE_PS1") ?
                          getenv("DRIZZLE_PS1") :
                          "drizzle> ");
-  
+
   if (default_prompt == NULL)
   {
     fprintf(stderr, _("Memory allocation error while constructing initial "
@@ -1272,9 +1272,9 @@
   char * output_buff= (char *)calloc(output_buff_size, sizeof(char));
 
   snprintf(output_buff, output_buff_size,
-          _("Your Drizzle connection id is %u\nServer version: %s\n"),
-          drizzle_con_thread_id(&con),
-          server_version_string(&con));
+           _("Your Drizzle connection id is %u\nServer version: %s\n"),
+           drizzle_con_thread_id(&con),
+           server_version_string(&con));
   put_info(output_buff, INFO_INFO, 0, 0);
 
   initialize_readline(current_prompt);
@@ -1285,8 +1285,8 @@
       histfile= strdup(getenv("DRIZZLE_HISTFILE"));
     else if (getenv("HOME"))
     {
-			size_t histfile_size = strlen(getenv("HOME")) +
-				strlen("/.drizzle_history") + 2;
+      size_t histfile_size = strlen(getenv("HOME")) +
+        strlen("/.drizzle_history") + 2;
       histfile=(char*) malloc(histfile_size);
       if (histfile)
         snprintf(histfile, histfile_size, "%s/.drizzle_history",getenv("HOME"));
@@ -1308,7 +1308,7 @@
       if (verbose)
         tee_fprintf(stdout, _("Reading history-file %s\n"),histfile);
       read_history(histfile);
-			size_t histfile_tmp_size = strlen(histfile) + 5;
+      size_t histfile_tmp_size = strlen(histfile) + 5;
       if (!(histfile_tmp= (char*) malloc(histfile_tmp_size)))
       {
         fprintf(stderr, _("Couldn't allocate memory for temp histfile!\n"));
@@ -1392,7 +1392,7 @@
 
   /* kill_buffer is always big enough because max length of %lu is 15 */
   snprintf(kill_buffer, sizeof(kill_buffer), "KILL /*!50000 QUERY */ %u",
-          drizzle_con_thread_id(&con));
+           drizzle_con_thread_id(&con));
 
   if (drizzle_query_str(&kill_drizzle, &res, kill_buffer, &ret) != NULL)
     drizzle_result_free(&res);
@@ -1422,164 +1422,164 @@
 static struct my_option my_long_options[] =
 {
   {"help", '?', N_("Display this help and exit."), 0, 0, 0, GET_NO_ARG, NO_ARG, 0,
-   0, 0, 0, 0, 0},
+    0, 0, 0, 0, 0},
   {"help", 'I', N_("Synonym for -?"), 0, 0, 0, GET_NO_ARG, NO_ARG, 0,
-   0, 0, 0, 0, 0},
+    0, 0, 0, 0, 0},
   {"auto-rehash", OPT_AUTO_REHASH,
-   N_("Enable automatic rehashing. One doesn't need to use 'rehash' to get table and field completion, but startup and reconnecting may take a longer time. Disable with --disable-auto-rehash."),
-   (char**) &opt_rehash, (char**) &opt_rehash, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0,
-   0, 0},
+    N_("Enable automatic rehashing. One doesn't need to use 'rehash' to get table and field completion, but startup and reconnecting may take a longer time. Disable with --disable-auto-rehash."),
+    (char**) &opt_rehash, (char**) &opt_rehash, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0,
+    0, 0},
   {"no-auto-rehash", 'A',
-   N_("No automatic rehashing. One has to use 'rehash' to get table and field completion. This gives a quicker start of drizzle_st and disables rehashing on reconnect. WARNING: options deprecated; use --disable-auto-rehash instead."),
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    N_("No automatic rehashing. One has to use 'rehash' to get table and field completion. This gives a quicker start of drizzle_st and disables rehashing on reconnect. WARNING: options deprecated; use --disable-auto-rehash instead."),
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"auto-vertical-output", OPT_AUTO_VERTICAL_OUTPUT,
-   N_("Automatically switch to vertical output mode if the result is wider than the terminal width."),
-   (char**) &auto_vertical_output, (char**) &auto_vertical_output, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Automatically switch to vertical output mode if the result is wider than the terminal width."),
+    (char**) &auto_vertical_output, (char**) &auto_vertical_output, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"batch", 'B',
-   N_("Don't use history file. Disable interactive behavior. (Enables --silent)"), 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Don't use history file. Disable interactive behavior. (Enables --silent)"), 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"column-type-info", OPT_COLUMN_TYPES, N_("Display column type information."),
-   (char**) &column_types_flag, (char**) &column_types_flag,
-   0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &column_types_flag, (char**) &column_types_flag,
+    0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"comments", 'c', N_("Preserve comments. Send comments to the server. The default is --skip-comments (discard comments), enable with --comments"),
-   (char**) &preserve_comments, (char**) &preserve_comments,
-   0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &preserve_comments, (char**) &preserve_comments,
+    0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"compress", 'C', N_("Use compression in server/client protocol."),
-   (char**) &opt_compress, (char**) &opt_compress, 0, GET_BOOL, NO_ARG, 0, 0, 0,
-   0, 0, 0},
+    (char**) &opt_compress, (char**) &opt_compress, 0, GET_BOOL, NO_ARG, 0, 0, 0,
+    0, 0, 0},
   {"database", 'D', N_("Database to use."), (char**) &current_db,
-   (char**) &current_db, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &current_db, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"default-character-set", OPT_DEFAULT_CHARSET,
-   N_("(not used)"), 0,
-   0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    N_("(not used)"), 0,
+    0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"delimiter", OPT_DELIMITER, N_("Delimiter to be used."), (char**) &delimiter_str,
-   (char**) &delimiter_str, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &delimiter_str, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"execute", 'e', N_("Execute command and quit. (Disables --force and history file)"), 0,
-   0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"vertical", 'E', N_("Print the output of a query (rows) vertically."),
-   (char**) &vertical, (char**) &vertical, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0,
-   0},
+    (char**) &vertical, (char**) &vertical, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0,
+    0},
   {"force", 'f', N_("Continue even if we get an sql error."),
-   (char**) &ignore_errors, (char**) &ignore_errors, 0, GET_BOOL, NO_ARG, 0, 0,
-   0, 0, 0, 0},
+    (char**) &ignore_errors, (char**) &ignore_errors, 0, GET_BOOL, NO_ARG, 0, 0,
+    0, 0, 0, 0},
   {"named-commands", 'G',
-   N_("Enable named commands. Named commands mean this program's internal commands; see drizzle> help . When enabled, the named commands can be used from any line of the query, otherwise only from the first line, before an enter. Disable with --disable-named-commands. This option is disabled by default."),
-   (char**) &named_cmds, (char**) &named_cmds, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    N_("Enable named commands. Named commands mean this program's internal commands; see drizzle> help . When enabled, the named commands can be used from any line of the query, otherwise only from the first line, before an enter. Disable with --disable-named-commands. This option is disabled by default."),
+    (char**) &named_cmds, (char**) &named_cmds, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
+    0, 0},
   {"no-named-commands", 'g',
-   N_("Named commands are disabled. Use \\* form only, or use named commands only in the beginning of a line ending with a semicolon (;) Since version 10.9 the client now starts with this option ENABLED by default! Disable with '-G'. Long format commands still work from the first line. WARNING: option deprecated; use --disable-named-commands instead."),
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Named commands are disabled. Use \\* form only, or use named commands only in the beginning of a line ending with a semicolon (;) Since version 10.9 the client now starts with this option ENABLED by default! Disable with '-G'. Long format commands still work from the first line. WARNING: option deprecated; use --disable-named-commands instead."),
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"ignore-spaces", 'i', N_("Ignore space after function names."), 0, 0, 0,
-   GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"local-infile", OPT_LOCAL_INFILE, N_("Enable/disable LOAD DATA LOCAL INFILE."),
-   (char**) &opt_local_infile,
-   (char**) &opt_local_infile, 0, GET_BOOL, OPT_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_local_infile,
+    (char**) &opt_local_infile, 0, GET_BOOL, OPT_ARG, 0, 0, 0, 0, 0, 0},
   {"no-beep", 'b', N_("Turn off beep on error."), (char**) &opt_nobeep,
-   (char**) &opt_nobeep, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_nobeep, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"host", 'h', N_("Connect to host."), (char**) &current_host,
-   (char**) &current_host, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &current_host, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"line-numbers", OPT_LINE_NUMBERS, N_("Write line numbers for errors."),
-   (char**) &line_numbers, (char**) &line_numbers, 0, GET_BOOL,
-   NO_ARG, 1, 0, 0, 0, 0, 0},
+    (char**) &line_numbers, (char**) &line_numbers, 0, GET_BOOL,
+    NO_ARG, 1, 0, 0, 0, 0, 0},
   {"skip-line-numbers", 'L', N_("Don't write line number for errors. WARNING: -L is deprecated, use long version of this option instead."), 0, 0, 0, GET_NO_ARG,
-   NO_ARG, 0, 0, 0, 0, 0, 0},
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"unbuffered", 'n', N_("Flush buffer after each query."), (char**) &unbuffered,
-   (char**) &unbuffered, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &unbuffered, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"column-names", OPT_COLUMN_NAMES, N_("Write column names in results."),
-   (char**) &column_names, (char**) &column_names, 0, GET_BOOL,
-   NO_ARG, 1, 0, 0, 0, 0, 0},
+    (char**) &column_names, (char**) &column_names, 0, GET_BOOL,
+    NO_ARG, 1, 0, 0, 0, 0, 0},
   {"skip-column-names", 'N',
-   N_("Don't write column names in results. WARNING: -N is deprecated, use long version of this options instead."),
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Don't write column names in results. WARNING: -N is deprecated, use long version of this options instead."),
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"set-variable", 'O',
-   N_("Change the value of a variable. Please note that this option is deprecated; you can set variables directly with --variable-name=value."),
-   0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Change the value of a variable. Please note that this option is deprecated; you can set variables directly with --variable-name=value."),
+    0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"sigint-ignore", OPT_SIGINT_IGNORE, N_("Ignore SIGINT (CTRL-C)"),
-   (char**) &opt_sigint_ignore,  (char**) &opt_sigint_ignore, 0, GET_BOOL,
-   NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_sigint_ignore,  (char**) &opt_sigint_ignore, 0, GET_BOOL,
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"one-database", 'o',
-   N_("Only update the default database. This is useful for skipping updates to other database in the update log."),
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Only update the default database. This is useful for skipping updates to other database in the update log."),
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"pager", OPT_PAGER,
-   N_("Pager to use to display results. If you don't supply an option the default pager is taken from your ENV variable PAGER. Valid pagers are less, more, cat [> filename], etc. See interactive help (\\h) also. This option does not work in batch mode. Disable with --disable-pager. This option is disabled by default."),
-   0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Pager to use to display results. If you don't supply an option the default pager is taken from your ENV variable PAGER. Valid pagers are less, more, cat [> filename], etc. See interactive help (\\h) also. This option does not work in batch mode. Disable with --disable-pager. This option is disabled by default."),
+    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
   {"no-pager", OPT_NOPAGER,
-   N_("Disable pager and print to stdout. See interactive help (\\h) also. WARNING: option deprecated; use --disable-pager instead."),
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Disable pager and print to stdout. See interactive help (\\h) also. WARNING: option deprecated; use --disable-pager instead."),
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"password", 'P',
-   N_("Password to use when connecting to server. If password is not given it's asked from the tty."),
-   0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Password to use when connecting to server. If password is not given it's asked from the tty."),
+    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
   {"port", 'p', N_("Port number to use for connection or 0 for default to, in order of preference, drizzle.cnf, $DRIZZLE_TCP_PORT, ")
-   N_("built-in default") " (" STRINGIFY_ARG(DRIZZLE_PORT) ").",
-   0, 0, 0, GET_UINT, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    N_("built-in default") " (" STRINGIFY_ARG(DRIZZLE_PORT) ").",
+    0, 0, 0, GET_UINT, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"prompt", OPT_PROMPT, N_("Set the drizzle prompt to this value."),
-   (char**) &current_prompt, (char**) &current_prompt, 0, GET_STR_ALLOC,
-   REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &current_prompt, (char**) &current_prompt, 0, GET_STR_ALLOC,
+    REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"quick", 'q',
-   N_("Don't cache result, print it row by row. This may slow down the server if the output is suspended. Doesn't use history file."),
-   (char**) &quick, (char**) &quick, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Don't cache result, print it row by row. This may slow down the server if the output is suspended. Doesn't use history file."),
+    (char**) &quick, (char**) &quick, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"raw", 'r', N_("Write fields without conversion. Used with --batch."),
-   (char**) &opt_raw_data, (char**) &opt_raw_data, 0, GET_BOOL, NO_ARG, 0, 0, 0,
-   0, 0, 0},
+    (char**) &opt_raw_data, (char**) &opt_raw_data, 0, GET_BOOL, NO_ARG, 0, 0, 0,
+    0, 0, 0},
   {"reconnect", OPT_RECONNECT, N_("Reconnect if the connection is lost. Disable with --disable-reconnect. This option is enabled by default."),
-   (char**) &opt_reconnect, (char**) &opt_reconnect, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
+    (char**) &opt_reconnect, (char**) &opt_reconnect, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
   {"shutdown", OPT_SHUTDOWN, N_("Shutdown the server."),
-   (char**) &opt_shutdown, (char**) &opt_shutdown, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_shutdown, (char**) &opt_shutdown, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"silent", 's', N_("Be more silent. Print results with a tab as separator, each row on new line."), 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    0, 0},
   {"table", 't', N_("Output in table format."), (char**) &output_tables,
-   (char**) &output_tables, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &output_tables, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"tee", OPT_TEE,
-   N_("Append everything into outfile. See interactive help (\\h) also. Does not work in batch mode. Disable with --disable-tee. This option is disabled by default."),
-   0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    N_("Append everything into outfile. See interactive help (\\h) also. Does not work in batch mode. Disable with --disable-tee. This option is disabled by default."),
+    0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"no-tee", OPT_NOTEE, N_("Disable outfile. See interactive help (\\h) also. WARNING: option deprecated; use --disable-tee instead"), 0, 0, 0, GET_NO_ARG,
-   NO_ARG, 0, 0, 0, 0, 0, 0},
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"user", 'u', N_("User for login if not current user."), (char**) &current_user,
-   (char**) &current_user, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &current_user, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"safe-updates", 'U', N_("Only allow UPDATE and DELETE that uses keys."),
-   (char**) &safe_updates, (char**) &safe_updates, 0, GET_BOOL, NO_ARG, 0, 0,
-   0, 0, 0, 0},
+    (char**) &safe_updates, (char**) &safe_updates, 0, GET_BOOL, NO_ARG, 0, 0,
+    0, 0, 0, 0},
   {"i-am-a-dummy", 'U', N_("Synonym for option --safe-updates, -U."),
-   (char**) &safe_updates, (char**) &safe_updates, 0, GET_BOOL, NO_ARG, 0, 0,
-   0, 0, 0, 0},
+    (char**) &safe_updates, (char**) &safe_updates, 0, GET_BOOL, NO_ARG, 0, 0,
+    0, 0, 0, 0},
   {"verbose", 'v', N_("Write more. (-v -v -v gives the table output format)."), 0,
-   0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"version", 'V', N_("Output version information and exit."), 0, 0, 0,
-   GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"wait", 'w', N_("Wait and retry if connection is down."), 0, 0, 0, GET_NO_ARG,
-   NO_ARG, 0, 0, 0, 0, 0, 0},
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"connect_timeout", OPT_CONNECT_TIMEOUT,
-   N_("Number of seconds before connection timeout."),
-   (char**) &opt_connect_timeout,
-   (char**) &opt_connect_timeout, 0, GET_UINT32, REQUIRED_ARG, 0, 0, 3600*12, 0,
-   0, 0},
+    N_("Number of seconds before connection timeout."),
+    (char**) &opt_connect_timeout,
+    (char**) &opt_connect_timeout, 0, GET_UINT32, REQUIRED_ARG, 0, 0, 3600*12, 0,
+    0, 0},
   {"max_input_line", OPT_MAX_INPUT_LINE,
-   N_("Max length of input line"),
-   (char**) &opt_max_input_line, (char**) &opt_max_input_line, 0,
-   GET_UINT32, REQUIRED_ARG, 16 *1024L*1024L, 4096,
-   (int64_t) 2*1024L*1024L*1024L, MALLOC_OVERHEAD, 1024, 0},
+    N_("Max length of input line"),
+    (char**) &opt_max_input_line, (char**) &opt_max_input_line, 0,
+    GET_UINT32, REQUIRED_ARG, 16 *1024L*1024L, 4096,
+    (int64_t) 2*1024L*1024L*1024L, MALLOC_OVERHEAD, 1024, 0},
   {"select_limit", OPT_SELECT_LIMIT,
-   N_("Automatic limit for SELECT when using --safe-updates"),
-   (char**) &select_limit,
-   (char**) &select_limit, 0, GET_UINT32, REQUIRED_ARG, 1000L, 1, ULONG_MAX,
-   0, 1, 0},
+    N_("Automatic limit for SELECT when using --safe-updates"),
+    (char**) &select_limit,
+    (char**) &select_limit, 0, GET_UINT32, REQUIRED_ARG, 1000L, 1, ULONG_MAX,
+    0, 1, 0},
   {"max_join_size", OPT_MAX_JOIN_SIZE,
-   N_("Automatic limit for rows in a join when using --safe-updates"),
-   (char**) &max_join_size,
-   (char**) &max_join_size, 0, GET_UINT32, REQUIRED_ARG, 1000000L, 1, ULONG_MAX,
-   0, 1, 0},
+    N_("Automatic limit for rows in a join when using --safe-updates"),
+    (char**) &max_join_size,
+    (char**) &max_join_size, 0, GET_UINT32, REQUIRED_ARG, 1000000L, 1, ULONG_MAX,
+    0, 1, 0},
   {"secure-auth", OPT_SECURE_AUTH, N_("Refuse client connecting to server if it uses old (pre-4.1.1) protocol"), (char**) &opt_secure_auth,
-   (char**) &opt_secure_auth, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_secure_auth, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"show-warnings", OPT_SHOW_WARNINGS, N_("Show warnings after every statement."),
-   (char**) &show_warnings, (char**) &show_warnings, 0, GET_BOOL, NO_ARG,
-   0, 0, 0, 0, 0, 0},
+    (char**) &show_warnings, (char**) &show_warnings, 0, GET_BOOL, NO_ARG,
+    0, 0, 0, 0, 0, 0},
   {"show-progress-size", OPT_SHOW_PROGRESS_SIZE, N_("Number of lines before each import progress report."),
-   (char**) &show_progress_size, (char**) &show_progress_size, 0, GET_UINT32, REQUIRED_ARG,
-   0, 0, 0, 0, 0, 0},
+    (char**) &show_progress_size, (char**) &show_progress_size, 0, GET_UINT32, REQUIRED_ARG,
+    0, 0, 0, 0, 0, 0},
   {"ping", OPT_PING, N_("Ping the server to check if it's alive."),
-   (char**) &opt_ping, (char**) &opt_ping, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_ping, (char**) &opt_ping, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"mysql", 'm', N_("Use MySQL Protocol."),
-   (char**) &opt_mysql, (char**) &opt_mysql, 0, GET_BOOL, NO_ARG, 1, 0, 0,
-   0, 0, 0},
+    (char**) &opt_mysql, (char**) &opt_mysql, 0, GET_BOOL, NO_ARG, 1, 0, 0,
+    0, 0, 0},
   { 0, 0, 0, 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0}
 };
 
@@ -1607,7 +1607,7 @@
 }
 
 
-static bool get_one_option(int optid, const struct my_option *, char *argument)
+static int get_one_option(int optid, const struct my_option *, char *argument)
 {
   char *endchar= NULL;
   uint64_t temp_drizzle_port= 0;
@@ -1632,7 +1632,7 @@
       {
         put_info(_("DELIMITER cannot contain a backslash character"),
                  INFO_ERROR,0,0);
-        return false;
+        return EXIT_ARGUMENT_INVALID;
       }
     }
     delimiter_length= (uint32_t)strlen(delimiter);
@@ -1707,15 +1707,15 @@
     if (strlen(endchar) != 0)
     {
       put_info(_("Non-integer value supplied for port.  If you are trying to enter a password please use --password instead."), INFO_ERROR, 0, 0);
-      return false;
+      return EXIT_ARGUMENT_INVALID;
     }
     /* If the port number is > 65535 it is not a valid port
-       This also helps with potential data loss casting unsigned long to a
-       uint32_t. */
+      This also helps with potential data loss casting unsigned long to a
+      uint32_t. */
     if ((temp_drizzle_port == 0) || (temp_drizzle_port > 65535))
     {
       put_info(_("Value supplied for port is not valid."), INFO_ERROR, 0, 0);
-      return false;
+      return EXIT_ARGUMENT_INVALID;
     }
     else
     {
@@ -1972,7 +1972,7 @@
 
 
 static bool add_line(string *buffer, char *line, char *in_string,
-                        bool *ml_comment)
+                     bool *ml_comment)
 {
   unsigned char inchar;
   char *pos, *out;
@@ -2241,8 +2241,8 @@
 }
 
 /*****************************************************************
-            Interface to Readline Completion
-******************************************************************/
+  Interface to Readline Completion
+ ******************************************************************/
 
 
 static char **mysql_completion (const char *text, int start, int end);
@@ -2480,8 +2480,8 @@
       if (drizzle_result_row_count(&tables) > 0 && !opt_silent && write_info)
       {
         tee_fprintf(stdout, _("\
-Reading table information for completion of table and column names\n    \
-You can turn off this feature to get a quicker startup with -A\n\n"));
+                              Reading table information for completion of table and column names\n    \
+                              You can turn off this feature to get a quicker startup with -A\n\n"));
       }
       while ((table_row=drizzle_row_next(&tables)))
       {
@@ -2510,7 +2510,7 @@
     query.append("show fields in '");
     query.append(table_row[0]);
     query.append("'");
-    
+
     if (drizzle_query(&con, &fields, query.c_str(), query.length(),
                       &ret) != NULL)
     {
@@ -2576,8 +2576,8 @@
 }
 
 /***************************************************************************
- The different commands
-***************************************************************************/
+  The different commands
+ ***************************************************************************/
 
 int drizzleclient_real_query_for_lazy(const char *buf, int length,
                                       drizzle_result_st *result,
@@ -2659,9 +2659,9 @@
 
 /*
   Execute command
-  Returns: 0  if ok
-  -1 if not fatal error
-  1  if fatal error
+Returns: 0  if ok
+-1 if not fatal error
+1  if fatal error
 */
 static int
 com_go(string *buffer, const char *)
@@ -2763,9 +2763,9 @@
         else
           print_table_data(&result);
         snprintf(buff, sizeof(buff), 
-                ngettext("%ld row in set","%ld rows in set",
-                         (long) drizzle_result_row_count(&result)),
-                (long) drizzle_result_row_count(&result));
+                 ngettext("%ld row in set","%ld rows in set",
+                          (long) drizzle_result_row_count(&result)),
+                 (long) drizzle_result_row_count(&result));
         end_pager();
         if (drizzle_result_error_code(&result))
           error= put_error(&con, &result);
@@ -2775,9 +2775,9 @@
       strcpy(buff,_("Query OK"));
     else
       snprintf(buff, sizeof(buff), ngettext("Query OK, %ld row affected",
-                             "Query OK, %ld rows affected",
-                             (long) drizzle_result_affected_rows(&result)),
-              (long) drizzle_result_affected_rows(&result));
+                                            "Query OK, %ld rows affected",
+                                            (long) drizzle_result_affected_rows(&result)),
+               (long) drizzle_result_affected_rows(&result));
 
     pos= strchr(buff, '\0');
     if ((warnings= drizzle_result_warning_count(&result)))
@@ -2904,17 +2904,17 @@
 static const char *fieldtype2str(drizzle_column_type_t type)
 {
   switch (type) {
-    case DRIZZLE_COLUMN_TYPE_BLOB:        return "BLOB";
-    case DRIZZLE_COLUMN_TYPE_DATE:        return "DATE";
-    case DRIZZLE_COLUMN_TYPE_DATETIME:    return "DATETIME";
-    case DRIZZLE_COLUMN_TYPE_NEWDECIMAL:  return "DECIMAL";
-    case DRIZZLE_COLUMN_TYPE_DOUBLE:      return "DOUBLE";
-    case DRIZZLE_COLUMN_TYPE_ENUM:        return "ENUM";
-    case DRIZZLE_COLUMN_TYPE_LONG:        return "LONG";
-    case DRIZZLE_COLUMN_TYPE_LONGLONG:    return "LONGLONG";
-    case DRIZZLE_COLUMN_TYPE_NULL:        return "NULL";
-    case DRIZZLE_COLUMN_TYPE_TIMESTAMP:   return "TIMESTAMP";
-    default:                     return "?-unknown-?";
+  case DRIZZLE_COLUMN_TYPE_BLOB:        return "BLOB";
+  case DRIZZLE_COLUMN_TYPE_DATE:        return "DATE";
+  case DRIZZLE_COLUMN_TYPE_DATETIME:    return "DATETIME";
+  case DRIZZLE_COLUMN_TYPE_NEWDECIMAL:  return "DECIMAL";
+  case DRIZZLE_COLUMN_TYPE_DOUBLE:      return "DOUBLE";
+  case DRIZZLE_COLUMN_TYPE_ENUM:        return "ENUM";
+  case DRIZZLE_COLUMN_TYPE_LONG:        return "LONG";
+  case DRIZZLE_COLUMN_TYPE_LONGLONG:    return "LONGLONG";
+  case DRIZZLE_COLUMN_TYPE_NULL:        return "NULL";
+  case DRIZZLE_COLUMN_TYPE_TIMESTAMP:   return "TIMESTAMP";
+  default:                     return "?-unknown-?";
   }
 }
 
@@ -2924,7 +2924,7 @@
   *s=0;
 #define ff2s_check_flag(X)                                              \
   if (f & DRIZZLE_COLUMN_FLAGS_ ## X) { s=strcpy(s, # X " ")+strlen(# X " "); \
-                        f &= ~ DRIZZLE_COLUMN_FLAGS_ ## X; }
+    f &= ~ DRIZZLE_COLUMN_FLAGS_ ## X; }
   ff2s_check_flag(NOT_NULL);
   ff2s_check_flag(PRI_KEY);
   ff2s_check_flag(UNIQUE_KEY);
@@ -3011,8 +3011,8 @@
       uint32_t name_length= strlen(drizzle_column_name(field));
 
       /* Check if the max_byte value is really the maximum in terms
-         of visual length since multibyte characters can affect the
-         length of the separator. */
+        of visual length since multibyte characters can affect the
+        length of the separator. */
       length= charset_info->cset->numcells(charset_info,
                                            drizzle_column_name(field),
                                            drizzle_column_name(field) +
@@ -3028,7 +3028,7 @@
         length= name_length;
       }
     }
-  
+
     if (quick)
       length=max(length,drizzle_column_size(field));
     else
@@ -3055,11 +3055,11 @@
     {
       uint32_t name_length= (uint32_t) strlen(drizzle_column_name(field));
       uint32_t numcells= charset_info->cset->numcells(charset_info,
-                                                  drizzle_column_name(field),
-                                                  drizzle_column_name(field) +
-                                                  name_length);
+                                                      drizzle_column_name(field),
+                                                      drizzle_column_name(field) +
+                                                      name_length);
       uint32_t display_length= drizzle_column_max_size(field) + name_length -
-                               numcells;
+        numcells;
       tee_fprintf(PAGER, " %-*s |",(int) min(display_length,
                                              MAX_COLUMN_LENGTH),
                   drizzle_column_name(field));
@@ -3144,20 +3144,20 @@
 }
 
 /**
-   Return the length of a field after it would be rendered into text.
-
-   This doesn't know or care about multibyte characters.  Assume we're
-   using such a charset.  We can't know that all of the upcoming rows
-   for this column will have bytes that each render into some fraction
-   of a character.  It's at least possible that a row has bytes that
-   all render into one character each, and so the maximum length is
-   still the number of bytes.  (Assumption 1:  This can't be better
-   because we can never know the number of characters that the DB is
-   going to send -- only the number of bytes.  2: Chars <= Bytes.)
-
-   @param  field  Pointer to a field to be inspected
-
-   @returns  number of character positions to be used, at most
+  Return the length of a field after it would be rendered into text.
+
+  This doesn't know or care about multibyte characters.  Assume we're
+  using such a charset.  We can't know that all of the upcoming rows
+  for this column will have bytes that each render into some fraction
+  of a character.  It's at least possible that a row has bytes that
+  all render into one character each, and so the maximum length is
+  still the number of bytes.  (Assumption 1:  This can't be better
+  because we can never know the number of characters that the DB is
+  going to send -- only the number of bytes.  2: Chars <= Bytes.)
+
+  @param  field  Pointer to a field to be inspected
+
+  @returns  number of character positions to be used, at most
 */
 static int get_field_disp_length(drizzle_column_st *field)
 {
@@ -3169,7 +3169,7 @@
     length= max(length, (uint32_t)drizzle_column_max_size(field));
 
   if (length < 4 &&
-    !(drizzle_column_flags(field) & DRIZZLE_COLUMN_FLAGS_NOT_NULL))
+      !(drizzle_column_flags(field) & DRIZZLE_COLUMN_FLAGS_NOT_NULL))
   {
     length= 4;        /* Room for "NULL" */
   }
@@ -3178,12 +3178,12 @@
 }
 
 /**
-   For a new result, return the max number of characters that any
-   upcoming row may return.
-
-   @param  result  Pointer to the result to judge
-
-   @returns  The max number of characters in any row of this result
+  For a new result, return the max number of characters that any
+  upcoming row may return.
+
+  @param  result  Pointer to the result to judge
+
+  @returns  The max number of characters in any row of this result
 */
 static int get_result_width(drizzle_result_st *result)
 {
@@ -3307,7 +3307,7 @@
     warning.
   */
   if (!cur || (num_rows == 1 &&
-      error_code == (uint32_t) strtoul(cur[1], NULL, 10)))
+               error_code == (uint32_t) strtoul(cur[1], NULL, 10)))
   {
     goto end;
   }
@@ -3605,7 +3605,7 @@
     snprintf(buff, sizeof(buff), "Connection id:    %u",drizzle_con_thread_id(&con));
     put_info(buff,INFO_INFO,0,0);
     snprintf(buff, sizeof(buff), "Current database: %.128s\n",
-            current_db ? current_db : "*** NONE ***");
+             current_db ? current_db : "*** NONE ***");
     put_info(buff,INFO_INFO,0,0);
   }
   return error;
@@ -3868,7 +3868,7 @@
 
 static int
 sql_connect(char *host,char *database,char *user,char *password,
-                 uint32_t silent)
+            uint32_t silent)
 {
   drizzle_return_t ret;
 
@@ -3887,26 +3887,26 @@
     return 1;
   }
 
-/* XXX add this back in
-  if (opt_connect_timeout)
-  {
+  /* XXX add this back in
+    if (opt_connect_timeout)
+    {
     uint32_t timeout=opt_connect_timeout;
     drizzleclient_options(&drizzle,DRIZZLE_OPT_CONNECT_TIMEOUT,
-                  (char*) &timeout);
-  }
-*/
+    (char*) &timeout);
+    }
+  */
 
-/* XXX Do we need this?
-  if (safe_updates)
-  {
+  /* XXX Do we need this?
+    if (safe_updates)
+    {
     char init_command[100];
     sprintf(init_command,
-            "SET SQL_SAFE_UPDATES=1,SQL_SELECT_LIMIT=%"PRIu32
-            ",MAX_JOIN_SIZE=%"PRIu32,
-            select_limit, max_join_size);
+    "SET SQL_SAFE_UPDATES=1,SQL_SELECT_LIMIT=%"PRIu32
+    ",MAX_JOIN_SIZE=%"PRIu32,
+    select_limit, max_join_size);
     drizzleclient_options(&drizzle, DRIZZLE_INIT_COMMAND, init_command);
-  }
-*/
+    }
+  */
   if ((ret= drizzle_con_connect(&con)) != DRIZZLE_RETURN_OK)
   {
     if (!silent || (ret != DRIZZLE_RETURN_GETADDRINFO &&
@@ -3928,10 +3928,10 @@
 static int
 com_status(string *, const char *)
 {
-/*
-  char buff[40];
-  uint64_t id;
-*/
+  /*
+    char buff[40];
+    uint64_t id;
+  */
   drizzle_result_st result;
   drizzle_return_t ret;
 
@@ -3979,12 +3979,12 @@
   tee_fprintf(stdout, "Server version:\t\t%s\n", server_version_string(&con));
   tee_fprintf(stdout, "Protocol version:\t%d\n", drizzle_con_protocol_version(&con));
   tee_fprintf(stdout, "Connection:\t\t%s\n", drizzle_con_host(&con));
-/* XXX need to save this from result
-  if ((id= drizzleclient_insert_id(&drizzle)))
+  /* XXX need to save this from result
+    if ((id= drizzleclient_insert_id(&drizzle)))
     tee_fprintf(stdout, "Insert id:\t\t%s\n", internal::llstr(id, buff));
-*/
+  */
 
-  if (strcmp(drizzle_con_uds(&con), ""))
+  if (drizzle_con_uds(&con))
     tee_fprintf(stdout, "UNIX socket:\t\t%s\n", drizzle_con_uds(&con));
   else
     tee_fprintf(stdout, "TCP port:\t\t%d\n", drizzle_con_port(&con));
@@ -3995,10 +3995,10 @@
     tee_fprintf(stdout, "\nNote that you are running in safe_update_mode:\n");
     vidattr(A_NORMAL);
     tee_fprintf(stdout, "\
-UPDATEs and DELETEs that don't use a key in the WHERE clause are not allowed.\n\
-(One can force an UPDATE/DELETE by adding LIMIT # at the end of the command.)\n \
-SELECT has an automatic 'LIMIT %lu' if LIMIT is not used.\n             \
-Max number of examined row combination in a join is set to: %lu\n\n",
+                UPDATEs and DELETEs that don't use a key in the WHERE clause are not allowed.\n\
+                (One can force an UPDATE/DELETE by adding LIMIT # at the end of the command.)\n \
+                SELECT has an automatic 'LIMIT %lu' if LIMIT is not used.\n             \
+                Max number of examined row combination in a join is set to: %lu\n\n",
                 select_limit, max_join_size);
   }
   tee_puts("--------------\n", stdout);
@@ -4133,9 +4133,9 @@
 
   return put_info(error, INFO_ERROR,
                   res == NULL ? drizzle_con_error_code(local_con) :
-                                drizzle_result_error_code(res),
+                  drizzle_result_error_code(res),
                   res == NULL ? drizzle_con_sqlstate(local_con) :
-                                drizzle_result_sqlstate(res));
+                  drizzle_result_sqlstate(res));
 }
 
 
@@ -4208,10 +4208,10 @@
 
 
 /**
-   Write as many as 52+1 bytes to buff, in the form of a legible
-   duration of time.
+  Write as many as 52+1 bytes to buff, in the form of a legible
+  duration of time.
 
-   len("4294967296 days, 23 hours, 59 minutes, 60.00 seconds")  ->  52
+  len("4294967296 days, 23 hours, 59 minutes, 60.00 seconds")  ->  52
 */
 static void nice_time(double sec,char *buff,bool part_second)
 {
@@ -4312,36 +4312,36 @@
         processed_prompt->append(current_db ? current_db : "(none)");
         break;
       case 'h':
-      {
-        const char *prompt;
-        prompt= connected ? drizzle_con_host(&con) : "not_connected";
-        if (strstr(prompt, "Localhost"))
-          processed_prompt->append("localhost");
-        else
         {
-          const char *end=strrchr(prompt,' ');
-          if (end != NULL)
-            processed_prompt->append(prompt, (end-prompt));
+          const char *prompt;
+          prompt= connected ? drizzle_con_host(&con) : "not_connected";
+          if (strstr(prompt, "Localhost"))
+            processed_prompt->append("localhost");
+          else
+          {
+            const char *end=strrchr(prompt,' ');
+            if (end != NULL)
+              processed_prompt->append(prompt, (end-prompt));
+          }
+          break;
         }
-        break;
-      }
       case 'p':
-      {
-        if (!connected)
         {
-          processed_prompt->append("not_connected");
-          break;
-        }
+          if (!connected)
+          {
+            processed_prompt->append("not_connected");
+            break;
+          }
 
-        if (strcmp(drizzle_con_uds(&con), ""))
-        {
-          const char *pos=strrchr(drizzle_con_uds(&con),'/');
-          processed_prompt->append(pos ? pos+1 : drizzle_con_uds(&con));
+          if (drizzle_con_uds(&con))
+          {
+            const char *pos=strrchr(drizzle_con_uds(&con),'/');
+            processed_prompt->append(pos ? pos+1 : drizzle_con_uds(&con));
+          }
+          else
+            add_int_to_prompt(drizzle_con_port(&con));
         }
-        else
-          add_int_to_prompt(drizzle_con_port(&con));
-      }
-      break;
+        break;
       case 'U':
         if (!full_username)
           init_username();
@@ -4451,20 +4451,20 @@
 
 static void init_username()
 {
-/* XXX need this?
-  free(full_username);
-  free(part_username);
+  /* XXX need this?
+    free(full_username);
+    free(part_username);
 
-  drizzle_result_st *result;
-  if (!drizzleclient_query(&drizzle,"select USER()") &&
-      (result=drizzleclient_use_result(&drizzle)))
-  {
+    drizzle_result_st *result;
+    if (!drizzleclient_query(&drizzle,"select USER()") &&
+    (result=drizzleclient_use_result(&drizzle)))
+    {
     drizzle_row_t cur=drizzleclient_fetch_row(result);
     full_username= strdup(cur[0]);
     part_username= strdup(strtok(cur[0],"@"));
     (void) drizzleclient_fetch_row(result);        // Read eof
-  }
-*/
+    }
+  */
 }
 
 static int com_prompt(string *, const char *line)
@@ -4487,9 +4487,9 @@
 }
 
 /*
-    strcont(str, set) if str contanies any character in the string set.
-    The result is the position of the first found character in str, or NULL
-    if there isn't anything found.
+  strcont(str, set) if str contanies any character in the string set.
+  The result is the position of the first found character in str, or NULL
+  if there isn't anything found.
 */
 
 static const char * strcont(register const char *str, register const char *set)

=== modified file 'client/drizzledump.1'
--- client/drizzledump.1	2009-07-17 17:13:52 +0000
+++ client/drizzledump.1	2010-03-22 14:33:29 +0000
@@ -1,43 +1,36 @@
-.\"     Title: \fBmysqldump\fR
+.\"     Title: \fBdrizzledump\fR
 .\"    Author: 
 .\" Generator: DocBook XSL Stylesheets v1.70.1 <http://docbook.sf.net/>
 .\"      Date: 05/23/2009
-.\"    Manual: MySQL Database System
-.\"    Source: MySQL 6.0
+.\"    Manual: drizzle Database System
+.\"    Source: drizzle 6.0
 .\"
-.TH "\fBMYSQLDUMP\fR" "1" "05/23/2009" "MySQL 6.0" "MySQL Database System"
+.TH "\fBMYSQLDUMP\fR" "1" "05/23/2009" "drizzle" "drizzle Database System"
 .\" disable hyphenation
 .nh
 .\" disable justification (adjust text to left margin only)
 .ad l
 .SH "NAME"
-mysqldump \- a database backup program
+drizzledump \- a database backup program
 .SH "SYNOPSIS"
 .HP 45
-\fBmysqldump [\fR\fB\fIoptions\fR\fR\fB] [\fR\fB\fIdb_name\fR\fR\fB [\fR\fB\fItbl_name\fR\fR\fB ...]]\fR
+\fBdrizzledump [\fR\fB\fIoptions\fR\fR\fB] [\fR\fB\fIdb_name\fR\fR\fB [\fR\fB\fItbl_name\fR\fR\fB ...]]\fR
 .SH "DESCRIPTION"
 .PP
 The
-\fBmysqldump\fR
-client is a backup program originally written by Igor Romanenko. It can be used to dump a database or a collection of databases for backup or transfer to another SQL server (not necessarily a MySQL server). The dump typically contains SQL statements to create the table, populate it, or both. However,
-\fBmysqldump\fR
+\fBdrizzledump\fR
+client is a backup program originally written by Igor Romanenko. It can be used to dump a database or a collection of databases for backup or transfer to another SQL server (not necessarily a drizzle server). The dump typically contains SQL statements to create the table, populate it, or both. However,
+\fBdrizzledump\fR
 can also be used to generate files in CSV, other delimited text, or XML format.
 .PP
-If you are doing a backup on the server and your tables all are
-MyISAM
-tables, consider using the
-\fBmysqlhotcopy\fR
-instead because it can accomplish faster backups and faster restores. See
-\fBmysqlhotcopy\fR(1).
-.PP
 There are three general ways to invoke
-\fBmysqldump\fR:
+\fBdrizzledump\fR:
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump [\fR\fB\fIoptions\fR\fR\fB] \fR\fB\fIdb_name\fR\fR\fB [\fR\fB\fItables\fR\fR\fB]\fR
-shell> \fBmysqldump [\fR\fB\fIoptions\fR\fR\fB] \-\-databases \fR\fB\fIdb_name1\fR\fR\fB [\fR\fB\fIdb_name2\fR\fR\fB \fR\fB\fIdb_name3\fR\fR\fB...]\fR
-shell> \fBmysqldump [\fR\fB\fIoptions\fR\fR\fB] \-\-all\-databases\fR
+shell> \fBdrizzledump [\fR\fB\fIoptions\fR\fR\fB] \fR\fB\fIdb_name\fR\fR\fB [\fR\fB\fItables\fR\fR\fB]\fR
+shell> \fBdrizzledump [\fR\fB\fIoptions\fR\fR\fB] \-\-databases \fR\fB\fIdb_name1\fR\fR\fB [\fR\fB\fIdb_name2\fR\fR\fB \fR\fB\fIdb_name3\fR\fR\fB...]\fR
+shell> \fBdrizzledump [\fR\fB\fIoptions\fR\fR\fB] \-\-all\-databases\fR
 .fi
 .RE
 .PP
@@ -49,20 +42,20 @@
 \fB\-\-all\-databases\fR
 option, entire databases are dumped.
 .PP
-\fBmysqldump\fR
+\fBdrizzledump\fR
 does not dump the
 INFORMATION_SCHEMA
 database. If you name that database explicitly on the command line,
-\fBmysqldump\fR
+\fBdrizzledump\fR
 silently ignores it.
 .PP
 To get a list of the options your version of
-\fBmysqldump\fR
+\fBdrizzledump\fR
 supports, execute
-\fBmysqldump \-\-help\fR.
+\fBdrizzledump \-\-help\fR.
 .PP
 Some
-\fBmysqldump\fR
+\fBdrizzledump\fR
 options are shorthand for groups of other options.
 \fB\-\-opt\fR
 and
@@ -97,7 +90,7 @@
 option for each feature. For example, to disable extended inserts and memory buffering, use
 \fB\-\-opt\fR
 \fB\-\-skip\-extended\-insert\fR
-\fB\-\-skip\-quick\fR. (As of MySQL 6.0,
+\fB\-\-skip\-quick\fR. (
 \fB\-\-skip\-extended\-insert\fR
 \fB\-\-skip\-quick\fR
 is sufficient because
@@ -122,7 +115,7 @@
 \fB\-\-skip\-opt\fR
 by itself.
 .PP
-\fBmysqldump\fR
+\fBdrizzledump\fR
 can retrieve and dump table contents row by row, or it can retrieve the entire content from a table and buffer it in memory before dumping it. Buffering in memory can be a problem if you are dumping large tables. To dump tables row by row, use the
 \fB\-\-quick\fR
 option (or
@@ -130,12 +123,12 @@
 \fB\-\-quick\fR). The
 \fB\-\-opt\fR
 option (and hence
-\fB\-\-quick\fR) is enabled by default in MySQL 6.0; to enable memory buffering, use
+\fB\-\-quick\fR) is enabled by default; to enable memory buffering, use
 \fB\-\-skip\-quick\fR.
 .PP
 If you are using a recent version of
-\fBmysqldump\fR
-to generate a dump to be reloaded into a very old MySQL server, you should not use the
+\fBdrizzledump\fR
+to generate a dump to be reloaded into a very old drizzle server, you should not use the
 \fB\-\-opt\fR
 or
 \fB\-\-extended\-insert\fR
@@ -143,9 +136,8 @@
 \fB\-\-skip\-opt\fR
 instead.
 .PP
-\fBmysqldump\fR
-supports the options in the following list. It also reads option files and supports the options for processing them described at
-Section\ 4.2.3.2.1, \(lqCommand\-Line Options that Affect Option\-File Handling\(rq.
+\fBdrizzledump\fR
+supports the options in the following list.
 .TP 3n
 \(bu
 \fB\-\-help\fR,
@@ -178,8 +170,7 @@
 LOCK TABLES
 and
 UNLOCK TABLES
-statements. This results in faster inserts when the dump file is reloaded. See
-Section\ 7.2.25, \(lqSpeed of INSERT Statements\(rq.
+statements. This results in faster inserts when the dump file is reloaded.
 .TP 3n
 \(bu
 \fB\-\-all\-databases\fR,
@@ -205,13 +196,12 @@
 CHANGE MASTER TO
 statement and a
 START SLAVE
-statement at the end of the output. This option was added in MySQL 6.0.4.
+statement at the end of the output.
 .TP 3n
 \(bu
 \fB\-\-character\-sets\-dir=\fR\fB\fIpath\fR\fR
 .sp
-The directory where character sets are installed. See
-Section\ 9.2, \(lqThe Character Set Used for Data and Sorting\(rq.
+The directory where character sets are installed.
 .TP 3n
 \(bu
 \fB\-\-comments\fR,
@@ -234,7 +224,7 @@
 \(bu
 \fB\-\-compatible=\fR\fB\fIname\fR\fR
 .sp
-Produce output that is more compatible with other database systems or with older MySQL servers. The value of
+Produce output that is more compatible with other database systems or with older drizzle servers. The value of
 name
 can be
 ansi,
@@ -247,8 +237,7 @@
 maxdb,
 no_key_options,
 no_table_options, or
-no_field_options. To use several values, separate them by commas. These values have the same meaning as the corresponding options for setting the server SQL mode. See
-Section\ 5.1.7, \(lqServer SQL Modes\(rq.
+no_field_options. To use several values, separate them by commas. These values have the same meaning as the corresponding options for setting the server SQL mode.
 .sp
 This option does not guarantee compatibility with other servers. It only enables those SQL mode values that are currently available for making dump output more compatible. For example,
 \fB\-\-compatible=oracle\fR
@@ -273,7 +262,7 @@
 \(bu
 \fB\-\-create\-options\fR
 .sp
-Include all MySQL\-specific table options in the
+Include all drizzle\-specific table options in the
 CREATE TABLE
 statements.
 .TP 3n
@@ -282,7 +271,7 @@
 \fB\-B\fR
 .sp
 Dump several databases. Normally,
-\fBmysqldump\fR
+\fBdrizzledump\fR
 treats the first name argument on the command line as a database name and following names as table names. With this option, it treats all name arguments as database names.
 CREATE DATABASE
 and
@@ -297,7 +286,7 @@
 \fIdebug_options\fR
 string is
 \'d:t:o,\fIfile_name\fR'. The default value is
-\'d:t:o,/tmp/mysqldump.trace'.
+\'d:t:o,/tmp/drizzledump.trace'.
 .TP 3n
 \(bu
 \fB\-\-debug\-check\fR
@@ -314,12 +303,10 @@
 .sp
 Use
 \fIcharset_name\fR
-as the default character set. See
-Section\ 9.2, \(lqThe Character Set Used for Data and Sorting\(rq. If no character set is specified,
-\fBmysqldump\fR
+as the default character set. If no character set is specified,
+\fBdrizzledump\fR
 uses
-utf8, and earlier versions use
-latin1.
+utf8
 .sp
 This option has no effect for output data files produced by using the
 \fB\-\-tab\fR
@@ -357,7 +344,7 @@
 \(bu
 \fB\-\-dump\-date\fR
 .sp
-\fBmysqldump\fR
+\fBdrizzledump\fR
 produces a
 \-\- Dump completed on \fIDATE\fR
 comment at the end of the dump if the
@@ -370,7 +357,7 @@
 \fB\-\-dump\-date\fR
 (include the date in the comment).
 \fB\-\-skip\-dump\-date\fR
-suppresses date printing. This option was added in MySQL 6.0.4.
+suppresses date printing.
 .TP 3n
 \(bu
 \fB\-\-dump\-slave[=\fR\fB\fIvalue\fR\fR\fB]\fR
@@ -381,7 +368,7 @@
 CHANGE MASTER TO
 statement that indicates the binary log coordinates (file name and position) of the dumped slave's master (rather than the coordinates of the dumped server, as is done by the
 \fB\-\-master\-data\fR
-option). These are the master server coordinates from which the slave should start replicating. This option was added in MySQL 6.0.4.
+option). These are the master server coordinates from which the slave should start replicating.
 .sp
 The option value is handled the same way as for
 \fB\-\-master\-data\fR
@@ -421,8 +408,7 @@
 These options are used with the
 \fB\-T\fR
 option and have the same meaning as the corresponding clauses for
-LOAD DATA INFILE. See
-Section\ 12.2.6, \(lqLOAD DATA INFILE Syntax\(rq.
+LOAD DATA INFILE. 
 .TP 3n
 \(bu
 \fB\-\-first\-slave\fR,
@@ -435,7 +421,7 @@
 \fB\-\-flush\-logs\fR,
 \fB\-F\fR
 .sp
-Flush the MySQL server log files before starting the dump. This option requires the
+Flush the drizzle server log files before starting the dump. This option requires the
 RELOAD
 privilege. Note that if you use this option in combination with the
 \fB\-\-all\-databases\fR
@@ -457,11 +443,11 @@
 Emit a
 FLUSH PRIVILEGES
 statement after dumping the
-mysql
+drizzle
 database. This option should be used any time the dump contains the
-mysql
+drizzle
 database and any other database that depends on the data in the
-mysql
+drizzle
 database for proper restoration.
 .TP 3n
 \(bu
@@ -471,20 +457,20 @@
 Continue even if an SQL error occurs during a table dump.
 .sp
 One use for this option is to cause
-\fBmysqldump\fR
+\fBdrizzledump\fR
 to continue executing even when it encounters a view that has become invalid because the definition refers to a table that has been dropped. Without
 \fB\-\-force\fR,
-\fBmysqldump\fR
+\fBdrizzledump\fR
 exits with an error message. With
 \fB\-\-force\fR,
-\fBmysqldump\fR
+\fBdrizzledump\fR
 prints the error message, but it also writes an SQL comment containing the view definition to the dump output and continues executing.
 .TP 3n
 \(bu
 \fB\-\-host=\fR\fB\fIhost_name\fR\fR,
 \fB\-h \fR\fB\fIhost_name\fR\fR
 .sp
-Dump data from the MySQL server on the given host. The default host is
+Dump data from the drizzle server on the given host. The default host is
 localhost.
 .TP 3n
 \(bu
@@ -510,7 +496,7 @@
 MASTER_PORT
 and
 MASTER_PORT
-options for the host name and TCP/IP port number of the slave's master. This option was added in MySQL 6.0.4.
+options for the host name and TCP/IP port number of the slave's master.
 .TP 3n
 \(bu
 \fB\-\-ignore\-table=\fR\fB\fIdb_name.tbl_name\fR\fR
@@ -532,8 +518,7 @@
 This option is used with the
 \fB\-T\fR
 option and has the same meaning as the corresponding clause for
-LOAD DATA INFILE. See
-Section\ 12.2.6, \(lqLOAD DATA INFILE Syntax\(rq.
+LOAD DATA INFILE. 
 .TP 3n
 \(bu
 \fB\-\-lock\-all\-tables\fR,
@@ -652,7 +637,7 @@
 \fB\-\-extended\-insert\fR
 \fB\-\-lock\-tables\fR
 \fB\-\-quick\fR
-\fB\-\-set\-charset\fR. It should give you a fast dump operation and produce a dump file that can be reloaded into a MySQL server quickly.
+\fB\-\-set\-charset\fR. It should give you a fast dump operation and produce a dump file that can be reloaded into a drizzle server quickly.
 .sp
 \fIThe \fR\fI\fB\-\-opt\fR\fR\fI option is enabled by default. Use \fR\fI\fB\-\-skip\-opt\fR\fR\fI to disable it.\fR
 See the discussion at the beginning of this section for information about selectively enabling or disabling certain of the options affected by
@@ -681,8 +666,7 @@
 \fB\-p\fR
 option on the command line, you are prompted for one.
 .sp
-Specifying a password on the command line should be considered insecure. See
-Section\ 5.5.6.2, \(lqEnd\-User Guidelines for Password Security\(rq.
+Specifying a password on the command line should be considered insecure. 
 .TP 3n
 \(bu
 \fB\-\-pipe\fR,
@@ -699,15 +683,14 @@
 \(bu
 \fB\-\-protocol={TCP|SOCKET|PIPE|MEMORY}\fR
 .sp
-The connection protocol to use for connecting to the server. It is useful when the other connection parameters normally would cause a protocol to be used other than the one you want. For details on the allowable values, see
-Section\ 4.2.2, \(lqConnecting to the MySQL Server\(rq.
+The connection protocol to use for connecting to the server. It is useful when the other connection parameters normally would cause a protocol to be used other than the one you want.
 .TP 3n
 \(bu
 \fB\-\-quick\fR,
 \fB\-q\fR
 .sp
 This option is useful for dumping large tables. It forces
-\fBmysqldump\fR
+\fBdrizzledump\fR
 to retrieve rows for a table from the server a row at a time rather than retrieving the entire row set and buffering it in memory before writing it out.
 .TP 3n
 \(bu
@@ -752,7 +735,7 @@
 Dump stored routines (procedures and functions) from the dumped databases. Use of this option requires the
 SELECT
 privilege for the
-mysql.proc
+drizzle.proc
 table. The output generated by using
 \fB\-\-routines\fR
 contains
@@ -763,9 +746,9 @@
 .sp
 If you require routines to be re\-created with their original timestamp attributes, do not use
 \fB\-\-routines\fR. Instead, dump and reload the contents of the
-mysql.proc
-table directly, using a MySQL account that has appropriate privileges for the
-mysql
+drizzle.proc
+table directly, using a drizzle account that has appropriate privileges for the
+drizzle
 database.
 .TP 3n
 \(bu
@@ -807,7 +790,7 @@
 TRUNCATE TABLE. A consistent read is not isolated from those statements, so use of them on a table to be dumped can cause the
 SELECT
 performed by
-\fBmysqldump\fR
+\fBdrizzledump\fR
 to retrieve the table contents to obtain incorrect contents or fail.
 .sp
 The
@@ -847,15 +830,14 @@
 .sp
 Options that begin with
 \fB\-\-ssl\fR
-specify whether to connect to the server via SSL and indicate where to find SSL keys and certificates. See
-Section\ 5.5.7.3, \(lqSSL Command Options\(rq.
+specify whether to connect to the server via SSL and indicate where to find SSL keys and certificates. 
 .TP 3n
 \(bu
 \fB\-\-tab=\fR\fB\fIpath\fR\fR,
 \fB\-T \fR\fB\fIpath\fR\fR
 .sp
 Produce tab\-separated data files. For each dumped table,
-\fBmysqldump\fR
+\fBdrizzledump\fR
 creates a
 \fI\fItbl_name\fR\fR\fI.sql\fR
 file that contains the
@@ -884,9 +866,9 @@
 .br
 \fBNote\fR
 This option should be used only when
-\fBmysqldump\fR
+\fBdrizzledump\fR
 is run on the same machine as the
-\fBmysqld\fR
+\fBdrizzled\fR
 server. You must have the
 FILE
 privilege, and the server must have permission to write files in the directory that you specify.
@@ -899,7 +881,7 @@
 or
 \fB\-B\fR
 option.
-\fBmysqldump\fR
+\fBdrizzledump\fR
 regards all name arguments following the option as table names.
 .TP 3n
 \(bu
@@ -914,7 +896,7 @@
 This option enables
 TIMESTAMP
 columns to be dumped and reloaded between servers in different time zones.
-\fBmysqldump\fR
+\fBdrizzledump\fR
 sets its connection time zone to UTC and adds
 SET TIME_ZONE='+00:00'
 to the dump file. Without this option,
@@ -930,7 +912,7 @@
 \fB\-\-user=\fR\fB\fIuser_name\fR\fR,
 \fB\-u \fR\fB\fIuser_name\fR\fR
 .sp
-The MySQL user name to use when connecting to the server.
+The drizzle user name to use when connecting to the server.
 .TP 3n
 \(bu
 \fB\-\-verbose\fR,
@@ -1007,21 +989,21 @@
 .TE
 .sp
 The output from the
-\fBmysql\fR
+\fBdrizzle\fR
 client when run using the
 \fB\-\-xml\fR
 option also follows these rules. (See
 the section called \(lq\fBMYSQL\fR OPTIONS\(rq.)
 .sp
 XML output from
-\fBmysqldump\fR
+\fBdrizzledump\fR
 includes the XML namespace, as shown here:
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump \-\-xml \-u root world City\fR
+shell> \fBdrizzledump \-\-xml \-u root world City\fR
 <?xml version="1.0"?>
-<mysqldump xmlns:xsi="http://www.w3.org/2001/XMLSchema\-instance">
+<drizzledump xmlns:xsi="http://www.w3.org/2001/XMLSchema\-instance">
 <database name="world">
 <table_structure name="City">
 <field Field="ID" Type="int(11)" Null="NO" Key="PRI" Extra="auto_increment" />
@@ -1053,7 +1035,7 @@
 </row>
 </table_data>
 </database>
-</mysqldump>
+</drizzledump>
 .fi
 .RE
 .sp
@@ -1076,22 +1058,22 @@
 \fB\-\-extended\-insert\fR
 or
 \fB\-\-opt\fR),
-\fBmysqldump\fR
+\fBdrizzledump\fR
 creates rows up to
 net_buffer_length
 length. If you increase this variable, you should also ensure that the
 net_buffer_length
-variable in the MySQL server is at least this large.
+variable in the drizzle server is at least this large.
 .sp
 .RE
 .PP
 The most common use of
-\fBmysqldump\fR
+\fBdrizzledump\fR
 is probably for making a backup of an entire database:
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump \fR\fB\fIdb_name\fR\fR\fB > \fR\fB\fIbackup\-file.sql\fR\fR
+shell> \fBdrizzledump \fR\fB\fIdb_name\fR\fR\fB > \fR\fB\fIbackup\-file.sql\fR\fR
 .fi
 .RE
 .PP
@@ -1099,7 +1081,7 @@
 .sp
 .RS 3n
 .nf
-shell> \fBmysql \fR\fB\fIdb_name\fR\fR\fB < \fR\fB\fIbackup\-file.sql\fR\fR
+shell> \fBdrizzle \fR\fB\fIdb_name\fR\fR\fB < \fR\fB\fIbackup\-file.sql\fR\fR
 .fi
 .RE
 .PP
@@ -1107,16 +1089,16 @@
 .sp
 .RS 3n
 .nf
-shell> \fBmysql \-e "source \fR\fB\fI/path\-to\-backup/backup\-file.sql\fR\fR\fB" \fR\fB\fIdb_name\fR\fR
+shell> \fBdrizzle \-e "source \fR\fB\fI/path\-to\-backup/backup\-file.sql\fR\fR\fB" \fR\fB\fIdb_name\fR\fR
 .fi
 .RE
 .PP
-\fBmysqldump\fR
-is also very useful for populating databases by copying data from one MySQL server to another:
+\fBdrizzledump\fR
+is also very useful for populating databases by copying data from one drizzle server to another:
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump \-\-opt \fR\fB\fIdb_name\fR\fR\fB | mysql \-\-host=\fR\fB\fIremote_host\fR\fR\fB \-C \fR\fB\fIdb_name\fR\fR
+shell> \fBdrizzledump \-\-opt \fR\fB\fIdb_name\fR\fR\fB | drizzle \-\-host=\fR\fB\fIremote_host\fR\fR\fB \-C \fR\fB\fIdb_name\fR\fR
 .fi
 .RE
 .PP
@@ -1124,7 +1106,7 @@
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump \-\-databases \fR\fB\fIdb_name1\fR\fR\fB [\fR\fB\fIdb_name2\fR\fR\fB ...] > my_databases.sql\fR
+shell> \fBdrizzledump \-\-databases \fR\fB\fIdb_name1\fR\fR\fB [\fR\fB\fIdb_name2\fR\fR\fB ...] > my_databases.sql\fR
 .fi
 .RE
 .PP
@@ -1134,35 +1116,34 @@
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump \-\-all\-databases > all_databases.sql\fR
+shell> \fBdrizzledump \-\-all\-databases > all_databases.sql\fR
 .fi
 .RE
 .PP
 For
 InnoDB
 tables,
-\fBmysqldump\fR
+\fBdrizzledump\fR
 provides a way of making an online backup:
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump \-\-all\-databases \-\-single\-transaction > all_databases.sql\fR
+shell> \fBdrizzledump \-\-all\-databases \-\-single\-transaction > all_databases.sql\fR
 .fi
 .RE
 .PP
 This backup acquires a global read lock on all tables (using
 FLUSH TABLES WITH READ LOCK) at the beginning of the dump. As soon as this lock has been acquired, the binary log coordinates are read and the lock is released. If long updating statements are running when the
 FLUSH
-statement is issued, the MySQL server may get stalled until those statements finish. After that, the dump becomes lock\-free and does not disturb reads and writes on the tables. If the update statements that the MySQL server receives are short (in terms of execution time), the initial lock period should not be noticeable, even with many updates.
+statement is issued, the drizzle server may get stalled until those statements finish. After that, the dump becomes lock\-free and does not disturb reads and writes on the tables. If the update statements that the drizzle server receives are short (in terms of execution time), the initial lock period should not be noticeable, even with many updates.
 .PP
 For point\-in\-time recovery (also known as
 \(lqroll\-forward,\(rq
-when you need to restore an old backup and replay the changes that happened since that backup), it is often useful to rotate the binary log (see
-Section\ 5.2.4, \(lqThe Binary Log\(rq) or at least know the binary log coordinates to which the dump corresponds:
+when you need to restore an old backup and replay the changes that happened since that backup), it is often useful to rotate the binary log , \(lqThe Binary Log\(rq) or at least know the binary log coordinates to which the dump corresponds:
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump \-\-all\-databases \-\-master\-data=2 > all_databases.sql\fR
+shell> \fBdrizzledump \-\-all\-databases \-\-master\-data=2 > all_databases.sql\fR
 .fi
 .RE
 .PP
@@ -1170,7 +1151,7 @@
 .sp
 .RS 3n
 .nf
-shell> \fBmysqldump \-\-all\-databases \-\-flush\-logs \-\-master\-data=2\fR
+shell> \fBdrizzledump \-\-all\-databases \-\-flush\-logs \-\-master\-data=2\fR
               \fB> all_databases.sql\fR
 .fi
 .RE
@@ -1183,15 +1164,11 @@
 InnoDB
 storage engine.
 .PP
-For more information on making backups, see
-Section\ 6.1, \(lqDatabase Backups\(rq, and
-Section\ 6.2, \(lqExample Backup and Recovery Strategy\(rq.
-.PP
-If you encounter problems backing up views, please read the section that covers restrictions on views which describes a workaround for backing up views when this fails due to insufficient privileges. See
-Section\ D.5, \(lqRestrictions on Views\(rq.
+If you encounter problems backing up views, please read the section that covers restrictions on views which describes a workaround for backing up views when this fails due to insufficient privileges. 
 .SH "COPYRIGHT"
 .PP
 Copyright 2007\-2008 MySQL AB, 2009 Sun Microsystems, Inc.
+Copyright 2010 Drizzle Team
 .PP
 This documentation is free software; you can redistribute it and/or modify it only under the terms of the GNU General Public License as published by the Free Software Foundation; version 2 of the License.
 .PP
@@ -1199,8 +1176,6 @@
 .PP
 You should have received a copy of the GNU General Public License along with the program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110\-1301 USA or see http://www.gnu.org/licenses/.
 .SH "SEE ALSO"
-For more information, please refer to the MySQL Reference Manual,
-which may already be installed locally and which is also available
-online at http://dev.mysql.com/doc/.
+For more information, please refer to http://www.drizzle.org/wiki.
 .SH AUTHOR
-Sun Microsystems, Inc. (http://www.mysql.com/).
+Sun Microsystems, Inc. (http://www.mysql.com/), Drizzle Team

=== modified file 'client/drizzledump.cc'
--- client/drizzledump.cc	2010-03-26 11:10:37 +0000
+++ client/drizzledump.cc	2010-03-26 19:25:23 +0000
@@ -1,32 +1,32 @@
 /* Copyright 2000-2008 MySQL AB, 2008, 2009 Sun Microsystems, Inc.
 
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; version 2 of the License.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this program; if not, write to the Free Software
+  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
 
 /* drizzledump.cc  - Dump a tables contents and format to an ASCII file
 
  * Derived from mysqldump, which originally came from:
-**
-** The author's original notes follow :-
-**
-** AUTHOR: Igor Romanenko (igor@frog.kiev.ua)
-** DATE:   December 3, 1994
-** WARRANTY: None, expressed, impressed, implied
-**          or other
-** STATUS: Public domain
+ **
+ ** The author's original notes follow :-
+ **
+ ** AUTHOR: Igor Romanenko (igor@frog.kiev.ua)
+ ** DATE:   December 3, 1994
+ ** WARRANTY: None, expressed, impressed, implied
+ **          or other
+ ** STATUS: Public domain
 
-* and more work by Monty, Jani & Sinisa
-* and all the MySQL developers over the years.
+ * and more work by Monty, Jani & Sinisa
+ * and all the MySQL developers over the years.
 */
 
 #include "client_priv.h"
@@ -76,7 +76,7 @@
 static void add_load_option(string &str, const char *option,
                             const char *option_value);
 static uint32_t find_set(TYPELIB *lib, const char *x, uint32_t length,
-			 char **err_pos, uint32_t *err_len);
+                         char **err_pos, uint32_t *err_len);
 
 static void field_escape(string &in, const char *from);
 static bool  verbose= false;
@@ -151,195 +151,195 @@
   NULL
 };
 static TYPELIB compatible_mode_typelib= {array_elements(compatible_mode_names) - 1,
-                                  "", compatible_mode_names, NULL};
+  "", compatible_mode_names, NULL};
 
 drizzled::hash_set<string> ignore_table;
 
 static struct my_option my_long_options[] =
 {
   {"all", 'a', "Deprecated. Use --create-options instead.",
-   (char**) &create_options, (char**) &create_options, 0, GET_BOOL, NO_ARG, 1,
-   0, 0, 0, 0, 0},
+    (char**) &create_options, (char**) &create_options, 0, GET_BOOL, NO_ARG, 1,
+    0, 0, 0, 0, 0},
   {"all-databases", 'A',
-   "Dump all the databases. This will be same as --databases with all databases selected.",
-   (char**) &opt_alldbs, (char**) &opt_alldbs, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    "Dump all the databases. This will be same as --databases with all databases selected.",
+    (char**) &opt_alldbs, (char**) &opt_alldbs, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
+    0, 0},
   {"all-tablespaces", 'Y',
-   "Dump all the tablespaces.",
-   (char**) &opt_alltspcs, (char**) &opt_alltspcs, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    "Dump all the tablespaces.",
+    (char**) &opt_alltspcs, (char**) &opt_alltspcs, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
+    0, 0},
   {"add-drop-database", OPT_DROP_DATABASE, "Add a 'DROP DATABASE' before each create.",
-   (char**) &opt_drop_database, (char**) &opt_drop_database, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0,
-   0},
+    (char**) &opt_drop_database, (char**) &opt_drop_database, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0,
+    0},
   {"add-drop-table", OPT_DROP, "Add a 'drop table' before each create.",
-   (char**) &opt_drop, (char**) &opt_drop, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0,
-   0},
+    (char**) &opt_drop, (char**) &opt_drop, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0,
+    0},
   {"allow-keywords", OPT_KEYWORDS,
-   "Allow creation of column names that are keywords.", (char**) &opt_keywords,
-   (char**) &opt_keywords, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    "Allow creation of column names that are keywords.", (char**) &opt_keywords,
+    (char**) &opt_keywords, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"comments", 'i', "Write additional information.",
-   (char**) &opt_comments, (char**) &opt_comments, 0, GET_BOOL, NO_ARG,
-   1, 0, 0, 0, 0, 0},
+    (char**) &opt_comments, (char**) &opt_comments, 0, GET_BOOL, NO_ARG,
+    1, 0, 0, 0, 0, 0},
   {"compatible", OPT_COMPATIBLE,
-   "Change the dump to be compatible with a given mode. By default tables are dumped in a format optimized for MySQL. Legal modes are: ansi, mysql323, mysql40, postgresql, oracle, mssql, db2, maxdb, no_key_options, no_table_options, no_field_options. One can use several modes separated by commas. Note: Requires DRIZZLE server version 4.1.0 or higher. This option is ignored with earlier server versions.",
-   (char**) &opt_compatible_mode_str, (char**) &opt_compatible_mode_str, 0,
-   GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    "Change the dump to be compatible with a given mode. By default tables are dumped in a format optimized for MySQL. Legal modes are: ansi, mysql323, mysql40, postgresql, oracle, mssql, db2, maxdb, no_key_options, no_table_options, no_field_options. One can use several modes separated by commas. Note: Requires DRIZZLE server version 4.1.0 or higher. This option is ignored with earlier server versions.",
+    (char**) &opt_compatible_mode_str, (char**) &opt_compatible_mode_str, 0,
+    GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"compact", OPT_COMPACT,
-   "Give less verbose output (useful for debugging). Disables structure comments and header/footer constructs.  Enables options --skip-add-drop-table --no-set-names --skip-disable-keys --skip-add-locks",
-   (char**) &opt_compact, (char**) &opt_compact, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    "Give less verbose output (useful for debugging). Disables structure comments and header/footer constructs.  Enables options --skip-add-drop-table --no-set-names --skip-disable-keys --skip-add-locks",
+    (char**) &opt_compact, (char**) &opt_compact, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
+    0, 0},
   {"complete-insert", 'c', "Use complete insert statements.",
-   (char**) &opt_complete_insert, (char**) &opt_complete_insert, 0, GET_BOOL,
-   NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_complete_insert, (char**) &opt_complete_insert, 0, GET_BOOL,
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"compress", 'C', "Use compression in server/client protocol.",
-   (char**) &opt_compress, (char**) &opt_compress, 0, GET_BOOL, NO_ARG, 0, 0, 0,
-   0, 0, 0},
+    (char**) &opt_compress, (char**) &opt_compress, 0, GET_BOOL, NO_ARG, 0, 0, 0,
+    0, 0, 0},
   {"create-options", OPT_CREATE_OPTIONS,
-   "Include all DRIZZLE specific create options.",
-   (char**) &create_options, (char**) &create_options, 0, GET_BOOL, NO_ARG, 1,
-   0, 0, 0, 0, 0},
+    "Include all DRIZZLE specific create options.",
+    (char**) &create_options, (char**) &create_options, 0, GET_BOOL, NO_ARG, 1,
+    0, 0, 0, 0, 0},
   {"databases", 'B',
-   "To dump several databases. Note the difference in usage; In this case no tables are given. All name arguments are regarded as databasenames. 'USE db_name;' will be included in the output.",
-   (char**) &opt_databases, (char**) &opt_databases, 0, GET_BOOL, NO_ARG, 0, 0,
-   0, 0, 0, 0},
+    "To dump several databases. Note the difference in usage; In this case no tables are given. All name arguments are regarded as databasenames. 'USE db_name;' will be included in the output.",
+    (char**) &opt_databases, (char**) &opt_databases, 0, GET_BOOL, NO_ARG, 0, 0,
+    0, 0, 0, 0},
   {"delayed-insert", OPT_DELAYED, "Insert rows with INSERT DELAYED; ",
-   (char**) &opt_delayed, (char**) &opt_delayed, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    (char**) &opt_delayed, (char**) &opt_delayed, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
+    0, 0},
   {"disable-keys", 'K',
-   "'ALTER TABLE tb_name DISABLE KEYS; and 'ALTER TABLE tb_name ENABLE KEYS; will be put in the output.", (char**) &opt_disable_keys,
-   (char**) &opt_disable_keys, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
+    "'ALTER TABLE tb_name DISABLE KEYS; and 'ALTER TABLE tb_name ENABLE KEYS; will be put in the output.", (char**) &opt_disable_keys,
+    (char**) &opt_disable_keys, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
   {"extended-insert", 'e',
-   "Allows utilization of the new, much faster INSERT syntax.",
-   (char**) &extended_insert, (char**) &extended_insert, 0, GET_BOOL, NO_ARG,
-   1, 0, 0, 0, 0, 0},
+    "Allows utilization of the new, much faster INSERT syntax.",
+    (char**) &extended_insert, (char**) &extended_insert, 0, GET_BOOL, NO_ARG,
+    1, 0, 0, 0, 0, 0},
   {"fields-terminated-by", OPT_FTB,
-   "Fields in the textfile are terminated by ...", (char**) &fields_terminated,
-   (char**) &fields_terminated, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    "Fields in the textfile are terminated by ...", (char**) &fields_terminated,
+    (char**) &fields_terminated, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"fields-enclosed-by", OPT_ENC,
-   "Fields in the importfile are enclosed by ...", (char**) &enclosed,
-   (char**) &enclosed, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0 ,0, 0},
+    "Fields in the importfile are enclosed by ...", (char**) &enclosed,
+    (char**) &enclosed, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0 ,0, 0},
   {"fields-optionally-enclosed-by", OPT_O_ENC,
-   "Fields in the i.file are opt. enclosed by ...", (char**) &opt_enclosed,
-   (char**) &opt_enclosed, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0 ,0, 0},
+    "Fields in the i.file are opt. enclosed by ...", (char**) &opt_enclosed,
+    (char**) &opt_enclosed, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0 ,0, 0},
   {"fields-escaped-by", OPT_ESC, "Fields in the i.file are escaped by ...",
-   (char**) &escaped, (char**) &escaped, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &escaped, (char**) &escaped, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"flush-logs", 'F', "Flush logs file in server before starting dump. "
-   "Note that if you dump many databases at once (using the option "
-   "--databases= or --all-databases), the logs will be flushed for "
-   "each database dumped. The exception is when using --lock-all-tables "
-   "in this case the logs will be flushed only once, corresponding "
-   "to the moment all tables are locked. So if you want your dump and "
-   "the log flush to happen at the same exact moment you should use "
-   "--lock-all-tables or --flush-logs",
-   (char**) &flush_logs, (char**) &flush_logs, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    "Note that if you dump many databases at once (using the option "
+      "--databases= or --all-databases), the logs will be flushed for "
+      "each database dumped. The exception is when using --lock-all-tables "
+      "in this case the logs will be flushed only once, corresponding "
+      "to the moment all tables are locked. So if you want your dump and "
+      "the log flush to happen at the same exact moment you should use "
+      "--lock-all-tables or --flush-logs",
+    (char**) &flush_logs, (char**) &flush_logs, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
+    0, 0},
   {"force", 'f', "Continue even if we get an sql-error.",
-   (char**) &ignore_errors, (char**) &ignore_errors, 0, GET_BOOL, NO_ARG,
-   0, 0, 0, 0, 0, 0},
+    (char**) &ignore_errors, (char**) &ignore_errors, 0, GET_BOOL, NO_ARG,
+    0, 0, 0, 0, 0, 0},
   {"help", '?', "Display this help message and exit.", 0, 0, 0, GET_NO_ARG,
-   NO_ARG, 0, 0, 0, 0, 0, 0},
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"hex-blob", OPT_HEXBLOB, "Dump binary strings (BINARY, "
     "VARBINARY, BLOB) in hexadecimal format.",
-   (char**) &opt_hex_blob, (char**) &opt_hex_blob, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_hex_blob, (char**) &opt_hex_blob, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"host", 'h', "Connect to host.", (char**) &current_host,
-   (char**) &current_host, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &current_host, 0, GET_STR_ALLOC, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"ignore-table", OPT_IGNORE_TABLE,
-   "Do not dump the specified table. To specify more than one table to ignore, "
-   "use the directive multiple times, once for each table.  Each table must "
-   "be specified with both database and table names, e.g. --ignore-table=database.table",
-   0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    "Do not dump the specified table. To specify more than one table to ignore, "
+      "use the directive multiple times, once for each table.  Each table must "
+      "be specified with both database and table names, e.g. --ignore-table=database.table",
+    0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"insert-ignore", OPT_INSERT_IGNORE, "Insert rows with INSERT IGNORE.",
-   (char**) &opt_ignore, (char**) &opt_ignore, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    (char**) &opt_ignore, (char**) &opt_ignore, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
+    0, 0},
   {"lines-terminated-by", OPT_LTB, "Lines in the i.file are terminated by ...",
-   (char**) &lines_terminated, (char**) &lines_terminated, 0, GET_STR,
-   REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &lines_terminated, (char**) &lines_terminated, 0, GET_STR,
+    REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"lock-all-tables", 'x', "Locks all tables across all databases. This "
-   "is achieved by taking a global read lock for the duration of the whole "
-   "dump. Automatically turns --single-transaction and --lock-tables off.",
-   (char**) &opt_lock_all_tables, (char**) &opt_lock_all_tables, 0, GET_BOOL, NO_ARG,
-   0, 0, 0, 0, 0, 0},
+    "is achieved by taking a global read lock for the duration of the whole "
+      "dump. Automatically turns --single-transaction and --lock-tables off.",
+    (char**) &opt_lock_all_tables, (char**) &opt_lock_all_tables, 0, GET_BOOL, NO_ARG,
+    0, 0, 0, 0, 0, 0},
   {"mysql", 'm', N_("Use MySQL Protocol."),
-   (char**) &opt_mysql, (char**) &opt_mysql, 0, GET_BOOL, NO_ARG, 1, 0, 0,
-   0, 0, 0},
+    (char**) &opt_mysql, (char**) &opt_mysql, 0, GET_BOOL, NO_ARG, 1, 0, 0,
+    0, 0, 0},
   {"no-autocommit", OPT_AUTOCOMMIT,
-   "Wrap tables with autocommit/commit statements.",
-   (char**) &opt_autocommit, (char**) &opt_autocommit, 0, GET_BOOL, NO_ARG,
-   0, 0, 0, 0, 0, 0},
+    "Wrap tables with autocommit/commit statements.",
+    (char**) &opt_autocommit, (char**) &opt_autocommit, 0, GET_BOOL, NO_ARG,
+    0, 0, 0, 0, 0, 0},
   {"no-create-db", 'n',
-   "'CREATE DATABASE IF NOT EXISTS db_name;' will not be put in the output. The above line will be added otherwise, if --databases or --all-databases option was given.}.",
-   (char**) &opt_create_db, (char**) &opt_create_db, 0, GET_BOOL, NO_ARG, 0, 0,
-   0, 0, 0, 0},
+    "'CREATE DATABASE IF NOT EXISTS db_name;' will not be put in the output. The above line will be added otherwise, if --databases or --all-databases option was given.}.",
+    (char**) &opt_create_db, (char**) &opt_create_db, 0, GET_BOOL, NO_ARG, 0, 0,
+    0, 0, 0, 0},
   {"no-create-info", 't', "Don't write table creation info.",
-   (char**) &opt_no_create_info, (char**) &opt_no_create_info, 0, GET_BOOL,
-   NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_no_create_info, (char**) &opt_no_create_info, 0, GET_BOOL,
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"no-data", 'd', "No row information.", (char**) &opt_no_data,
-   (char**) &opt_no_data, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_no_data, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"no-set-names", 'N',
-   "Deprecated. Use --skip-set-charset instead.",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    "Deprecated. Use --skip-set-charset instead.",
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"opt", OPT_OPTIMIZE,
-   "Same as --add-drop-table, --add-locks, --create-options, --quick, --extended-insert, --lock-tables, --set-charset, and --disable-keys. Enabled by default, disable with --skip-opt.",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    "Same as --add-drop-table, --add-locks, --create-options, --quick, --extended-insert, --lock-tables, --set-charset, and --disable-keys. Enabled by default, disable with --skip-opt.",
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"order-by-primary", OPT_ORDER_BY_PRIMARY,
-   "Sorts each table's rows by primary key, or first unique key, if such a key exists.  Useful when dumping a MyISAM table to be loaded into an InnoDB table, but will make the dump itself take considerably longer.",
-   (char**) &opt_order_by_primary, (char**) &opt_order_by_primary, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    "Sorts each table's rows by primary key, or first unique key, if such a key exists.  Useful when dumping a MyISAM table to be loaded into an InnoDB table, but will make the dump itself take considerably longer.",
+    (char**) &opt_order_by_primary, (char**) &opt_order_by_primary, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"password", 'P',
-   "Password to use when connecting to server. If password is not given it's solicited on the tty.",
-   0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
+    "Password to use when connecting to server. If password is not given it's solicited on the tty.",
+    0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
   {"port", 'p', "Port number to use for connection.", 
-   0, 0, 0, GET_UINT, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    0, 0, 0, GET_UINT, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"quick", 'q', "Don't buffer query, dump directly to stdout.",
-   (char**) &quick, (char**) &quick, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
+    (char**) &quick, (char**) &quick, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
   {"quote-names",'Q', "Quote table and column names with backticks (`).",
-   (char**) &opt_quoted, (char**) &opt_quoted, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0,
-   0, 0},
+    (char**) &opt_quoted, (char**) &opt_quoted, 0, GET_BOOL, NO_ARG, 1, 0, 0, 0,
+    0, 0},
   {"replace", OPT_DRIZZLE_REPLACE_INTO, "Use REPLACE INTO instead of INSERT INTO.",
-   (char**) &opt_replace_into, (char**) &opt_replace_into, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
-   0, 0},
+    (char**) &opt_replace_into, (char**) &opt_replace_into, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0,
+    0, 0},
   {"result-file", 'r',
-   "Direct output to a given file. This option should be used in MSDOS, because it prevents new line '\\n' from being converted to '\\r\\n' (carriage return + line feed).",
-   0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    "Direct output to a given file. This option should be used in MSDOS, because it prevents new line '\\n' from being converted to '\\r\\n' (carriage return + line feed).",
+    0, 0, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"routines", 'R', "Dump stored routines (functions and procedures).",
-     (char**) &opt_routines, (char**) &opt_routines, 0, GET_BOOL,
-     NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &opt_routines, (char**) &opt_routines, 0, GET_BOOL,
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {"single-transaction", OPT_TRANSACTION,
-   "Creates a consistent snapshot by dumping all tables in a single "
-   "transaction. Works ONLY for tables stored in storage engines which "
-   "support multiversioning (currently only InnoDB does); the dump is NOT "
-   "guaranteed to be consistent for other storage engines. "
-   "While a --single-transaction dump is in process, to ensure a valid "
-   "dump file (correct table contents), no other "
-   "connection should use the following statements: ALTER TABLE, DROP "
-   "TABLE, RENAME TABLE, TRUNCATE TABLE, as consistent snapshot is not "
-   "isolated from them. Option automatically turns off --lock-tables.",
-   (char**) &opt_single_transaction, (char**) &opt_single_transaction, 0,
-   GET_BOOL, NO_ARG,  0, 0, 0, 0, 0, 0},
+    "Creates a consistent snapshot by dumping all tables in a single "
+      "transaction. Works ONLY for tables stored in storage engines which "
+      "support multiversioning (currently only InnoDB does); the dump is NOT "
+      "guaranteed to be consistent for other storage engines. "
+      "While a --single-transaction dump is in process, to ensure a valid "
+      "dump file (correct table contents), no other "
+      "connection should use the following statements: ALTER TABLE, DROP "
+      "TABLE, RENAME TABLE, TRUNCATE TABLE, as consistent snapshot is not "
+      "isolated from them. Option automatically turns off --lock-tables.",
+    (char**) &opt_single_transaction, (char**) &opt_single_transaction, 0,
+    GET_BOOL, NO_ARG,  0, 0, 0, 0, 0, 0},
   {"dump-date", OPT_DUMP_DATE, "Put a dump date to the end of the output.",
-   (char**) &opt_dump_date, (char**) &opt_dump_date, 0,
-   GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
+    (char**) &opt_dump_date, (char**) &opt_dump_date, 0,
+    GET_BOOL, NO_ARG, 1, 0, 0, 0, 0, 0},
   {"skip-opt", OPT_SKIP_OPTIMIZATION,
-   "Disable --opt. Disables --add-drop-table, --add-locks, --create-options, --quick, --extended-insert, --lock-tables, --set-charset, and --disable-keys.",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    "Disable --opt. Disables --add-drop-table, --add-locks, --create-options, --quick, --extended-insert, --lock-tables, --set-charset, and --disable-keys.",
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"tab",'T',
-   "Creates tab separated textfile for each table to given path. (creates .sql and .txt files). NOTE: This only works if mysqldump is run on the same machine as the mysqld daemon.",
-   (char**) &path, (char**) &path, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    "Creates tab separated textfile for each table to given path. (creates .sql and .txt files). NOTE: This only works if drizzledump is run on the same machine as the drizzled daemon.",
+    (char**) &path, (char**) &path, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"tables", OPT_TABLES, "Overrides option --databases (-B).",
-   0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"show-progress-size", OPT_SHOW_PROGRESS_SIZE, N_("Number of rows before each output progress report (requires --verbose)."),
-   (char**) &show_progress_size, (char**) &show_progress_size, 0, GET_UINT32, REQUIRED_ARG,
-   10000, 0, 0, 0, 0, 0},
+    (char**) &show_progress_size, (char**) &show_progress_size, 0, GET_UINT32, REQUIRED_ARG,
+    10000, 0, 0, 0, 0, 0},
   {"user", 'u', "User for login if not current user.",
-   (char**) &current_user, (char**) &current_user, 0, GET_STR, REQUIRED_ARG,
-   0, 0, 0, 0, 0, 0},
+    (char**) &current_user, (char**) &current_user, 0, GET_STR, REQUIRED_ARG,
+    0, 0, 0, 0, 0, 0},
   {"verbose", 'v', "Print info about the various stages.",
-   (char**) &verbose, (char**) &verbose, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &verbose, (char**) &verbose, 0, GET_BOOL, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"version",'V', "Output version information and exit.", 0, 0, 0,
-   GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
+    GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
   {"where", 'w', "Dump only selected records; QUOTES mandatory!",
-   (char**) &where, (char**) &where, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
+    (char**) &where, (char**) &where, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
   {"xml", 'X', "Dump a database as well formed XML.", 0, 0, 0, GET_NO_ARG,
-   NO_ARG, 0, 0, 0, 0, 0, 0},
+    NO_ARG, 0, 0, 0, 0, 0, 0},
   {0, 0, 0, 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0}
 };
 
@@ -368,9 +368,9 @@
   Print the supplied message if in verbose mode
 
   SYNOPSIS
-    verbose_msg()
-    fmt   format specifier
-    ...   variable number of parameters
+  verbose_msg()
+  fmt   format specifier
+  ...   variable number of parameters
 */
 static void verbose_msg(const char *fmt, ...)
 {
@@ -389,8 +389,8 @@
   exit with message if ferror(file)
 
   SYNOPSIS
-    check_io()
-    file        - checked file
+  check_io()
+  file        - checked file
 */
 
 static void check_io(FILE *file)
@@ -441,7 +441,7 @@
     fputs("<?xml version=\"1.0\"?>\n", sql_file);
     /*
       Schema reference.  Allows use of xsi:nil for NULL values and
-      xsi:type to define an element's data type.
+xsi:type to define an element's data type.
     */
     fputs("<drizzledump ", sql_file);
     fputs("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"",
@@ -466,14 +466,11 @@
     }
     if (opt_set_charset)
       fprintf(sql_file,
-"\nSET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION;\n");
+              "\nSET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION;\n");
 
     if (path == NULL)
     {
-      fprintf(md_result_file,"\
-SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;\n\
-SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;\n\
-");
+      fprintf(md_result_file,"SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;\nSET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;\n");
     }
     check_io(sql_file);
   }
@@ -491,9 +488,7 @@
   {
     if (path == NULL)
     {
-      fprintf(md_result_file,"\
-SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;\n\
-SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;\n");
+      fprintf(md_result_file,"SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;\nSET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;\n");
     }
     if (opt_set_charset)
       fprintf(sql_file, "SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION;\n");
@@ -514,7 +509,7 @@
 } /* write_footer */
 
 
-static bool get_one_option(int optid, const struct my_option *, char *argument)
+static int get_one_option(int optid, const struct my_option *, char *argument)
 {
   char *endchar= NULL;
   uint64_t temp_drizzle_port= 0;
@@ -526,15 +521,15 @@
     if (strlen(endchar) != 0)
     {
       fprintf(stderr, _("Non-integer value supplied for port.  If you are trying to enter a password please use --password instead.\n"));
-      exit(EX_USAGE);
+      return EXIT_ARGUMENT_INVALID;
     }
     /* If the port number is > 65535 it is not a valid port
- *        This also helps with potential data loss casting unsigned long to a
- *               uint32_t. */
+     *        This also helps with potential data loss casting unsigned long to a
+     *               uint32_t. */
     if ((temp_drizzle_port == 0) || (temp_drizzle_port > 65535))
     {
       fprintf(stderr, _("Value supplied for port is not valid.\n"));
-      exit(EX_USAGE);
+      return EXIT_ARGUMENT_INVALID;
     }
     else
     {
@@ -551,8 +546,8 @@
       if (opt_password == NULL)
       {
         fprintf(stderr, _("Memory allocation error while copying password. "
-                        "Aborting.\n"));
-        exit(ENOMEM);
+                          "Aborting.\n"));
+        return EXIT_OUT_OF_MEMORY;
       }
       while (*argument)
       {
@@ -589,81 +584,82 @@
         a crash even if the input destination buffer is large enough
         to hold the output.
       */
-      die(EX_USAGE, _("Input filename too long: %s"), argument);
+      fprintf(stderr, _("Input filename too long: %s"), argument);
+      return EXIT_ARGUMENT_INVALID;
     }
 
     break;
   case 'V': print_version(); exit(0);
   case 'X':
-    opt_xml= 1;
-    extended_insert= opt_drop=
-      opt_disable_keys= opt_autocommit= opt_create_db= 0;
-    break;
+            opt_xml= 1;
+            extended_insert= opt_drop=
+              opt_disable_keys= opt_autocommit= opt_create_db= 0;
+            break;
   case 'I':
   case '?':
-    usage();
-    exit(0);
+            usage();
+            exit(0);
   case (int) OPT_OPTIMIZE:
-    extended_insert= opt_drop= quick= create_options=
-      opt_disable_keys= opt_set_charset= 1;
-    break;
+            extended_insert= opt_drop= quick= create_options=
+              opt_disable_keys= opt_set_charset= 1;
+            break;
   case (int) OPT_SKIP_OPTIMIZATION:
-    extended_insert= opt_drop= quick= create_options=
-      opt_disable_keys= opt_set_charset= 0;
-    break;
+            extended_insert= opt_drop= quick= create_options=
+              opt_disable_keys= opt_set_charset= 0;
+            break;
   case (int) OPT_COMPACT:
-  if (opt_compact)
-  {
-    opt_comments= opt_drop= opt_disable_keys= 0;
-    opt_set_charset= 0;
-  }
+            if (opt_compact)
+            {
+              opt_comments= opt_drop= opt_disable_keys= 0;
+              opt_set_charset= 0;
+            }
   case (int) OPT_TABLES:
-    opt_databases=0;
-    break;
+            opt_databases=0;
+            break;
   case (int) OPT_IGNORE_TABLE:
-  {
-    if (!strchr(argument, '.'))
-    {
-      fprintf(stderr, _("Illegal use of option --ignore-table=<database>.<table>\n"));
-      exit(1);
-    }
-    string tmpptr(argument);
-    ignore_table.insert(tmpptr); 
-    break;
-  }
+            {
+              if (!strchr(argument, '.'))
+              {
+                fprintf(stderr, _("Illegal use of option --ignore-table=<database>.<table>\n"));
+                return EXIT_ARGUMENT_INVALID;
+              }
+              string tmpptr(argument);
+              ignore_table.insert(tmpptr); 
+              break;
+            }
   case (int) OPT_COMPATIBLE:
-    {
-      char buff[255];
-      char *end= compatible_mode_normal_str;
-      uint32_t i;
-      uint32_t mode;
-      uint32_t error_len;
+            {
+              char buff[255];
+              char *end= compatible_mode_normal_str;
+              uint32_t i;
+              uint32_t mode;
+              uint32_t error_len;
 
-      opt_quoted= 1;
-      opt_set_charset= 0;
-      opt_compatible_mode_str= argument;
-      opt_compatible_mode= find_set(&compatible_mode_typelib,
-                                    argument, strlen(argument),
-                                    &err_ptr, &error_len);
-      if (error_len)
-      {
-        strncpy(buff, err_ptr, min((uint32_t)sizeof(buff), error_len+1));
-        fprintf(stderr, _("Invalid mode to --compatible: %s\n"), buff);
-        exit(1);
-      }
-      mode= opt_compatible_mode;
-      for (i= 0, mode= opt_compatible_mode; mode; mode>>= 1, i++)
-      {
-        if (mode & 1)
-        {
-          uint32_t len = strlen(compatible_mode_names[i]);
-          end= strcpy(end, compatible_mode_names[i]) + len;
-          end= strcpy(end, ",")+1;
-        }
-      }
-      if (end!=compatible_mode_normal_str)
-        end[-1]= 0;
-    }
+              opt_quoted= 1;
+              opt_set_charset= 0;
+              opt_compatible_mode_str= argument;
+              opt_compatible_mode= find_set(&compatible_mode_typelib,
+                                            argument, strlen(argument),
+                                            &err_ptr, &error_len);
+              if (error_len)
+              {
+                strncpy(buff, err_ptr, min((uint32_t)sizeof(buff), error_len+1));
+                fprintf(stderr, _("Invalid mode to --compatible: %s\n"), buff);
+                return EXIT_ARGUMENT_INVALID;
+              }
+              mode= opt_compatible_mode;
+              for (i= 0, mode= opt_compatible_mode; mode; mode>>= 1, i++)
+              {
+                if (mode & 1)
+                {
+                  uint32_t len = strlen(compatible_mode_names[i]);
+                  end= strcpy(end, compatible_mode_names[i]) + len;
+                  end= strcpy(end, ",")+1;
+                }
+              }
+              if (end!=compatible_mode_normal_str)
+                end[-1]= 0;
+            }
   }
   return 0;
 }
@@ -690,7 +686,7 @@
   if (opt_single_transaction && opt_lock_all_tables)
   {
     fprintf(stderr, _("%s: You can't use --single-transaction and "
-            "--lock-all-tables at the same time.\n"), internal::my_progname);
+                      "--lock-all-tables at the same time.\n"), internal::my_progname);
     return(EX_USAGE);
   }
   if (enclosed && opt_enclosed)
@@ -717,7 +713,7 @@
 
 
 /*
-** DB_error -- prints DRIZZLE error message and exits the program.
+ ** DB_error -- prints DRIZZLE error message and exits the program.
 */
 static void DB_error(drizzle_result_st *res, drizzle_return_t ret,
                      const char *when)
@@ -726,8 +722,8 @@
   {
     maybe_die(EX_DRIZZLEERR, _("Got error: %s (%d) %s"),
               drizzle_result_error(res),
-	      drizzle_result_error_code(res),
-	      when);
+              drizzle_result_error_code(res),
+              when);
     drizzle_result_free(res);
   }
   else
@@ -742,14 +738,14 @@
   Prints out an error message and kills the process.
 
   SYNOPSIS
-    die()
-    error_num   - process return value
-    fmt_reason  - a format string for use by vsnprintf.
-    ...         - variable arguments for above fmt_reason string
+  die()
+  error_num   - process return value
+  fmt_reason  - a format string for use by vsnprintf.
+  ...         - variable arguments for above fmt_reason string
 
   DESCRIPTION
-    This call prints out the formatted error message to stderr and then
-    terminates the process.
+  This call prints out the formatted error message to stderr and then
+  terminates the process.
 */
 static void die(int error_num, const char* fmt_reason, ...)
 {
@@ -771,18 +767,18 @@
   Prints out an error message and maybe kills the process.
 
   SYNOPSIS
-    maybe_die()
-    error_num   - process return value
-    fmt_reason  - a format string for use by vsnprintf.
-    ...         - variable arguments for above fmt_reason string
+  maybe_die()
+  error_num   - process return value
+  fmt_reason  - a format string for use by vsnprintf.
+  ...         - variable arguments for above fmt_reason string
 
   DESCRIPTION
-    This call prints out the formatted error message to stderr and then
-    terminates the process, unless the --force command line option is used.
+  This call prints out the formatted error message to stderr and then
+  terminates the process, unless the --force command line option is used.
 
-    This call should be used for non-fatal errors (such as database
-    errors) that the code may still be able to continue to the next unit
-    of work.
+  This call should be used for non-fatal errors (such as database
+  errors) that the code may still be able to continue to the next unit
+  of work.
 
 */
 static void maybe_die(int error_num, const char* fmt_reason, ...)
@@ -806,15 +802,15 @@
   some.
 
   SYNOPSIS
-    drizzleclient_query_with_error_report()
-    drizzle_con       connection to use
-    res             if non zero, result will be put there with
-                    drizzleclient_store_result()
-    query           query to send to server
+  drizzleclient_query_with_error_report()
+  drizzle_con       connection to use
+  res             if non zero, result will be put there with
+  drizzleclient_store_result()
+  query           query to send to server
 
   RETURN VALUES
-    0               query sending and (if res!=0) result reading went ok
-    1               error
+  0               query sending and (if res!=0) result reading went ok
+  1               error
 */
 
 static int drizzleclient_query_with_error_report(drizzle_con_st *con,
@@ -861,12 +857,12 @@
   Open a new .sql file to dump the table or view into
 
   SYNOPSIS
-    open_sql_file_for_table
-    name      name of the table or view
+  open_sql_file_for_table
+  name      name of the table or view
 
   RETURN VALUES
-    0        Failed to open file
-    > 0      Handle of the open file
+  0        Failed to open file
+  > 0      Handle of the open file
 */
 static FILE* open_sql_file_for_table(const char* table)
 {
@@ -930,7 +926,7 @@
 
 
 /*
-** dbDisconnect -- disconnects from the host.
+ ** dbDisconnect -- disconnects from the host.
 */
 static void dbDisconnect(char *host)
 {
@@ -1007,22 +1003,22 @@
   Quote a table name so it can be used in "SHOW TABLES LIKE <tabname>"
 
   SYNOPSIS
-    quote_for_like()
-    name     name of the table
-    buff     quoted name of the table
+  quote_for_like()
+  name     name of the table
+  buff     quoted name of the table
 
   DESCRIPTION
-    Quote \, _, ' and % characters
-
-    Note: Because DRIZZLE uses the C escape syntax in strings
-    (for example, '\n' to represent newline), you must double
-    any '\' that you use in your LIKE  strings. For example, to
-    search for '\n', specify it as '\\n'. To search for '\', specify
-    it as '\\\\' (the backslashes are stripped once by the parser
-    and another time when the pattern match is done, leaving a
-    single backslash to be matched).
-
-    Example: "t\1" => "t\\\\1"
+  Quote \, _, ' and % characters
+
+Note: Because DRIZZLE uses the C escape syntax in strings
+(for example, '\n' to represent newline), you must double
+any '\' that you use in your LIKE  strings. For example, to
+search for '\n', specify it as '\\n'. To search for '\', specify
+it as '\\\\' (the backslashes are stripped once by the parser
+and another time when the pattern match is done, leaving a
+single backslash to be matched).
+
+Example: "t\1" => "t\\\\1"
 
 */
 static char *quote_for_like(const char *name, char *buff)
@@ -1051,13 +1047,13 @@
   Quote and print a string.
 
   SYNOPSIS
-    print_quoted_xml()
-    xml_file    - output file
-    str         - string to print
-    len         - its length
+  print_quoted_xml()
+  xml_file    - output file
+  str         - string to print
+  len         - its length
 
   DESCRIPTION
-    Quote '<' '>' '&' '\"' chars and print a string to the xml_file.
+  Quote '<' '>' '&' '\"' chars and print a string to the xml_file.
 */
 
 static void print_quoted_xml(FILE *xml_file, const char *str, uint32_t len)
@@ -1076,8 +1072,8 @@
     case '&':
       fputs("&amp;", xml_file);
       break;
-    case '\"':
-      fputs("&quot;", xml_file);
+      case '\"':
+        fputs("&quot;", xml_file);
       break;
     default:
       fputc(*str, xml_file);
@@ -1092,28 +1088,28 @@
   Print xml tag. Optionally add attribute(s).
 
   SYNOPSIS
-    print_xml_tag(xml_file, sbeg, send, tag_name, first_attribute_name,
-                    ..., attribute_name_n, attribute_value_n, NULL)
-    xml_file              - output file
-    sbeg                  - line beginning
-    line_end              - line ending
-    tag_name              - XML tag name.
-    first_attribute_name  - tag and first attribute
-    first_attribute_value - (Implied) value of first attribute
-    attribute_name_n      - attribute n
-    attribute_value_n     - value of attribute n
+  print_xml_tag(xml_file, sbeg, send, tag_name, first_attribute_name,
+  ..., attribute_name_n, attribute_value_n, NULL)
+  xml_file              - output file
+  sbeg                  - line beginning
+  line_end              - line ending
+  tag_name              - XML tag name.
+  first_attribute_name  - tag and first attribute
+  first_attribute_value - (Implied) value of first attribute
+  attribute_name_n      - attribute n
+  attribute_value_n     - value of attribute n
 
   DESCRIPTION
-    Print XML tag with any number of attribute="value" pairs to the xml_file.
+  Print XML tag with any number of attribute="value" pairs to the xml_file.
 
-    Format is:
-      sbeg<tag_name first_attribute_name="first_attribute_value" ...
-      attribute_name_n="attribute_value_n">send
+  Format is:
+  sbeg<tag_name first_attribute_name="first_attribute_value" ...
+  attribute_name_n="attribute_value_n">send
   NOTE
-    Additional arguments must be present in attribute/value pairs.
-    The last argument should be the null character pointer.
-    All attribute_value arguments MUST be NULL terminated strings.
-    All attribute_value arguments will be quoted before output.
+  Additional arguments must be present in attribute/value pairs.
+  The last argument should be the null character pointer.
+  All attribute_value arguments MUST be NULL terminated strings.
+  All attribute_value arguments will be quoted before output.
 */
 
 static void print_xml_tag(FILE * xml_file, const char* sbeg,
@@ -1156,19 +1152,19 @@
   Print xml tag with for a field that is null
 
   SYNOPSIS
-    print_xml_null_tag()
-    xml_file    - output file
-    sbeg        - line beginning
-    stag_atr    - tag and attribute
-    sval        - value of attribute
-    line_end        - line ending
+  print_xml_null_tag()
+  xml_file    - output file
+  sbeg        - line beginning
+  stag_atr    - tag and attribute
+  sval        - value of attribute
+  line_end        - line ending
 
   DESCRIPTION
-    Print tag with one attribute to the xml_file. Format is:
-      <stag_atr="sval" xsi:nil="true"/>
+  Print tag with one attribute to the xml_file. Format is:
+  <stag_atr="sval" xsi:nil="true"/>
   NOTE
-    sval MUST be a NULL terminated string.
-    sval string will be qouted before output.
+  sval MUST be a NULL terminated string.
+  sval string will be qouted before output.
 */
 
 static void print_xml_null_tag(FILE * xml_file, const char* sbeg,
@@ -1190,17 +1186,17 @@
   Print xml tag with many attributes.
 
   SYNOPSIS
-    print_xml_row()
-    xml_file    - output file
-    row_name    - xml tag name
-    tableRes    - query result
-    row         - result row
+  print_xml_row()
+  xml_file    - output file
+  row_name    - xml tag name
+  tableRes    - query result
+  row         - result row
 
   DESCRIPTION
-    Print tag with many attribute to the xml_file. Format is:
-      \t\t<row_name Atr1="Val1" Atr2="Val2"... />
+  Print tag with many attribute to the xml_file. Format is:
+  \t\t<row_name Atr1="Val1" Atr2="Val2"... />
   NOTE
-    All atributes and values will be quoted before output.
+  All atributes and values will be quoted before output.
 */
 
 static void print_xml_row(FILE *xml_file, const char *row_name,
@@ -1235,22 +1231,22 @@
   Print hex value for blob data.
 
   SYNOPSIS
-    print_blob_as_hex()
-    output_file         - output file
-    str                 - string to print
-    len                 - its length
+  print_blob_as_hex()
+  output_file         - output file
+  str                 - string to print
+  len                 - its length
 
   DESCRIPTION
-    Print hex value for blob data.
+  Print hex value for blob data.
 */
 
 static void print_blob_as_hex(FILE *output_file, const char *str, uint32_t len)
 {
-    /* sakaik got the idea to to provide blob's in hex notation. */
-    const char *ptr= str, *end= ptr + len;
-    for (; ptr < end ; ptr++)
-      fprintf(output_file, "%02X", *((unsigned char *)ptr));
-    check_io(output_file);
+  /* sakaik got the idea to to provide blob's in hex notation. */
+  const char *ptr= str, *end= ptr + len;
+  for (; ptr < end ; ptr++)
+    fprintf(output_file, "%02X", *((unsigned char *)ptr));
+  check_io(output_file);
 }
 
 /*
@@ -1259,14 +1255,14 @@
   be dumping.
 
   ARGS
-    table       - table name
-    db          - db name
-    table_type  - table type, e.g. "MyISAM" or "InnoDB", but also "VIEW"
-    ignore_flag - what we must particularly ignore - see IGNORE_ defines above
-    num_fields  - number of fields in the table
+  table       - table name
+  db          - db name
+  table_type  - table type, e.g. "MyISAM" or "InnoDB", but also "VIEW"
+  ignore_flag - what we must particularly ignore - see IGNORE_ defines above
+  num_fields  - number of fields in the table
 
   RETURN
-    true if success, false if error
+  true if success, false if error
 */
 
 static bool get_table_structure(char *table, char *db, char *table_type,
@@ -1290,7 +1286,7 @@
   {
     delayed= 0;
     verbose_msg(_("-- Warning: Unable to use delayed inserts for table '%s' "
-                "because it's of type %s\n"), table, table_type);
+                  "because it's of type %s\n"), table, table_type);
   }
 
   complete_insert= 0;
@@ -1346,9 +1342,9 @@
       }
       if (opt_drop)
       {
-      /*
-        Even if the "table" is a view, we do a DROP TABLE here.
-       */
+        /*
+          Even if the "table" is a view, we do a DROP TABLE here.
+        */
         fprintf(sql_file, "DROP TABLE IF EXISTS %s;\n", opt_quoted_table);
         check_io(sql_file);
       }
@@ -1446,7 +1442,7 @@
         fprintf(sql_file, "CREATE TABLE %s (\n", result_table);
       else
         print_xml_tag(sql_file, "\t", "\n", "table_structure", "name=", table,
-                NULL);
+                      NULL);
       check_io(sql_file);
     }
 
@@ -1709,17 +1705,17 @@
 
 /*
 
- SYNOPSIS
+  SYNOPSIS
   dump_table()
 
   dump_table saves database contents as a series of INSERT statements.
 
   ARGS
-   table - table name
-   db    - db name
+  table - table name
+  db    - db name
 
-   RETURNS
-    void
+  RETURNS
+  void
 */
 
 
@@ -1759,12 +1755,12 @@
 
   /*
     If the table type is a merge table or any type that has to be
-     _completely_ ignored and no data dumped
+    _completely_ ignored and no data dumped
   */
   if (ignore_flag & IGNORE_DATA)
   {
     verbose_msg(_("-- Warning: Skipping data for table '%s' because " \
-                "it's of type %s\n"), table, table_type);
+                  "it's of type %s\n"), table, table_type);
     return;
   }
   /* Check that there are any fields in the table */
@@ -1897,7 +1893,7 @@
     if (opt_disable_keys)
     {
       fprintf(md_result_file, "ALTER TABLE %s DISABLE KEYS;\n",
-	      opt_quoted_table);
+              opt_quoted_table);
       check_io(md_result_file);
     }
 
@@ -1907,7 +1903,7 @@
     init_length=(uint32_t) insert_pat.length()+4;
     if (opt_xml)
       print_xml_tag(md_result_file, "\t", "\n", "table_data", "name=", table,
-              NULL);
+                    NULL);
     if (opt_autocommit)
     {
       fprintf(md_result_file, "set autocommit=0;\n");
@@ -1930,7 +1926,7 @@
         if (ret != DRIZZLE_RETURN_OK)
         {
           fprintf(stderr,
-                _("%s: Error reading rows for table: %s (%d:%s) ! Aborting.\n"),
+                  _("%s: Error reading rows for table: %s (%d:%s) ! Aborting.\n"),
                   internal::my_progname, result_table, ret, drizzle_con_error(&dcon));
           drizzle_result_free(&result);
           goto err;
@@ -1969,13 +1965,13 @@
 
         if (!(column= drizzle_column_next(&result)))
           die(EX_CONSCHECK,
-                      _("Not enough fields from table %s! Aborting.\n"),
-                      result_table);
+              _("Not enough fields from table %s! Aborting.\n"),
+              result_table);
 
         /*
-           63 is my_charset_bin. If charsetnr is not 63,
-           we have not a BLOB but a TEXT column.
-           we'll dump in hex only BLOB columns.
+          63 is my_charset_bin. If charsetnr is not 63,
+          we have not a BLOB but a TEXT column.
+          we'll dump in hex only BLOB columns.
         */
         is_blob= (opt_hex_blob && drizzle_column_charset(column) == 63 &&
                   (drizzle_column_type(column) == DRIZZLE_COLUMN_TYPE_VARCHAR ||
@@ -2026,7 +2022,7 @@
                 /* change any strings ("inf", "-inf", "nan") into NULL */
                 char *ptr= row[i];
                 if (my_isalpha(charset_info, *ptr) || (*ptr == '-' &&
-                    my_isalpha(charset_info, ptr[1])))
+                                                       my_isalpha(charset_info, ptr[1])))
                   extended_row.append( "NULL");
                 else
                 {
@@ -2083,7 +2079,7 @@
               if (opt_xml)
               {
                 print_xml_tag(md_result_file, "\t\t", "", "field", "name=",
-                        drizzle_column_name(column), NULL);
+                              drizzle_column_name(column), NULL);
                 fputs(!my_isalpha(charset_info, *ptr) ? ptr: "NULL",
                       md_result_file);
                 fputs("</field>\n", md_result_file);
@@ -2146,7 +2142,7 @@
 
     /* XML - close table tag and supress regular output */
     if (opt_xml)
-        fputs("\t</table_data>\n", md_result_file);
+      fputs("\t</table_data>\n", md_result_file);
     else if (extended_insert && row_break)
       fputs(";\n", md_result_file);             /* If not empty table */
     fflush(md_result_file);
@@ -2236,13 +2232,13 @@
 
 
 /*
-Table Specific database initalization.
+  Table Specific database initalization.
 
-SYNOPSIS
+  SYNOPSIS
   init_dumping_tables
   qdatabase      quoted name of the database
 
-RETURN VALUES
+  RETURN VALUES
   0        Success.
   1        Failure.
 */
@@ -2305,7 +2301,7 @@
     return 1;
 
   if (drizzle_select_db(&dcon, &result, database, &ret) == NULL ||
-        ret != DRIZZLE_RETURN_OK)
+      ret != DRIZZLE_RETURN_OK)
   {
     DB_error(&result, ret, _("when executing 'SELECT INTO OUTFILE'"));
     return 1;                   /* If --force */
@@ -2404,8 +2400,8 @@
   different case (e.g.  T1 vs t1)
 
   RETURN
-    pointer to the table name
-    0 if error
+  pointer to the table name
+  0 if error
 */
 
 static char *get_actual_table_name(const char *old_table_name,
@@ -2433,7 +2429,7 @@
     size_t *lengths;
     /*
       Return first row
-      TODO: Return all matching rows
+      TODO-> Return all matching rows
     */
     row= drizzle_row_next(&result);
     lengths= drizzle_row_field_sizes(&result);
@@ -2458,7 +2454,7 @@
 
   init_alloc_root(&root, 8192);
   if (!(dump_tables= pos= (char**) alloc_root(&root, tables * sizeof(char *))))
-     die(EX_EOM, _("alloc_root failure."));
+    die(EX_EOM, _("alloc_root failure."));
 
   for (; tables > 0 ; tables-- , table_names++)
   {
@@ -2516,14 +2512,14 @@
     We do first a FLUSH TABLES. If a long update is running, the FLUSH TABLES
     will wait but will not stall the whole mysqld, and when the long update is
     done the FLUSH TABLES WITH READ LOCK will start and succeed quickly. So,
-    FLUSH TABLES is to lower the probability of a stage where both mysqldump
+    FLUSH TABLES is to lower the probability of a stage where both drizzled
     and most client connections are stalled. Of course, if a second long
     update starts between the two FLUSHes, we have that bad stall.
   */
   return
     ( drizzleclient_query_with_error_report(drizzle_con, 0, "FLUSH TABLES", false) ||
       drizzleclient_query_with_error_report(drizzle_con, 0,
-                                    "FLUSH TABLES WITH READ LOCK", false) );
+                                            "FLUSH TABLES WITH READ LOCK", false) );
 }
 
 static int do_unlock_tables(drizzle_con_st *drizzle_con)
@@ -2534,16 +2530,16 @@
 static int start_transaction(drizzle_con_st *drizzle_con)
 {
   return (drizzleclient_query_with_error_report(drizzle_con, 0,
-                                        "SET SESSION TRANSACTION ISOLATION "
-                                        "LEVEL REPEATABLE READ", false) ||
+                                                "SET SESSION TRANSACTION ISOLATION "
+                                                "LEVEL REPEATABLE READ", false) ||
           drizzleclient_query_with_error_report(drizzle_con, 0,
-                                        "START TRANSACTION "
-                                        "WITH CONSISTENT SNAPSHOT", false));
+                                                "START TRANSACTION "
+                                                "WITH CONSISTENT SNAPSHOT", false));
 }
 
 
 static uint32_t find_set(TYPELIB *lib, const char *x, uint32_t length,
-                      char **err_pos, uint32_t *err_len)
+                         char **err_pos, uint32_t *err_len)
 {
   const char *end= x + length;
   uint32_t found= 0;
@@ -2649,16 +2645,16 @@
 
   ARGS
 
-    check_if_ignore_table()
-    table_name                  Table name to check
-    table_type                  Type of table
+  check_if_ignore_table()
+  table_name                  Table name to check
+  table_type                  Type of table
 
   GLOBAL VARIABLES
-    drizzle                       Drizzle connection
-    verbose                     Write warning messages
+  drizzle                       Drizzle connection
+  verbose                     Write warning messages
 
   RETURN
-    char (bit value)            See IGNORE_ values at top
+  char (bit value)            See IGNORE_ values at top
 */
 
 char check_if_ignore_table(const char *table_name, char *table_type)
@@ -2694,10 +2690,10 @@
   }
   /*
     If the table type matches any of these, we do support delayed inserts.
-    Note: we do not want to skip dumping this table if if is not one of
+    Note-> we do not want to skip dumping this table if if is not one of
     these types, but we do want to use delayed inserts in the dump if
     the table type is _NOT_ one of these types
-    */
+  */
   {
     strncpy(table_type, row[1], DRIZZLE_MAX_TABLE_SIZE-1);
     if (opt_delayed)
@@ -2718,18 +2714,18 @@
   Get string of comma-separated primary key field names
 
   SYNOPSIS
-    char *primary_key_fields(const char *table_name)
-    RETURNS     pointer to allocated buffer (must be freed by caller)
-    table_name  quoted table name
+  char *primary_key_fields(const char *table_name)
+  RETURNS     pointer to allocated buffer (must be freed by caller)
+  table_name  quoted table name
 
   DESCRIPTION
-    Use SHOW KEYS FROM table_name, allocate a buffer to hold the
-    field names, and then build that string and return the pointer
-    to that buffer.
+  Use SHOW KEYS FROM table_name, allocate a buffer to hold the
+  field names, and then build that string and return the pointer
+  to that buffer.
 
-    Returns NULL if there is no PRIMARY or UNIQUE key on the table,
-    or if there is some failure.  It is better to continue to dump
-    the table unsorted, rather than exit without dumping the data.
+  Returns NULL if there is no PRIMARY or UNIQUE key on the table,
+  or if there is some failure.  It is better to continue to dump
+  the table unsorted, rather than exit without dumping the data.
 */
 
 static char *primary_key_fields(const char *table_name)
@@ -2752,14 +2748,14 @@
     if (ret == DRIZZLE_RETURN_ERROR_CODE)
     {
       fprintf(stderr, _("Warning: Couldn't read keys from table %s;"
-              " records are NOT sorted (%s)\n"),
+                        " records are NOT sorted (%s)\n"),
               table_name, drizzle_result_error(&res));
       drizzle_result_free(&res);
     }
     else
     {
       fprintf(stderr, _("Warning: Couldn't read keys from table %s;"
-              " records are NOT sorted (%s)\n"),
+                        " records are NOT sorted (%s)\n"),
               table_name, drizzle_con_error(&dcon));
     }
 
@@ -2769,7 +2765,7 @@
   if (drizzle_result_buffer(&res) != DRIZZLE_RETURN_OK)
   {
     fprintf(stderr, _("Warning: Couldn't read keys from table %s;"
-            " records are NOT sorted (%s)\n"),
+                      " records are NOT sorted (%s)\n"),
             table_name, drizzle_con_error(&dcon));
     return result;
   }
@@ -2779,7 +2775,7 @@
    * Note that SHOW KEYS is ordered:  a PRIMARY key is always the first
    * row, and UNIQUE keys come before others.  So we only need to check
    * the first key, not all keys.
-   */
+ */
   if ((row= drizzle_row_next(&res)) && atoi(row[1]) == 0)
   {
     /* Key is unique */
@@ -2808,12 +2804,12 @@
     row= drizzle_row_next(&res);
     quoted_field= quote_name(row[4], buff, 0);
     end= strcpy(result, quoted_field) + strlen(quoted_field);
-    resutl_length_alloc-= strlen(quoted_field);
+    result_length_alloc -= strlen(quoted_field);
     while ((row= drizzle_row_next(&res)) && atoi(row[3]) > 1)
     {
       quoted_field= quote_name(row[4], buff, 0);
       end+= snprintf(end, result_length_alloc, ",%s",quoted_field);
-      resutl_length_alloc-= strlen(quoted_field);
+      result_length_alloc -= strlen(quoted_field);
     }
   }
 
@@ -2848,7 +2844,7 @@
   if ((opt_lock_all_tables) && do_flush_tables_read_lock(&dcon))
     goto err;
   if (opt_single_transaction && start_transaction(&dcon))
-      goto err;
+    goto err;
   if (opt_lock_all_tables)
   {
     if (drizzleclient_query_with_error_report(&dcon, &result, "FLUSH LOGS", false))

=== modified file 'client/drizzleimport.cc'
--- client/drizzleimport.cc	2010-03-04 17:10:35 +0000
+++ client/drizzleimport.cc	2010-03-25 09:08:56 +0000
@@ -170,7 +170,7 @@
   my_print_variables(my_long_options);
 }
 
-static bool get_one_option(int optid, const struct my_option *, char *argument)
+static int get_one_option(int optid, const struct my_option *, char *argument)
 {
   char *endchar= NULL;
   uint64_t temp_drizzle_port= 0;
@@ -182,7 +182,7 @@
     if (strlen(endchar) != 0)
     {
       fprintf(stderr, _("Non-integer value supplied for port.  If you are trying to enter a password please use --password instead.\n"));
-      exit(1);
+      return EXIT_ARGUMENT_INVALID;
     }
     /* If the port number is > 65535 it is not a valid port
        This also helps with potential data loss casting unsigned long to a
@@ -190,7 +190,7 @@
     if ((temp_drizzle_port == 0) || (temp_drizzle_port > 65535))
     {
       fprintf(stderr, _("Value supplied for port is not valid.\n"));
-      exit(1);
+      return EXIT_ARGUMENT_INVALID;
     }
     else
     {
@@ -208,7 +208,7 @@
       {
         fprintf(stderr, "Memory allocation error while copying password. "
                         "Aborting.\n");
-        exit(ENOMEM);
+        return EXIT_OUT_OF_MEMORY;
       }
       while (*argument)
       {

=== modified file 'client/drizzleslap.cc'
--- client/drizzleslap.cc	2010-03-04 17:10:35 +0000
+++ client/drizzleslap.cc	2010-03-25 09:08:56 +0000
@@ -727,7 +727,7 @@
   my_print_help(my_long_options);
 }
 
-static bool get_one_option(int optid, const struct my_option *, char *argument)
+static int get_one_option(int optid, const struct my_option *, char *argument)
 {
   char *endchar= NULL;
   uint64_t temp_drizzle_port= 0;
@@ -742,7 +742,7 @@
     if (strlen(endchar) != 0)
     {
       fprintf(stderr, _("Non-integer value supplied for port.  If you are trying to enter a password please use --password instead.\n"));
-      exit(1);
+      return EXIT_ARGUMENT_INVALID;
     }
     /* If the port number is > 65535 it is not a valid port
        This also helps with potential data loss casting unsigned long to a
@@ -750,7 +750,7 @@
     if ((temp_drizzle_port == 0) || (temp_drizzle_port > 65535))
     {
       fprintf(stderr, _("Value supplied for port is not valid.\n"));
-      exit(1);
+      return EXIT_ARGUMENT_INVALID;
     }
     else
     {
@@ -768,7 +768,7 @@
       {
         fprintf(stderr, "Memory allocation error while copying password. "
                         "Aborting.\n");
-        exit(ENOMEM);
+        return EXIT_OUT_OF_MEMORY;
       }
       while (*argument)
       {

=== modified file 'client/drizzletest.cc'
--- client/drizzletest.cc	2010-03-04 17:10:35 +0000
+++ client/drizzletest.cc	2010-03-25 09:08:56 +0000
@@ -77,7 +77,7 @@
 extern "C"
 unsigned char *get_var_key(const unsigned char* var, size_t *len, bool);
 
-bool get_one_option(int optid, const struct my_option *, char *argument);
+int get_one_option(int optid, const struct my_option *, char *argument);
 
 #define MAX_VAR_NAME_LENGTH    256
 #define MAX_COLUMNS            256
@@ -4666,7 +4666,7 @@
   my_print_variables(my_long_options);
 }
 
-bool get_one_option(int optid, const struct my_option *, char *argument)
+int get_one_option(int optid, const struct my_option *, char *argument)
 {
   char *endchar= NULL;
   uint64_t temp_drizzle_port= 0;
@@ -4686,9 +4686,15 @@
     internal::fn_format(buff, argument, "", "", MY_UNPACK_FILENAME);
     assert(cur_file == file_stack && cur_file->file == 0);
     if (!(cur_file->file= fopen(buff, "r")))
-      die("Could not open '%s' for reading: errno = %d", buff, errno);
+    {
+      fprintf(stderr, _("Could not open '%s' for reading: errno = %d"), buff, errno);
+      return EXIT_ARGUMENT_INVALID;
+    }
     if (!(cur_file->file_name= strdup(buff)))
-      die("Out of memory");
+    {
+      fprintf(stderr, _("Out of memory"));
+      return EXIT_OUT_OF_MEMORY;
+    }
     cur_file->lineno= 1;
     break;
   }
@@ -4711,7 +4717,7 @@
     if (strlen(endchar) != 0)
     {
       fprintf(stderr, _("Non-integer value supplied for port.  If you are trying to enter a password please use --password instead.\n"));
-      exit(1);
+      return EXIT_ARGUMENT_INVALID;
     }
     /* If the port number is > 65535 it is not a valid port
        This also helps with potential data loss casting unsigned long to a
@@ -4719,7 +4725,7 @@
     if ((temp_drizzle_port == 0) || (temp_drizzle_port > 65535))
     {
       fprintf(stderr, _("Value supplied for port is not valid.\n"));
-      exit(1);
+      return EXIT_ARGUMENT_INVALID;
     }
     else
     {
@@ -4733,7 +4739,10 @@
         free(opt_pass);
       opt_pass = strdup(argument);
       if (opt_pass == NULL)
-        die("Out of memory");
+      {
+        fprintf(stderr, _("Out of memory"));
+        return EXIT_OUT_OF_MEMORY;
+      }
       while (*argument)
       {
         /* Overwriting password with 'x' */

=== modified file 'config/pandora-plugin'
--- config/pandora-plugin	2010-03-10 18:07:45 +0000
+++ config/pandora-plugin	2010-03-23 08:39:53 +0000
@@ -20,6 +20,7 @@
 
 import ConfigParser, os, sys
 import datetime, time
+import subprocess
 
 top_srcdir='.'
 top_builddir='.'
@@ -35,6 +36,7 @@
 root_plugin_dir='plugin'
 pkgplugindir='$(libdir)/drizzle'
 default_install='True'
+default_plugin_version=''
 
 class ChangeProtectedFile(object):
 
@@ -383,7 +385,7 @@
         print "External Plugins are required to specifiy a version"
         sys.exit(1)
     if not plugin.has_key('version'):
-      plugin['version']=datetime.date.fromtimestamp(time.time()).isoformat()
+      plugin['version'] = default_plugin_version
    
     if plugin.has_key('load_by_default'):
       plugin['load_by_default']=parser.getboolean('plugin','load_by_default')
@@ -480,6 +482,28 @@
 
 #MAIN STARTS HERE:
 
+# I'm 3 seconds away from writing a comprehensive build solution
+if not os.path.exists('config/pandora_vc_revinfo'):
+  if os.path.exists('.bzr'):
+    bzr_revno= subprocess.Popen(["bzr", "revno"], stdout=subprocess.PIPE).communicate()[0].strip()
+    rev_date= datetime.date.fromtimestamp(time.time())
+    default_plugin_version = "%d.%02d.%s" % (rev_date.year, rev_date.month, bzr_revno)
+  else:
+    default_plugin_version=datetime.date.fromtimestamp(time.time()).isoformat()
+else:
+  # need to read config/pandora_vc_revno
+  pandora_vc_revno=open('config/pandora_vc_revinfo','r').read().split()
+  rev_date=""
+  bzr_revno=""
+  for revno_line in pandora_vc_revno:
+    (revno_key,revno_val)= revno_line.split("=")
+    if revno_key == 'PANDORA_VC_REVNO':
+      bzr_revno=revno_val.strip()
+    elif revno_key == 'PANDORA_RELEASE_DATE':
+      rev_date=revno_val.strip()
+
+  default_plugin_version = "%s.%s" % (rev_date, bzr_revno)
+
 actions=[]
 for arg in sys.argv:
   if arg.startswith('--top_srcdir='):

=== modified file 'configure.ac'
--- configure.ac	2010-03-11 18:44:09 +0000
+++ configure.ac	2010-03-22 21:30:21 +0000
@@ -48,8 +48,6 @@
 PANDORA_PROTOBUF_REQUIRE_VERSION([2.1.0])
 PANDORA_REQUIRE_PROTOC
 
-AX_BOOST_BASE([1.32])
-
 AC_LANG_PUSH(C++)
 PANDORA_REQUIRE_PTHREAD
 PANDORA_REQUIRE_LIBUUID

=== modified file 'drizzled/algorithm/include.am'
--- drizzled/algorithm/include.am	2010-01-06 02:20:42 +0000
+++ drizzled/algorithm/include.am	2010-03-19 22:06:24 +0000
@@ -13,7 +13,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-nobase_dist_include_HEADERS+= drizzled/algorithm/crc32.h
+nobase_dist_include_HEADERS+= drizzled/algorithm/crc32.h drizzled/algorithm/sha1.h
 
 noinst_LTLIBRARIES+= drizzled/algorithm/libhash.la
-drizzled_algorithm_libhash_la_SOURCES= drizzled/algorithm/crc32.cc
+drizzled_algorithm_libhash_la_SOURCES= drizzled/algorithm/crc32.cc drizzled/algorithm/sha1.cc

=== added file 'drizzled/algorithm/sha1.cc'
--- drizzled/algorithm/sha1.cc	1970-01-01 00:00:00 +0000
+++ drizzled/algorithm/sha1.cc	2010-03-19 22:06:24 +0000
@@ -0,0 +1,197 @@
+/*
+ * Copyright (C) 2010 nobody (this is public domain)
+ */
+
+/**
+ * @file
+ * @brief SHA1 Definitions
+ */
+
+/*
+ * SHA-1 in C
+ * By Steve Reid <steve@edmweb.com>
+ * 100% Public Domain
+ *
+ * Test Vectors (from FIPS PUB 180-1)
+ * "abc"
+ *   A9993E36 4706816A BA3E2571 7850C26C 9CD0D89D
+ * "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"
+ *   84983E44 1C3BD26E BAAE4AA1 F95129E5 E54670F1
+ * A million repetitions of "a"
+ *   34AA973C D4C4DAA4 F61EEB2B DBAD2731 6534016F
+ */
+
+#include "config.h"
+#include "sha1.h"
+#include <string.h>
+
+namespace drizzled
+{
+
+#define rol(value, bits) (((value) << (bits)) | ((value) >> (32 - (bits))))
+
+/* Solaris + gcc don't always define this. */
+#ifndef BYTE_ORDER
+# define LITTLE_ENDIAN 1234
+# define BIG_ENDIAN 4321
+# if defined(sparc) || defined(__sparc) || defined(__sparc__)
+#  define BYTE_ORDER BIG_ENDIAN
+# else
+#  define BYTE_ORDER LITTLE_ENDIAN
+# endif
+#endif /* BYTE_ORDER */
+
+/*
+ * blk0() and blk() perform the initial expand.
+ * I got the idea of expanding during the round function from SSLeay
+ */
+#if BYTE_ORDER == LITTLE_ENDIAN
+# define blk0(i) (block->l[i] = (rol(block->l[i],24)&0xFF00FF00) \
+    |(rol(block->l[i],8)&0x00FF00FF))
+#else
+# define blk0(i) block->l[i]
+#endif
+#define blk(i) (block->l[i&15] = rol(block->l[(i+13)&15]^block->l[(i+8)&15] \
+    ^block->l[(i+2)&15]^block->l[i&15],1))
+
+/*
+ * (R0+R1), R2, R3, R4 are the different operations (rounds) used in SHA1
+ */
+#define R0(v,w,x,y,z,i) z+=((w&(x^y))^y)+blk0(i)+0x5A827999+rol(v,5);w=rol(w,30);
+#define R1(v,w,x,y,z,i) z+=((w&(x^y))^y)+blk(i)+0x5A827999+rol(v,5);w=rol(w,30);
+#define R2(v,w,x,y,z,i) z+=(w^x^y)+blk(i)+0x6ED9EBA1+rol(v,5);w=rol(w,30);
+#define R3(v,w,x,y,z,i) z+=(((w|x)&y)|(w&x))+blk(i)+0x8F1BBCDC+rol(v,5);w=rol(w,30);
+#define R4(v,w,x,y,z,i) z+=(w^x^y)+blk(i)+0xCA62C1D6+rol(v,5);w=rol(w,30);
+
+/*
+ * Hash a single 512-bit block. This is the core of the algorithm.
+ */
+void
+SHA1Transform(uint32_t state[5], const uint8_t buffer[SHA1_BLOCK_LENGTH])
+{
+	uint32_t a, b, c, d, e;
+	typedef union {
+		uint8_t c[64];
+		uint32_t l[16];
+	} CHAR64LONG16;
+	CHAR64LONG16 realBlock;
+	CHAR64LONG16 *block= &realBlock;
+
+	(void)memcpy(block, buffer, SHA1_BLOCK_LENGTH);
+
+	/* Copy context->state[] to working vars */
+	a = state[0];
+	b = state[1];
+	c = state[2];
+	d = state[3];
+	e = state[4];
+
+	/* 4 rounds of 20 operations each. Loop unrolled. */
+	R0(a,b,c,d,e, 0); R0(e,a,b,c,d, 1); R0(d,e,a,b,c, 2); R0(c,d,e,a,b, 3);
+	R0(b,c,d,e,a, 4); R0(a,b,c,d,e, 5); R0(e,a,b,c,d, 6); R0(d,e,a,b,c, 7);
+	R0(c,d,e,a,b, 8); R0(b,c,d,e,a, 9); R0(a,b,c,d,e,10); R0(e,a,b,c,d,11);
+	R0(d,e,a,b,c,12); R0(c,d,e,a,b,13); R0(b,c,d,e,a,14); R0(a,b,c,d,e,15);
+	R1(e,a,b,c,d,16); R1(d,e,a,b,c,17); R1(c,d,e,a,b,18); R1(b,c,d,e,a,19);
+	R2(a,b,c,d,e,20); R2(e,a,b,c,d,21); R2(d,e,a,b,c,22); R2(c,d,e,a,b,23);
+	R2(b,c,d,e,a,24); R2(a,b,c,d,e,25); R2(e,a,b,c,d,26); R2(d,e,a,b,c,27);
+	R2(c,d,e,a,b,28); R2(b,c,d,e,a,29); R2(a,b,c,d,e,30); R2(e,a,b,c,d,31);
+	R2(d,e,a,b,c,32); R2(c,d,e,a,b,33); R2(b,c,d,e,a,34); R2(a,b,c,d,e,35);
+	R2(e,a,b,c,d,36); R2(d,e,a,b,c,37); R2(c,d,e,a,b,38); R2(b,c,d,e,a,39);
+	R3(a,b,c,d,e,40); R3(e,a,b,c,d,41); R3(d,e,a,b,c,42); R3(c,d,e,a,b,43);
+	R3(b,c,d,e,a,44); R3(a,b,c,d,e,45); R3(e,a,b,c,d,46); R3(d,e,a,b,c,47);
+	R3(c,d,e,a,b,48); R3(b,c,d,e,a,49); R3(a,b,c,d,e,50); R3(e,a,b,c,d,51);
+	R3(d,e,a,b,c,52); R3(c,d,e,a,b,53); R3(b,c,d,e,a,54); R3(a,b,c,d,e,55);
+	R3(e,a,b,c,d,56); R3(d,e,a,b,c,57); R3(c,d,e,a,b,58); R3(b,c,d,e,a,59);
+	R4(a,b,c,d,e,60); R4(e,a,b,c,d,61); R4(d,e,a,b,c,62); R4(c,d,e,a,b,63);
+	R4(b,c,d,e,a,64); R4(a,b,c,d,e,65); R4(e,a,b,c,d,66); R4(d,e,a,b,c,67);
+	R4(c,d,e,a,b,68); R4(b,c,d,e,a,69); R4(a,b,c,d,e,70); R4(e,a,b,c,d,71);
+	R4(d,e,a,b,c,72); R4(c,d,e,a,b,73); R4(b,c,d,e,a,74); R4(a,b,c,d,e,75);
+	R4(e,a,b,c,d,76); R4(d,e,a,b,c,77); R4(c,d,e,a,b,78); R4(b,c,d,e,a,79);
+
+	/* Add the working vars back into context.state[] */
+	state[0] += a;
+	state[1] += b;
+	state[2] += c;
+	state[3] += d;
+	state[4] += e;
+
+	/* Wipe variables */
+	a = b = c = d = e = 0;
+}
+
+
+/*
+ * SHA1Init - Initialize new context
+ */
+void
+SHA1Init(SHA1_CTX *context)
+{
+
+	/* SHA1 initialization constants */
+	context->count = 0;
+	context->state[0] = 0x67452301;
+	context->state[1] = 0xEFCDAB89;
+	context->state[2] = 0x98BADCFE;
+	context->state[3] = 0x10325476;
+	context->state[4] = 0xC3D2E1F0;
+}
+
+
+/*
+ * Run your data through this.
+ */
+void
+SHA1Update(SHA1_CTX *context, const uint8_t *data, size_t len)
+{
+	size_t i, j;
+
+	j = (size_t)((context->count >> 3) & 63);
+	context->count += (len << 3);
+	if ((j + len) > 63) {
+		(void)memcpy(&context->buffer[j], data, (i = 64-j));
+		SHA1Transform(context->state, context->buffer);
+		for ( ; i + 63 < len; i += 64)
+			SHA1Transform(context->state, (uint8_t *)&data[i]);
+		j = 0;
+	} else {
+		i = 0;
+	}
+	(void)memcpy(&context->buffer[j], &data[i], len - i);
+}
+
+
+/*
+ * Add padding and return the message digest.
+ */
+void
+SHA1Pad(SHA1_CTX *context)
+{
+	uint8_t finalcount[8];
+	u_int i;
+
+	for (i = 0; i < 8; i++) {
+		finalcount[i] = (uint8_t)((context->count >>
+		    ((7 - (i & 7)) * 8)) & 255);	/* Endian independent */
+	}
+	SHA1Update(context, (uint8_t *)"\200", 1);
+	while ((context->count & 504) != 448)
+		SHA1Update(context, (uint8_t *)"\0", 1);
+	SHA1Update(context, finalcount, 8); /* Should cause a SHA1Transform() */
+}
+
+void
+SHA1Final(uint8_t digest[SHA1_DIGEST_LENGTH], SHA1_CTX *context)
+{
+	u_int i;
+
+	SHA1Pad(context);
+	if (digest) {
+		for (i = 0; i < SHA1_DIGEST_LENGTH; i++) {
+			digest[i] = (uint8_t)
+			   ((context->state[i>>2] >> ((3-(i & 3)) * 8) ) & 255);
+		}
+		memset(context, 0, sizeof(*context));
+	}
+}
+
+} /* namespace drizzled */

=== added file 'drizzled/algorithm/sha1.h'
--- drizzled/algorithm/sha1.h	1970-01-01 00:00:00 +0000
+++ drizzled/algorithm/sha1.h	2010-03-19 22:19:04 +0000
@@ -0,0 +1,46 @@
+/*
+ * Copyright (C) 2010 nobody (this is public domain)
+ */
+
+/**
+ * @file
+ * @brief SHA1 Declarations
+ */
+
+#ifndef DRIZZLED_ALGORITHM_SHA1_H
+#define DRIZZLED_ALGORITHM_SHA1_H
+
+#include <stdint.h>
+#include <sys/types.h>
+
+namespace drizzled
+{
+
+/**
+ * @addtogroup sha1 SHA-1 in C
+ * By Steve Reid <steve@edmweb.com>
+ * 100% Public Domain
+ * @{
+ */
+
+#define	SHA1_BLOCK_LENGTH		64
+#define	SHA1_DIGEST_LENGTH		20
+#define	SHA1_DIGEST_STRING_LENGTH	(SHA1_DIGEST_LENGTH * 2 + 1)
+
+typedef struct {
+    uint32_t state[5];
+    uint64_t count;
+    uint8_t buffer[SHA1_BLOCK_LENGTH];
+} SHA1_CTX;
+
+void SHA1Init(SHA1_CTX *);
+void SHA1Pad(SHA1_CTX *);
+void SHA1Transform(uint32_t [5], const uint8_t [SHA1_BLOCK_LENGTH]);
+void SHA1Update(SHA1_CTX *, const uint8_t *, size_t);
+void SHA1Final(uint8_t [SHA1_DIGEST_LENGTH], SHA1_CTX *);
+
+/** @} */
+
+} /* namespace drizzled */
+
+#endif /* DRIZZLED_ALGORITHM_SHA1_H */

=== modified file 'drizzled/cached_directory.h'
--- drizzled/cached_directory.h	2010-02-05 08:11:15 +0000
+++ drizzled/cached_directory.h	2010-03-23 01:22:14 +0000
@@ -155,6 +155,22 @@
   bool open(const std::string &in_path, std::set<std::string> &allowable_exts);
   bool open(const std::string &in_path, std::set<std::string> &allowed_exts, enum CachedDirectory::FILTER filter);
 
+  friend std::ostream& operator<<(std::ostream& output, CachedDirectory &directory)
+  {
+    output << "CachedDirectory:(Path: " << directory.getPath() << ")\n";
+
+    CachedDirectory::Entries files= directory.getEntries();
+
+    for (CachedDirectory::Entries::iterator fileIter= files.begin();
+         fileIter != files.end(); fileIter++)
+    {
+      CachedDirectory::Entry *entry= *fileIter;
+      output << "\t(" << entry->filename << ")\n";
+    }
+
+    return output;  // for multiple << operators.
+  }
+
 };
 
 } /* namespace drizzled */

=== removed file 'drizzled/cost_vect.h'
--- drizzled/cost_vect.h	2010-02-04 08:14:46 +0000
+++ drizzled/cost_vect.h	1970-01-01 00:00:00 +0000
@@ -1,86 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_COST_VECT_H
-#define DRIZZLED_COST_VECT_H
-
-namespace drizzled
-{
-
-class COST_VECT
-{
-public:
-  double io_count;     /* number of I/O                 */
-  double avg_io_cost;  /* cost of an average I/O oper.  */
-  double cpu_cost;     /* cost of operations in CPU     */
-  double mem_cost;     /* cost of used memory           */
-  double import_cost;  /* cost of remote operations     */
-
-  static const uint32_t IO_COEFF=1;
-  static const uint32_t CPU_COEFF=1;
-  static const uint32_t MEM_COEFF=1;
-  static const uint32_t IMPORT_COEFF=1;
-
-  COST_VECT() :
-    io_count(0.0),
-    avg_io_cost(1.0),
-    cpu_cost(0.0),
-    mem_cost(0.0),
-    import_cost(0.0)
-  {}
-
-  double total_cost()
-  {
-    return IO_COEFF*io_count*avg_io_cost + CPU_COEFF * cpu_cost +
-      MEM_COEFF*mem_cost + IMPORT_COEFF*import_cost;
-  }
-
-  void zero()
-  {
-    avg_io_cost= 1.0;
-    io_count= cpu_cost= mem_cost= import_cost= 0.0;
-  }
-
-  void multiply(double m)
-  {
-    io_count *= m;
-    cpu_cost *= m;
-    import_cost *= m;
-    /* Don't multiply mem_cost */
-  }
-
-  void add(const COST_VECT* cost)
-  {
-    double io_count_sum= io_count + cost->io_count;
-    add_io(cost->io_count, cost->avg_io_cost);
-    io_count= io_count_sum;
-    cpu_cost += cost->cpu_cost;
-  }
-  void add_io(double add_io_cnt, double add_avg_cost)
-  {
-    double io_count_sum= io_count + add_io_cnt;
-    avg_io_cost= (io_count * avg_io_cost +
-                  add_io_cnt * add_avg_cost) / io_count_sum;
-    io_count= io_count_sum;
-  }
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_COST_VECT_H */

=== modified file 'drizzled/cursor.cc'
--- drizzled/cursor.cc	2010-03-16 21:30:44 +0000
+++ drizzled/cursor.cc	2010-03-23 10:05:10 +0000
@@ -32,7 +32,7 @@
 #include "drizzled/gettext.h"
 #include "drizzled/probes.h"
 #include "drizzled/sql_parse.h"
-#include "drizzled/cost_vect.h"
+#include "drizzled/optimizer/cost_vector.h"
 #include "drizzled/session.h"
 #include "drizzled/sql_base.h"
 #include "drizzled/transaction_services.h"
@@ -962,7 +962,7 @@
 Cursor::multi_range_read_info_const(uint32_t keyno, RANGE_SEQ_IF *seq,
                                      void *seq_init_param,
                                      uint32_t ,
-                                     uint32_t *bufsz, uint32_t *flags, COST_VECT *cost)
+                                     uint32_t *bufsz, uint32_t *flags, optimizer::CostVector *cost)
 {
   KEY_MULTI_RANGE range;
   range_seq_t seq_it;
@@ -1005,12 +1005,12 @@
     /* The following calculation is the same as in multi_range_read_info(): */
     *flags |= HA_MRR_USE_DEFAULT_IMPL;
     cost->zero();
-    cost->avg_io_cost= 1; /* assume random seeks */
+    cost->setAvgIOCost(1); /* assume random seeks */
     if ((*flags & HA_MRR_INDEX_ONLY) && total_rows > 2)
-      cost->io_count= index_only_read_time(keyno, (uint32_t)total_rows);
+      cost->setIOCount(index_only_read_time(keyno, (uint32_t)total_rows));
     else
-      cost->io_count= read_time(keyno, n_ranges, total_rows);
-    cost->cpu_cost= (double) total_rows / TIME_FOR_COMPARE + 0.01;
+      cost->setIOCount(read_time(keyno, n_ranges, total_rows));
+    cost->setCpuCost((double) total_rows / TIME_FOR_COMPARE + 0.01);
   }
   return total_rows;
 }
@@ -1051,20 +1051,20 @@
 */
 
 int Cursor::multi_range_read_info(uint32_t keyno, uint32_t n_ranges, uint32_t n_rows,
-                                   uint32_t *bufsz, uint32_t *flags, COST_VECT *cost)
+                                   uint32_t *bufsz, uint32_t *flags, optimizer::CostVector *cost)
 {
   *bufsz= 0; /* Default implementation doesn't need a buffer */
 
   *flags |= HA_MRR_USE_DEFAULT_IMPL;
 
   cost->zero();
-  cost->avg_io_cost= 1; /* assume random seeks */
+  cost->setAvgIOCost(1); /* assume random seeks */
 
   /* Produce the same cost as non-MRR code does */
   if (*flags & HA_MRR_INDEX_ONLY)
-    cost->io_count= index_only_read_time(keyno, n_rows);
+    cost->setIOCount(index_only_read_time(keyno, n_rows));
   else
-    cost->io_count= read_time(keyno, n_ranges, n_rows);
+    cost->setIOCount(read_time(keyno, n_ranges, n_rows));
   return 0;
 }
 
@@ -1450,18 +1450,18 @@
   {
     if (lock_type == F_RDLCK)
     {
-      DRIZZLE_CURSOR_RDLOCK_START(table_share->db.str,
-                                  table_share->table_name.str);
+      DRIZZLE_CURSOR_RDLOCK_START(table_share->getSchemaName(),
+                                  table_share->getTableName());
     }
     else if (lock_type == F_WRLCK)
     {
-      DRIZZLE_CURSOR_WRLOCK_START(table_share->db.str,
-                                  table_share->table_name.str);
+      DRIZZLE_CURSOR_WRLOCK_START(table_share->getSchemaName(),
+                                  table_share->getTableName());
     }
     else if (lock_type == F_UNLCK)
     {
-      DRIZZLE_CURSOR_UNLOCK_START(table_share->db.str,
-                                  table_share->table_name.str);
+      DRIZZLE_CURSOR_UNLOCK_START(table_share->getSchemaName(),
+                                  table_share->getTableName());
     }
   }
 
@@ -1528,7 +1528,7 @@
   if (table->timestamp_field_type & TIMESTAMP_AUTO_SET_ON_INSERT)
     table->timestamp_field->set_time();
 
-  DRIZZLE_INSERT_ROW_START(table_share->db.str, table_share->table_name.str);
+  DRIZZLE_INSERT_ROW_START(table_share->getSchemaName(), table_share->getTableName());
   setTransactionReadWrite();
   error= write_row(buf);
   DRIZZLE_INSERT_ROW_DONE(error);
@@ -1555,7 +1555,7 @@
    */
   assert(new_data == table->record[0]);
 
-  DRIZZLE_UPDATE_ROW_START(table_share->db.str, table_share->table_name.str);
+  DRIZZLE_UPDATE_ROW_START(table_share->getSchemaName(), table_share->getTableName());
   setTransactionReadWrite();
   error= update_row(old_data, new_data);
   DRIZZLE_UPDATE_ROW_DONE(error);
@@ -1575,7 +1575,7 @@
 {
   int error;
 
-  DRIZZLE_DELETE_ROW_START(table_share->db.str, table_share->table_name.str);
+  DRIZZLE_DELETE_ROW_START(table_share->getSchemaName(), table_share->getTableName());
   setTransactionReadWrite();
   error= delete_row(buf);
   DRIZZLE_DELETE_ROW_DONE(error);

=== modified file 'drizzled/cursor.h'
--- drizzled/cursor.h	2010-03-16 23:08:03 +0000
+++ drizzled/cursor.h	2010-03-23 23:08:36 +0000
@@ -39,8 +39,6 @@
 /* Bits to show what an alter table will do */
 #include <drizzled/sql_bitmap.h>
 
-#include <drizzled/cursor.h>
-
 #include <bitset>
 #include <algorithm>
 
@@ -90,7 +88,10 @@
 
 typedef struct system_status_var system_status_var;
 
-class COST_VECT;
+namespace optimizer
+{
+  class CostVector;
+}
 
 uint32_t calculate_key_len(Table *, uint, const unsigned char *, key_part_map);
 /*
@@ -298,9 +299,9 @@
   virtual ha_rows multi_range_read_info_const(uint32_t keyno, RANGE_SEQ_IF *seq,
                                               void *seq_init_param,
                                               uint32_t n_ranges, uint32_t *bufsz,
-                                              uint32_t *flags, COST_VECT *cost);
+                                              uint32_t *flags, optimizer::CostVector *cost);
   virtual int multi_range_read_info(uint32_t keyno, uint32_t n_ranges, uint32_t keys,
-                                    uint32_t *bufsz, uint32_t *flags, COST_VECT *cost);
+                                    uint32_t *bufsz, uint32_t *flags, optimizer::CostVector *cost);
   virtual int multi_range_read_init(RANGE_SEQ_IF *seq, void *seq_init_param,
                                     uint32_t n_ranges, uint32_t mode,
                                     HANDLER_BUFFER *buf);
@@ -720,8 +721,7 @@
                                 HA_CREATE_INFO *create_info,
                                 message::Table &table_proto,
                                 AlterInfo *alter_info,
-                                bool tmp_table,
-                                uint32_t select_field_count,
+                                bool tmp_table, uint32_t select_field_count,
                                 bool is_if_not_exists);
 
 bool mysql_create_like_table(Session* session,
@@ -731,9 +731,10 @@
                              bool is_if_not_exists,
                              bool is_engine_set);
 
-bool mysql_rename_table(plugin::StorageEngine *base, const char *old_db,
-                        const char * old_name, const char *new_db,
-                        const char * new_name, uint32_t flags);
+bool mysql_rename_table(plugin::StorageEngine *base,
+                        TableIdentifier &old_identifier,
+                        TableIdentifier &new_identifier,
+                        uint32_t flags);
 
 bool mysql_prepare_update(Session *session, TableList *table_list,
                           Item **conds, uint32_t order_num, order_st *order);

=== modified file 'drizzled/db.cc'
--- drizzled/db.cc	2010-03-18 01:23:59 +0000
+++ drizzled/db.cc	2010-03-23 01:22:14 +0000
@@ -231,6 +231,17 @@
     return -1;
   }
 
+  // Lets delete the temporary tables first outside of locks.  
+  set<string> set_of_names;
+  session->doGetTableNames(schema_name, set_of_names);
+
+  for (set<string>::iterator iter= set_of_names.begin(); iter != set_of_names.end(); iter++)
+  {
+    TableIdentifier identifier(schema_name, *iter, TEMP_TABLE);
+    Table *table= session->find_temporary_table(identifier);
+    session->close_temporary_table(table);
+  }
+
   pthread_mutex_lock(&LOCK_create_db);
 
 
@@ -348,10 +359,13 @@
 
   for (table= tables; table; table= table->next_local)
   {
+    TableIdentifier identifier(table->db, table->table_name);
     TableShare *share;
     table->db_type= NULL;
-    if ((share= TableShare::getShare(table->db, table->table_name)))
+    if ((share= TableShare::getShare(identifier)))
+    {
       table->db_type= share->db_type();
+    }
   }
 
   if (lock_table_names_exclusively(session, tables))

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-03-16 23:08:03 +0000
+++ drizzled/drizzled.cc	2010-03-25 09:08:56 +0000
@@ -376,7 +376,7 @@
 extern "C" pthread_handler_t signal_hand(void *arg);
 static void drizzle_init_variables(void);
 static void get_options(int *argc,char **argv);
-bool drizzled_get_one_option(int, const struct my_option *, char *);
+int drizzled_get_one_option(int, const struct my_option *, char *);
 static int init_thread_environment();
 static const char *get_relative_path(const char *path);
 static void fix_paths(string &progname);
@@ -1870,7 +1870,7 @@
 }
 
 
-bool drizzled_get_one_option(int optid, const struct my_option *opt,
+int drizzled_get_one_option(int optid, const struct my_option *opt,
                              char *argument)
 {
   switch(optid) {
@@ -1938,14 +1938,14 @@
       if (getaddrinfo(argument, NULL, &hints, &res_lst) != 0)
       {
           errmsg_printf(ERRMSG_LVL_ERROR, _("Can't start server: cannot resolve hostname!"));
-        exit(1);
+        return EXIT_ARGUMENT_INVALID;
       }
 
       if (res_lst->ai_next)
       {
           errmsg_printf(ERRMSG_LVL_ERROR, _("Can't start server: bind-address refers to "
                           "multiple interfaces!"));
-        exit(1);
+        return EXIT_ARGUMENT_INVALID;
       }
       freeaddrinfo(res_lst);
     }

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2010-02-14 19:27:57 +0000
+++ drizzled/filesort.cc	2010-03-23 10:05:10 +0000
@@ -148,7 +148,7 @@
   TableList *tab= table->pos_in_table_list;
   Item_subselect *subselect= tab ? tab->containing_subselect() : 0;
 
-  DRIZZLE_FILESORT_START(table->s->db.str, table->s->table_name.str);
+  DRIZZLE_FILESORT_START(table->s->getSchemaName(), table->s->getTableName());
 
   /*
    Release InnoDB's adaptive hash index latch (if holding) before

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-03-18 11:20:28 +0000
+++ drizzled/include.am	2010-03-22 17:38:58 +0000
@@ -52,7 +52,6 @@
 			      drizzled/check_stack_overrun.h \
 			      drizzled/common.h \
 			      drizzled/comp_creator.h \
-			      drizzled/cost_vect.h \
 			      drizzled/create_field.h \
 			      drizzled/current_session.h \
 			      drizzled/data_home.h \
@@ -268,6 +267,7 @@
 			      drizzled/natural_join_column.h \
 			      drizzled/nested_join.h \
 			      drizzled/open_tables_state.h \
+                              drizzled/optimizer/cost_vector.h \
 			      drizzled/optimizer/key_field.h \
 			      drizzled/optimizer/key_use.h \
 			      drizzled/optimizer/explain_plan.h \
@@ -292,6 +292,8 @@
 			      drizzled/plugin/authentication.h \
 			      drizzled/plugin/authorization.h \
 			      drizzled/plugin/client.h \
+			      drizzled/plugin/context.h \
+			      drizzled/plugin/daemon.h \
 			      drizzled/plugin/error_message.h \
 			      drizzled/plugin/function.h \
 			      drizzled/plugin/library.h \

=== modified file 'drizzled/message/statement_transform.cc'
--- drizzled/message/statement_transform.cc	2010-03-15 23:02:06 +0000
+++ drizzled/message/statement_transform.cc	2010-03-24 19:36:31 +0000
@@ -819,7 +819,7 @@
 enum TransformSqlError
 transformTableDefinitionToSql(const Table &table,
                               string &destination,
-                              enum TransformSqlVariant sql_variant)
+                              enum TransformSqlVariant sql_variant, bool with_schema)
 {
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
@@ -831,6 +831,13 @@
     destination.append("TEMPORARY ", 10);
   
   destination.append("TABLE ", 6);
+  if (with_schema)
+  {
+    destination.push_back(quoted_identifier);
+    destination.append(table.schema());
+    destination.push_back(quoted_identifier);
+    destination.push_back('.');
+  }
   destination.push_back(quoted_identifier);
   destination.append(table.name());
   destination.push_back(quoted_identifier);
@@ -1112,11 +1119,11 @@
     break;
   case Table::Field::ENUM:
     {
-      size_t num_field_values= field.set_options().field_value_size();
+      size_t num_field_values= field.enumeration_values().field_value_size();
       destination.append(" ENUM(", 6);
       for (size_t x= 0; x < num_field_values; ++x)
       {
-        const string &type= field.set_options().field_value(x);
+        const string &type= field.enumeration_values().field_value(x);
 
         if (x != 0)
           destination.push_back(',');

=== modified file 'drizzled/message/statement_transform.h'
--- drizzled/message/statement_transform.h	2010-03-15 23:02:06 +0000
+++ drizzled/message/statement_transform.h	2010-03-23 23:08:36 +0000
@@ -389,7 +389,8 @@
 enum TransformSqlError
 transformTableDefinitionToSql(const Table &table,
                               std::string &destination,
-                              enum TransformSqlVariant sql_variant= DRIZZLE);
+                              enum TransformSqlVariant sql_variant= DRIZZLE,
+                              bool with_schema= false);
 
 /**
  * Appends to the supplied string an SQL expression

=== modified file 'drizzled/message/table.proto'
--- drizzled/message/table.proto	2010-03-17 19:19:39 +0000
+++ drizzled/message/table.proto	2010-03-24 19:36:31 +0000
@@ -124,7 +124,7 @@
       optional string collation = 4;
     }
 
-    message SetFieldOptions {
+    message EnumerationValues {
       optional uint32 collation_id = 2;
       optional string collation = 3;
       repeated string field_value = 4;
@@ -139,7 +139,7 @@
     optional StringFieldOptions string_options = 7;
 
     optional string comment = 16; /* Reserve 0-15 for frequently accessed attributes */
-    optional SetFieldOptions set_options = 17;
+    optional EnumerationValues enumeration_values = 17;
     optional TimestampFieldOptions timestamp_options = 18;
   }
 
@@ -194,6 +194,7 @@
   optional TableStats stats = 10;
   required uint64 creation_timestamp= 11 [default = 0];
   required uint64 update_timestamp= 12 [default = 0];
+  optional string catalog = 13;
 }
 
 message AlterTable {

=== modified file 'drizzled/message/table_reader.cc'
--- drizzled/message/table_reader.cc	2010-02-26 20:48:50 +0000
+++ drizzled/message/table_reader.cc	2010-03-23 23:08:36 +0000
@@ -76,7 +76,7 @@
   }
 
   string output;
-  (void) message::transformTableDefinitionToSql(table, output);
+  (void) message::transformTableDefinitionToSql(table, output, message::DRIZZLE, true);
 
   cout << output << endl;
 

=== modified file 'drizzled/message/table_writer.cc'
--- drizzled/message/table_writer.cc	2010-03-17 05:21:31 +0000
+++ drizzled/message/table_writer.cc	2010-03-24 19:36:31 +0000
@@ -107,7 +107,7 @@
   message::Table::Field::FieldConstraints *field_constraints;
   message::Table::Field::StringFieldOptions *string_field_options;
   message::Table::Field::NumericFieldOptions *numeric_field_options;
-  message::Table::Field::SetFieldOptions *set_field_options;
+  message::Table::Field::EnumerationValues *enumeration_options;
 
   table->set_name(name);
   table->set_type(message::Table::STANDARD);
@@ -147,10 +147,10 @@
     field->set_type(message::Table::Field::ENUM);
     field->set_name("colors");
 
-    set_field_options= field->mutable_set_options();
-    set_field_options->add_field_value("red");
-    set_field_options->add_field_value("blue");
-    set_field_options->add_field_value("green");
+    enumeration_options= field->mutable_enumeration_values();
+    enumeration_options->add_field_value("red");
+    enumeration_options->add_field_value("blue");
+    enumeration_options->add_field_value("green");
   }
   /* Write out a BLOB */
   {

=== modified file 'drizzled/my_getopt.cc'
--- drizzled/my_getopt.cc	2010-02-13 02:23:32 +0000
+++ drizzled/my_getopt.cc	2010-03-25 09:08:56 +0000
@@ -32,1244 +32,1258 @@
 namespace drizzled
 {
 
-typedef void (*init_func_p)(const struct my_option *option, char **variable,
-                            int64_t value);
-
-void default_reporter(enum loglevel level, const char *format, ...);
-my_error_reporter my_getopt_error_reporter= &default_reporter;
-
-static int findopt(char *optpat, uint32_t length,
-		   const struct my_option **opt_res,
-		   char **ffname);
-static int64_t getopt_ll(char *arg, const struct my_option *optp, int *err);
-static uint64_t getopt_ull(char *arg, const struct my_option *optp,
-			    int *err);
-static size_t getopt_size(char *arg, const struct my_option *optp, int *err);
-static double getopt_double(char *arg, const struct my_option *optp, int *err);
-static void init_variables(const struct my_option *options,
-                           init_func_p init_one_value);
-static void init_one_value(const struct my_option *option, char **variable,
-			   int64_t value);
-static void fini_one_value(const struct my_option *option, char **variable,
-			   int64_t value);
-static int setval(const struct my_option *opts, char* *value, char *argument,
-		  bool set_maximum_value);
-static char *check_struct_option(char *cur_arg, char *key_name);
-
-/*
-  The following three variables belong to same group and the number and
-  order of their arguments must correspond to each other.
-*/
-static const char *special_opt_prefix[]=
-{"skip", "disable", "enable", "maximum", "loose", 0};
-static const uint32_t special_opt_prefix_lengths[]=
-{ 4,      7,         6,        7,         5,      0};
-enum enum_special_opt
-{ OPT_SKIP, OPT_DISABLE, OPT_ENABLE, OPT_MAXIMUM, OPT_LOOSE};
-
-char *disabled_my_option= (char*) "0";
-
-/*
-   This is a flag that can be set in client programs. 1 means that
-   my_getopt will skip over options it does not know how to handle.
-*/
-
-bool my_getopt_skip_unknown= 0;
-
-void default_reporter(enum loglevel level, const char *format, ...)
-{
-  va_list args;
-  va_start(args, format);
-  if (level == WARNING_LEVEL)
-    fprintf(stderr, "%s", _("Warning: "));
-  else if (level == INFORMATION_LEVEL)
-    fprintf(stderr, "%s", _("Info: "));
-  vfprintf(stderr, format, args);
-  va_end(args);
-  fputc('\n', stderr);
-  fflush(stderr);
-}
-
-/*
-  function: handle_options
-
-  Sort options; put options first, until special end of options (--), or
-  until end of argv. Parse options; check that the given option matches with
-  one of the options in struct 'my_option', return error in case of ambiguous
-  or unknown option. Check that option was given an argument if it requires
-  one. Call function 'get_one_option()' once for each option.
-*/
-
-static getopt_get_addr_func getopt_get_addr;
-
-int handle_options(int *argc, char ***argv,
-		   const struct my_option *longopts,
-                   my_get_one_option get_one_option)
-{
-  uint32_t opt_found, argvpos= 0, length;
-  bool end_of_options= 0, must_be_var, set_maximum_value=false,
-          option_is_loose;
-  char **pos, **pos_end, *optend, *prev_found=NULL,
-       *opt_str, key_name[FN_REFLEN];
-  const struct my_option *optp;
-  char* *value;
-  int error, i;
-
-  /* handle_options() assumes arg0 (program name) always exists */
-  assert(argc && *argc >= 1);
-  assert(argv && *argv);
-  (*argc)--; /* Skip the program name */
-  (*argv)++; /*      --- || ----      */
-  init_variables(longopts, init_one_value);
-
-  for (pos= *argv, pos_end=pos+ *argc; pos != pos_end ; pos++)
-  {
-    char **first= pos;
-    char *cur_arg= *pos;
-    if (cur_arg[0] == '-' && cur_arg[1] && !end_of_options) /* must be opt */
+  typedef void (*init_func_p)(const struct my_option *option, char **variable,
+      int64_t value);
+
+  void default_reporter(enum loglevel level, const char *format, ...);
+  my_error_reporter my_getopt_error_reporter= &default_reporter;
+
+  static int findopt(char *optpat, uint32_t length,
+      const struct my_option **opt_res,
+      char **ffname);
+  static int64_t getopt_ll(char *arg, const struct my_option *optp, int *err);
+  static uint64_t getopt_ull(char *arg, const struct my_option *optp,
+      int *err);
+  static size_t getopt_size(char *arg, const struct my_option *optp, int *err);
+  static double getopt_double(char *arg, const struct my_option *optp, int *err);
+  static void init_variables(const struct my_option *options,
+      init_func_p init_one_value);
+  static void init_one_value(const struct my_option *option, char **variable,
+      int64_t value);
+  static void fini_one_value(const struct my_option *option, char **variable,
+      int64_t value);
+  static int setval(const struct my_option *opts, char* *value, char *argument,
+      bool set_maximum_value);
+  static char *check_struct_option(char *cur_arg, char *key_name);
+
+  /*
+     The following three variables belong to same group and the number and
+     order of their arguments must correspond to each other.
+   */
+  static const char *special_opt_prefix[]=
+  {"skip", "disable", "enable", "maximum", "loose", 0};
+  static const uint32_t special_opt_prefix_lengths[]=
+  { 4,      7,         6,        7,         5,      0};
+  enum enum_special_opt
+  { OPT_SKIP, OPT_DISABLE, OPT_ENABLE, OPT_MAXIMUM, OPT_LOOSE};
+
+  char *disabled_my_option= (char*) "0";
+
+  /*
+     This is a flag that can be set in client programs. 1 means that
+     my_getopt will skip over options it does not know how to handle.
+   */
+
+  bool my_getopt_skip_unknown= 0;
+
+  void default_reporter(enum loglevel level, const char *format, ...)
+  {
+    va_list args;
+    va_start(args, format);
+    if (level == WARNING_LEVEL)
+      fprintf(stderr, "%s", _("Warning: "));
+    else if (level == INFORMATION_LEVEL)
+      fprintf(stderr, "%s", _("Info: "));
+    vfprintf(stderr, format, args);
+    va_end(args);
+    fputc('\n', stderr);
+    fflush(stderr);
+  }
+
+  /*
+function: handle_options
+
+Sort options; put options first, until special end of options (--), or
+until end of argv. Parse options; check that the given option matches with
+one of the options in struct 'my_option', return error in case of ambiguous
+or unknown option. Check that option was given an argument if it requires
+one. Call function 'get_one_option()' once for each option.
+   */
+
+  static getopt_get_addr_func getopt_get_addr;
+
+  int handle_options(int *argc, char ***argv,
+      const struct my_option *longopts,
+      my_get_one_option get_one_option)
+  {
+    uint32_t opt_found, argvpos= 0, length;
+    bool end_of_options= 0, must_be_var, set_maximum_value=false,
+         option_is_loose;
+    char **pos, **pos_end, *optend, *prev_found=NULL,
+         *opt_str, key_name[FN_REFLEN];
+    const struct my_option *optp;
+    char* *value;
+    int error, i;
+
+    /* handle_options() assumes arg0 (program name) always exists */
+    assert(argc && *argc >= 1);
+    assert(argv && *argv);
+    (*argc)--; /* Skip the program name */
+    (*argv)++; /*      --- || ----      */
+    init_variables(longopts, init_one_value);
+
+    for (pos= *argv, pos_end=pos+ *argc; pos != pos_end ; pos++)
     {
-      char *argument=    0;
-      must_be_var=       0;
-      set_maximum_value= 0;
-      option_is_loose=   0;
-
-      cur_arg++;		/* skip '-' */
-      if (*cur_arg == '-' || *cur_arg == 'O') /* check for long option, */
-      {                                       /* --set-variable, or -O  */
-	if (*cur_arg == 'O')
-	{
-	  must_be_var= 1;
-
-	  if (!(*++cur_arg))	/* If not -Ovar=# */
-	  {
-	    /* the argument must be in next argv */
-	    if (!*++pos)
-	    {
-              my_getopt_error_reporter(ERROR_LEVEL,
-                                       "%s: Option '-O' requires an argument",
-                                       internal::my_progname);
-	      return EXIT_ARGUMENT_REQUIRED;
-	    }
-	    cur_arg= *pos;
-	    (*argc)--;
-	  }
-	}
-	else if (!getopt_compare_strings(cur_arg, "-set-variable", 13))
-	{
-	  must_be_var= 1;
-	  if (cur_arg[13] == '=')
-	  {
-	    cur_arg+= 14;
-	    if (!*cur_arg)
-	    {
-              my_getopt_error_reporter(ERROR_LEVEL,
-                                       "%s: Option '--set-variable' requires an argument",
-                                       internal::my_progname);
-	      return EXIT_ARGUMENT_REQUIRED;
-	    }
-	  }
-	  else if (cur_arg[14]) /* garbage, or another option. break out */
-	    must_be_var= 0;
-	  else
-	  {
-	    /* the argument must be in next argv */
-	    if (!*++pos)
-	    {
-              my_getopt_error_reporter(ERROR_LEVEL,
-                                       "%s: Option '--set-variable' requires an argument",
-                                       internal::my_progname);
-	      return EXIT_ARGUMENT_REQUIRED;
-	    }
-	    cur_arg= *pos;
-	    (*argc)--;
-	  }
-	}
-	else if (!must_be_var)
-	{
-	  if (!*++cur_arg)	/* skip the double dash */
-	  {
-	    /* '--' means end of options, look no further */
-	    end_of_options= 1;
-	    (*argc)--;
-	    continue;
-	  }
-	}
-	opt_str= check_struct_option(cur_arg, key_name);
-	optend= strrchr(opt_str, '=');
-	if (optend != NULL)
-        {
-	  length= (uint32_t) (optend - opt_str);
-	  optend++;
-        }
-	else
-        {
-          length= static_cast<uint32_t>(strlen(opt_str));
-	  optend= 0;
-        }
-
-	/*
-	  Find first the right option. Return error in case of an ambiguous,
-	  or unknown option
-	*/
-	optp= longopts;
-	if (!(opt_found= findopt(opt_str, length, &optp, &prev_found)))
-	{
-	  /*
-	    Didn't find any matching option. Let's see if someone called
-	    option with a special option prefix
-	  */
-	  if (!must_be_var)
-	  {
-	    if (optend)
-	      must_be_var= 1; /* option is followed by an argument */
-	    for (i= 0; special_opt_prefix[i]; i++)
-	    {
-	      if (!getopt_compare_strings(special_opt_prefix[i], opt_str,
-					  special_opt_prefix_lengths[i]) &&
-		  (opt_str[special_opt_prefix_lengths[i]] == '-' ||
-		   opt_str[special_opt_prefix_lengths[i]] == '_'))
-	      {
-		/*
-		  We were called with a special prefix, we can reuse opt_found
-		*/
-		opt_str+= special_opt_prefix_lengths[i] + 1;
-                length-= special_opt_prefix_lengths[i] + 1;
-		if (i == OPT_LOOSE)
-		  option_is_loose= 1;
-		if ((opt_found= findopt(opt_str, length, &optp, &prev_found)))
-		{
-		  if (opt_found > 1)
-		  {
-                    my_getopt_error_reporter(ERROR_LEVEL,
-                                             "%s: ambiguous option '--%s-%s' (--%s-%s)",
-                                             internal::my_progname,
-                                             special_opt_prefix[i],
-                                             cur_arg, special_opt_prefix[i],
-                                             prev_found);
-		    return EXIT_AMBIGUOUS_OPTION;
-		  }
-		  switch (i) {
-		  case OPT_SKIP:
-		  case OPT_DISABLE: /* fall through */
-		    /*
-		      double negation is actually enable again,
-		      for example: --skip-option=0 -> option = true
-		    */
-		    optend= (optend && *optend == '0' && !(*(optend + 1))) ?
-		      (char*) "1" : disabled_my_option;
-		    break;
-		  case OPT_ENABLE:
-		    optend= (optend && *optend == '0' && !(*(optend + 1))) ?
-                      disabled_my_option : (char*) "1";
-		    break;
-		  case OPT_MAXIMUM:
-		    set_maximum_value= true;
-		    must_be_var= true;
-		    break;
-		  }
-		  break; /* break from the inner loop, main loop continues */
-		}
-                i= -1; /* restart the loop */
-	      }
-	    }
-	  }
-	  if (!opt_found)
-	  {
-            if (my_getopt_skip_unknown)
+      char **first= pos;
+      char *cur_arg= *pos;
+      if (cur_arg[0] == '-' && cur_arg[1] && !end_of_options) /* must be opt */
+      {
+        char *argument=    0;
+        must_be_var=       0;
+        set_maximum_value= 0;
+        option_is_loose=   0;
+
+        cur_arg++;  /* skip '-' */
+        if (*cur_arg == '-' || *cur_arg == 'O') /* check for long option, */
+        {                                       /* --set-variable, or -O  */
+          if (*cur_arg == 'O')
+          {
+            must_be_var= 1;
+
+            if (!(*++cur_arg))	/* If not -Ovar=# */
+            {
+              /* the argument must be in next argv */
+              if (!*++pos)
+              {
+                my_getopt_error_reporter(ERROR_LEVEL,
+                    "%s: Option '-O' requires an argument",
+                    internal::my_progname);
+                return EXIT_ARGUMENT_REQUIRED;
+              }
+              cur_arg= *pos;
+              (*argc)--;
+            }
+          }
+          else if (!getopt_compare_strings(cur_arg, "-set-variable", 13))
+          {
+            must_be_var= 1;
+            if (cur_arg[13] == '=')
+            {
+              cur_arg+= 14;
+              if (!*cur_arg)
+              {
+                my_getopt_error_reporter(ERROR_LEVEL,
+                    "%s: Option '--set-variable' requires an argument",
+                    internal::my_progname);
+                return EXIT_ARGUMENT_REQUIRED;
+              }
+            }
+            else if (cur_arg[14]) /* garbage, or another option. break out */
+              must_be_var= 0;
+            else
+            {
+              /* the argument must be in next argv */
+              if (!*++pos)
+              {
+                my_getopt_error_reporter(ERROR_LEVEL,
+                    "%s: Option '--set-variable' requires an argument",
+                    internal::my_progname);
+                return EXIT_ARGUMENT_REQUIRED;
+              }
+              cur_arg= *pos;
+              (*argc)--;
+            }
+          }
+          else if (!must_be_var)
+          {
+            if (!*++cur_arg)	/* skip the double dash */
+            {
+              /* '--' means end of options, look no further */
+              end_of_options= 1;
+              (*argc)--;
+              continue;
+            }
+          }
+          opt_str= check_struct_option(cur_arg, key_name);
+          optend= strrchr(opt_str, '=');
+          if (optend != NULL)
+          {
+            length= (uint32_t) (optend - opt_str);
+            optend++;
+          }
+          else
+          {
+            length= static_cast<uint32_t>(strlen(opt_str));
+            optend= 0;
+          }
+
+          /*
+             Find first the right option. Return error in case of an ambiguous,
+             or unknown option
+           */
+          optp= longopts;
+          if (!(opt_found= findopt(opt_str, length, &optp, &prev_found)))
+          {
+            /*
+               Didn't find any matching option. Let's see if someone called
+               option with a special option prefix
+             */
+            if (!must_be_var)
+            {
+              if (optend)
+                must_be_var= 1; /* option is followed by an argument */
+              for (i= 0; special_opt_prefix[i]; i++)
+              {
+                if (!getopt_compare_strings(special_opt_prefix[i], opt_str,
+                      special_opt_prefix_lengths[i]) &&
+                    (opt_str[special_opt_prefix_lengths[i]] == '-' ||
+                     opt_str[special_opt_prefix_lengths[i]] == '_'))
+                {
+                  /*
+                     We were called with a special prefix, we can reuse opt_found
+                   */
+                  opt_str+= special_opt_prefix_lengths[i] + 1;
+                  length-= special_opt_prefix_lengths[i] + 1;
+                  if (i == OPT_LOOSE)
+                    option_is_loose= 1;
+                  if ((opt_found= findopt(opt_str, length, &optp, &prev_found)))
+                  {
+                    if (opt_found > 1)
+                    {
+                      my_getopt_error_reporter(ERROR_LEVEL,
+                          "%s: ambiguous option '--%s-%s' (--%s-%s)",
+                          internal::my_progname,
+                          special_opt_prefix[i],
+                          cur_arg, special_opt_prefix[i],
+                          prev_found);
+                      return EXIT_AMBIGUOUS_OPTION;
+                    }
+                    switch (i) {
+                      case OPT_SKIP:
+                      case OPT_DISABLE: /* fall through */
+                        /*
+                           double negation is actually enable again,
+                           for example: --skip-option=0 -> option = true
+                         */
+                        optend= (optend && *optend == '0' && !(*(optend + 1))) ?
+                          (char*) "1" : disabled_my_option;
+                        break;
+                      case OPT_ENABLE:
+                        optend= (optend && *optend == '0' && !(*(optend + 1))) ?
+                          disabled_my_option : (char*) "1";
+                        break;
+                      case OPT_MAXIMUM:
+                        set_maximum_value= true;
+                        must_be_var= true;
+                        break;
+                    }
+                    break; /* break from the inner loop, main loop continues */
+                  }
+                  i= -1; /* restart the loop */
+                }
+              }
+            }
+            if (!opt_found)
+            {
+              if (my_getopt_skip_unknown)
+              {
+                /*
+                   preserve all the components of this unknown option, this may
+                   occurr when the user provides options like: "-O foo" or
+                   "--set-variable foo" (note that theres a space in there)
+                   Generally, these kind of options are to be avoided
+                 */
+                do {
+                  (*argv)[argvpos++]= *first++;
+                } while (first <= pos);
+                continue;
+              }
+              if (must_be_var)
+              {
+                my_getopt_error_reporter(option_is_loose ?
+                    WARNING_LEVEL : ERROR_LEVEL,
+                    "%s: unknown variable '%s'",
+                    internal::my_progname, cur_arg);
+                if (!option_is_loose)
+                  return EXIT_UNKNOWN_VARIABLE;
+              }
+              else
+              {
+                my_getopt_error_reporter(option_is_loose ?
+                    WARNING_LEVEL : ERROR_LEVEL,
+                    "%s: unknown option '--%s'",
+                    internal::my_progname, cur_arg);
+                if (!option_is_loose)
+                  return EXIT_UNKNOWN_OPTION;
+              }
+              if (option_is_loose)
+              {
+                (*argc)--;
+                continue;
+              }
+            }
+          }
+          if (opt_found > 1)
+          {
+            if (must_be_var)
+            {
+              my_getopt_error_reporter(ERROR_LEVEL,
+                  "%s: variable prefix '%s' is not unique",
+                  internal::my_progname, opt_str);
+              return EXIT_VAR_PREFIX_NOT_UNIQUE;
+            }
+            else
+            {
+              my_getopt_error_reporter(ERROR_LEVEL,
+                  "%s: ambiguous option '--%s' (%s, %s)",
+                  internal::my_progname, opt_str, prev_found,
+                  optp->name);
+              return EXIT_AMBIGUOUS_OPTION;
+            }
+          }
+          if ((optp->var_type & GET_TYPE_MASK) == GET_DISABLED)
+          {
+            fprintf(stderr,
+                _("%s: %s: Option '%s' used, but is disabled\n"),
+                internal::my_progname,
+                option_is_loose ? _("WARNING") : _("ERROR"), opt_str);
+            if (option_is_loose)
+            {
+              (*argc)--;
+              continue;
+            }
+            return EXIT_OPTION_DISABLED;
+          }
+          if (must_be_var && (optp->var_type & GET_TYPE_MASK) == GET_NO_ARG)
+          {
+            my_getopt_error_reporter(ERROR_LEVEL,
+                "%s: option '%s' cannot take an argument",
+                internal::my_progname, optp->name);
+            return EXIT_NO_ARGUMENT_ALLOWED;
+          }
+          value= optp->var_type & GET_ASK_ADDR ?
+            (*getopt_get_addr)(key_name, (uint32_t) strlen(key_name), optp) : optp->value;
+
+          if (optp->arg_type == NO_ARG)
+          {
+            if (optend && (optp->var_type & GET_TYPE_MASK) != GET_BOOL)
+            {
+              my_getopt_error_reporter(ERROR_LEVEL,
+                  "%s: option '--%s' cannot take an argument",
+                  internal::my_progname, optp->name);
+              return EXIT_NO_ARGUMENT_ALLOWED;
+            }
+            if ((optp->var_type & GET_TYPE_MASK) == GET_BOOL)
             {
               /*
-                preserve all the components of this unknown option, this may
-                occurr when the user provides options like: "-O foo" or
-                "--set-variable foo" (note that theres a space in there)
-                Generally, these kind of options are to be avoided
-              */
-              do {
-                (*argv)[argvpos++]= *first++;
-              } while (first <= pos);
-              continue;
-            }
-	    if (must_be_var)
-	    {
-              my_getopt_error_reporter(option_is_loose ?
-                                       WARNING_LEVEL : ERROR_LEVEL,
-                                       "%s: unknown variable '%s'",
-                                       internal::my_progname, cur_arg);
-	      if (!option_is_loose)
-		return EXIT_UNKNOWN_VARIABLE;
-	    }
-	    else
-	    {
-              my_getopt_error_reporter(option_is_loose ?
-                                       WARNING_LEVEL : ERROR_LEVEL,
-                                       "%s: unknown option '--%s'",
-                                       internal::my_progname, cur_arg);
-	      if (!option_is_loose)
-		return EXIT_UNKNOWN_OPTION;
-	    }
-	    if (option_is_loose)
-	    {
-	      (*argc)--;
-	      continue;
-	    }
-	  }
-	}
-	if (opt_found > 1)
-	{
-	  if (must_be_var)
-	  {
-            my_getopt_error_reporter(ERROR_LEVEL,
-                                     "%s: variable prefix '%s' is not unique",
-                                     internal::my_progname, opt_str);
-	    return EXIT_VAR_PREFIX_NOT_UNIQUE;
-	  }
-	  else
-	  {
-            my_getopt_error_reporter(ERROR_LEVEL,
-                                     "%s: ambiguous option '--%s' (%s, %s)",
-                                     internal::my_progname, opt_str, prev_found,
-                                     optp->name);
-	    return EXIT_AMBIGUOUS_OPTION;
-	  }
-	}
-	if ((optp->var_type & GET_TYPE_MASK) == GET_DISABLED)
-	{
-          fprintf(stderr,
-                  _("%s: %s: Option '%s' used, but is disabled\n"),
-                  internal::my_progname,
-                  option_is_loose ? _("WARNING") : _("ERROR"), opt_str);
-	  if (option_is_loose)
-	  {
-	    (*argc)--;
-	    continue;
-	  }
-	  return EXIT_OPTION_DISABLED;
-	}
-	if (must_be_var && (optp->var_type & GET_TYPE_MASK) == GET_NO_ARG)
-	{
+                 Set bool to 1 if no argument or if the user has used
+                 --enable-'option-name'.
+               *optend was set to '0' if one used --disable-option
+               */
+              (*argc)--;
+              if (!optend || *optend == '1' ||
+                  !my_strcasecmp(&my_charset_utf8_general_ci, optend, "true"))
+                *((bool*) value)= (bool) 1;
+              else if (*optend == '0' ||
+                  !my_strcasecmp(&my_charset_utf8_general_ci, optend, "false"))
+                *((bool*) value)= (bool) 0;
+              else
+              {
+                my_getopt_error_reporter(WARNING_LEVEL,
+                    "%s: ignoring option '--%s' due to "
+                    "invalid value '%s'",
+                    internal::my_progname,
+                    optp->name, optend);
+                continue;
+              }
+              error= get_one_option(optp->id, optp, *((bool*) value) ?
+                                    (char*) "1" : disabled_my_option);
+              if (error != 0)
+                return error;
+              else
+                continue;
+            }
+            argument= optend;
+          }
+          else if (optp->arg_type == OPT_ARG &&
+              (optp->var_type & GET_TYPE_MASK) == GET_BOOL)
+          {
+            if (optend == disabled_my_option)
+              *((bool*) value)= (bool) 0;
+            else
+            {
+              if (!optend) /* No argument -> enable option */
+                *((bool*) value)= (bool) 1;
+              else
+                argument= optend;
+            }
+          }
+          else if (optp->arg_type == REQUIRED_ARG && !optend)
+          {
+            /* Check if there are more arguments after this one */
+            if (!*++pos)
+            {
+              my_getopt_error_reporter(ERROR_LEVEL,
+                  "%s: option '--%s' requires an argument",
+                  internal::my_progname, optp->name);
+              return EXIT_ARGUMENT_REQUIRED;
+            }
+            argument= *pos;
+            (*argc)--;
+          }
+          else
+            argument= optend;
+        }
+        else  /* must be short option */
+        {
+          for (optend= cur_arg; *optend; optend++)
+          {
+            opt_found= 0;
+            for (optp= longopts; optp->id; optp++)
+            {
+              if (optp->id == (int) (unsigned char) *optend)
+              {
+                /* Option recognized. Find next what to do with it */
+                opt_found= 1;
+                if ((optp->var_type & GET_TYPE_MASK) == GET_DISABLED)
+                {
+                  fprintf(stderr,
+                      _("%s: ERROR: Option '-%c' used, but is disabled\n"),
+                      internal::my_progname, optp->id);
+                  return EXIT_OPTION_DISABLED;
+                }
+                if ((optp->var_type & GET_TYPE_MASK) == GET_BOOL &&
+                    optp->arg_type == NO_ARG)
+                {
+                  *((bool*) optp->value)= (bool) 1;
+                  error= get_one_option(optp->id, optp, argument);
+                  if (error != 0)
+                    return error;
+                  else
+                    continue;
+
+                }
+                else if (optp->arg_type == REQUIRED_ARG ||
+                    optp->arg_type == OPT_ARG)
+                {
+                  if (*(optend + 1))
+                  {
+                    /* The rest of the option is option argument */
+                    argument= optend + 1;
+                    /* This is in effect a jump out of the outer loop */
+                    optend= (char*) " ";
+                  }
+                  else
+                  {
+                    if (optp->arg_type == OPT_ARG)
+                    {
+                      if (optp->var_type == GET_BOOL)
+                        *((bool*) optp->value)= (bool) 1;
+                      error= get_one_option(optp->id, optp, argument);
+                      if (error != 0)
+                        return error;
+                      else
+                        continue;
+                    }
+                    /* Check if there are more arguments after this one */
+                    if (!pos[1])
+                    {
+                      my_getopt_error_reporter(ERROR_LEVEL,
+                          "%s: option '-%c' requires "
+                          "an argument",
+                          internal::my_progname, optp->id);
+                      return EXIT_ARGUMENT_REQUIRED;
+                    }
+                    argument= *++pos;
+                    (*argc)--;
+                    /* the other loop will break, because *optend + 1 == 0 */
+                  }
+                }
+                if ((error= setval(optp, optp->value, argument,
+                        set_maximum_value)))
+                {
+                  my_getopt_error_reporter(ERROR_LEVEL,
+                      "%s: Error while setting value '%s' "
+                      "to '%s'",
+                      internal::my_progname,
+                      argument, optp->name);
+                  return error;
+                }
+                error= get_one_option(optp->id, optp, argument);
+                if (error != 0)
+                  return error;
+                else
+                  break;
+              }
+            }
+            if (!opt_found)
+            {
+              my_getopt_error_reporter(ERROR_LEVEL,
+                  "%s: unknown option '-%c'",
+                  internal::my_progname, *optend);
+              return EXIT_UNKNOWN_OPTION;
+            }
+          }
+          (*argc)--; /* option handled (short), decrease argument count */
+          continue;
+        }
+        if ((error= setval(optp, value, argument, set_maximum_value)))
+        {
           my_getopt_error_reporter(ERROR_LEVEL,
-                                   "%s: option '%s' cannot take an argument",
-                                   internal::my_progname, optp->name);
-	  return EXIT_NO_ARGUMENT_ALLOWED;
-	}
-	value= optp->var_type & GET_ASK_ADDR ?
-	  (*getopt_get_addr)(key_name, (uint32_t) strlen(key_name), optp) : optp->value;
-
-	if (optp->arg_type == NO_ARG)
-	{
-	  if (optend && (optp->var_type & GET_TYPE_MASK) != GET_BOOL)
-	  {
-            my_getopt_error_reporter(ERROR_LEVEL,
-                                     "%s: option '--%s' cannot take an argument",
-                                     internal::my_progname, optp->name);
-	    return EXIT_NO_ARGUMENT_ALLOWED;
-	  }
-	  if ((optp->var_type & GET_TYPE_MASK) == GET_BOOL)
-	  {
-	    /*
-	      Set bool to 1 if no argument or if the user has used
-	      --enable-'option-name'.
-	      *optend was set to '0' if one used --disable-option
-	      */
-	    (*argc)--;
-	    if (!optend || *optend == '1' ||
-		!my_strcasecmp(&my_charset_utf8_general_ci, optend, "true"))
-	      *((bool*) value)= (bool) 1;
-	    else if (*optend == '0' ||
-		     !my_strcasecmp(&my_charset_utf8_general_ci, optend, "false"))
-	      *((bool*) value)= (bool) 0;
-	    else
-	    {
-	      my_getopt_error_reporter(WARNING_LEVEL,
-				       "%s: ignoring option '--%s' due to "
-                                       "invalid value '%s'",
-				       internal::my_progname,
-                                       optp->name, optend);
-	      continue;
-	    }
-	    get_one_option(optp->id, optp,
-			   *((bool*) value) ?
-			   (char*) "1" : disabled_my_option);
-	    continue;
-	  }
-	  argument= optend;
-	}
-	else if (optp->arg_type == OPT_ARG &&
-		 (optp->var_type & GET_TYPE_MASK) == GET_BOOL)
-	{
-	  if (optend == disabled_my_option)
-	    *((bool*) value)= (bool) 0;
-	  else
-	  {
-	    if (!optend) /* No argument -> enable option */
-	      *((bool*) value)= (bool) 1;
-            else
-              argument= optend;
-	  }
-	}
-	else if (optp->arg_type == REQUIRED_ARG && !optend)
-	{
-	  /* Check if there are more arguments after this one */
-	  if (!*++pos)
-	  {
-            my_getopt_error_reporter(ERROR_LEVEL,
-                                     "%s: option '--%s' requires an argument",
-                                     internal::my_progname, optp->name);
-	    return EXIT_ARGUMENT_REQUIRED;
-	  }
-	  argument= *pos;
-	  (*argc)--;
-	}
-	else
-	  argument= optend;
-      }
-      else  /* must be short option */
-      {
-	for (optend= cur_arg; *optend; optend++)
-	{
-	  opt_found= 0;
-	  for (optp= longopts; optp->id; optp++)
-	  {
-	    if (optp->id == (int) (unsigned char) *optend)
-	    {
-	      /* Option recognized. Find next what to do with it */
-	      opt_found= 1;
-	      if ((optp->var_type & GET_TYPE_MASK) == GET_DISABLED)
-	      {
-                fprintf(stderr,
-                        _("%s: ERROR: Option '-%c' used, but is disabled\n"),
-                        internal::my_progname, optp->id);
-		return EXIT_OPTION_DISABLED;
-	      }
-	      if ((optp->var_type & GET_TYPE_MASK) == GET_BOOL &&
-		  optp->arg_type == NO_ARG)
-	      {
-		*((bool*) optp->value)= (bool) 1;
-		get_one_option(optp->id, optp, argument);
-		continue;
-	      }
-	      else if (optp->arg_type == REQUIRED_ARG ||
-		       optp->arg_type == OPT_ARG)
-	      {
-		if (*(optend + 1))
-		{
-		  /* The rest of the option is option argument */
-		  argument= optend + 1;
-		  /* This is in effect a jump out of the outer loop */
-		  optend= (char*) " ";
-		}
-		else
-		{
-                  if (optp->arg_type == OPT_ARG)
-                  {
-                    if (optp->var_type == GET_BOOL)
-                      *((bool*) optp->value)= (bool) 1;
-                    get_one_option(optp->id, optp, argument);
-                    continue;
-                  }
-		  /* Check if there are more arguments after this one */
-		  if (!pos[1])
-		  {
-                    my_getopt_error_reporter(ERROR_LEVEL,
-                                             "%s: option '-%c' requires "
-                                             "an argument",
-                                             internal::my_progname, optp->id);
-                    return EXIT_ARGUMENT_REQUIRED;
-		  }
-		  argument= *++pos;
-		  (*argc)--;
-		  /* the other loop will break, because *optend + 1 == 0 */
-		}
-	      }
-              if ((error= setval(optp, optp->value, argument,
-                                 set_maximum_value)))
-              {
-                my_getopt_error_reporter(ERROR_LEVEL,
-                                         "%s: Error while setting value '%s' "
-                                         "to '%s'",
-                                         internal::my_progname,
-                                         argument, optp->name);
-                return error;
-              }
-              get_one_option(optp->id, optp, argument);
-              break;
-            }
-          }
-          if (!opt_found)
-          {
-            my_getopt_error_reporter(ERROR_LEVEL,
-                                     "%s: unknown option '-%c'",
-                                     internal::my_progname, *optend);
-            return EXIT_UNKNOWN_OPTION;
-          }
+              "%s: Error while setting value '%s' to '%s'",
+              internal::my_progname, argument, optp->name);
+          return error;
         }
-        (*argc)--; /* option handled (short), decrease argument count */
-        continue;
-      }
-      if ((error= setval(optp, value, argument, set_maximum_value)))
-      {
-        my_getopt_error_reporter(ERROR_LEVEL,
-                                 "%s: Error while setting value '%s' to '%s'",
-                                 internal::my_progname, argument, optp->name);
-        return error;
-      }
-      get_one_option(optp->id, optp, argument);
-
-      (*argc)--; /* option handled (short or long), decrease argument count */
-    }
-    else /* non-option found */
-      (*argv)[argvpos++]= cur_arg;
-  }
-  /*
-    Destroy the first, already handled option, so that programs that look
-    for arguments in 'argv', without checking 'argc', know when to stop.
-    Items in argv, before the destroyed one, are all non-option -arguments
-    to the program, yet to be (possibly) handled.
-  */
-  (*argv)[argvpos]= 0;
-  return 0;
-}
-
-
-/*
-  function: check_struct_option
-
-  Arguments: Current argument under processing from argv and a variable
-  where to store the possible key name.
-
-  Return value: In case option is a struct option, returns a pointer to
-  the current argument at the position where the struct option (key_name)
-  ends, the next character after the dot. In case argument is not a struct
-  option, returns a pointer to the argument.
-
-  key_name will hold the name of the key, or 0 if not found.
-*/
-
-static char *check_struct_option(char *cur_arg, char *key_name)
-{
-  char *ptr, *end;
-
-  ptr= strrchr(cur_arg + 1, '.'); /* Skip the first character */
-  end= strrchr(cur_arg, '=');
-
-  /*
-     If the first dot is after an equal sign, then it is part
-     of a variable value and the option is not a struct option.
-     Also, if the last character in the string before the ending
-     NULL, or the character right before equal sign is the first
-     dot found, the option is not a struct option.
-  */
-  if ((ptr != NULL) && (end != NULL) && (end - ptr > 1))
-  {
-    uint32_t len= (uint32_t) (ptr - cur_arg);
-    set_if_smaller(len, (uint32_t)FN_REFLEN-1);
-    strncpy(key_name, cur_arg, len);
-    return ++ptr;
-  }
-  key_name[0]= 0;
-  return cur_arg;
-}
-
-/*
-  function: setval
-
-  Arguments: opts, argument
-  Will set the option value to given value
-*/
-
-static int setval(const struct my_option *opts, char **value, char *argument,
-                  bool set_maximum_value)
-{
-  int err= 0;
-
-  if (value && argument)
-  {
-    char* *result_pos= ((set_maximum_value) ?
-                        opts->u_max_value : value);
-
-    if (!result_pos)
-      return EXIT_NO_PTR_TO_VARIABLE;
-
-    switch ((opts->var_type & GET_TYPE_MASK)) {
-    case GET_BOOL: /* If argument differs from 0, enable option, else disable */
-      *((bool*) result_pos)= (bool) atoi(argument) != 0;
-      break;
-    case GET_INT:
-      *((int32_t*) result_pos)= (int) getopt_ll(argument, opts, &err);
-      break;
-    case GET_UINT:
-    case GET_UINT32:
-      *((uint32_t*) result_pos)= (uint32_t) getopt_ull(argument, opts, &err);
-      break;
-    case GET_ULONG_IS_FAIL:
-      *((ulong*) result_pos)= (ulong) getopt_ull(argument, opts, &err);
-      break;
-    case GET_LONG:
-      *((long*) result_pos)= (long) getopt_ll(argument, opts, &err);
-      break;
-    case GET_LL:
-      *((int64_t*) result_pos)= getopt_ll(argument, opts, &err);
-      break;
-    case GET_ULL:
-    case GET_UINT64:
-      *((uint64_t*) result_pos)= getopt_ull(argument, opts, &err);
-      break;
-    case GET_SIZE:
-      *((size_t*) result_pos)= getopt_size(argument, opts, &err);
-      break;
-    case GET_DOUBLE:
-      *((double*) result_pos)= getopt_double(argument, opts, &err);
-      break;
-    case GET_STR:
-      *((char**) result_pos)= argument;
-      break;
-    case GET_STR_ALLOC:
-      if ((*((char**) result_pos)))
-	free((*(char**) result_pos));
-      if (!(*((char**) result_pos)= strdup(argument)))
-	return EXIT_OUT_OF_MEMORY;
-      break;
-    case GET_ENUM:
-      if (((*(int*)result_pos)= find_type(argument, opts->typelib, 2) - 1) < 0)
-        return EXIT_ARGUMENT_INVALID;
-      break;
-    case GET_SET:
-      *((uint64_t*)result_pos)= find_typeset(argument, opts->typelib, &err);
+        error= get_one_option(optp->id, optp, argument);
+        if (error != 0)
+          return error;
+
+        (*argc)--; /* option handled (short or long), decrease argument count */
+      }
+      else /* non-option found */
+        (*argv)[argvpos++]= cur_arg;
+    }
+    /*
+       Destroy the first, already handled option, so that programs that look
+       for arguments in 'argv', without checking 'argc', know when to stop.
+       Items in argv, before the destroyed one, are all non-option -arguments
+       to the program, yet to be (possibly) handled.
+     */
+    (*argv)[argvpos]= 0;
+    return 0;
+  }
+
+
+  /*
+function: check_struct_option
+
+Arguments: Current argument under processing from argv and a variable
+where to store the possible key name.
+
+Return value: In case option is a struct option, returns a pointer to
+the current argument at the position where the struct option (key_name)
+ends, the next character after the dot. In case argument is not a struct
+option, returns a pointer to the argument.
+
+key_name will hold the name of the key, or 0 if not found.
+   */
+
+  static char *check_struct_option(char *cur_arg, char *key_name)
+  {
+    char *ptr, *end;
+
+    ptr= strrchr(cur_arg + 1, '.'); /* Skip the first character */
+    end= strrchr(cur_arg, '=');
+
+    /*
+       If the first dot is after an equal sign, then it is part
+       of a variable value and the option is not a struct option.
+       Also, if the last character in the string before the ending
+       NULL, or the character right before equal sign is the first
+       dot found, the option is not a struct option.
+     */
+    if ((ptr != NULL) && (end != NULL) && (end - ptr > 1))
+    {
+      uint32_t len= (uint32_t) (ptr - cur_arg);
+      set_if_smaller(len, (uint32_t)FN_REFLEN-1);
+      strncpy(key_name, cur_arg, len);
+      return ++ptr;
+    }
+    key_name[0]= 0;
+    return cur_arg;
+  }
+
+  /*
+function: setval
+
+Arguments: opts, argument
+Will set the option value to given value
+   */
+
+  static int setval(const struct my_option *opts, char **value, char *argument,
+      bool set_maximum_value)
+  {
+    int err= 0;
+
+    if (value && argument)
+    {
+      char* *result_pos= ((set_maximum_value) ?
+          opts->u_max_value : value);
+
+      if (!result_pos)
+        return EXIT_NO_PTR_TO_VARIABLE;
+
+      switch ((opts->var_type & GET_TYPE_MASK)) {
+        case GET_BOOL: /* If argument differs from 0, enable option, else disable */
+          *((bool*) result_pos)= (bool) atoi(argument) != 0;
+          break;
+        case GET_INT:
+          *((int32_t*) result_pos)= (int) getopt_ll(argument, opts, &err);
+          break;
+        case GET_UINT:
+        case GET_UINT32:
+          *((uint32_t*) result_pos)= (uint32_t) getopt_ull(argument, opts, &err);
+          break;
+        case GET_ULONG_IS_FAIL:
+          *((ulong*) result_pos)= (ulong) getopt_ull(argument, opts, &err);
+          break;
+        case GET_LONG:
+          *((long*) result_pos)= (long) getopt_ll(argument, opts, &err);
+          break;
+        case GET_LL:
+          *((int64_t*) result_pos)= getopt_ll(argument, opts, &err);
+          break;
+        case GET_ULL:
+        case GET_UINT64:
+          *((uint64_t*) result_pos)= getopt_ull(argument, opts, &err);
+          break;
+        case GET_SIZE:
+          *((size_t*) result_pos)= getopt_size(argument, opts, &err);
+          break;
+        case GET_DOUBLE:
+          *((double*) result_pos)= getopt_double(argument, opts, &err);
+          break;
+        case GET_STR:
+          *((char**) result_pos)= argument;
+          break;
+        case GET_STR_ALLOC:
+          if ((*((char**) result_pos)))
+            free((*(char**) result_pos));
+          if (!(*((char**) result_pos)= strdup(argument)))
+            return EXIT_OUT_OF_MEMORY;
+          break;
+        case GET_ENUM:
+          if (((*(int*)result_pos)= find_type(argument, opts->typelib, 2) - 1) < 0)
+            return EXIT_ARGUMENT_INVALID;
+          break;
+        case GET_SET:
+          *((uint64_t*)result_pos)= find_typeset(argument, opts->typelib, &err);
+          if (err)
+            return EXIT_ARGUMENT_INVALID;
+          break;
+        default:    /* dummy default to avoid compiler warnings */
+          break;
+      }
       if (err)
-        return EXIT_ARGUMENT_INVALID;
-      break;
-    default:    /* dummy default to avoid compiler warnings */
-      break;
-    }
-    if (err)
-      return EXIT_UNKNOWN_SUFFIX;
-  }
-  return 0;
-}
-
-
-/*
-  Find option
-
-  SYNOPSIS
-    findopt()
-    optpat	Prefix of option to find (with - or _)
-    length	Length of optpat
-    opt_res	Options
-    ffname	Place for pointer to first found name
-
-  IMPLEMENTATION
-    Go through all options in the my_option struct. Return number
-    of options found that match the pattern and in the argument
-    list the option found, if any. In case of ambiguous option, store
-    the name in ffname argument
-
-    RETURN
-    0    No matching options
-    #   Number of matching options
-        ffname points to first matching option
-*/
-
-static int findopt(char *optpat, uint32_t length,
-		   const struct my_option **opt_res,
-		   char **ffname)
-{
-  uint32_t count;
-  struct my_option *opt= (struct my_option *) *opt_res;
-
-  for (count= 0; opt->name; opt++)
-  {
-    if (!getopt_compare_strings(opt->name, optpat, length)) /* match found */
-    {
-      (*opt_res)= opt;
-      if (!opt->name[length])		/* Exact match */
-	return 1;
-      if (!count)
-      {
-	count= 1;
-	*ffname= (char *) opt->name;	/* We only need to know one prev */
-      }
-      else if (strcmp(*ffname, opt->name))
-      {
-	/*
-	  The above test is to not count same option twice
-	  (see mysql.cc, option "help")
-	*/
-	count++;
-      }
-    }
-  }
-  return count;
-}
-
-
-/*
-  function: compare_strings
-
-  Works like strncmp, other than 1.) considers '-' and '_' the same.
-  2.) Returns -1 if strings differ, 0 if they are equal
-*/
-
-bool getopt_compare_strings(register const char *s, register const char *t,
-			       uint32_t length)
-{
-  char const *end= s + length;
-  for (;s != end ; s++, t++)
-  {
-    if ((*s != '-' ? *s : '_') != (*t != '-' ? *t : '_'))
-      return 1;
-  }
-  return 0;
-}
-
-/*
-  function: eval_num_suffix
-
-  Transforms a number with a suffix to real number. Suffix can
-  be k|K for kilo, m|M for mega or g|G for giga.
-*/
-
-static int64_t eval_num_suffix(char *argument, int *error, char *option_name)
-{
-  char *endchar;
-  int64_t num;
-
-  *error= 0;
-  errno= 0;
-  num= strtoll(argument, &endchar, 10);
-  if (errno == ERANGE)
-  {
-    my_getopt_error_reporter(ERROR_LEVEL,
-                             "Incorrect integer value: '%s'", argument);
-    *error= 1;
-    return 0;
-  }
-  if (*endchar == 'k' || *endchar == 'K')
-    num*= 1024L;
-  else if (*endchar == 'm' || *endchar == 'M')
-    num*= 1024L * 1024L;
-  else if (*endchar == 'g' || *endchar == 'G')
-    num*= 1024L * 1024L * 1024L;
-  else if (*endchar)
-  {
-    fprintf(stderr,
-	    _("Unknown suffix '%c' used for variable '%s' (value '%s')\n"),
-	    *endchar, option_name, argument);
-    *error= 1;
-    return 0;
-  }
-  return num;
-}
-
-/*
-  function: getopt_ll
-
-  Evaluates and returns the value that user gave as an argument
-  to a variable. Recognizes (case insensitive) K as KILO, M as MEGA
-  and G as GIGA bytes. Some values must be in certain blocks, as
-  defined in the given my_option struct, this function will check
-  that those values are honored.
-  In case of an error, set error value in *err.
-*/
-
-static int64_t getopt_ll(char *arg, const struct my_option *optp, int *err)
-{
-  int64_t num=eval_num_suffix(arg, err, (char*) optp->name);
-  return getopt_ll_limit_value(num, optp, NULL);
-}
-
-/*
-  function: getopt_ll_limit_value
-
-  Applies min/max/block_size to a numeric value of an option.
-  Returns "fixed" value.
-*/
-
-int64_t getopt_ll_limit_value(int64_t num, const struct my_option *optp,
-                               bool *fix)
-{
-  int64_t old= num;
-  bool adjusted= false;
-  char buf1[255], buf2[255];
-  uint64_t block_size= (optp->block_size ? (uint64_t) optp->block_size : 1L);
-
-  if (num > 0 && ((uint64_t) num > (uint64_t) optp->max_value) &&
-      optp->max_value) /* if max value is not set -> no upper limit */
-  {
-    num= (uint64_t) optp->max_value;
-    adjusted= true;
-  }
-
-  switch ((optp->var_type & GET_TYPE_MASK)) {
-  case GET_INT:
-    if (num > (int64_t) INT_MAX)
-    {
-      num= ((int64_t) INT_MAX);
-      adjusted= true;
-    }
-    break;
-  case GET_LONG:
-    if (num > (int64_t) INT32_MAX)
-    {
-      num= ((int64_t) INT32_MAX);
-      adjusted= true;
-    }
-    break;
-  default:
-    assert((optp->var_type & GET_TYPE_MASK) == GET_LL);
-    break;
-  }
-
-  num= ((num - optp->sub_size) / block_size);
-  num= (int64_t) (num * block_size);
-
-  if (num < optp->min_value)
-  {
-    num= optp->min_value;
-    adjusted= true;
-  }
-
-  if (fix)
-    *fix= adjusted;
-  else if (adjusted)
-    my_getopt_error_reporter(WARNING_LEVEL,
-                             "option '%s': signed value %s adjusted to %s",
-                             optp->name, internal::llstr(old, buf1), internal::llstr(num, buf2));
-  return num;
-}
-
-/*
-  function: getopt_ull
-
-  This is the same as getopt_ll, but is meant for uint64_t
-  values.
-*/
-
-static uint64_t getopt_ull(char *arg, const struct my_option *optp, int *err)
-{
-  uint64_t num= eval_num_suffix(arg, err, (char*) optp->name);
-  return getopt_ull_limit_value(num, optp, NULL);
-}
-
-
-static size_t getopt_size(char *arg, const struct my_option *optp, int *err)
-{
-  return (size_t)getopt_ull(arg, optp, err);
-}
-
-
-
-uint64_t getopt_ull_limit_value(uint64_t num, const struct my_option *optp,
-				bool *fix)
-{
-  bool adjusted= false;
-  uint64_t old= num;
-  char buf1[255], buf2[255];
-
-  if ((uint64_t) num > (uint64_t) optp->max_value &&
-      optp->max_value) /* if max value is not set -> no upper limit */
-  {
-    num= (uint64_t) optp->max_value;
-    adjusted= true;
-  }
-
-  switch ((optp->var_type & GET_TYPE_MASK)) {
-  case GET_UINT:
-    if (num > (uint64_t) UINT_MAX)
-    {
-      num= ((uint64_t) UINT_MAX);
-      adjusted= true;
-    }
-    break;
-  case GET_UINT32:
-  case GET_ULONG_IS_FAIL:
-    if (num > (uint64_t) UINT32_MAX)
-    {
-      num= ((uint64_t) UINT32_MAX);
-      adjusted= true;
-    }
-    break;
-  case GET_SIZE:
-    if (num > (uint64_t) SIZE_MAX)
-    {
-      num= ((uint64_t) SIZE_MAX);
-      adjusted= true;
-    }
-    break;
-  default:
-    assert(((optp->var_type & GET_TYPE_MASK) == GET_ULL)
-	   || ((optp->var_type & GET_TYPE_MASK) == GET_UINT64));
-    break;
-  }
-
-  if (optp->block_size > 1)
-  {
-    num/= (uint64_t) optp->block_size;
-    num*= (uint64_t) optp->block_size;
-  }
-
-  if (num < (uint64_t) optp->min_value)
-  {
-    num= (uint64_t) optp->min_value;
-    adjusted= true;
-  }
-
-  if (fix)
-    *fix= adjusted;
-  else if (adjusted)
-    my_getopt_error_reporter(WARNING_LEVEL,
-                             "option '%s': unsigned value %s adjusted to %s",
-                             optp->name, internal::ullstr(old, buf1), internal::ullstr(num, buf2));
-
-  return num;
-}
-
-
-/*
-  Get double value withing ranges
-
-  Evaluates and returns the value that user gave as an argument to a variable.
-
-  RETURN
-    decimal value of arg
-
-    In case of an error, prints an error message and sets *err to
-    EXIT_ARGUMENT_INVALID.  Otherwise err is not touched
-*/
-
-static double getopt_double(char *arg, const struct my_option *optp, int *err)
-{
-  double num;
-  int error;
-  char *end= arg + 1000;                     /* Big enough as *arg is \0 terminated */
-  num= internal::my_strtod(arg, &end, &error);
-  if (end[0] != 0 || error)
-  {
-    fprintf(stderr,
-            _("%s: ERROR: Invalid decimal value for option '%s'\n"),
-            internal::my_progname, optp->name);
-    *err= EXIT_ARGUMENT_INVALID;
-    return 0.0;
-  }
-  if (optp->max_value && num > (double) optp->max_value)
-    num= (double) optp->max_value;
-  return max(num, (double) optp->min_value);
-}
-
-/*
-  Init one value to it's default values
-
-  SYNOPSIS
-    init_one_value()
-    option		Option to initialize
-    value		Pointer to variable
-*/
-
-static void init_one_value(const struct my_option *option, char** variable,
-			   int64_t value)
-{
-  switch ((option->var_type & GET_TYPE_MASK)) {
-  case GET_BOOL:
-    *((bool*) variable)= (bool) value;
-    break;
-  case GET_INT:
-    *((int*) variable)= (int) value;
-    break;
-  case GET_UINT:
-  case GET_ENUM:
-    *((uint*) variable)= (uint32_t) value;
-    break;
-  case GET_LONG:
-    *((long*) variable)= (long) value;
-    break;
-  case GET_UINT32:
-    *((uint32_t*) variable)= (uint32_t) value;
-    break;
-  case GET_ULONG_IS_FAIL:
-    *((ulong*) variable)= (ulong) value;
-    break;
-  case GET_LL:
-    *((int64_t*) variable)= (int64_t) value;
-    break;
-  case GET_SIZE:
-    *((size_t*) variable)= (size_t) value;
-    break;
-  case GET_ULL:
-  case GET_SET:
-  case GET_UINT64:
-    *((uint64_t*) variable)=  (uint64_t) value;
-    break;
-  case GET_DOUBLE:
-    *((double*) variable)=  (double) value;
-    break;
-  case GET_STR:
-    /*
-      Do not clear variable value if it has no default value.
-      The default value may already be set.
-      NOTE: To avoid compiler warnings, we first cast int64_t to intptr_t,
-      so that the value has the same size as a pointer.
-    */
-    if ((char*) (intptr_t) value)
-      *((char**) variable)= (char*) (intptr_t) value;
-    break;
-  case GET_STR_ALLOC:
-    /*
-      Do not clear variable value if it has no default value.
-      The default value may already be set.
-      NOTE: To avoid compiler warnings, we first cast int64_t to intptr_t,
-      so that the value has the same size as a pointer.
-    */
-    if ((char*) (intptr_t) value)
-    {
-      free((*(char**) variable));
-      char *tmpptr= strdup((char *) (intptr_t) value);
-      if (tmpptr != NULL)
-        *((char**) variable)= tmpptr;
-    }
-    break;
-  default: /* dummy default to avoid compiler warnings */
-    break;
-  }
-  return;
-}
-
-
-/*
-  Init one value to it's default values
-
-  SYNOPSIS
-    init_one_value()
-    option		Option to initialize
-    value		Pointer to variable
-*/
-
-static void fini_one_value(const struct my_option *option, char **variable,
-			   int64_t)
-{
-  switch ((option->var_type & GET_TYPE_MASK)) {
-  case GET_STR_ALLOC:
-    free((*(char**) variable));
-    *((char**) variable)= NULL;
-    break;
-  default: /* dummy default to avoid compiler warnings */
-    break;
-  }
-  return;
-}
-
-
-void my_cleanup_options(const struct my_option *options)
-{
-  init_variables(options, fini_one_value);
-}
-
-
-/*
-  initialize all variables to their default values
-
-  SYNOPSIS
-    init_variables()
-    options		Array of options
-
-  NOTES
-    We will initialize the value that is pointed to by options->value.
-    If the value is of type GET_ASK_ADDR, we will also ask for the address
-    for a value and initialize.
-*/
-
-static void init_variables(const struct my_option *options,
-                           init_func_p init_one_value)
-{
-  for (; options->name; options++)
-  {
-    char* *variable;
-    /*
-      We must set u_max_value first as for some variables
-      options->u_max_value == options->value and in this case we want to
-      set the value to default value.
-    */
-    if (options->u_max_value)
-      init_one_value(options, options->u_max_value, options->max_value);
-    if (options->value)
-      init_one_value(options, options->value, options->def_value);
-    if (options->var_type & GET_ASK_ADDR &&
-	(variable= (*getopt_get_addr)("", 0, options)))
-      init_one_value(options, variable, options->def_value);
-  }
-  return;
-}
-
-
-/*
-  function: my_print_options
-
-  Print help for all options and variables.
-*/
-
-void my_print_help(const struct my_option *options)
-{
-  uint32_t col, name_space= 22, comment_space= 57;
-  const char *line_end;
-  const struct my_option *optp;
-
-  for (optp= options; optp->id; optp++)
-  {
-    if (optp->id < 256)
-    {
-      printf("  -%c%s", optp->id, strlen(optp->name) ? ", " : "  ");
-      col= 6;
-    }
-    else
-    {
-      printf("  ");
-      col= 2;
-    }
-    if (strlen(optp->name))
-    {
-      printf("--%s", optp->name);
-      col+= 2 + (uint32_t) strlen(optp->name);
-      if ((optp->var_type & GET_TYPE_MASK) == GET_STR ||
-	  (optp->var_type & GET_TYPE_MASK) == GET_STR_ALLOC)
-      {
-	printf("%s=name%s ", optp->arg_type == OPT_ARG ? "[" : "",
-	       optp->arg_type == OPT_ARG ? "]" : "");
-	col+= (optp->arg_type == OPT_ARG) ? 8 : 6;
-      }
-      else if ((optp->var_type & GET_TYPE_MASK) == GET_NO_ARG ||
-	       (optp->var_type & GET_TYPE_MASK) == GET_BOOL)
-      {
-	putchar(' ');
-	col++;
-      }
-      else
-      {
-	printf("%s=#%s ", optp->arg_type == OPT_ARG ? "[" : "",
-	       optp->arg_type == OPT_ARG ? "]" : "");
-	col+= (optp->arg_type == OPT_ARG) ? 5 : 3;
-      }
-      if (col > name_space && optp->comment && *optp->comment)
-      {
-	putchar('\n');
-	col= 0;
-      }
-    }
-    for (; col < name_space; col++)
-      putchar(' ');
-    if (optp->comment && *optp->comment)
-    {
-      const char *comment= _(optp->comment), *end= strchr(comment, '\0');
-
-      while ((uint32_t) (end - comment) > comment_space)
-      {
-	for (line_end= comment + comment_space; *line_end != ' '; line_end--)
-          {}
-	for (; comment != line_end; comment++)
-	  putchar(*comment);
-	comment++; /* skip the space, as a newline will take it's place now */
-	putchar('\n');
-	for (col= 0; col < name_space; col++)
-	  putchar(' ');
-      }
-      printf("%s", comment);
-    }
-    putchar('\n');
-    if ((optp->var_type & GET_TYPE_MASK) == GET_NO_ARG ||
-             (optp->var_type & GET_TYPE_MASK) == GET_BOOL)
-    {
-      if (optp->def_value != 0)
-      {
-        printf(_("%*s(Defaults to on; use --skip-%s to disable.)\n"), name_space, "", optp->name);
-      }
-    }
-  }
-}
-
-
-/*
-  function: my_print_options
-
-  Print variables.
-*/
-
-void my_print_variables(const struct my_option *options)
-{
-  uint32_t name_space= 34, length, nr;
-  uint64_t bit, llvalue;
-  char buff[255];
-  const struct my_option *optp;
-
-  printf(_("\nVariables (--variable-name=value)\n"
-         "and boolean options {false|true}  Value (after reading options)\n"
-         "--------------------------------- -----------------------------\n"));
-  for (optp= options; optp->id; optp++)
-  {
-    char* *value= (optp->var_type & GET_ASK_ADDR ?
-		  (*getopt_get_addr)("", 0, optp) : optp->value);
-    if (value)
-    {
-      printf("%s ", optp->name);
-      length= (uint32_t) strlen(optp->name)+1;
-      for (; length < name_space; length++)
-	putchar(' ');
-      switch ((optp->var_type & GET_TYPE_MASK)) {
-      case GET_SET:
-        if (!(llvalue= *(uint64_t*) value))
-	  printf("%s\n", _("(No default value)"));
-	else
-        for (nr= 0, bit= 1; llvalue && nr < optp->typelib->count; nr++, bit<<=1)
-	{
-	  if (!(bit & llvalue))
-	    continue;
-	  llvalue&= ~bit;
-	  printf( llvalue ? "%s," : "%s\n", get_type(optp->typelib, nr));
-	}
-	break;
+        return EXIT_UNKNOWN_SUFFIX;
+    }
+    return 0;
+  }
+
+
+  /*
+     Find option
+
+     SYNOPSIS
+     findopt()
+     optpat	Prefix of option to find (with - or _)
+     length	Length of optpat
+     opt_res	Options
+     ffname	Place for pointer to first found name
+
+     IMPLEMENTATION
+     Go through all options in the my_option struct. Return number
+     of options found that match the pattern and in the argument
+     list the option found, if any. In case of ambiguous option, store
+     the name in ffname argument
+
+     RETURN
+     0    No matching options
+#   Number of matching options
+ffname points to first matching option
+   */
+
+  static int findopt(char *optpat, uint32_t length,
+      const struct my_option **opt_res,
+      char **ffname)
+  {
+    uint32_t count;
+    struct my_option *opt= (struct my_option *) *opt_res;
+
+    for (count= 0; opt->name; opt++)
+    {
+      if (!getopt_compare_strings(opt->name, optpat, length)) /* match found */
+      {
+        (*opt_res)= opt;
+        if (!opt->name[length])		/* Exact match */
+          return 1;
+        if (!count)
+        {
+          count= 1;
+          *ffname= (char *) opt->name;	/* We only need to know one prev */
+        }
+        else if (strcmp(*ffname, opt->name))
+        {
+          /*
+             The above test is to not count same option twice
+             (see mysql.cc, option "help")
+           */
+          count++;
+        }
+      }
+    }
+    return count;
+  }
+
+
+  /*
+function: compare_strings
+
+Works like strncmp, other than 1.) considers '-' and '_' the same.
+2.) Returns -1 if strings differ, 0 if they are equal
+   */
+
+  bool getopt_compare_strings(register const char *s, register const char *t,
+      uint32_t length)
+  {
+    char const *end= s + length;
+    for (;s != end ; s++, t++)
+    {
+      if ((*s != '-' ? *s : '_') != (*t != '-' ? *t : '_'))
+        return 1;
+    }
+    return 0;
+  }
+
+  /*
+function: eval_num_suffix
+
+Transforms a number with a suffix to real number. Suffix can
+be k|K for kilo, m|M for mega or g|G for giga.
+   */
+
+  static int64_t eval_num_suffix(char *argument, int *error, char *option_name)
+  {
+    char *endchar;
+    int64_t num;
+
+    *error= 0;
+    errno= 0;
+    num= strtoll(argument, &endchar, 10);
+    if (errno == ERANGE)
+    {
+      my_getopt_error_reporter(ERROR_LEVEL,
+          "Incorrect integer value: '%s'", argument);
+      *error= 1;
+      return 0;
+    }
+    if (*endchar == 'k' || *endchar == 'K')
+      num*= 1024L;
+    else if (*endchar == 'm' || *endchar == 'M')
+      num*= 1024L * 1024L;
+    else if (*endchar == 'g' || *endchar == 'G')
+      num*= 1024L * 1024L * 1024L;
+    else if (*endchar)
+    {
+      fprintf(stderr,
+          _("Unknown suffix '%c' used for variable '%s' (value '%s')\n"),
+          *endchar, option_name, argument);
+      *error= 1;
+      return 0;
+    }
+    return num;
+  }
+
+  /*
+function: getopt_ll
+
+Evaluates and returns the value that user gave as an argument
+to a variable. Recognizes (case insensitive) K as KILO, M as MEGA
+and G as GIGA bytes. Some values must be in certain blocks, as
+defined in the given my_option struct, this function will check
+that those values are honored.
+In case of an error, set error value in *err.
+   */
+
+  static int64_t getopt_ll(char *arg, const struct my_option *optp, int *err)
+  {
+    int64_t num=eval_num_suffix(arg, err, (char*) optp->name);
+    return getopt_ll_limit_value(num, optp, NULL);
+  }
+
+  /*
+function: getopt_ll_limit_value
+
+Applies min/max/block_size to a numeric value of an option.
+Returns "fixed" value.
+   */
+
+  int64_t getopt_ll_limit_value(int64_t num, const struct my_option *optp,
+      bool *fix)
+  {
+    int64_t old= num;
+    bool adjusted= false;
+    char buf1[255], buf2[255];
+    uint64_t block_size= (optp->block_size ? (uint64_t) optp->block_size : 1L);
+
+    if (num > 0 && ((uint64_t) num > (uint64_t) optp->max_value) &&
+        optp->max_value) /* if max value is not set -> no upper limit */
+    {
+      num= (uint64_t) optp->max_value;
+      adjusted= true;
+    }
+
+    switch ((optp->var_type & GET_TYPE_MASK)) {
+      case GET_INT:
+        if (num > (int64_t) INT_MAX)
+        {
+          num= ((int64_t) INT_MAX);
+          adjusted= true;
+        }
+        break;
+      case GET_LONG:
+        if (num > (int64_t) INT32_MAX)
+        {
+          num= ((int64_t) INT32_MAX);
+          adjusted= true;
+        }
+        break;
+      default:
+        assert((optp->var_type & GET_TYPE_MASK) == GET_LL);
+        break;
+    }
+
+    num= ((num - optp->sub_size) / block_size);
+    num= (int64_t) (num * block_size);
+
+    if (num < optp->min_value)
+    {
+      num= optp->min_value;
+      adjusted= true;
+    }
+
+    if (fix)
+      *fix= adjusted;
+    else if (adjusted)
+      my_getopt_error_reporter(WARNING_LEVEL,
+          "option '%s': signed value %s adjusted to %s",
+          optp->name, internal::llstr(old, buf1), internal::llstr(num, buf2));
+    return num;
+  }
+
+  /*
+function: getopt_ull
+
+This is the same as getopt_ll, but is meant for uint64_t
+values.
+   */
+
+  static uint64_t getopt_ull(char *arg, const struct my_option *optp, int *err)
+  {
+    uint64_t num= eval_num_suffix(arg, err, (char*) optp->name);
+    return getopt_ull_limit_value(num, optp, NULL);
+  }
+
+
+  static size_t getopt_size(char *arg, const struct my_option *optp, int *err)
+  {
+    return (size_t)getopt_ull(arg, optp, err);
+  }
+
+
+
+  uint64_t getopt_ull_limit_value(uint64_t num, const struct my_option *optp,
+      bool *fix)
+  {
+    bool adjusted= false;
+    uint64_t old= num;
+    char buf1[255], buf2[255];
+
+    if ((uint64_t) num > (uint64_t) optp->max_value &&
+        optp->max_value) /* if max value is not set -> no upper limit */
+    {
+      num= (uint64_t) optp->max_value;
+      adjusted= true;
+    }
+
+    switch ((optp->var_type & GET_TYPE_MASK)) {
+      case GET_UINT:
+        if (num > (uint64_t) UINT_MAX)
+        {
+          num= ((uint64_t) UINT_MAX);
+          adjusted= true;
+        }
+        break;
+      case GET_UINT32:
+      case GET_ULONG_IS_FAIL:
+        if (num > (uint64_t) UINT32_MAX)
+        {
+          num= ((uint64_t) UINT32_MAX);
+          adjusted= true;
+        }
+        break;
+      case GET_SIZE:
+        if (num > (uint64_t) SIZE_MAX)
+        {
+          num= ((uint64_t) SIZE_MAX);
+          adjusted= true;
+        }
+        break;
+      default:
+        assert(((optp->var_type & GET_TYPE_MASK) == GET_ULL)
+            || ((optp->var_type & GET_TYPE_MASK) == GET_UINT64));
+        break;
+    }
+
+    if (optp->block_size > 1)
+    {
+      num/= (uint64_t) optp->block_size;
+      num*= (uint64_t) optp->block_size;
+    }
+
+    if (num < (uint64_t) optp->min_value)
+    {
+      num= (uint64_t) optp->min_value;
+      adjusted= true;
+    }
+
+    if (fix)
+      *fix= adjusted;
+    else if (adjusted)
+      my_getopt_error_reporter(WARNING_LEVEL,
+          "option '%s': unsigned value %s adjusted to %s",
+          optp->name, internal::ullstr(old, buf1), internal::ullstr(num, buf2));
+
+    return num;
+  }
+
+
+  /*
+     Get double value withing ranges
+
+     Evaluates and returns the value that user gave as an argument to a variable.
+
+     RETURN
+     decimal value of arg
+
+     In case of an error, prints an error message and sets *err to
+     EXIT_ARGUMENT_INVALID.  Otherwise err is not touched
+   */
+
+  static double getopt_double(char *arg, const struct my_option *optp, int *err)
+  {
+    double num;
+    int error;
+    char *end= arg + 1000;                     /* Big enough as *arg is \0 terminated */
+    num= internal::my_strtod(arg, &end, &error);
+    if (end[0] != 0 || error)
+    {
+      fprintf(stderr,
+          _("%s: ERROR: Invalid decimal value for option '%s'\n"),
+          internal::my_progname, optp->name);
+      *err= EXIT_ARGUMENT_INVALID;
+      return 0.0;
+    }
+    if (optp->max_value && num > (double) optp->max_value)
+      num= (double) optp->max_value;
+    return max(num, (double) optp->min_value);
+  }
+
+  /*
+     Init one value to it's default values
+
+     SYNOPSIS
+     init_one_value()
+     option		Option to initialize
+     value		Pointer to variable
+   */
+
+  static void init_one_value(const struct my_option *option, char** variable,
+      int64_t value)
+  {
+    switch ((option->var_type & GET_TYPE_MASK)) {
+      case GET_BOOL:
+        *((bool*) variable)= (bool) value;
+        break;
+      case GET_INT:
+        *((int*) variable)= (int) value;
+        break;
+      case GET_UINT:
       case GET_ENUM:
-        printf("%s\n", get_type(optp->typelib, *(uint*) value));
-	break;
-      case GET_STR:
-      case GET_STR_ALLOC:                    /* fall through */
-	printf("%s\n", *((char**) value) ? *((char**) value) :
-	       _("(No default value)"));
-	break;
-      case GET_BOOL:
-	printf("%s\n", *((bool*) value) ? _("true") : _("false"));
-	break;
-      case GET_INT:
-	printf("%d\n", *((int*) value));
-	break;
-      case GET_UINT:
-	printf("%d\n", *((uint*) value));
-	break;
+        *((uint*) variable)= (uint32_t) value;
+        break;
       case GET_LONG:
-	printf("%ld\n", *((long*) value));
-	break;
+        *((long*) variable)= (long) value;
+        break;
       case GET_UINT32:
-	printf("%u\n", *((uint32_t*) value));
-	break;
+        *((uint32_t*) variable)= (uint32_t) value;
+        break;
       case GET_ULONG_IS_FAIL:
-	printf("%lu\n", *((ulong*) value));
-	break;
-      case GET_SIZE:
-	internal::int64_t2str((uint64_t)(*(size_t*)value), buff, 10);
-	printf("%s\n", buff);
-	break;
+        *((ulong*) variable)= (ulong) value;
+        break;
       case GET_LL:
-	printf("%s\n", internal::llstr(*((int64_t*) value), buff));
-	break;
+        *((int64_t*) variable)= (int64_t) value;
+        break;
+      case GET_SIZE:
+        *((size_t*) variable)= (size_t) value;
+        break;
       case GET_ULL:
+      case GET_SET:
       case GET_UINT64:
-	internal::int64_t2str(*((uint64_t*) value), buff, 10);
-	printf("%s\n", buff);
-	break;
+        *((uint64_t*) variable)=  (uint64_t) value;
+        break;
       case GET_DOUBLE:
-	printf("%g\n", *(double*) value);
-	break;
-      default:
-	printf(_("(Disabled)\n"));
-	break;
-      }
-    }
-  }
-}
+        *((double*) variable)=  (double) value;
+        break;
+      case GET_STR:
+        /*
+           Do not clear variable value if it has no default value.
+           The default value may already be set.
+NOTE: To avoid compiler warnings, we first cast int64_t to intptr_t,
+so that the value has the same size as a pointer.
+         */
+        if ((char*) (intptr_t) value)
+          *((char**) variable)= (char*) (intptr_t) value;
+        break;
+      case GET_STR_ALLOC:
+        /*
+           Do not clear variable value if it has no default value.
+           The default value may already be set.
+NOTE: To avoid compiler warnings, we first cast int64_t to intptr_t,
+so that the value has the same size as a pointer.
+         */
+        if ((char*) (intptr_t) value)
+        {
+          free((*(char**) variable));
+          char *tmpptr= strdup((char *) (intptr_t) value);
+          if (tmpptr != NULL)
+            *((char**) variable)= tmpptr;
+        }
+        break;
+      default: /* dummy default to avoid compiler warnings */
+        break;
+    }
+    return;
+  }
+
+
+  /*
+     Init one value to it's default values
+
+     SYNOPSIS
+     init_one_value()
+     option		Option to initialize
+     value		Pointer to variable
+   */
+
+  static void fini_one_value(const struct my_option *option, char **variable,
+      int64_t)
+  {
+    switch ((option->var_type & GET_TYPE_MASK)) {
+      case GET_STR_ALLOC:
+        free((*(char**) variable));
+        *((char**) variable)= NULL;
+        break;
+      default: /* dummy default to avoid compiler warnings */
+        break;
+    }
+    return;
+  }
+
+
+  void my_cleanup_options(const struct my_option *options)
+  {
+    init_variables(options, fini_one_value);
+  }
+
+
+  /*
+     initialize all variables to their default values
+
+     SYNOPSIS
+     init_variables()
+     options		Array of options
+
+     NOTES
+     We will initialize the value that is pointed to by options->value.
+     If the value is of type GET_ASK_ADDR, we will also ask for the address
+     for a value and initialize.
+   */
+
+  static void init_variables(const struct my_option *options,
+      init_func_p init_one_value)
+  {
+    for (; options->name; options++)
+    {
+      char* *variable;
+      /*
+         We must set u_max_value first as for some variables
+         options->u_max_value == options->value and in this case we want to
+         set the value to default value.
+       */
+      if (options->u_max_value)
+        init_one_value(options, options->u_max_value, options->max_value);
+      if (options->value)
+        init_one_value(options, options->value, options->def_value);
+      if (options->var_type & GET_ASK_ADDR &&
+          (variable= (*getopt_get_addr)("", 0, options)))
+        init_one_value(options, variable, options->def_value);
+    }
+    return;
+  }
+
+
+  /*
+function: my_print_options
+
+Print help for all options and variables.
+   */
+
+  void my_print_help(const struct my_option *options)
+  {
+    uint32_t col, name_space= 22, comment_space= 57;
+    const char *line_end;
+    const struct my_option *optp;
+
+    for (optp= options; optp->id; optp++)
+    {
+      if (optp->id < 256)
+      {
+        printf("  -%c%s", optp->id, strlen(optp->name) ? ", " : "  ");
+        col= 6;
+      }
+      else
+      {
+        printf("  ");
+        col= 2;
+      }
+      if (strlen(optp->name))
+      {
+        printf("--%s", optp->name);
+        col+= 2 + (uint32_t) strlen(optp->name);
+        if ((optp->var_type & GET_TYPE_MASK) == GET_STR ||
+            (optp->var_type & GET_TYPE_MASK) == GET_STR_ALLOC)
+        {
+          printf("%s=name%s ", optp->arg_type == OPT_ARG ? "[" : "",
+              optp->arg_type == OPT_ARG ? "]" : "");
+          col+= (optp->arg_type == OPT_ARG) ? 8 : 6;
+        }
+        else if ((optp->var_type & GET_TYPE_MASK) == GET_NO_ARG ||
+            (optp->var_type & GET_TYPE_MASK) == GET_BOOL)
+        {
+          putchar(' ');
+          col++;
+        }
+        else
+        {
+          printf("%s=#%s ", optp->arg_type == OPT_ARG ? "[" : "",
+              optp->arg_type == OPT_ARG ? "]" : "");
+          col+= (optp->arg_type == OPT_ARG) ? 5 : 3;
+        }
+        if (col > name_space && optp->comment && *optp->comment)
+        {
+          putchar('\n');
+          col= 0;
+        }
+      }
+      for (; col < name_space; col++)
+        putchar(' ');
+      if (optp->comment && *optp->comment)
+      {
+        const char *comment= _(optp->comment), *end= strchr(comment, '\0');
+
+        while ((uint32_t) (end - comment) > comment_space)
+        {
+          for (line_end= comment + comment_space; *line_end != ' '; line_end--)
+          {}
+          for (; comment != line_end; comment++)
+            putchar(*comment);
+          comment++; /* skip the space, as a newline will take it's place now */
+          putchar('\n');
+          for (col= 0; col < name_space; col++)
+            putchar(' ');
+        }
+        printf("%s", comment);
+      }
+      putchar('\n');
+      if ((optp->var_type & GET_TYPE_MASK) == GET_NO_ARG ||
+          (optp->var_type & GET_TYPE_MASK) == GET_BOOL)
+      {
+        if (optp->def_value != 0)
+        {
+          printf(_("%*s(Defaults to on; use --skip-%s to disable.)\n"), name_space, "", optp->name);
+        }
+      }
+    }
+  }
+
+
+  /*
+function: my_print_options
+
+Print variables.
+   */
+
+  void my_print_variables(const struct my_option *options)
+  {
+    uint32_t name_space= 34, length, nr;
+    uint64_t bit, llvalue;
+    char buff[255];
+    const struct my_option *optp;
+
+    printf(_("\nVariables (--variable-name=value)\n"
+          "and boolean options {false|true}  Value (after reading options)\n"
+          "--------------------------------- -----------------------------\n"));
+    for (optp= options; optp->id; optp++)
+    {
+      char* *value= (optp->var_type & GET_ASK_ADDR ?
+          (*getopt_get_addr)("", 0, optp) : optp->value);
+      if (value)
+      {
+        printf("%s ", optp->name);
+        length= (uint32_t) strlen(optp->name)+1;
+        for (; length < name_space; length++)
+          putchar(' ');
+        switch ((optp->var_type & GET_TYPE_MASK)) {
+          case GET_SET:
+            if (!(llvalue= *(uint64_t*) value))
+              printf("%s\n", _("(No default value)"));
+            else
+              for (nr= 0, bit= 1; llvalue && nr < optp->typelib->count; nr++, bit<<=1)
+              {
+                if (!(bit & llvalue))
+                  continue;
+                llvalue&= ~bit;
+                printf( llvalue ? "%s," : "%s\n", get_type(optp->typelib, nr));
+              }
+            break;
+          case GET_ENUM:
+            printf("%s\n", get_type(optp->typelib, *(uint*) value));
+            break;
+          case GET_STR:
+          case GET_STR_ALLOC:                    /* fall through */
+            printf("%s\n", *((char**) value) ? *((char**) value) :
+                _("(No default value)"));
+            break;
+          case GET_BOOL:
+            printf("%s\n", *((bool*) value) ? _("true") : _("false"));
+            break;
+          case GET_INT:
+            printf("%d\n", *((int*) value));
+            break;
+          case GET_UINT:
+            printf("%d\n", *((uint*) value));
+            break;
+          case GET_LONG:
+            printf("%ld\n", *((long*) value));
+            break;
+          case GET_UINT32:
+            printf("%u\n", *((uint32_t*) value));
+            break;
+          case GET_ULONG_IS_FAIL:
+            printf("%lu\n", *((ulong*) value));
+            break;
+          case GET_SIZE:
+            internal::int64_t2str((uint64_t)(*(size_t*)value), buff, 10);
+            printf("%s\n", buff);
+            break;
+          case GET_LL:
+            printf("%s\n", internal::llstr(*((int64_t*) value), buff));
+            break;
+          case GET_ULL:
+          case GET_UINT64:
+            internal::int64_t2str(*((uint64_t*) value), buff, 10);
+            printf("%s\n", buff);
+            break;
+          case GET_DOUBLE:
+            printf("%g\n", *(double*) value);
+            break;
+          default:
+            printf(_("(Disabled)\n"));
+            break;
+        }
+      }
+    }
+  }
 
 } /* namespace drizzled */

=== modified file 'drizzled/my_getopt.h'
--- drizzled/my_getopt.h	2010-02-04 08:14:46 +0000
+++ drizzled/my_getopt.h	2010-03-25 09:08:56 +0000
@@ -71,7 +71,7 @@
 };
 
 
-typedef bool (* my_get_one_option) (int, const struct my_option *, char * );
+typedef int (* my_get_one_option) (int, const struct my_option *, char * );
 typedef void (* my_error_reporter) (enum loglevel level, const char *format, ... );
 typedef char ** (*getopt_get_addr_func)(const char *, uint32_t, const struct my_option *);
 

=== added file 'drizzled/optimizer/cost_vector.h'
--- drizzled/optimizer/cost_vector.h	1970-01-01 00:00:00 +0000
+++ drizzled/optimizer/cost_vector.h	2010-03-19 11:57:00 +0000
@@ -0,0 +1,133 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_OPTIMIZER_COST_VECTOR_H
+#define DRIZZLED_OPTIMIZER_COST_VECTOR_H
+
+namespace drizzled
+{
+namespace optimizer
+{
+class CostVector
+{
+
+public:
+  CostVector() :
+    io_count(0.0),
+    avg_io_cost(1.0),
+    cpu_cost(0.0),
+    mem_cost(0.0),
+    import_cost(0.0)
+  {}
+
+  double total_cost()
+  {
+    return IO_COEFF*io_count*avg_io_cost + CPU_COEFF * cpu_cost +
+      MEM_COEFF*mem_cost + IMPORT_COEFF*import_cost;
+  }
+
+  void zero()
+  {
+    avg_io_cost= 1.0;
+    io_count= cpu_cost= mem_cost= import_cost= 0.0;
+  }
+
+  void multiply(double m)
+  {
+    io_count *= m;
+    cpu_cost *= m;
+    import_cost *= m;
+    /* Don't multiply mem_cost */
+  }
+
+  void add(const CostVector* cost)
+  {
+    double io_count_sum= io_count + cost->io_count;
+    add_io(cost->io_count, cost->avg_io_cost);
+    io_count= io_count_sum;
+    cpu_cost += cost->cpu_cost;
+  }
+  void add_io(double add_io_cnt, double add_avg_cost)
+  {
+    double io_count_sum= io_count + add_io_cnt;
+    avg_io_cost= (io_count * avg_io_cost +
+                  add_io_cnt * add_avg_cost) / io_count_sum;
+    io_count= io_count_sum;
+  }
+
+  /* accessor methods*/
+  void setIOCount(double m)
+  {
+     io_count= m;
+  }
+  double getIOCount() const 
+  {
+     return io_count;
+  }
+  void setAvgIOCost(double m)
+  {
+     avg_io_cost= m;
+  }
+  double getAvgIOCost() const 
+  {
+     return avg_io_cost;
+  }
+  void setCpuCost(double m)
+  { 
+     cpu_cost= m;
+  }
+  double getCpuCost() const
+  {
+     return cpu_cost;
+  }
+  void setMemCost(double m)
+  { 
+     mem_cost= m;
+  }
+  double getMemCost() const
+  {
+     return mem_cost;
+  }
+  void setImportCost(double m)
+  {
+     import_cost= m;
+  }
+  double getImportCost() const
+  {
+     return import_cost;
+  }
+
+private:
+
+  double io_count;     /* number of I/O                 */
+  double avg_io_cost;  /* cost of an average I/O oper.  */
+  double cpu_cost;     /* cost of operations in CPU     */
+  double mem_cost;     /* cost of used memory           */
+  double import_cost;  /* cost of remote operations     */
+
+  static const uint32_t IO_COEFF=1;
+  static const uint32_t CPU_COEFF=1;
+  static const uint32_t MEM_COEFF=1;
+  static const uint32_t IMPORT_COEFF=1;
+
+};
+} /* namespace optimizer */
+} /* namespace drizzled */
+
+#endif /* DRIZZLED_OPTIMIZER_COST_VECTOR_H */

=== modified file 'drizzled/optimizer/range.cc'
--- drizzled/optimizer/range.cc	2010-03-15 20:06:02 +0000
+++ drizzled/optimizer/range.cc	2010-03-22 05:47:41 +0000
@@ -112,7 +112,7 @@
 #include "drizzled/sql_base.h"
 #include "drizzled/sql_select.h"
 #include "drizzled/error.h"
-#include "drizzled/cost_vect.h"
+#include "drizzled/optimizer/cost_vector.h"
 #include "drizzled/item/cmpfunc.h"
 #include "drizzled/field/num.h"
 #include "drizzled/check_stack_overrun.h"
@@ -201,14 +201,14 @@
 static void get_sweep_read_cost(Table *table,
                                 ha_rows nrows,
                                 bool interrupted,
-                                COST_VECT *cost)
+                                optimizer::CostVector *cost)
 {
   cost->zero();
   if (table->cursor->primary_key_is_clustered())
   {
-    cost->io_count= table->cursor->read_time(table->s->primary_key,
+    cost->setIOCount(table->cursor->read_time(table->s->primary_key,
                                              static_cast<uint32_t>(nrows),
-                                             nrows);
+                                             nrows));
   }
   else
   {
@@ -219,13 +219,13 @@
     if (busy_blocks < 1.0)
       busy_blocks= 1.0;
 
-    cost->io_count= busy_blocks;
+    cost->setIOCount(busy_blocks);
 
     if (! interrupted)
     {
       /* Assume reading is done in one 'sweep' */
-      cost->avg_io_cost= (DISK_SEEK_BASE_COST +
-                          DISK_SEEK_PROP_COST*n_blocks/busy_blocks);
+      cost->setAvgIOCost((DISK_SEEK_BASE_COST +
+                          DISK_SEEK_PROP_COST*n_blocks/busy_blocks));
     }
   }
 }
@@ -257,7 +257,7 @@
                                   bool update_tbl_stats,
                                   uint32_t *mrr_flags,
                                   uint32_t *bufsize,
-                                  COST_VECT *cost);
+                                  optimizer::CostVector *cost);
 
 static optimizer::RangeReadPlan *get_key_scans_params(optimizer::Parameter *param,
                                                       optimizer::SEL_TREE *tree,
@@ -1030,7 +1030,7 @@
 
   /* Calculate cost(rowid_to_row_scan) */
   {
-    COST_VECT sweep_cost;
+    optimizer::CostVector sweep_cost;
     JOIN *join= param->session->lex->select_lex.join;
     bool is_interrupted= test(join && join->tables == 1);
     get_sweep_read_cost(param->table, non_cpk_scan_records, is_interrupted,
@@ -1148,7 +1148,7 @@
   */
   double roru_total_cost;
   {
-    COST_VECT sweep_cost;
+    optimizer::CostVector sweep_cost;
     JOIN *join= param->session->lex->select_lex.join;
     bool is_interrupted= test(join && join->tables == 1);
     get_sweep_read_cost(param->table, roru_total_records, is_interrupted,
@@ -1615,7 +1615,7 @@
   info->total_cost= info->index_scan_costs;
   if (!info->is_covering)
   {
-    COST_VECT sweep_cost;
+    optimizer::CostVector sweep_cost;
     JOIN *join= info->param->session->lex->select_lex.join;
     bool is_interrupted= test(join && join->tables == 1);
     get_sweep_read_cost(info->param->table, double2rows(info->out_rows),
@@ -2015,7 +2015,7 @@
     if (*key)
     {
       ha_rows found_records;
-      COST_VECT cost;
+      optimizer::CostVector cost;
       double found_read_time= 0.0;
       uint32_t mrr_flags, buf_size;
       uint32_t keynr= param->real_keynr[idx];
@@ -3832,7 +3832,7 @@
                            bool update_tbl_stats,
                            uint32_t *mrr_flags,
                            uint32_t *bufsize,
-                           COST_VECT *cost)
+                           optimizer::CostVector *cost)
 {
   SEL_ARG_RANGE_SEQ seq;
   RANGE_SEQ_IF seq_if = {sel_arg_range_seq_init, sel_arg_range_seq_next};
@@ -4258,7 +4258,7 @@
   optimizer::QuickRange *range= NULL;
   uint32_t part;
   bool create_err= false;
-  COST_VECT cost;
+  optimizer::CostVector cost;
 
   old_root= session->mem_root;
   /* The following call may change session->mem_root */
@@ -4925,7 +4925,7 @@
                                            param,
                                            &cur_param_idx);
       /* Check if this range tree can be used for prefix retrieval. */
-      COST_VECT dummy_cost;
+      optimizer::CostVector dummy_cost;
       uint32_t mrr_flags= HA_MRR_USE_DEFAULT_IMPL;
       uint32_t mrr_bufsize= 0;
       cur_quick_prefix_records= check_quick_select(param,

=== modified file 'drizzled/optimizer/table_read_plan.h'
--- drizzled/optimizer/table_read_plan.h	2010-03-15 20:06:02 +0000
+++ drizzled/optimizer/table_read_plan.h	2010-03-20 23:44:04 +0000
@@ -21,6 +21,7 @@
 #define DRIZZLED_OPTIMIZER_TABLE_READ_PLAN_H
 
 #include "drizzled/util/functors.h"
+#include <algorithm>
 
 namespace drizzled
 {
@@ -156,9 +157,9 @@
 
   virtual ~RorIntersectReadPlan() 
   {
-    for_each(ror_range_scans.begin(),
-             ror_range_scans.end(),
-             DeletePtr());
+    std::for_each(ror_range_scans.begin(),
+                  ror_range_scans.end(),
+                  DeletePtr());
     ror_range_scans.clear();
   }
 

=== modified file 'drizzled/plugin.h'
--- drizzled/plugin.h	2010-02-22 16:14:47 +0000
+++ drizzled/plugin.h	2010-03-06 02:08:13 +0000
@@ -26,6 +26,7 @@
 #include <drizzled/plugin/module.h>
 #include "drizzled/plugin/version.h"
 #include "drizzled/definitions.h"
+#include "drizzled/plugin/context.h"
 
 
 namespace drizzled
@@ -66,7 +67,7 @@
 
 
 #define DRIZZLE_DECLARE_PLUGIN_END
-#define DRIZZLE_PLUGIN(init,deinit,system) \
+#define DRIZZLE_PLUGIN(init,system) \
   DRIZZLE_DECLARE_PLUGIN \
   { \
     DRIZZLE_VERSION_ID, \
@@ -75,7 +76,7 @@
     STRINGIFY_ARG(PANDORA_MODULE_AUTHOR), \
     STRINGIFY_ARG(PANDORA_MODULE_TITLE), \
     PANDORA_MODULE_LICENSE, \
-    init, deinit, system, NULL \
+    init, system, NULL \
   } 
 
 

=== modified file 'drizzled/plugin/authentication.cc'
--- drizzled/plugin/authentication.cc	2010-03-02 22:58:02 +0000
+++ drizzled/plugin/authentication.cc	2010-03-18 18:07:58 +0000
@@ -77,19 +77,19 @@
     find_if(all_authentication.begin(), all_authentication.end(),
             AuthenticateBy(sctx, password));
 
-  /* If iter is == end() here, that means that all of the plugins returned
-   * false, which in this case means they all succeeded. Since we want to 
-   * return false on success, we return the value of the two being != 
+  /* We only require one plugin to return success in order to authenticate.
+   * If iter is == end() here, that means that all of the plugins returned
+   * false, which means they all failed.
    */
-  if (iter != all_authentication.end())
+  if (iter == all_authentication.end())
   {
     my_error(ER_ACCESS_DENIED_ERROR, MYF(0),
              sctx.getUser().c_str(),
              sctx.getIp().c_str(),
              password.empty() ? ER(ER_NO) : ER(ER_YES));
-    return true;
+    return false;
   }
-  return false;
+  return true;
 }
 
 } /* namespace drizzled */

=== added file 'drizzled/plugin/context.h'
--- drizzled/plugin/context.h	1970-01-01 00:00:00 +0000
+++ drizzled/plugin/context.h	2010-03-10 19:38:39 +0000
@@ -0,0 +1,92 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Monty Taylor
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_PLUGIN_CONTEXT_H
+#define DRIZZLED_PLUGIN_CONTEXT_H
+
+/**
+ * @file Defines a Plugin Context
+ *
+ * A plugin::Context object is a proxy object containing state information
+ * about the plugin being registered that knows how to perform registration
+ * actions.
+ *
+ * The plugin registration system creates a new plugin::Context for each
+ * plugin::Module during the initializtion phase and passes a reference to
+ * the plugin::Context to the module's init method. This allows the plugin
+ * to call registration methods without having access to larger plugin::Registry
+ * calls. It also provides a filter layer through which calls are made in order
+ * to force things like proper name prefixing and the like.
+ */
+
+#include "drizzled/plugin/registry.h"
+
+namespace drizzled
+{
+
+class sys_var;
+
+namespace plugin
+{
+class Module;
+
+class Context
+{
+private:
+  Registry &registry;
+  Module *module;
+
+  Context(const Context&);
+  Context& operator=(const Context&);
+public:
+
+  Context(Registry &registry_arg,
+          Module *module_arg) :
+     registry(registry_arg),
+     module(module_arg)
+  { }
+
+  template<class T>
+  void add(T *plugin)
+  {
+    plugin->setModule(module);
+    registry.add(plugin);
+  }
+
+  template<class T>
+  void remove(T *plugin)
+  {
+    registry.remove(plugin);
+  }
+
+  void registerVariable(sys_var *var);
+};
+
+inline void Context::registerVariable(sys_var *)
+{
+/* In here, you can do:
+  sys_var->append_name_prefix(module->getName());
+  register_variable_whatever();
+*/
+}
+
+} /* end namespace plugin */
+} /* end namespace drizzled */
+
+#endif /* DRIZZLED_PLUGIN_CONTEXT_H */

=== added file 'drizzled/plugin/daemon.h'
--- drizzled/plugin/daemon.h	1970-01-01 00:00:00 +0000
+++ drizzled/plugin/daemon.h	2010-03-06 02:08:13 +0000
@@ -0,0 +1,61 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Daemon Plugin Interface
+ *
+ *  Copyright (C) 2010 Monty Taylor
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_PLUGIN_DAEMON_H
+#define DRIZZLED_PLUGIN_DAEMON_H
+
+#include "drizzled/plugin/plugin.h"
+
+namespace drizzled
+{
+class Session;
+
+namespace plugin
+{
+
+class Daemon : public Plugin
+{
+  Daemon();
+  Daemon(const Daemon &);
+  Daemon& operator=(const Daemon &);
+public:
+  explicit Daemon(std::string name_arg)
+    : Plugin(name_arg, "Daemon")
+  {}
+
+  virtual ~Daemon() {}
+
+  /**
+   * Standard plugin system registration hooks
+   */
+  static bool addPlugin(Daemon *)
+  {
+    return false;
+  }
+  static void removePlugin(Daemon *)
+  {}
+
+};
+
+} /* namespace plugin */
+} /* namespace drizzled */
+
+#endif /* DRIZZLED_PLUGIN_DAEMON_H */

=== modified file 'drizzled/plugin/library.cc'
--- drizzled/plugin/library.cc	2009-12-14 00:09:39 +0000
+++ drizzled/plugin/library.cc	2010-03-24 19:45:37 +0000
@@ -68,7 +68,12 @@
   dlpath.append("/");
   dlpath.append("lib");
   dlpath.append(plugin_name);
-  dlpath.append("_plugin.so");
+  dlpath.append("_plugin");
+#if defined(TARGET_OS_OSX)
+  dlpath.append(".dylib");
+#else
+  dlpath.append(".so");
+#endif
 
   /* Open new dll handle */
   void *handle= dlopen(dlpath.c_str(), RTLD_NOW|RTLD_GLOBAL);

=== modified file 'drizzled/plugin/library.h'
--- drizzled/plugin/library.h	2009-11-27 21:14:56 +0000
+++ drizzled/plugin/library.h	2010-03-11 21:35:22 +0000
@@ -20,6 +20,14 @@
 #ifndef DRIZZLED_PLUGIN_LIBRARY_H
 #define DRIZZLED_PLUGIN_LIBRARY_H
 
+/**
+ * @file Defines a Plugin Library Wrapper
+ *
+ * A plugin::Library is a wrapper object around a plugin .so file. It owns
+ * the void * returned by dlopen and contains the knowledge of how to load
+ * and unload plugin libraries via dlopen().
+ */
+
 #include <string>
 
 namespace drizzled

=== modified file 'drizzled/plugin/loader.cc'
--- drizzled/plugin/loader.cc	2010-02-18 04:43:04 +0000
+++ drizzled/plugin/loader.cc	2010-03-26 06:54:35 +0000
@@ -154,7 +154,7 @@
                               const vector<string> &plugins_to_remove);
 static bool plugin_load_list(plugin::Registry &registry,
                              memory::Root *tmp_root, int *argc, char **argv,
-                             const vector<string> &plugin_list);
+                             const set<string> &plugin_list);
 static int test_plugin_options(memory::Root *, plugin::Module *,
                                int *, char **);
 static void unlock_variables(Session *session, struct system_variables *vars);
@@ -281,16 +281,8 @@
 }
 
 
-static void delete_module(plugin::Registry &registry, plugin::Module *module)
+static void delete_module(plugin::Module *module)
 {
-  plugin::Manifest manifest= module->getManifest();
-
-  if (module->isInited)
-  {
-    if (manifest.deinit)
-      manifest.deinit(registry);
-  }
-
   /* Free allocated strings before deleting the plugin. */
   plugin_vars_free_values(module->system_vars);
   module->isInited= false;
@@ -303,17 +295,16 @@
 
 static void reap_plugins(plugin::Registry &registry)
 {
-  plugin::Module *module;
-
   std::map<std::string, plugin::Module *>::const_iterator modules=
     registry.getModulesMap().begin();
-    
+
   while (modules != registry.getModulesMap().end())
   {
-    module= (*modules).second;
-    delete_module(registry, module);
+    plugin::Module *module= (*modules).second;
+    delete_module(module);
     ++modules;
   }
+
   drizzle_del_plugin_sysvar();
 }
 
@@ -343,10 +334,10 @@
 {
   assert(module->isInited == false);
 
-  registry.setCurrentModule(module);
+  plugin::Context loading_context(registry, module);
   if (module->getManifest().init)
   {
-    if (module->getManifest().init(registry))
+    if (module->getManifest().init(loading_context))
     {
       errmsg_printf(ERRMSG_LVL_ERROR,
                     _("Plugin '%s' init function returned error.\n"),
@@ -354,7 +345,6 @@
       return true;
     }
   }
-  registry.clearCurrentModule();
   module->isInited= true;
 
 
@@ -456,10 +446,13 @@
     tokenize(opt_plugin_remove, plugins_to_remove, ",", true);
     plugin_prune_list(plugin_list, plugins_to_remove);
   }
+
+  /* Uniquify the list */
+  const set<string> plugin_list_set(plugin_list.begin(), plugin_list.end());
   
   /* Register all dynamic plugins */
   load_failed= plugin_load_list(registry, &tmp_root, argc, argv,
-                                plugin_list);
+                                plugin_list_set);
   if (load_failed)
   {
     free_root(&tmp_root, MYF(0));
@@ -487,7 +480,7 @@
       plugin_initialize_vars(module);
 
       if (plugin_initialize(registry, module))
-        delete_module(registry, module);
+        delete_module(module);
     }
   }
 
@@ -533,11 +526,11 @@
 */
 static bool plugin_load_list(plugin::Registry &registry,
                              memory::Root *tmp_root, int *argc, char **argv,
-                             const vector<string> &plugin_list)
+                             const set<string> &plugin_list)
 {
   plugin::Library *library= NULL;
 
-  for (vector<string>::const_iterator iter= plugin_list.begin();
+  for (set<string>::const_iterator iter= plugin_list.begin();
        iter != plugin_list.end();
        ++iter)
   {
@@ -1450,7 +1443,7 @@
     options->arg_type= OPT_ARG;
 }
 
-static bool get_one_plugin_option(int, const struct my_option *, char *)
+static int get_one_plugin_option(int, const struct my_option *, char *)
 {
   return 0;
 }

=== modified file 'drizzled/plugin/manifest.h'
--- drizzled/plugin/manifest.h	2010-02-18 04:43:04 +0000
+++ drizzled/plugin/manifest.h	2010-03-11 21:35:22 +0000
@@ -20,7 +20,13 @@
 #ifndef DRIZZLED_PLUGIN_MANIFEST_H
 #define DRIZZLED_PLUGIN_MANIFEST_H
 
-#include <drizzled/plugin/registry.h>
+/**
+ * @file Defines a Plugin Manifest
+ *
+ * A plugin::Manifest is the struct contained in every Plugin Library.
+ */
+
+#include "drizzled/plugin/context.h"
 
 namespace drizzled
 {
@@ -41,7 +47,7 @@
 namespace plugin
 {
 
-typedef int (*initialize_func_t)(Registry &);
+typedef int (*initialize_func_t)(Context &);
 
 /**
  * Plugin Manfiest
@@ -60,7 +66,6 @@
   const char *descr;         /* general descriptive text (for SHOW PLUGINS ) */
   plugin_license_type license; /* plugin license (PLUGIN_LICENSE_XXX)          */
   initialize_func_t init;     /* function to invoke when plugin is loaded     */
-  initialize_func_t deinit;   /* function to invoke when plugin is unloaded   */
   drizzle_sys_var **system_vars;
   void *reserved1;           /* reserved for dependency checking             */
 };

=== modified file 'drizzled/plugin/module.h'
--- drizzled/plugin/module.h	2010-02-04 08:14:46 +0000
+++ drizzled/plugin/module.h	2010-03-16 20:32:51 +0000
@@ -20,7 +20,16 @@
 #ifndef DRIZZLED_PLUGIN_MODULE_H
 #define DRIZZLED_PLUGIN_MODULE_H
 
-#include "drizzled/lex_string.h"
+/**
+ * @file Defines a Plugin Module
+ *
+ * A plugin::Module is the fundamental functional element of the plugin system.
+ * Plugins are inited and deinited by module. A module init can register one
+ * or more plugin::Plugin objects. 
+ */
+
+#include <cassert>
+
 #include "drizzled/plugin/manifest.h"
 
 namespace drizzled
@@ -44,12 +53,18 @@
   Module(const Manifest *manifest_arg, Library *library_arg)
     : name(manifest_arg->name), manifest(manifest_arg), plugin_dl(library_arg),
       isInited(false),
-      system_vars(NULL) {}
+      system_vars(NULL)
+  {
+    assert(manifest != NULL);
+  }
       
   Module(const Manifest *manifest_arg)
     : name(manifest_arg->name), manifest(manifest_arg), plugin_dl(NULL),
       isInited(false),
-      system_vars(NULL) {}
+      system_vars(NULL)
+  {
+    assert(manifest != NULL);
+  }
       
   const std::string& getName() const
   {

=== modified file 'drizzled/plugin/query_cache.h'
--- drizzled/plugin/query_cache.h	2009-12-21 07:54:59 +0000
+++ drizzled/plugin/query_cache.h	2010-03-06 02:08:13 +0000
@@ -24,10 +24,10 @@
 
 #include "drizzled/plugin/plugin.h"
 
+namespace drizzled
+{
 class Session;
 
-namespace drizzled
-{
 namespace plugin
 {
 

=== modified file 'drizzled/plugin/registry.cc'
--- drizzled/plugin/registry.cc	2009-12-21 09:40:31 +0000
+++ drizzled/plugin/registry.cc	2010-03-06 02:12:09 +0000
@@ -37,11 +37,29 @@
 
 plugin::Registry::~Registry()
 {
-  map<string, plugin::Library *>::iterator iter= library_map.begin();
-  while (iter != library_map.end())
-  {
-    delete (*iter).second;
-    ++iter;
+  map<string, plugin::Plugin *>::iterator plugin_iter= plugin_registry.begin();
+  while (plugin_iter != plugin_registry.end())
+  {
+    delete (*plugin_iter).second;
+    ++plugin_iter;
+  }
+  plugin_registry.clear();
+
+  /*
+    @TODO When we delete modules here, we segfault on a bad string. Why?
+    map<string, plugin::Module *>::iterator module_iter= module_map.begin();
+  while (module_iter != module_map.end())
+  {
+    delete (*module_iter).second;
+    ++module_iter;
+  }
+  module_map.clear();
+  */
+  map<string, plugin::Library *>::iterator library_iter= library_map.begin();
+  while (library_iter != library_map.end())
+  {
+    delete (*library_iter).second;
+    ++library_iter;
   }
   library_map.clear();
 }

=== modified file 'drizzled/plugin/registry.h'
--- drizzled/plugin/registry.h	2009-11-27 21:14:56 +0000
+++ drizzled/plugin/registry.h	2010-03-06 02:08:13 +0000
@@ -42,14 +42,11 @@
 private:
   std::map<std::string, Library *> library_map;
   std::map<std::string, Module *> module_map;
-  std::map<std::string, const Plugin *> plugin_registry;
-
-  Module *current_module;
+  std::map<std::string, Plugin *> plugin_registry;
 
   Registry()
    : module_map(),
-     plugin_registry(),
-     current_module(NULL)
+     plugin_registry()
   { }
 
   Registry(const Registry&);
@@ -69,19 +66,10 @@
 
   void add(Module *module);
 
-  void setCurrentModule(Module *module)
-  {
-    current_module= module;
-  }
-
-  void clearCurrentModule()
-  {
-    current_module= NULL;
-  }
 
   std::vector<Module *> getList(bool active);
 
-  const std::map<std::string, const Plugin *> &getPluginsMap() const
+  const std::map<std::string, Plugin *> &getPluginsMap() const
   {
     return plugin_registry;
   }
@@ -98,7 +86,6 @@
   template<class T>
   void add(T *plugin)
   {
-    plugin->setModule(current_module);
     bool failed= false;
     std::string plugin_name(plugin->getName());
     std::transform(plugin_name.begin(), plugin_name.end(),
@@ -119,7 +106,7 @@
                     plugin->getName().c_str());
       unireg_abort(1);
     }
-    plugin_registry.insert(std::pair<std::string, const Plugin *>(plugin_name, plugin));
+    plugin_registry.insert(std::pair<std::string, Plugin *>(plugin_name, plugin));
   }
 
   template<class T>

=== modified file 'drizzled/plugin/storage_engine.cc'
--- drizzled/plugin/storage_engine.cc	2010-03-19 04:54:45 +0000
+++ drizzled/plugin/storage_engine.cc	2010-03-24 19:52:38 +0000
@@ -74,17 +74,15 @@
 static std::set<std::string> set_of_table_definition_ext;
 
 StorageEngine::StorageEngine(const string name_arg,
-                             const bitset<HTON_BIT_SIZE> &flags_arg)
-    : Plugin(name_arg, "StorageEngine"),
-      MonitoredInTransaction(), /* This gives the storage engine a "slot" or ID */
-      flags(flags_arg)
+                             const bitset<HTON_BIT_SIZE> &flags_arg) :
+  Plugin(name_arg, "StorageEngine"),
+  MonitoredInTransaction(), /* This gives the storage engine a "slot" or ID */
+  flags(flags_arg)
 {
-  pthread_mutex_init(&proto_cache_mutex, NULL);
 }
 
 StorageEngine::~StorageEngine()
 {
-  pthread_mutex_destroy(&proto_cache_mutex);
 }
 
 void StorageEngine::setTransactionReadWrite(Session& session)
@@ -93,24 +91,14 @@
   statement_ctx.markModifiedNonTransData();
 }
 
-int StorageEngine::doRenameTable(Session *,
-                                 const char *from,
-                                 const char *to)
+
+int StorageEngine::renameTable(Session &session, TableIdentifier &from, TableIdentifier &to)
 {
-  int error= 0;
-  for (const char **ext= bas_ext(); *ext ; ext++)
-  {
-    if (rename_file_ext(from, to, *ext))
-    {
-      if ((error=errno) != ENOENT)
-	break;
-      error= 0;
-    }
-  }
-  return error;
+  setTransactionReadWrite(session);
+
+  return doRenameTable(session, from, to);
 }
 
-
 /**
   Delete all files with extension from bas_ext().
 
@@ -140,7 +128,7 @@
     if (internal::my_delete_with_symlink(buff, MYF(0)))
     {
       if ((error= errno) != ENOENT)
-	break;
+        break;
     }
     else
       enoent_or_zero= 0;                        // No error for ENOENT
@@ -184,11 +172,13 @@
 class FindEngineByName
   : public unary_function<StorageEngine *, bool>
 {
-  const string target;
+  const string &target;
+
 public:
-  explicit FindEngineByName(const string target_arg)
-    : target(target_arg)
-  {}
+  explicit FindEngineByName(const string &target_arg) :
+    target(target_arg)
+  {
+  }
   result_type operator() (argument_type engine)
   {
     string engine_name(engine->getName());
@@ -199,15 +189,16 @@
   }
 };
 
-StorageEngine *StorageEngine::findByName(string find_str)
+StorageEngine *StorageEngine::findByName(const string &find_str)
 {
-  transform(find_str.begin(), find_str.end(),
-            find_str.begin(), ::tolower);
+  string search_string(find_str);
+  transform(search_string.begin(), search_string.end(),
+            search_string.begin(), ::tolower);
 
   
   EngineVector::iterator iter= find_if(vector_of_engines.begin(),
                                        vector_of_engines.end(),
-                                       FindEngineByName(find_str));
+                                       FindEngineByName(search_string));
   if (iter != vector_of_engines.end())
   {
     StorageEngine *engine= *iter;
@@ -218,19 +209,18 @@
   return NULL;
 }
 
-StorageEngine *StorageEngine::findByName(Session& session,
-                                                         string find_str)
+StorageEngine *StorageEngine::findByName(Session& session, const string &find_str)
 {
-  
-  transform(find_str.begin(), find_str.end(),
-            find_str.begin(), ::tolower);
+  string search_string(find_str);
+  transform(search_string.begin(), search_string.end(),
+            search_string.begin(), ::tolower);
 
-  if (find_str.compare("default") == 0)
+  if (search_string.compare("default") == 0)
     return session.getDefaultStorageEngine();
 
   EngineVector::iterator iter= find_if(vector_of_engines.begin(),
                                        vector_of_engines.end(),
-                                       FindEngineByName(find_str));
+                                       FindEngineByName(search_string));
   if (iter != vector_of_engines.end())
   {
     StorageEngine *engine= *iter;
@@ -241,8 +231,7 @@
   return NULL;
 }
 
-class StorageEngineCloseConnection
-: public unary_function<StorageEngine *, void>
+class StorageEngineCloseConnection : public unary_function<StorageEngine *, void>
 {
   Session *session;
 public:
@@ -290,13 +279,13 @@
   Session& session;
   TableIdentifier &identifier;
   message::Table &table_message;
-  int *err;
+  int &err;
 
 public:
   StorageEngineGetTableDefinition(Session& session_arg,
                                   TableIdentifier &identifier_arg,
                                   message::Table &table_message_arg,
-                                  int *err_arg) :
+                                  int &err_arg) :
     session(session_arg), 
     identifier(identifier_arg),
     table_message(table_message_arg), 
@@ -309,9 +298,9 @@
                                           table_message);
 
     if (ret != ENOENT)
-      *err= ret;
+      err= ret;
 
-    return *err == EEXIST || *err != ENOENT;
+    return err == EEXIST || err != ENOENT;
   }
 };
 
@@ -384,7 +373,7 @@
 
   EngineVector::iterator iter=
     find_if(vector_of_engines.begin(), vector_of_engines.end(),
-            StorageEngineGetTableDefinition(session, identifier, table_message, &err));
+            StorageEngineGetTableDefinition(session, identifier, table_message, err));
 
   if (iter == vector_of_engines.end())
   {
@@ -442,9 +431,7 @@
 
   result_type operator() (argument_type engine)
   {
-    // @todo someday check that at least one engine said "true"
-    std::string path(identifier.getPath());
-    bool success= engine->doDropTable(session, identifier, path);
+    bool success= engine->doDropTable(session, identifier);
 
     if (success)
       success_count++;
@@ -478,7 +465,7 @@
   {
     std::string path(identifier.getPath());
     engine->setTransactionReadWrite(session);
-    error= engine->doDropTable(session, identifier, path);
+    error= engine->doDropTable(session, identifier);
 
     if (not error)
     {
@@ -505,10 +492,8 @@
    0  ok
   @retval
    1  error
-
-   @todo refactor to remove goto
 */
-int StorageEngine::createTable(Session& session,
+int StorageEngine::createTable(Session &session,
                                TableIdentifier &identifier,
                                bool update_create_info,
                                message::Table& table_message)
@@ -518,62 +503,62 @@
   TableShare share(identifier.getDBName().c_str(), 0, identifier.getTableName().c_str(), identifier.getPath().c_str());
   message::Table tmp_proto;
 
-  if (parse_table_proto(session, table_message, &share))
-    goto err;
-
-  if (open_table_from_share(&session, &share, "", 0, 0,
-                            &table))
-    goto err;
-
-  if (update_create_info)
-    table.updateCreateInfo(&table_message);
-
-  /* Check for legal operations against the Engine using the proto (if used) */
-  if (table_message.type() == message::Table::TEMPORARY &&
-      share.storage_engine->check_flag(HTON_BIT_TEMPORARY_NOT_SUPPORTED) == true)
-  {
-    error= HA_ERR_UNSUPPORTED;
-    goto err2;
-  }
-  else if (table_message.type() != message::Table::TEMPORARY &&
-           share.storage_engine->check_flag(HTON_BIT_TEMPORARY_ONLY) == true)
-  {
-    error= HA_ERR_UNSUPPORTED;
-    goto err2;
-  }
-
-  {
-    if (not share.storage_engine->check_flag(HTON_BIT_HAS_DATA_DICTIONARY))
-    {
-      int protoerr= StorageEngine::writeDefinitionFromPath(identifier, table_message);
-
-      if (protoerr)
-      {
-        error= protoerr;
-        goto err2;
-      }
-    }
-
-    share.storage_engine->setTransactionReadWrite(session);
-
-    error= share.storage_engine->doCreateTable(&session,
-                                               table,
-                                               identifier,
-                                               table_message);
-  }
-
-err2:
-  if (error)
-  {
-    if (not share.storage_engine->check_flag(HTON_BIT_HAS_DATA_DICTIONARY))
-      plugin::StorageEngine::deleteDefinitionFromPath(identifier);
-
-    my_error(ER_CANT_CREATE_TABLE, MYF(ME_BELL+ME_WAITTANG), identifier.getSQLPath().c_str(), error);
-  }
-
-  table.closefrm(false);
-
-err:
+  if (parse_table_proto(session, table_message, &share) || open_table_from_share(&session, &share, "", 0, 0, &table))
+  { 
+    // @note Error occured, we should probably do a little more here.
+  }
+  else
+  {
+    if (update_create_info)
+      table.updateCreateInfo(&table_message);
+
+    /* Check for legal operations against the Engine using the proto (if used) */
+    if (table_message.type() == message::Table::TEMPORARY &&
+        share.storage_engine->check_flag(HTON_BIT_TEMPORARY_NOT_SUPPORTED) == true)
+    {
+      error= HA_ERR_UNSUPPORTED;
+    }
+    else if (table_message.type() != message::Table::TEMPORARY &&
+             share.storage_engine->check_flag(HTON_BIT_TEMPORARY_ONLY) == true)
+    {
+      error= HA_ERR_UNSUPPORTED;
+    }
+    else
+    {
+      bool do_create= true;
+      if (not share.storage_engine->check_flag(HTON_BIT_HAS_DATA_DICTIONARY))
+      {
+        int protoerr= StorageEngine::writeDefinitionFromPath(identifier, table_message);
+
+        if (protoerr)
+        {
+          error= protoerr;
+          do_create= false;
+        }
+      }
+
+      if (do_create)
+      {
+        share.storage_engine->setTransactionReadWrite(session);
+
+        error= share.storage_engine->doCreateTable(&session,
+                                                   table,
+                                                   identifier,
+                                                   table_message);
+      }
+    }
+
+    if (error)
+    {
+      if (not share.storage_engine->check_flag(HTON_BIT_HAS_DATA_DICTIONARY))
+        plugin::StorageEngine::deleteDefinitionFromPath(identifier);
+
+      my_error(ER_CANT_CREATE_TABLE, MYF(ME_BELL+ME_WAITTANG), identifier.getSQLPath().c_str(), error);
+    }
+
+    table.closefrm(false);
+  }
+
   share.free_table_share();
   return(error != 0);
 }
@@ -862,7 +847,7 @@
          iter++)
     {
       TableIdentifier dummy((*iter).c_str());
-      int error= engine->doDropTable(session, dummy, *iter);
+      int error= engine->doDropTable(session, dummy);
 
       // On a return of zero we know we found and deleted the table. So we
       // remove it from our search.
@@ -1222,6 +1207,48 @@
   src_path.append(DEFAULT_DEFINITION_FILE_EXT);
   dest_path.append(DEFAULT_DEFINITION_FILE_EXT);
 
+  int fd= open(src_path.c_str(), O_RDONLY);
+
+  if (fd == -1)
+  {
+    perror(src_path.c_str());
+    return errno;
+  }
+
+  google::protobuf::io::ZeroCopyInputStream* input=
+    new google::protobuf::io::FileInputStream(fd);
+
+  if (not input)
+    return HA_ERR_CRASHED_ON_USAGE;
+
+  message::Table table_message;
+  if (not table_message.ParseFromZeroCopyStream(input))
+  {
+    close(fd);
+    delete input;
+    if (not table_message.IsInitialized())
+    {
+      my_error(ER_CORRUPT_TABLE_DEFINITION, MYF(0),
+               table_message.InitializationErrorString().c_str());
+      return ER_CORRUPT_TABLE_DEFINITION;
+    }
+
+    return HA_ERR_CRASHED_ON_USAGE;
+  }
+  close(fd);
+  delete input;
+
+  dest.copyToTableMessage(table_message);
+
+  // We have to update the source to have the right information before we
+  // make it the master.
+  int error=  StorageEngine::writeDefinitionFromPath(src, table_message);
+  if (error)
+  {
+    perror(src_path.c_str());
+    return error;
+  }
+
   return internal::my_rename(src_path.c_str(), dest_path.c_str(), MYF(MY_WME));
 }
 
@@ -1234,7 +1261,10 @@
   int fd= open(file_name.c_str(), O_RDWR|O_CREAT|O_TRUNC, internal::my_umask);
 
   if (fd == -1)
+  {
+    perror(file_name.c_str());
     return errno;
+  }
 
   google::protobuf::io::ZeroCopyOutputStream* output=
     new google::protobuf::io::FileOutputStream(fd);
@@ -1243,11 +1273,13 @@
   {
     delete output;
     close(fd);
+    perror(file_name.c_str());
     return errno;
   }
 
   delete output;
   close(fd);
+
   return 0;
 }
 

=== modified file 'drizzled/plugin/storage_engine.h'
--- drizzled/plugin/storage_engine.h	2010-03-19 01:45:39 +0000
+++ drizzled/plugin/storage_engine.h	2010-03-25 00:11:02 +0000
@@ -83,6 +83,7 @@
   HTON_BIT_HAS_CHECKSUM,
   HTON_BIT_SKIP_STORE_LOCK,
   HTON_BIT_SCHEMA_DICTIONARY,
+  HTON_BIT_FOREIGN_KEYS,
   HTON_BIT_SIZE
 };
 
@@ -115,6 +116,7 @@
 static const std::bitset<HTON_BIT_SIZE> HTON_HAS_CHECKSUM(1 << HTON_BIT_HAS_CHECKSUM);
 static const std::bitset<HTON_BIT_SIZE> HTON_SKIP_STORE_LOCK(1 << HTON_BIT_SKIP_STORE_LOCK);
 static const std::bitset<HTON_BIT_SIZE> HTON_HAS_SCHEMA_DICTIONARY(1 << HTON_BIT_SCHEMA_DICTIONARY);
+static const std::bitset<HTON_BIT_SIZE> HTON_HAS_FOREIGN_KEYS(1 << HTON_BIT_FOREIGN_KEYS);
 
 
 class Table;
@@ -285,29 +287,17 @@
                             TableIdentifier &identifier,
                             message::Table& proto)= 0;
 
-  virtual int doRenameTable(Session* session,
-                            const char *from, const char *to);
+  virtual int doRenameTable(Session &session,
+                            TableIdentifier &from, TableIdentifier &to)= 0;
 
 public:
 
-  int renameTable(Session *session, const char *from, const char *to) 
-  {
-    setTransactionReadWrite(*session);
-
-    return doRenameTable(session, from, to);
-  }
+  int renameTable(Session &session, TableIdentifier &from, TableIdentifier &to);
 
   // @todo move these to protected
   virtual void doGetTableNames(CachedDirectory &directory,
                                std::string& db_name,
                                TableNameList &set_of_names);
-  int doDropTable(Session &session,
-                  TableIdentifier &identifier,
-                  const std::string &table_path)
-  {
-    assert(not table_path.compare(identifier.getPath()));
-    return doDropTable(session, identifier);
-  }
 
   virtual int doDropTable(Session &session,
                           TableIdentifier &identifier)= 0;
@@ -326,9 +316,9 @@
 
   virtual bool doDoesTableExist(Session& session, TableIdentifier &identifier);
 
-  static plugin::StorageEngine *findByName(std::string find_str);
-  static plugin::StorageEngine *findByName(Session& session,
-                                           std::string find_str);
+  static plugin::StorageEngine *findByName(const std::string &find_str);
+  static plugin::StorageEngine *findByName(Session& session, const std::string &find_str);
+
   static void closeConnection(Session* session);
   static void dropDatabase(char* path);
   static bool flushLogs(plugin::StorageEngine *db_type);
@@ -404,7 +394,6 @@
   virtual uint32_t max_supported_key_part_length(void) const { return 255; }
 
   /* TODO-> Make private */
-  static int readDefinitionFromPath(TableIdentifier &identifier, message::Table &proto);
   static int deleteDefinitionFromPath(TableIdentifier &identifier);
   static int renameDefinitionFromPath(TableIdentifier &dest, TableIdentifier &src);
   static int writeDefinitionFromPath(TableIdentifier &identifier, message::Table &proto);

=== modified file 'drizzled/security_context.h'
--- drizzled/security_context.h	2010-03-02 18:41:37 +0000
+++ drizzled/security_context.h	2010-03-18 18:07:58 +0000
@@ -33,7 +33,15 @@
 
 class SecurityContext {
 public:
-  SecurityContext() {}
+  enum PasswordType
+  {
+    PLAIN_TEXT,
+    MYSQL_HASH
+  };
+
+  SecurityContext():
+    password_type(PLAIN_TEXT)
+  { }
 
   const std::string& getIp() const
   {
@@ -55,9 +63,31 @@
     user.assign(newuser);
   }
 
+  PasswordType getPasswordType(void) const
+  {
+    return password_type;
+  }
+
+  void setPasswordType(PasswordType newpassword_type)
+  {
+    password_type= newpassword_type;
+  }
+
+  const std::string& getPasswordContext() const
+  {
+    return password_context;
+  }
+
+  void setPasswordContext(const char *newpassword_context, size_t size)
+  {
+    password_context.assign(newpassword_context, size);
+  }
+
 private:
+  PasswordType password_type;
   std::string user;
   std::string ip;
+  std::string password_context;
 };
 
 } /* namespace drizzled */

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2010-03-19 04:54:45 +0000
+++ drizzled/session.cc	2010-03-24 19:52:38 +0000
@@ -2054,7 +2054,7 @@
   if (delete_table_proto_file(path))
     error= true;
 
-  if (base->doDropTable(*this, dummy, path))
+  if (base->doDropTable(*this, dummy))
   {
     error= true;
     errmsg_printf(ERRMSG_LVL_WARN, _("Could not remove temporary table: '%s', error: %d"),
@@ -2076,8 +2076,10 @@
 
   iter= table_message_cache.find(identifier.getPath());
 
-  if (iter != table_message_cache.end())
-    table_message_cache.erase(iter);
+  if (iter == table_message_cache.end())
+    return false;
+
+  table_message_cache.erase(iter);
 
   return true;
 }
@@ -2088,6 +2090,9 @@
 
   iter= table_message_cache.find(identifier.getPath());
 
+  if (iter == table_message_cache.end())
+    return false;
+
   table_message.CopyFrom(((*iter).second));
 
   return true;
@@ -2099,12 +2104,32 @@
 
   iter= table_message_cache.find(identifier.getPath());
 
-  if (iter != table_message_cache.end())
-  {
-    return true;
-  }
-
-  return false;
+  if (iter == table_message_cache.end())
+  {
+    return false;
+  }
+
+  return true;
+}
+
+bool Session::renameTableMessage(TableIdentifier &from, TableIdentifier &to)
+{
+  TableMessageCache::iterator iter;
+
+  table_message_cache[to.getPath()]= table_message_cache[from.getPath()];
+
+  iter= table_message_cache.find(to.getPath());
+
+  if (iter == table_message_cache.end())
+  {
+    return false;
+  }
+
+  to.copyToTableMessage((*iter).second);
+
+  (void)removeTableMessage(from);
+
+  return true;
 }
 
 } /* namespace drizzled */

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2010-03-19 04:54:45 +0000
+++ drizzled/session.h	2010-03-24 22:22:00 +0000
@@ -1351,6 +1351,7 @@
   void close_old_data_files(bool morph_locks= false,
                             bool send_refresh= false);
   void close_open_tables();
+  void close_data_files_and_morph_locks(TableIdentifier &identifier);
   void close_data_files_and_morph_locks(const char *db, const char *table_name);
 
 private:
@@ -1408,8 +1409,7 @@
   Table *openTable(TableList *table_list, bool *refresh, uint32_t flags= 0);
 
   void unlink_open_table(Table *find);
-  void drop_open_table(Table *table, const char *db_name,
-                       const char *table_name);
+  void drop_open_table(Table *table, TableIdentifier &identifier);
   void close_cached_table(Table *table);
 
   /* Create a lock in the cache */
@@ -1418,20 +1418,26 @@
   bool lock_table_name_if_not_cached(const char *db,
                                      const char *table_name, Table **table);
 
-  typedef std::map <std::string, message::Table> TableMessageCache;
+  typedef drizzled::hash_map<std::string, message::Table> TableMessageCache;
   TableMessageCache table_message_cache;
 
   bool storeTableMessage(TableIdentifier &identifier, message::Table &table_message);
   bool removeTableMessage(TableIdentifier &identifier);
   bool getTableMessage(TableIdentifier &identifier, message::Table &table_message);
   bool doesTableMessageExist(TableIdentifier &identifier);
+  bool renameTableMessage(TableIdentifier &from, TableIdentifier &to);
 
   /* Work with temporary tables */
   Table *find_temporary_table(TableList *table_list);
   Table *find_temporary_table(const char *db, const char *table_name);
+  Table *find_temporary_table(TableIdentifier &identifier);
+
   void doGetTableNames(CachedDirectory &directory,
                        const std::string& db_name,
                        std::set<std::string>& set_of_names);
+  void doGetTableNames(const std::string& db_name,
+                       std::set<std::string>& set_of_names);
+
   int doGetTableDefinition(drizzled::TableIdentifier &identifier,
                            message::Table &table_proto);
   bool doDoesTableExist(TableIdentifier &identifier);

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2010-03-04 16:54:08 +0000
+++ drizzled/show.cc	2010-03-22 19:44:37 +0000
@@ -404,12 +404,6 @@
 
     if (field->has_charset())
     {
-      if (field->charset() != share->table_charset)
-      {
-        packet->append(STRING_WITH_LEN(" CHARACTER SET "));
-        packet->append(field->charset()->csname);
-      }
-
       /*
         For string types dump collation name only if
         collation is not primary for the given charset

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2010-03-19 04:54:45 +0000
+++ drizzled/sql_base.cc	2010-03-24 22:22:00 +0000
@@ -416,7 +416,7 @@
       Open placeholders have Table::db_stat set to 0, so they should be
       handled by the first alternative.
     */
-    assert(!table->open_placeholder);
+    assert(not table->open_placeholder);
 
     /* Free memory and reset for next loop */
     table->cursor->ha_reset();
@@ -586,8 +586,7 @@
 }
 
 
-void Session::doGetTableNames(CachedDirectory &,
-                              const std::string& db_name,
+void Session::doGetTableNames(const std::string& db_name,
                               std::set<std::string>& set_of_names)
 {
   for (Table *table= temporary_tables ; table ; table= table->next)
@@ -599,15 +598,22 @@
   }
 }
 
+void Session::doGetTableNames(CachedDirectory &,
+                              const std::string &db_name,
+                              std::set<std::string> &set_of_names)
+{
+  doGetTableNames(db_name, set_of_names);
+}
+
 bool Session::doDoesTableExist(TableIdentifier &identifier)
 {
   for (Table *table= temporary_tables ; table ; table= table->next)
   {
     if (table->s->tmp_table == TEMP_TABLE)
     {
-      if (not strcmp(identifier.getSchemaName().c_str(), table->s->getSchemaName()))
+      if (not identifier.getSchemaName().compare(table->s->getSchemaName()))
       {
-        if (not strcmp(identifier.getTableName().c_str(), table->s->table_name.str))
+        if (not identifier.getTableName().compare(table->s->table_name.str))
         {
           return true;
         }
@@ -625,9 +631,9 @@
   {
     if (table->s->tmp_table == TEMP_TABLE)
     {
-      if (not strcmp(identifier.getSchemaName().c_str(), table->s->getSchemaName()))
+      if (not identifier.getSchemaName().compare(table->s->getSchemaName()))
       {
-        if (not strcmp(identifier.getTableName().c_str(), table->s->table_name.str))
+        if (not identifier.getTableName().compare(table->s->table_name.str))
         {
           table_proto.CopyFrom(*(table->s->getTableProto()));
 
@@ -644,15 +650,16 @@
 {
   char	key[MAX_DBKEY_LENGTH];
   uint	key_length;
-  Table *table;
 
   key_length= TableShare::createKey(key, new_db, table_name);
 
-  for (table= temporary_tables ; table ; table= table->next)
+  for (Table *table= temporary_tables ; table ; table= table->next)
   {
     if (table->s->table_cache_key.length == key_length &&
-        !memcmp(table->s->table_cache_key.str, key, key_length))
+        not memcmp(table->s->table_cache_key.str, key, key_length))
+    {
       return table;
+    }
   }
   return NULL;                               // Not a temporary table
 }
@@ -662,6 +669,24 @@
   return find_temporary_table(table_list->db, table_list->table_name);
 }
 
+Table *Session::find_temporary_table(TableIdentifier &identifier)
+{
+  char	key[MAX_DBKEY_LENGTH];
+  uint	key_length;
+
+  key_length= TableShare::createKey(key, identifier);
+
+  for (Table *table= temporary_tables ; table ; table= table->next)
+  {
+    if (table->s->table_cache_key.length == key_length &&
+        not memcmp(table->s->table_cache_key.str, key, key_length))
+
+      return table;
+  }
+
+  return NULL;                               // Not a temporary table
+}
+
 
 /**
   Drop a temporary table.
@@ -693,7 +718,7 @@
 {
   Table *table;
 
-  if (!(table= find_temporary_table(table_list)))
+  if (not (table= find_temporary_table(table_list)))
     return 1;
 
   /* Table might be in use by some outer statement. */
@@ -755,7 +780,7 @@
     list= *prev;
 
     if (list->s->table_cache_key.length == key_length &&
-        !memcmp(list->s->table_cache_key.str, key, key_length))
+        not memcmp(list->s->table_cache_key.str, key, key_length))
     {
       /* Remove table from open_tables list. */
       *prev= list->next;
@@ -793,8 +818,7 @@
   table that was locked with LOCK TABLES.
 */
 
-void Session::drop_open_table(Table *table, const char *db_name,
-                              const char *table_name)
+void Session::drop_open_table(Table *table, TableIdentifier &identifier)
 {
   if (table->s->tmp_table)
   {
@@ -808,7 +832,6 @@
       that something has happened.
     */
     unlink_open_table(table);
-    TableIdentifier identifier(db_name, table_name, STANDARD_TABLE);
     quick_rm_table(*this, identifier);
     pthread_mutex_unlock(&LOCK_open);
   }
@@ -1041,7 +1064,7 @@
     *table= 0;
     return false;
   }
-  if (!(*table= table_cache_insert_placeholder(key, key_length)))
+  if (not (*table= table_cache_insert_placeholder(key, key_length)))
   {
     pthread_mutex_unlock(&LOCK_open);
     return true;
@@ -1503,6 +1526,11 @@
   the strings are used in a loop even after the share may be freed.
 */
 
+void Session::close_data_files_and_morph_locks(TableIdentifier &identifier)
+{
+  close_data_files_and_morph_locks(identifier.getSchemaName().c_str(), identifier.getTableName().c_str());
+}
+
 void Session::close_data_files_and_morph_locks(const char *new_db, const char *new_table_name)
 {
   Table *table;
@@ -1929,10 +1957,10 @@
 
   safe_mutex_assert_owner(&LOCK_open);
 retry:
-  if (!(share= TableShare::getShare(session, table_list, cache_key,
-                                    cache_key_length,
-                                    table_list->i_s_requested_object,
-                                    &error)))
+  if (not (share= TableShare::getShare(session, table_list, cache_key,
+                                       cache_key_length,
+                                       table_list->i_s_requested_object,
+                                       &error)))
     return 1;
 
   while ((error= open_table_from_share(session, share, alias,
@@ -2291,7 +2319,7 @@
   /*
     First open the share, and then open the table from the share we just opened.
   */
-  if (open_table_def(*this, share) ||
+  if (open_table_def(*this, identifier, share) ||
       open_table_from_share(this, share, identifier.getTableName().c_str(),
                             (uint32_t) (HA_OPEN_KEYFILE | HA_OPEN_RNDFILE |
                                         HA_GET_INDEX),
@@ -4422,7 +4450,7 @@
   for (uint32_t idx=0 ; idx < open_cache.records ; idx++)
   {
     Table *table=(Table*) hash_element(&open_cache,idx);
-    if (not strcmp(table->s->getSchemaName(), schema_name.c_str()))
+    if (not schema_name.compare(table->s->getSchemaName()))
     {
       table->s->version= 0L;			/* Free when thread is ready */
       if (not table->in_use)

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2010-03-15 20:30:25 +0000
+++ drizzled/sql_insert.cc	2010-03-20 21:48:16 +0000
@@ -1597,8 +1597,8 @@
       *lock= 0;
     }
 
-    if (!create_info->table_existed)
-      session->drop_open_table(table, create_table->db, create_table->table_name);
+    if (not create_info->table_existed)
+      session->drop_open_table(table, identifier);
     return NULL;
   }
 
@@ -1764,8 +1764,8 @@
   {
     table->cursor->extra(HA_EXTRA_NO_IGNORE_DUP_KEY);
     table->cursor->extra(HA_EXTRA_WRITE_CANNOT_REPLACE);
-    if (!create_info->table_existed)
-      session->drop_open_table(table, create_table->db, create_table->table_name);
+    if (not create_info->table_existed)
+      session->drop_open_table(table, identifier);
     table= NULL;                                    // Safety
   }
 }

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2010-03-26 17:24:57 +0000
+++ drizzled/sql_table.cc	2010-03-26 19:25:23 +0000
@@ -179,10 +179,14 @@
 
   for (table= tables; table; table= table->next_local)
   {
+    TableIdentifier identifier(table->db, table->table_name);
     TableShare *share;
     table->db_type= NULL;
-    if ((share= TableShare::getShare(table->db, table->table_name)))
+
+    if ((share= TableShare::getShare(identifier)))
+    {
       table->db_type= share->db_type();
+    }
   }
 
   if (not drop_temporary && lock_table_names_exclusively(session, tables))
@@ -1277,6 +1281,105 @@
   return 0;
 }
 
+static bool locked_create_event(Session *session,
+                                TableIdentifier &identifier,
+                                HA_CREATE_INFO *create_info,
+                                message::Table &table_proto,
+                                AlterInfo *alter_info,
+                                bool is_if_not_exists,
+                                bool lex_identified_temp_table,
+                                bool internal_tmp_table,
+                                uint db_options,
+                                uint key_count,
+                                KEY *key_info_buffer)
+{
+  bool error= true;
+
+  {
+
+    /*
+      @note if we are building a temp table we need to check to see if a temp table
+      already exists, otherwise we just need to find out if a normal table exists (aka it is fine
+      to create a table under a temporary table.
+    */
+    bool exists= 
+      plugin::StorageEngine::doesTableExist(*session, identifier, lex_identified_temp_table);
+
+    if (exists)
+    {
+      if (is_if_not_exists)
+      {
+        error= false;
+        push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
+                            ER_TABLE_EXISTS_ERROR, ER(ER_TABLE_EXISTS_ERROR),
+                            identifier.getTableName().c_str());
+        create_info->table_existed= 1;		// Mark that table existed
+        return error;
+      }
+
+      my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getTableName().c_str());
+      return error;
+    }
+
+    if (not lex_identified_temp_table) // We have a real table
+    {
+      /*
+        We don't assert here, but check the result, because the table could be
+        in the table definition cache and in the same time the .frm could be
+        missing from the disk, in case of manual intervention which deletes
+        the .frm cursor. The user has to use FLUSH TABLES; to clear the cache.
+        Then she could create the table. This case is pretty obscure and
+        therefore we don't introduce a new error message only for it.
+      */
+      /*
+        @todo improve this error condition.
+      */
+      if (TableShare::getShare(identifier))
+      {
+        my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getTableName().c_str());
+        return error;
+      }
+    }
+  }
+
+  session->set_proc_info("creating table");
+  create_info->table_existed= 0;		// Mark that table is created
+
+  create_info->table_options= db_options;
+
+  if (not rea_create_table(session, identifier,
+                           table_proto,
+                           create_info, alter_info->create_list,
+                           key_count, key_info_buffer))
+  {
+    return error;
+  }
+
+  if (lex_identified_temp_table)
+  {
+    /* Open table and put in temporary table list */
+    if (not (session->open_temporary_table(identifier)))
+    {
+      (void) session->rm_temporary_table(identifier);
+      return error;
+    }
+  }
+
+  /* 
+    We keep this behind the lock to make sure ordering is correct for a table.
+    This is a very unlikely problem where before we would write out to the
+    trans log, someone would do a delete/create operation.
+  */
+
+  if (table_proto.type() == message::Table::STANDARD && not internal_tmp_table)
+  {
+    TransactionServices &transaction_services= TransactionServices::singleton();
+    transaction_services.createTable(session, table_proto);
+  }
+
+  return false;
+}
+
 
 /*
   Ignore the name of this function... it locks :(
@@ -1339,139 +1442,93 @@
 
   set_table_default_charset(create_info, identifier.getDBName().c_str());
 
-  /* Check if table exists */
-  if (mysql_prepare_create_table(session, create_info, table_proto, alter_info,
+  /* Build a Table object to pass down to the engine, and the do the actual create. */
+  if (not mysql_prepare_create_table(session, create_info, table_proto, alter_info,
                                  internal_tmp_table,
                                  &db_options,
                                  &key_info_buffer, &key_count,
                                  select_field_count))
-    goto err;
-
-  /* Check if table already exists */
-  if (lex_identified_temp_table &&
-      session->find_temporary_table(identifier.getDBName().c_str(), identifier.getTableName().c_str()))
+  {
+    pthread_mutex_lock(&LOCK_open); /* CREATE TABLE (some confussion on naming, double check) */
+    error= locked_create_event(session,
+                               identifier,
+                               create_info,
+                               table_proto,
+                               alter_info,
+                               is_if_not_exists,
+                               lex_identified_temp_table,
+                               internal_tmp_table,
+                               db_options, key_count,
+                               key_info_buffer);
+    pthread_mutex_unlock(&LOCK_open);
+  }
+
+  session->set_proc_info("After create");
+
+  return(error);
+}
+
+/**
+  @note the following two methods implement create [temporary] table.
+*/
+static bool drizzle_create_table(Session *session,
+                                 TableIdentifier &identifier,
+                                 HA_CREATE_INFO *create_info,
+                                 message::Table &table_proto,
+                                 AlterInfo *alter_info,
+                                 bool internal_tmp_table,
+                                 uint32_t select_field_count,
+                                 bool is_if_not_exists)
+{
+  Table *name_lock= NULL;
+  bool result;
+
+  if (session->lock_table_name_if_not_cached(identifier, &name_lock))
+  {
+    result= true;
+  }
+  else if (name_lock == NULL)
   {
     if (is_if_not_exists)
     {
-      create_info->table_existed= 1;		// Mark that table existed
       push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
                           ER_TABLE_EXISTS_ERROR, ER(ER_TABLE_EXISTS_ERROR),
                           identifier.getTableName().c_str());
-      error= 0;
-      goto err;
-    }
-    my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getTableName().c_str());
-    goto err;
-  }
-
-  pthread_mutex_lock(&LOCK_open); /* CREATE TABLE (some confussion on naming, double check) */
-  if (not internal_tmp_table && not lex_identified_temp_table)
-  {
-    if (plugin::StorageEngine::doesTableExist(*session, identifier, false)==EEXIST)
-    {
-      if (is_if_not_exists)
-      {
-        error= false;
-        push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
-                            ER_TABLE_EXISTS_ERROR, ER(ER_TABLE_EXISTS_ERROR),
-                            identifier.getTableName().c_str());
-        create_info->table_existed= 1;		// Mark that table existed
-      }
-      else 
-      {
-        my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getTableName().c_str());
-      }
-
-      goto unlock_and_end;
-    }
-    /*
-      We don't assert here, but check the result, because the table could be
-      in the table definition cache and in the same time the .frm could be
-      missing from the disk, in case of manual intervention which deletes
-      the .frm cursor. The user has to use FLUSH TABLES; to clear the cache.
-      Then she could create the table. This case is pretty obscure and
-      therefore we don't introduce a new error message only for it.
-    */
-    if (TableShare::getShare(identifier))
-    {
-      my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getTableName().c_str());
-      goto unlock_and_end;
-    }
-  }
-
-  /*
-    Check that table with given name does not already
-    exist in any storage engine. In such a case it should
-    be discovered and the error ER_TABLE_EXISTS_ERROR be returned
-    unless user specified CREATE TABLE IF EXISTS
-    The LOCK_open mutex has been locked to make sure no
-    one else is attempting to discover the table. Since
-    it's not on disk as a frm cursor, no one could be using it!
-  */
-  if (not lex_identified_temp_table)
-  {
-    bool exists= plugin::StorageEngine::doesTableExist(*session, identifier, false);
-
-    if (exists)
-    {
-      if (is_if_not_exists)
-      {
-        error= false;
-        push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
-                            ER_TABLE_EXISTS_ERROR, ER(ER_TABLE_EXISTS_ERROR),
-                            identifier.getTableName().c_str());
-        create_info->table_existed= 1;		// Mark that table existed
-        goto unlock_and_end;
-      }
-
-      my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getTableName().c_str());
-      goto unlock_and_end;
-    }
-  }
-
-  session->set_proc_info("creating table");
-  create_info->table_existed= 0;		// Mark that table is created
-
-  create_info->table_options= db_options;
-
-  if (rea_create_table(session, identifier,
-		       table_proto,
-                       create_info, alter_info->create_list,
-                       key_count, key_info_buffer))
-  {
-    goto unlock_and_end;
-  }
-
-  if (lex_identified_temp_table)
-  {
-    /* Open table and put in temporary table list */
-    if (not (session->open_temporary_table(identifier)))
-    {
-      (void) session->rm_temporary_table(identifier);
-      goto unlock_and_end;
-    }
-  }
-
-  if (not internal_tmp_table && not lex_identified_temp_table)
-  {
-    TransactionServices &transaction_services= TransactionServices::singleton();
-    transaction_services.createTable(session, table_proto);
-  }
-  error= false;
-unlock_and_end:
-  pthread_mutex_unlock(&LOCK_open);
-
-err:
-  session->set_proc_info("After create");
-
-  return(error);
+      create_info->table_existed= 1;
+      result= false;
+    }
+    else
+    {
+      my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getTableName().c_str());
+      result= true;
+    }
+  }
+  else
+  {
+    result= mysql_create_table_no_lock(session,
+                                       identifier,
+                                       create_info,
+                                       table_proto,
+                                       alter_info,
+                                       internal_tmp_table,
+                                       select_field_count,
+                                       is_if_not_exists);
+  }
+
+  if (name_lock)
+  {
+    pthread_mutex_lock(&LOCK_open); /* Lock for removing name_lock during table create */
+    session->unlink_open_table(name_lock);
+    pthread_mutex_unlock(&LOCK_open);
+  }
+
+  return(result);
 }
 
 
 /*
   Database locking aware wrapper for mysql_create_table_no_lock(),
 */
-
 bool mysql_create_table(Session *session,
                         TableIdentifier &identifier,
                         HA_CREATE_INFO *create_info,
@@ -1481,55 +1538,31 @@
                         uint32_t select_field_count,
                         bool is_if_not_exists)
 {
-  Table *name_lock= NULL;
-  bool result;
   bool lex_identified_temp_table=
     (table_proto.type() == message::Table::TEMPORARY);
 
-  if (not lex_identified_temp_table)
-  {
-    if (session->lock_table_name_if_not_cached(identifier, &name_lock))
-    {
-      result= true;
-      goto unlock;
-    }
-    if (name_lock == NULL)
-    {
-      if (is_if_not_exists)
-      {
-        push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
-                            ER_TABLE_EXISTS_ERROR, ER(ER_TABLE_EXISTS_ERROR),
-                            identifier.getTableName().c_str());
-        create_info->table_existed= 1;
-        result= false;
-      }
-      else
-      {
-        my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getTableName().c_str());
-        result= true;
-      }
-      goto unlock;
-    }
-  }
-
-  result= mysql_create_table_no_lock(session,
-                                     identifier,
-                                     create_info,
-                                     table_proto,
-                                     alter_info,
-                                     internal_tmp_table,
-                                     select_field_count,
-                                     is_if_not_exists);
-
-unlock:
-  if (name_lock)
-  {
-    pthread_mutex_lock(&LOCK_open); /* Lock for removing name_lock during table create */
-    session->unlink_open_table(name_lock);
-    pthread_mutex_unlock(&LOCK_open);
-  }
-
-  return(result);
+  if (lex_identified_temp_table)
+  {
+    return mysql_create_table_no_lock(session,
+                                      identifier,
+                                      create_info,
+                                      table_proto,
+                                      alter_info,
+                                      internal_tmp_table,
+                                      select_field_count,
+                                      is_if_not_exists);
+  }
+  else
+  {
+    return drizzle_create_table(session,
+                                identifier,
+                                create_info,
+                                table_proto,
+                                alter_info,
+                                internal_tmp_table,
+                                select_field_count,
+                                is_if_not_exists);
+  }
 }
 
 
@@ -1598,38 +1631,41 @@
 */
 
 bool
-mysql_rename_table(plugin::StorageEngine *base, const char *old_db,
-                   const char *old_name, const char *new_db,
-                   const char *new_name, uint32_t flags)
+mysql_rename_table(plugin::StorageEngine *base,
+                   TableIdentifier &from,
+                   TableIdentifier &to,
+                   uint32_t )
 {
   Session *session= current_session;
-  string from;
-  string to;
   int error= 0;
 
   assert(base);
 
-  build_table_filename(from, old_db, old_name,
-                       flags & FN_FROM_IS_TMP);
-  build_table_filename(to, new_db, new_name,
-                       flags & FN_TO_IS_TMP);
-
-  if (!(error= base->renameTable(session, from.c_str(), to.c_str())))
+  if (not (error= base->renameTable(*session, from, to)))
   {
-    if (base->check_flag(HTON_BIT_HAS_DATA_DICTIONARY) == 0
-       && rename_table_proto_file(from.c_str(), to.c_str()))
+    if (not base->check_flag(HTON_BIT_HAS_DATA_DICTIONARY))
     {
-      error= errno;
-      base->renameTable(session, to.c_str(), from.c_str());
+      if ((error= plugin::StorageEngine::renameDefinitionFromPath(to, from)))
+      {
+        error= errno;
+        base->renameTable(*session, to, from);
+      }
     }
   }
 
   if (error == HA_ERR_WRONG_COMMAND)
+  {
     my_error(ER_NOT_SUPPORTED_YET, MYF(0), "ALTER Table");
+  }
   else if (error)
-    my_error(ER_ERROR_ON_RENAME, MYF(0), from.c_str(), to.c_str(), error);
-
-  return(error != 0);
+  {
+    const char *from_identifier= from.isTmp() ? "#sql-temporary" : from.getSQLPath().c_str();
+    const char *to_identifier= to.isTmp() ? "#sql-temporary" : to.getSQLPath().c_str();
+
+    my_error(ER_ERROR_ON_RENAME, MYF(0), from_identifier, to_identifier, error);
+  }
+
+  return error ? true : false; 
 }
 
 
@@ -2013,7 +2049,7 @@
     during the call to plugin::StorageEngine::createTable().
     See bug #28614 for more info.
   */
-static bool create_table_wrapper(Session &session, message::Table& create_table_proto,
+static bool create_table_wrapper(Session &session, const message::Table& create_table_proto,
                                  TableIdentifier &destination_identifier,
                                  TableIdentifier &src_table,
                                  bool lex_identified_temp_table, bool is_engine_set)
@@ -2044,6 +2080,12 @@
     protoengine->set_name(create_table_proto.engine().name());
   }
 
+  { // We now do a selective copy of elements on to the new table.
+    new_proto.set_name(create_table_proto.name());
+    new_proto.set_schema(create_table_proto.schema());
+    new_proto.set_catalog(create_table_proto.catalog());
+  }
+
   if (protoerr && protoerr != EEXIST)
   {
     if (errno == ENOENT)
@@ -2084,7 +2126,7 @@
 bool mysql_create_like_table(Session* session,
                              TableIdentifier &destination_identifier,
                              TableList* table, TableList* src_table,
-                             message::Table& create_table_proto,
+                             message::Table &create_table_proto,
                              bool is_if_not_exists,
                              bool is_engine_set)
 {

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2010-03-18 11:20:28 +0000
+++ drizzled/sql_yacc.yy	2010-03-23 04:40:43 +0000
@@ -1260,10 +1260,38 @@
         | ROW_FORMAT_SYM opt_equal row_types
           {
             statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+            message::Table::TableOptions *table_options= statement->createTableMessage().mutable_options();
 
             statement->create_info.row_type= $3;
             statement->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
             statement->alter_info.flags.set(ALTER_ROW_FORMAT);
+
+            switch(statement->create_info.row_type)
+            {
+            case ROW_TYPE_DEFAULT:
+              /* No use setting a default row type... just adds redundant info to message */
+              break;
+            case ROW_TYPE_FIXED:
+              table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_FIXED);
+              break;
+            case ROW_TYPE_DYNAMIC:
+              table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_DYNAMIC);
+              break;
+            case ROW_TYPE_COMPRESSED:
+              table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_COMPRESSED);
+              break;
+            case ROW_TYPE_REDUNDANT:
+              table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_REDUNDANT);
+              break;
+            case ROW_TYPE_COMPACT:
+              table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_COMPACT);
+              break;
+            case ROW_TYPE_PAGE:
+              table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_PAGE);
+              break;
+            default:
+              abort();
+            }
           }
         | default_collation
         | KEY_BLOCK_SIZE opt_equal ulong_num
@@ -1587,11 +1615,18 @@
               $$=DRIZZLE_TYPE_BLOB;
               Lex->length=(char*) 0; /* use default length */
 
-            statement::CreateTable *statement=
-              (statement::CreateTable *)Lex->statement;
-
-            if (statement->current_proto_field)
-              statement->current_proto_field->set_type(message::Table::Field::BLOB);
+              statement::CreateTable *statement=
+                (statement::CreateTable *)Lex->statement;
+
+              if (statement->current_proto_field)
+              {
+                statement->current_proto_field->set_type(message::Table::Field::BLOB);
+                message::Table::Field::StringFieldOptions *string_field_options;
+
+                string_field_options= statement->current_proto_field->mutable_string_options();
+                string_field_options->set_collation_id(my_charset_bin.number);
+                string_field_options->set_collation(my_charset_bin.name);
+              }
             }
           | TEXT_SYM
             {
@@ -4707,14 +4742,14 @@
            DATABASES show_wild
            {
              LEX *lex= Lex;
+             Session *session= YYSession;
+
              lex->sql_command= SQLCOM_SELECT;
              lex->statement=
-               new(std::nothrow) statement::Select(YYSession);
+               new(std::nothrow) statement::Select(session);
              if (lex->statement == NULL)
                DRIZZLE_YYABORT;
 
-             Session *session= YYSession;
-
              std::string column_name= "Database";
              if (Lex->wild)
              {
@@ -4725,12 +4760,12 @@
 
              if (Lex->current_select->where)
              {
-               if (prepare_new_schema_table(YYSession, lex, "SCHEMAS"))
+               if (prepare_new_schema_table(session, lex, "SCHEMAS"))
                  DRIZZLE_YYABORT;
              }
              else
              {
-               if (prepare_new_schema_table(YYSession, lex, "SCHEMA_NAMES"))
+               if (prepare_new_schema_table(session, lex, "SCHEMA_NAMES"))
                  DRIZZLE_YYABORT;
              }
 
@@ -4744,13 +4779,18 @@
          | TABLES opt_db show_wild
            {
              LEX *lex= Lex;
+             Session *session= YYSession;
+
              lex->sql_command= SQLCOM_SELECT;
-             lex->statement=
+
+             statement::Select *select=
                new(std::nothrow) statement::Select(YYSession);
+
+             lex->statement= select;
+
              if (lex->statement == NULL)
                DRIZZLE_YYABORT;
 
-              Session *session= YYSession;
 
               std::string column_name= "Tables_in_";
 
@@ -4762,11 +4802,18 @@
                 {
                   my_error(ER_BAD_DB_ERROR, MYF(0), $2);
                 }
+                select->setShowPredicate($2, "");
               }
-              else
+              else if (not session->db.empty())
               {
                 column_name.append(session->db);
-              }
+                select->setShowPredicate(session->db, "");
+              }
+              else
+              {
+                 my_error(ER_NO_DB_ERROR, MYF(0));
+              }
+
 
              if (Lex->wild)
              {
@@ -4775,16 +4822,8 @@
                column_name.append(")");
              }
 
-             if (Lex->current_select->where)
-             {
-               if (prepare_new_schema_table(YYSession, lex, "TABLES"))
-                 DRIZZLE_YYABORT;
-             }
-             else
-             {
-               if (prepare_new_schema_table(YYSession, lex, "SHOW_TABLES"))
-                 DRIZZLE_YYABORT;
-             }
+             if (prepare_new_schema_table(YYSession, lex, "SHOW_TABLES"))
+               DRIZZLE_YYABORT;
 
              Item_field *my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "TABLE_NAME");
              my_field->is_autogenerated_name= false;
@@ -4908,7 +4947,7 @@
                }
              }
 
-             if (prepare_new_schema_table(session, lex, "show_indexes"))
+             if (prepare_new_schema_table(session, lex, "SHOW_INDEXES"))
                DRIZZLE_YYABORT;
 
              if (session->add_item_to_list( new Item_field(&session->lex->current_select->

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2010-03-18 01:46:14 +0000
+++ drizzled/statement/alter_table.cc	2010-03-25 01:22:33 +0000
@@ -73,7 +73,7 @@
                                   message::Table &create_message,
                                   AlterInfo *alter_info);
 
-static Table *open_alter_table(Session *session, Table *table, char *db, char *table_name);
+static Table *open_alter_table(Session *session, Table *table, TableIdentifier &identifier);
 
 bool statement::AlterTable::execute()
 {
@@ -97,30 +97,73 @@
     }
   }
 
+
   /* Must be set in the parser */
   assert(select_lex->db);
 
+  /* Chicken/Egg... we need to search for the table, to know if the table exists, so we can build a full identifier from it */
+  message::Table original_table_message;
+  {
+    TableIdentifier identifier(first_table->db, first_table->table_name);
+    if (plugin::StorageEngine::getTableDefinition(*session, identifier, original_table_message) != EEXIST)
+    {
+      my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getSQLPath().c_str());
+      return true;
+    }
+  }
+
   /* ALTER TABLE ends previous transaction */
-  if (! session->endActiveTransaction())
-  {
-    return true;
-  }
-
-  if (! (need_start_waiting= ! wait_if_global_read_lock(session, 0, 1)))
-  {
-    return true;
-  }
-
-  bool res= alter_table(session, 
-                        select_lex->db, 
-                        session->lex->name.str,
-                        &create_info,
-                        create_table_message,
-                        first_table,
-                        &alter_info,
-                        select_lex->order_list.elements,
-                        (order_st *) select_lex->order_list.first,
-                        session->lex->ignore);
+  if (not session->endActiveTransaction())
+  {
+    return true;
+  }
+
+  if (not (need_start_waiting= ! wait_if_global_read_lock(session, 0, 1)))
+  {
+    return true;
+  }
+
+  bool res;
+  if (original_table_message.type() == message::Table::STANDARD )
+  {
+    TableIdentifier identifier(first_table->db, first_table->table_name);
+    TableIdentifier new_identifier(select_lex->db ? select_lex->db : first_table->db,
+                                   session->lex->name.str ? session->lex->name.str : first_table->table_name);
+
+    res= alter_table(session, 
+                     identifier,
+                     new_identifier,
+                     &create_info,
+                     create_table_message,
+                     first_table,
+                     &alter_info,
+                     select_lex->order_list.elements,
+                     (order_st *) select_lex->order_list.first,
+                     session->lex->ignore);
+  }
+  else
+  {
+    Table *table= session->find_temporary_table(first_table);
+    assert(table);
+    {
+      TableIdentifier identifier(first_table->db, first_table->table_name, table->s->path.str);
+      TableIdentifier new_identifier(select_lex->db ? select_lex->db : first_table->db,
+                                     session->lex->name.str ? session->lex->name.str : first_table->table_name,
+                                     table->s->path.str);
+
+      res= alter_table(session, 
+                       identifier,
+                       new_identifier,
+                       &create_info,
+                       create_table_message,
+                       first_table,
+                       &alter_info,
+                       select_lex->order_list.elements,
+                       (order_st *) select_lex->order_list.first,
+                       session->lex->ignore);
+    }
+  }
+
   /*
      Release the protection against the global read lock and wake
      everyone, who might want to set a global read lock.
@@ -640,6 +683,53 @@
   return(error);
 }
 
+static bool lockTableIfDifferent(Session &session,
+                                 TableIdentifier &original_table_identifier,
+                                 TableIdentifier &new_table_identifier,
+                                 Table *name_lock)
+{
+  /* Check that we are not trying to rename to an existing table */
+  if (not (original_table_identifier == new_table_identifier))
+  {
+    if (original_table_identifier.isTmp())
+    {
+
+      if (session.find_temporary_table(new_table_identifier))
+      {
+        my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_table_identifier.getSQLPath().c_str());
+        return false;
+      }
+    }
+    else
+    {
+      if (session.lock_table_name_if_not_cached(new_table_identifier, &name_lock))
+      {
+        return false;
+      }
+
+      if (not name_lock)
+      {
+        my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_table_identifier.getSQLPath().c_str());
+        return false;
+      }
+
+      if (plugin::StorageEngine::doesTableExist(session, new_table_identifier))
+      {
+        /* Table will be closed by Session::executeCommand() */
+        my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_table_identifier.getSQLPath().c_str());
+
+        pthread_mutex_lock(&LOCK_open); /* ALTER TABLe */
+        session.unlink_open_table(name_lock);
+        pthread_mutex_unlock(&LOCK_open);
+
+        return false;
+      }
+    }
+  }
+
+  return true;
+}
+
 /**
   Alter table
 
@@ -681,141 +771,47 @@
     false  OK
     true   Error
 */
-bool alter_table(Session *session,
-                 char *new_db,
-                 char *new_name,
-                 HA_CREATE_INFO *create_info,
-                 message::Table &create_proto,
-                 TableList *table_list,
-                 AlterInfo *alter_info,
-                 uint32_t order_num,
-                 order_st *order,
-                 bool ignore)
+
+static bool internal_alter_table(Session *session,
+                                 Table *table,
+                                 TableIdentifier &original_table_identifier,
+                                 TableIdentifier &new_table_identifier,
+                                 HA_CREATE_INFO *create_info,
+                                 message::Table &create_proto,
+                                 TableList *table_list,
+                                 AlterInfo *alter_info,
+                                 uint32_t order_num,
+                                 order_st *order,
+                                 bool ignore)
 {
-  Table *table;
   Table *new_table= NULL;
-  Table *name_lock= NULL;
-  string new_name_str;
   int error= 0;
   char tmp_name[80];
   char old_name[32];
-  char *table_name;
-  char *db;
-  const char *new_alias;
   ha_rows copied= 0;
   ha_rows deleted= 0;
-  plugin::StorageEngine *old_db_type;
-  plugin::StorageEngine *new_db_type;
-  plugin::StorageEngine *save_old_db_type;
-  bitset<32> tmp;
+
+  message::Table *original_table_definition= table->s->getTableProto();
 
   session->set_proc_info("init");
 
-  /*
-    Assign variables table_name, new_name, db, new_db, path
-    to simplify further comparisons: we want to see if it's a RENAME
-    later just by comparing the pointers, avoiding the need for strcmp.
-  */
-  table_name= table_list->table_name;
-  db= table_list->db;
-  if (! new_db || ! my_strcasecmp(table_alias_charset, new_db, db))
-    new_db= db;
-
-  if (alter_info->tablespace_op != NO_TABLESPACE_OP)
-  {
-    /* DISCARD/IMPORT TABLESPACE is always alone in an ALTER Table */
-    return mysql_discard_or_import_tablespace(session, table_list, alter_info->tablespace_op);
-  }
-
-  /*
-    If this is just a rename of a view, short cut to the
-    following scenario: 1) lock LOCK_open 2) do a RENAME
-    2) unlock LOCK_open.
-    This is a copy-paste added to make sure
-    ALTER (sic:) Table .. RENAME works for views. ALTER VIEW is handled
-    as an independent branch in mysql_execute_command. The need
-    for a copy-paste arose because the main code flow of ALTER Table
-    ... RENAME tries to use openTableLock, which does not work for views
-    (openTableLock was never modified to merge table lists of child tables
-    into the main table list, like open_tables does).
-    This code is wrong and will be removed, please do not copy.
-  */
-
-  if (not (table= session->openTableLock(table_list, TL_WRITE_ALLOW_READ)))
-    return true;
-  
   table->use_all_columns();
 
-  /* Check that we are not trying to rename to an existing table */
-  if (new_name)
-  {
-    char new_alias_buff[FN_REFLEN];
-    char lower_case_table_name[FN_REFLEN];
-
-    strcpy(lower_case_table_name, new_name);
-    strcpy(new_alias_buff, new_name);
-    new_alias= new_alias_buff;
-
-    my_casedn_str(files_charset_info, lower_case_table_name);
-    new_alias= new_name; // Create lower case table name
-    my_casedn_str(files_charset_info, new_name);
-
-    if (new_db == db &&
-        not my_strcasecmp(table_alias_charset, lower_case_table_name, table_name))
-    {
-      /*
-        Source and destination table names are equal: make later check
-        easier.
-      */
-      new_alias= new_name= table_name;
-    }
-    else
-    {
-      if (table->s->tmp_table != STANDARD_TABLE)
-      {
-        if (session->find_temporary_table(new_db, lower_case_table_name))
-        {
-          my_error(ER_TABLE_EXISTS_ERROR, MYF(0), lower_case_table_name);
-          return true;
-        }
-      }
-      else
-      {
-        if (session->lock_table_name_if_not_cached(new_db, new_name, &name_lock))
-          return true;
-
-        if (not name_lock)
-        {
-          my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_alias);
-          return true;
-        }
-
-        TableIdentifier identifier(new_db, lower_case_table_name);
-
-        if (plugin::StorageEngine::doesTableExist(*session, identifier))
-        {
-          /* Table will be closed by Session::executeCommand() */
-          my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_alias);
-          goto err;
-        }
-      }
-    }
-  }
-  else
-  {
-    new_alias= table_name;
-    new_name= table_name;
-  }
-
-  old_db_type= table->s->db_type();
+  plugin::StorageEngine *new_engine;
+  plugin::StorageEngine *original_engine;
+
+  original_engine= table->s->getEngine();
+
   if (not create_info->db_type)
   {
-    create_info->db_type= old_db_type;
+    create_info->db_type= original_engine;
   }
-
-  create_proto.set_schema(new_db);
-
-  if (table->s->tmp_table != STANDARD_TABLE)
+  new_engine= create_info->db_type;
+
+
+  create_proto.set_schema(new_table_identifier.getSchemaName().c_str());
+
+  if (new_table_identifier.isTmp())
   {
     create_proto.set_type(message::Table::TEMPORARY);
   }
@@ -824,18 +820,25 @@
     create_proto.set_type(message::Table::STANDARD);
   }
 
-  new_db_type= create_info->db_type;
-
   /**
     @todo Have a check on the table definition for FK in the future 
     to remove the need for the cursor. (aka can_switch_engines())
   */
-  if (new_db_type != old_db_type &&
+  if (new_engine != original_engine &&
       not table->cursor->can_switch_engines())
   {
     assert(0);
     my_error(ER_ROW_IS_REFERENCED, MYF(0));
-    goto err;
+
+    return true;
+  }
+
+  if (original_engine->check_flag(HTON_BIT_ALTER_NOT_SUPPORTED) ||
+      new_engine->check_flag(HTON_BIT_ALTER_NOT_SUPPORTED))
+  {
+    my_error(ER_ILLEGAL_HA, MYF(0), new_table_identifier.getSQLPath().c_str());
+
+    return true;
   }
 
   if (create_info->row_type == ROW_TYPE_NOT_USED)
@@ -844,207 +847,272 @@
     table_options= create_proto.mutable_options();
 
     create_info->row_type= table->s->row_type;
-    table_options->set_row_type((message::Table_TableOptions_RowType)table->s->row_type);
-  }
-
-  if (old_db_type->check_flag(HTON_BIT_ALTER_NOT_SUPPORTED) ||
-      new_db_type->check_flag(HTON_BIT_ALTER_NOT_SUPPORTED))
-  {
-    my_error(ER_ILLEGAL_HA, MYF(0), table_name);
-    goto err;
+    table_options->set_row_type(original_table_definition->options().row_type());
   }
 
   session->set_proc_info("setup");
-  
+
   /*
    * test if no other bits except ALTER_RENAME and ALTER_KEYS_ONOFF are set
-   */
-  tmp.set();
-  tmp.reset(ALTER_RENAME);
-  tmp.reset(ALTER_KEYS_ONOFF);
-  tmp&= alter_info->flags;
-  if (! (tmp.any()) &&
-      ! table->s->tmp_table) // no need to touch frm
+ */
   {
-    switch (alter_info->keys_onoff)
-    {
-    case LEAVE_AS_IS:
-      break;
-    case ENABLE:
-      /*
-        wait_while_table_is_used() ensures that table being altered is
-        opened only by this thread and that Table::TableShare::version
-        of Table object corresponding to this table is 0.
-        The latter guarantees that no DML statement will open this table
-        until ALTER Table finishes (i.e. until close_thread_tables())
-        while the fact that the table is still open gives us protection
-        from concurrent DDL statements.
-      */
-      pthread_mutex_lock(&LOCK_open); /* DDL wait for/blocker */
-      wait_while_table_is_used(session, table, HA_EXTRA_FORCE_REOPEN);
-      pthread_mutex_unlock(&LOCK_open);
-      error= table->cursor->ha_enable_indexes(HA_KEY_SWITCH_NONUNIQ_SAVE);
-      /* COND_refresh will be signaled in close_thread_tables() */
-      break;
-    case DISABLE:
-      pthread_mutex_lock(&LOCK_open); /* DDL wait for/blocker */
-      wait_while_table_is_used(session, table, HA_EXTRA_FORCE_REOPEN);
-      pthread_mutex_unlock(&LOCK_open);
-      error=table->cursor->ha_disable_indexes(HA_KEY_SWITCH_NONUNIQ_SAVE);
-      /* COND_refresh will be signaled in close_thread_tables() */
-      break;
-    default:
-      assert(false);
-      error= 0;
-      break;
-    }
-
-    if (error == HA_ERR_WRONG_COMMAND)
-    {
-      error= 0;
-      push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
-			  ER_ILLEGAL_HA, ER(ER_ILLEGAL_HA),
-			  table->alias);
-    }
-
-    pthread_mutex_lock(&LOCK_open); /* Lock to remove all instances of table from table cache before ALTER */
-    /*
-      Unlike to the above case close_cached_table() below will remove ALL
-      instances of Table from table cache (it will also remove table lock
-      held by this thread). So to make actual table renaming and writing
-      to binlog atomic we have to put them into the same critical section
-      protected by LOCK_open mutex. This also removes gap for races between
-      access() and mysql_rename_table() calls.
-    */
-
-    if (error == 0 && 
-        (new_name != table_name || new_db != db))
-    {
-      session->set_proc_info("rename");
-      /*
-        Then do a 'simple' rename of the table. First we need to close all
-        instances of 'source' table.
-      */
-      session->close_cached_table(table);
-      /*
-        Then, we want check once again that target table does not exist.
-        Actually the order of these two steps does not matter since
-        earlier we took name-lock on the target table, so we do them
-        in this particular order only to be consistent with 5.0, in which
-        we don't take this name-lock and where this order really matters.
-        TODO: Investigate if we need this access() check at all.
-      */
-      TableIdentifier identifier(db, table_name);
-      if (not plugin::StorageEngine::doesTableExist(*session, identifier))
-      {
-        my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_name);
+    bitset<32> tmp;
+
+    tmp.set();
+    tmp.reset(ALTER_RENAME);
+    tmp.reset(ALTER_KEYS_ONOFF);
+    tmp&= alter_info->flags;
+
+    if (! (tmp.any()) && ! table->s->tmp_table) // no need to touch frm
+    {
+      switch (alter_info->keys_onoff)
+      {
+      case LEAVE_AS_IS:
+        break;
+      case ENABLE:
+        /*
+          wait_while_table_is_used() ensures that table being altered is
+          opened only by this thread and that Table::TableShare::version
+          of Table object corresponding to this table is 0.
+          The latter guarantees that no DML statement will open this table
+          until ALTER Table finishes (i.e. until close_thread_tables())
+          while the fact that the table is still open gives us protection
+          from concurrent DDL statements.
+        */
+        pthread_mutex_lock(&LOCK_open); /* DDL wait for/blocker */
+        wait_while_table_is_used(session, table, HA_EXTRA_FORCE_REOPEN);
+        pthread_mutex_unlock(&LOCK_open);
+        error= table->cursor->ha_enable_indexes(HA_KEY_SWITCH_NONUNIQ_SAVE);
+        /* COND_refresh will be signaled in close_thread_tables() */
+        break;
+      case DISABLE:
+        pthread_mutex_lock(&LOCK_open); /* DDL wait for/blocker */
+        wait_while_table_is_used(session, table, HA_EXTRA_FORCE_REOPEN);
+        pthread_mutex_unlock(&LOCK_open);
+        error=table->cursor->ha_disable_indexes(HA_KEY_SWITCH_NONUNIQ_SAVE);
+        /* COND_refresh will be signaled in close_thread_tables() */
+        break;
+      default:
+        assert(false);
+        error= 0;
+        break;
+      }
+
+      if (error == HA_ERR_WRONG_COMMAND)
+      {
+        error= 0;
+        push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
+                            ER_ILLEGAL_HA, ER(ER_ILLEGAL_HA),
+                            table->alias);
+      }
+
+      pthread_mutex_lock(&LOCK_open); /* Lock to remove all instances of table from table cache before ALTER */
+      /*
+        Unlike to the above case close_cached_table() below will remove ALL
+        instances of Table from table cache (it will also remove table lock
+        held by this thread). So to make actual table renaming and writing
+        to binlog atomic we have to put them into the same critical section
+        protected by LOCK_open mutex. This also removes gap for races between
+        access() and mysql_rename_table() calls.
+      */
+
+      if (error == 0 &&  not (original_table_identifier == new_table_identifier))
+      {
+        session->set_proc_info("rename");
+        /*
+          Then do a 'simple' rename of the table. First we need to close all
+          instances of 'source' table.
+        */
+        session->close_cached_table(table);
+        /*
+          Then, we want check once again that target table does not exist.
+          Actually the order of these two steps does not matter since
+          earlier we took name-lock on the target table, so we do them
+          in this particular order only to be consistent with 5.0, in which
+          we don't take this name-lock and where this order really matters.
+          @todo Investigate if we need this access() check at all.
+        */
+        if (plugin::StorageEngine::doesTableExist(*session, new_table_identifier))
+        {
+          my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_table_identifier.getSQLPath().c_str());
+          error= -1;
+        }
+        else
+        {
+          if (mysql_rename_table(original_engine, original_table_identifier, new_table_identifier, 0))
+          {
+            error= -1;
+          }
+        }
+      }
+
+      if (error == HA_ERR_WRONG_COMMAND)
+      {
+        error= 0;
+        push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
+                            ER_ILLEGAL_HA, ER(ER_ILLEGAL_HA),
+                            table->alias);
+      }
+
+      if (error == 0)
+      {
+        write_bin_log(session, session->query.c_str());
+        session->my_ok();
+      }
+      else if (error > 0)
+      {
+        table->print_error(error, MYF(0));
         error= -1;
       }
-      else
-      {
-        *internal::fn_ext(new_name)= 0;
-        if (mysql_rename_table(old_db_type, db, table_name, new_db, new_alias, 0))
-          error= -1;
-      }
-    }
-
-    if (error == HA_ERR_WRONG_COMMAND)
-    {
-      error= 0;
-      push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
-                          ER_ILLEGAL_HA, ER(ER_ILLEGAL_HA),
-                          table->alias);
-    }
-
-    if (error == 0)
-    {
-      write_bin_log(session, session->query.c_str());
-      session->my_ok();
-    }
-    else if (error > 0)
-    {
-      table->print_error(error, MYF(0));
-      error= -1;
-    }
-
-    if (name_lock)
-      session->unlink_open_table(name_lock);
-
-    pthread_mutex_unlock(&LOCK_open);
-    table_list->table= NULL;
-    return error;
+
+      pthread_mutex_unlock(&LOCK_open);
+      table_list->table= NULL;
+
+      return error;
+    }
   }
 
   /* We have to do full alter table. */
-  new_db_type= create_info->db_type;
+  new_engine= create_info->db_type;
 
   if (mysql_prepare_alter_table(session, table, create_info, create_proto, alter_info))
-      goto err;
+  {
+    return true;
+  }
 
-  set_table_default_charset(create_info, db);
+  set_table_default_charset(create_info, new_table_identifier.getSchemaName().c_str());
 
   alter_info->build_method= HA_BUILD_OFFLINE;
 
   snprintf(tmp_name, sizeof(tmp_name), "%s-%lx_%"PRIx64, TMP_FILE_PREFIX, (unsigned long) current_pid, session->thread_id);
 
-  /* Safety fix for innodb */
-  my_casedn_str(files_charset_info, tmp_name);
-
   /* Create a temporary table with the new format */
+  /**
+    @note we make an internal temporary table unless the table is a temporary table. In last
+    case we just use it as is. Neither of these tables require locks in order to  be
+    filled.
+  */
+  TableIdentifier new_table_as_temporary(original_table_identifier.getSchemaName(),
+                                         tmp_name,
+                                         create_proto.type() != message::Table::TEMPORARY ? INTERNAL_TMP_TABLE :
+                                         TEMP_TABLE);
+
+  error= create_temporary_table(session, new_table_as_temporary, create_info, create_proto, alter_info);
+
+  if (error != 0)
   {
-    /**
-      @note we make an internal temporary table unless the table is a temporary table. In last
-      case we just use it as is. Neither of these tables require locks in order to  be
-      filled.
-    */
-    TableIdentifier new_table_temp(new_db,
-                                   tmp_name,
-                                   create_proto.type() != message::Table::TEMPORARY ? INTERNAL_TMP_TABLE :
-                                   TEMP_TABLE);
-
-    error= create_temporary_table(session, new_table_temp, create_info, create_proto, alter_info);
-
-    if (error != 0)
-      goto err;
+    return true;
   }
 
   /* Open the table so we need to copy the data to it. */
-  new_table= open_alter_table(session, table, new_db, tmp_name);
+  new_table= open_alter_table(session, table, new_table_as_temporary);
 
-  if (new_table == NULL)
-    goto err1;
+  if (not new_table)
+  {
+    quick_rm_table(*session, new_table_as_temporary);
+    return true;
+  }
 
   /* Copy the data if necessary. */
-  session->count_cuted_fields= CHECK_FIELD_WARN;	// calc cuted fields
-  session->cuted_fields= 0L;
-  session->set_proc_info("copy to tmp table");
-  copied= deleted= 0;
-
-  assert(new_table);
-
-  /* We don't want update TIMESTAMP fields during ALTER Table. */
-  new_table->timestamp_field_type= TIMESTAMP_NO_AUTO_SET;
-  new_table->next_number_field= new_table->found_next_number_field;
-  error= copy_data_between_tables(table,
-                                  new_table,
-                                  alter_info->create_list,
-                                  ignore,
-                                  order_num,
-                                  order,
-                                  &copied,
-                                  &deleted,
-                                  alter_info->keys_onoff,
-                                  alter_info->error_if_not_empty);
-
-  /* We must not ignore bad input! */
-  session->count_cuted_fields= CHECK_FIELD_ERROR_FOR_NULL;
-
-  if (table->s->tmp_table != STANDARD_TABLE)
-  {
-    /* We changed a temporary table */
-    if (error)
-      goto err1;
-
+  {
+    session->count_cuted_fields= CHECK_FIELD_WARN;	// calc cuted fields
+    session->cuted_fields= 0L;
+    session->set_proc_info("copy to tmp table");
+    copied= deleted= 0;
+
+    /* We don't want update TIMESTAMP fields during ALTER Table. */
+    new_table->timestamp_field_type= TIMESTAMP_NO_AUTO_SET;
+    new_table->next_number_field= new_table->found_next_number_field;
+    error= copy_data_between_tables(table,
+                                    new_table,
+                                    alter_info->create_list,
+                                    ignore,
+                                    order_num,
+                                    order,
+                                    &copied,
+                                    &deleted,
+                                    alter_info->keys_onoff,
+                                    alter_info->error_if_not_empty);
+
+    /* We must not ignore bad input! */
+    session->count_cuted_fields= CHECK_FIELD_ERROR_FOR_NULL;
+  }
+
+  /* Now we need to resolve what just happened with the data copy. */
+
+  if (error)
+  {
+
+    /*
+      No default value was provided for a DATE/DATETIME field, the
+      current sql_mode doesn't allow the '0000-00-00' value and
+      the table to be altered isn't empty.
+      Report error here.
+    */
+    if (alter_info->error_if_not_empty && session->row_count)
+    {
+      const char *f_val= 0;
+      enum enum_drizzle_timestamp_type t_type= DRIZZLE_TIMESTAMP_DATE;
+
+      switch (alter_info->datetime_field->sql_type)
+      {
+      case DRIZZLE_TYPE_DATE:
+        f_val= "0000-00-00";
+        t_type= DRIZZLE_TIMESTAMP_DATE;
+        break;
+      case DRIZZLE_TYPE_DATETIME:
+        f_val= "0000-00-00 00:00:00";
+        t_type= DRIZZLE_TIMESTAMP_DATETIME;
+        break;
+      default:
+        /* Shouldn't get here. */
+        assert(0);
+      }
+      bool save_abort_on_warning= session->abort_on_warning;
+      session->abort_on_warning= true;
+      make_truncated_value_warning(session, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
+                                   f_val, internal::strlength(f_val), t_type,
+                                   alter_info->datetime_field->field_name);
+      session->abort_on_warning= save_abort_on_warning;
+    }
+
+    if (original_table_identifier.isTmp())
+    {
+      if (new_table)
+      {
+        /* close_temporary_table() frees the new_table pointer. */
+        session->close_temporary_table(new_table);
+      }
+      else
+      {
+        quick_rm_table(*session, new_table_as_temporary);
+      }
+
+      return true;
+    }
+    else
+    {
+      if (new_table)
+      {
+        /*
+          Close the intermediate table that will be the new table.
+          Note that MERGE tables do not have their children attached here.
+        */
+        new_table->intern_close_table();
+        free(new_table);
+      }
+
+      pthread_mutex_lock(&LOCK_open); /* ALTER TABLE */
+
+      quick_rm_table(*session, new_table_as_temporary);
+      pthread_mutex_unlock(&LOCK_open);
+
+      return true;
+    }
+  }
+  // Temporary table and success
+  else if (original_table_identifier.isTmp())
+  {
     /* Close lock if this is a transactional table */
     if (session->lock)
     {
@@ -1056,195 +1124,201 @@
     session->close_temporary_table(table);
 
     /* Should pass the 'new_name' as we store table name in the cache */
-    if (new_table->rename_temporary_table(new_db, new_name))
-      goto err1;
-
-    goto end_temporary;
-  }
-
-  if (new_table)
-  {
-    /*
-      Close the intermediate table that will be the new table.
-      Note that MERGE tables do not have their children attached here.
-    */
-    new_table->intern_close_table();
-    free(new_table);
-  }
-
-  pthread_mutex_lock(&LOCK_open); /* ALTER TABLE */
-
-  if (error)
-  {
-    TableIdentifier identifier(new_db, tmp_name, INTERNAL_TMP_TABLE);
-    quick_rm_table(*session, identifier);
-    pthread_mutex_unlock(&LOCK_open);
-    goto err;
-  }
-
-  /*
-    Data is copied. Now we:
-    1) Wait until all other threads close old version of table.
-    2) Close instances of table open by this thread and replace them
-       with exclusive name-locks.
-    3) Rename the old table to a temp name, rename the new one to the
-       old name.
-    4) If we are under LOCK TABLES and don't do ALTER Table ... RENAME
-       we reopen new version of table.
-    5) Write statement to the binary log.
-    6) If we are under LOCK TABLES and do ALTER Table ... RENAME we
-       remove name-locks from list of open tables and table cache.
-    7) If we are not not under LOCK TABLES we rely on close_thread_tables()
-       call to remove name-locks from table cache and list of open table.
-  */
-
-  session->set_proc_info("rename result table");
-
-  snprintf(old_name, sizeof(old_name), "%s2-%lx-%"PRIx64, TMP_FILE_PREFIX, (unsigned long) current_pid, session->thread_id);
-
-  my_casedn_str(files_charset_info, old_name);
-
-  wait_while_table_is_used(session, table, HA_EXTRA_PREPARE_FOR_RENAME);
-  session->close_data_files_and_morph_locks(db, table_name);
-
-  error= 0;
-  save_old_db_type= old_db_type;
-
-  /*
-    This leads to the storage engine (SE) not being notified for renames in
-    mysql_rename_table(), because we just juggle with the FRM and nothing
-    more. If we have an intermediate table, then we notify the SE that
-    it should become the actual table. Later, we will recycle the old table.
-    However, in case of ALTER Table RENAME there might be no intermediate
-    table. This is when the old and new tables are compatible, according to
-    compare_table(). Then, we need one additional call to
-  */
-  if (mysql_rename_table(old_db_type, db, table_name, db, old_name, FN_TO_IS_TMP))
-  {
-    error= 1;
-    TableIdentifier identifier(new_db, tmp_name, INTERNAL_TMP_TABLE);
-    quick_rm_table(*session, identifier);
-  }
+    if (new_table->renameAlterTemporaryTable(new_table_identifier))
+    {
+      if (new_table)
+      {
+        /* close_temporary_table() frees the new_table pointer. */
+        session->close_temporary_table(new_table);
+      }
+      else
+      {
+        quick_rm_table(*session, new_table_as_temporary);
+      }
+
+      return true;
+    }
+  }
+  // Normal table success
   else
   {
-    if (mysql_rename_table(new_db_type, new_db, tmp_name, new_db, new_alias, FN_FROM_IS_TMP) != 0)
-    {
-      /* Try to get everything back. */
+    if (new_table)
+    {
+      /*
+        Close the intermediate table that will be the new table.
+        Note that MERGE tables do not have their children attached here.
+      */
+      new_table->intern_close_table();
+      free(new_table);
+    }
+
+    pthread_mutex_lock(&LOCK_open); /* ALTER TABLE */
+
+    /*
+      Data is copied. Now we:
+      1) Wait until all other threads close old version of table.
+      2) Close instances of table open by this thread and replace them
+      with exclusive name-locks.
+      3) Rename the old table to a temp name, rename the new one to the
+      old name.
+      4) If we are under LOCK TABLES and don't do ALTER Table ... RENAME
+      we reopen new version of table.
+      5) Write statement to the binary log.
+      6) If we are under LOCK TABLES and do ALTER Table ... RENAME we
+      remove name-locks from list of open tables and table cache.
+      7) If we are not not under LOCK TABLES we rely on close_thread_tables()
+      call to remove name-locks from table cache and list of open table.
+    */
+
+    session->set_proc_info("rename result table");
+
+    snprintf(old_name, sizeof(old_name), "%s2-%lx-%"PRIx64, TMP_FILE_PREFIX, (unsigned long) current_pid, session->thread_id);
+
+    my_casedn_str(files_charset_info, old_name);
+
+    wait_while_table_is_used(session, table, HA_EXTRA_PREPARE_FOR_RENAME);
+    session->close_data_files_and_morph_locks(original_table_identifier);
+
+    error= 0;
+
+    /*
+      This leads to the storage engine (SE) not being notified for renames in
+      mysql_rename_table(), because we just juggle with the FRM and nothing
+      more. If we have an intermediate table, then we notify the SE that
+      it should become the actual table. Later, we will recycle the old table.
+      However, in case of ALTER Table RENAME there might be no intermediate
+      table. This is when the old and new tables are compatible, according to
+      compare_table(). Then, we need one additional call to
+    */
+    TableIdentifier original_table_to_drop(original_table_identifier.getSchemaName(),
+                                           old_name, TEMP_TABLE);
+
+    if (mysql_rename_table(original_engine, original_table_identifier, original_table_to_drop, FN_TO_IS_TMP))
+    {
       error= 1;
-
-      TableIdentifier alias_identifier(new_db, new_alias, STANDARD_TABLE);
-      quick_rm_table(*session, alias_identifier);
-
-      TableIdentifier tmp_identifier(new_db, tmp_name, INTERNAL_TMP_TABLE);
-      quick_rm_table(*session, tmp_identifier);
-
-      mysql_rename_table(old_db_type, db, old_name, db, table_name, FN_FROM_IS_TMP);
-    }
-  }
-
-  if (error)
-  {
-    /* This shouldn't happen. But let us play it safe. */
-    goto err_with_placeholders;
-  }
-
-  {
-    TableIdentifier old_identifier(db, old_name, INTERNAL_TMP_TABLE);
-    quick_rm_table(*session, old_identifier);
-  }
-  
-
-  pthread_mutex_unlock(&LOCK_open);
-
-  session->set_proc_info("end");
-
-  write_bin_log(session, session->query.c_str());
-  table_list->table= NULL;
-
-end_temporary:
+      quick_rm_table(*session, new_table_as_temporary);
+    }
+    else
+    {
+      if (mysql_rename_table(new_engine, new_table_as_temporary, new_table_identifier, FN_FROM_IS_TMP) != 0)
+      {
+        /* Try to get everything back. */
+        error= 1;
+
+        quick_rm_table(*session, new_table_identifier);
+
+        quick_rm_table(*session, new_table_as_temporary);
+
+        mysql_rename_table(original_engine, original_table_to_drop, original_table_identifier, FN_FROM_IS_TMP);
+      }
+      else
+      {
+        quick_rm_table(*session, original_table_to_drop);
+      }
+    }
+
+    if (error)
+    {
+      /*
+        An error happened while we were holding exclusive name-lock on table
+        being altered. To be safe under LOCK TABLES we should remove placeholders
+        from list of open tables list and table cache.
+      */
+      session->unlink_open_table(table);
+      pthread_mutex_unlock(&LOCK_open);
+
+      return true;
+    }
+
+
+    pthread_mutex_unlock(&LOCK_open);
+
+    session->set_proc_info("end");
+
+    write_bin_log(session, session->query.c_str());
+    table_list->table= NULL;
+  }
+
   /*
    * Field::store() may have called my_error().  If this is 
    * the case, we must not send an ok packet, since 
    * Diagnostics_area::is_set() will fail an assert.
-   */
-  if (! session->is_error())
-  {
-    snprintf(tmp_name, sizeof(tmp_name), ER(ER_INSERT_INFO),
-            (ulong) (copied + deleted), (ulong) deleted,
-            (ulong) session->cuted_fields);
-    session->my_ok(copied + deleted, 0, 0L, tmp_name);
-    session->some_tables_deleted=0;
-    return false;
-  }
-  else
+ */
+  if (session->is_error())
   {
     /* my_error() was called.  Return true (which means error...) */
     return true;
   }
 
-err1:
-  if (new_table)
-  {
-    /* close_temporary_table() frees the new_table pointer. */
-    session->close_temporary_table(new_table);
-  }
-  else
-  {
-    TableIdentifier tmp_identifier(new_db, tmp_name, INTERNAL_TMP_TABLE);
-    quick_rm_table(*session, tmp_identifier);
-  }
-
-err:
-  /*
-    No default value was provided for a DATE/DATETIME field, the
-    current sql_mode doesn't allow the '0000-00-00' value and
-    the table to be altered isn't empty.
-    Report error here.
-  */
-  if (alter_info->error_if_not_empty && session->row_count)
-  {
-    const char *f_val= 0;
-    enum enum_drizzle_timestamp_type t_type= DRIZZLE_TIMESTAMP_DATE;
-    switch (alter_info->datetime_field->sql_type)
-    {
-      case DRIZZLE_TYPE_DATE:
-        f_val= "0000-00-00";
-        t_type= DRIZZLE_TIMESTAMP_DATE;
-        break;
-      case DRIZZLE_TYPE_DATETIME:
-        f_val= "0000-00-00 00:00:00";
-        t_type= DRIZZLE_TIMESTAMP_DATETIME;
-        break;
-      default:
-        /* Shouldn't get here. */
-        assert(0);
-    }
-    bool save_abort_on_warning= session->abort_on_warning;
-    session->abort_on_warning= true;
-    make_truncated_value_warning(session, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
-                                 f_val, internal::strlength(f_val), t_type,
-                                 alter_info->datetime_field->field_name);
-    session->abort_on_warning= save_abort_on_warning;
-  }
-  if (name_lock)
-  {
-    pthread_mutex_lock(&LOCK_open); /* ALTER TABLe */
-    session->unlink_open_table(name_lock);
-    pthread_mutex_unlock(&LOCK_open);
-  }
-  return true;
-
-err_with_placeholders:
-  /*
-    An error happened while we were holding exclusive name-lock on table
-    being altered. To be safe under LOCK TABLES we should remove placeholders
-    from list of open tables list and table cache.
-  */
-  session->unlink_open_table(table);
-  if (name_lock)
-    session->unlink_open_table(name_lock);
-  pthread_mutex_unlock(&LOCK_open);
-  return true;
+  snprintf(tmp_name, sizeof(tmp_name), ER(ER_INSERT_INFO),
+           (ulong) (copied + deleted), (ulong) deleted,
+           (ulong) session->cuted_fields);
+  session->my_ok(copied + deleted, 0, 0L, tmp_name);
+  session->some_tables_deleted= 0;
+
+  return false;
+}
+
+bool alter_table(Session *session,
+                 TableIdentifier &original_table_identifier,
+                 TableIdentifier &new_table_identifier,
+                 HA_CREATE_INFO *create_info,
+                 message::Table &create_proto,
+                 TableList *table_list,
+                 AlterInfo *alter_info,
+                 uint32_t order_num,
+                 order_st *order,
+                 bool ignore)
+{
+  bool error;
+  Table *table;
+
+  if (alter_info->tablespace_op != NO_TABLESPACE_OP)
+  {
+    /* DISCARD/IMPORT TABLESPACE is always alone in an ALTER Table */
+    return mysql_discard_or_import_tablespace(session, table_list, alter_info->tablespace_op);
+  }
+
+  session->set_proc_info("init");
+
+  if (not (table= session->openTableLock(table_list, TL_WRITE_ALLOW_READ)))
+    return true;
+
+  session->set_proc_info("gained write lock on table");
+
+  /* 
+    Check that we are not trying to rename to an existing table,
+    if one existed we get a lock, if we can't we error.
+  */
+  {
+    Table *name_lock= NULL;
+
+    if (not lockTableIfDifferent(*session, original_table_identifier, new_table_identifier, name_lock))
+    {
+      return true;
+    }
+
+    error= internal_alter_table(session,
+                                table,
+                                original_table_identifier,
+                                new_table_identifier,
+                                create_info,
+                                create_proto,
+                                table_list,
+                                alter_info,
+                                order_num,
+                                order,
+                                ignore);
+
+    if (name_lock)
+    {
+      pthread_mutex_lock(&LOCK_open); /* ALTER TABLe */
+      session->unlink_open_table(name_lock);
+      pthread_mutex_unlock(&LOCK_open);
+    }
+  }
+
+  return error;
 }
 /* alter_table */
 
@@ -1344,9 +1418,11 @@
                                               (optimizer::SqlSelect *) 0, HA_POS_ERROR,
                                               1, &examined_rows)) ==
           HA_POS_ERROR)
+      {
         goto err;
+      }
     }
-  };
+  }
 
   /* Tell handler that we have values for all columns in the to table */
   to->use_all_columns();
@@ -1456,7 +1532,7 @@
   return error;
 }
 
-static Table *open_alter_table(Session *session, Table *table, char *db, char *table_name)
+static Table *open_alter_table(Session *session, Table *table, TableIdentifier &identifier)
 {
   Table *new_table;
 
@@ -1464,19 +1540,17 @@
   if (table->s->tmp_table)
   {
     TableList tbl;
-    tbl.db= db;
-    tbl.alias= table_name;
-    tbl.table_name= table_name;
+    tbl.db= const_cast<char *>(identifier.getSchemaName().c_str());
+    tbl.alias= const_cast<char *>(identifier.getTableName().c_str());
+    tbl.table_name= const_cast<char *>(identifier.getTableName().c_str());
 
     /* Table is in session->temporary_tables */
     new_table= session->openTable(&tbl, (bool*) 0, DRIZZLE_LOCK_IGNORE_FLUSH);
   }
   else
   {
-    TableIdentifier new_identifier(db, table_name, INTERNAL_TMP_TABLE);
-
     /* Open our intermediate table */
-    new_table= session->open_temporary_table(new_identifier, false);
+    new_table= session->open_temporary_table(identifier, false);
   }
 
   return new_table;

=== modified file 'drizzled/statement/alter_table.h'
--- drizzled/statement/alter_table.h	2010-03-16 23:42:10 +0000
+++ drizzled/statement/alter_table.h	2010-03-24 22:22:00 +0000
@@ -51,7 +51,9 @@
 } /* namespace statement */
 
 
-bool alter_table(Session *session, char *new_db, char *new_name,
+bool alter_table(Session *session,
+                 drizzled::TableIdentifier &original_table_identifier,
+                 drizzled::TableIdentifier &new_table_identifier,
                  HA_CREATE_INFO *create_info,
                  message::Table &create_proto,
                  TableList *table_list,

=== modified file 'drizzled/statement/create_index.cc'
--- drizzled/statement/create_index.cc	2010-03-16 23:42:10 +0000
+++ drizzled/statement/create_index.cc	2010-03-24 22:22:00 +0000
@@ -32,6 +32,18 @@
 {
   TableList *first_table= (TableList *) session->lex->select_lex.table_list.first;
   TableList *all_tables= session->lex->query_tables;
+
+  /* Chicken/Egg... we need to search for the table, to know if the table exists, so we can build a full identifier from it */
+  message::Table original_table_message;
+  {
+    TableIdentifier identifier(first_table->db, first_table->table_name);
+    if (plugin::StorageEngine::getTableDefinition(*session, identifier, original_table_message) != EEXIST)
+    {
+      my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getSQLPath().c_str());
+      return true;
+    }
+  }
+
   /*
     CREATE INDEX and DROP INDEX are implemented by calling ALTER
     TABLE with proper arguments.
@@ -50,14 +62,37 @@
   create_info.row_type= ROW_TYPE_NOT_USED;
   create_info.default_table_charset= plugin::StorageEngine::getSchemaCollation(session->db.c_str());
 
-  bool res= alter_table(session, 
-                        first_table->db, 
-                        first_table->table_name,
-                        &create_info, 
-                        create_table_message, 
-                        first_table,
-                        &alter_info,
-                        0, (order_st*) 0, 0);
+  bool res;
+  if (original_table_message.type() == message::Table::STANDARD )
+  {
+    TableIdentifier identifier(first_table->db, first_table->table_name);
+
+    res= alter_table(session, 
+                     identifier,
+                     identifier,
+                     &create_info, 
+                     create_table_message, 
+                     first_table,
+                     &alter_info,
+                     0, (order_st*) 0, 0);
+  }
+  else
+  {
+    Table *table= session->find_temporary_table(first_table);
+    assert(table);
+    {
+      TableIdentifier identifier(first_table->db, first_table->table_name, table->s->path.str);
+
+      res= alter_table(session, 
+                       identifier,
+                       identifier,
+                       &create_info, 
+                       create_table_message, 
+                       first_table,
+                       &alter_info,
+                       0, (order_st*) 0, 0);
+    }
+  }
   return res;
 }
 

=== modified file 'drizzled/statement/create_table.h'
--- drizzled/statement/create_table.h	2010-03-16 23:42:10 +0000
+++ drizzled/statement/create_table.h	2010-03-22 01:36:36 +0000
@@ -49,6 +49,10 @@
 
   bool execute();
   message::Table create_table_message;
+  message::Table &createTableMessage()
+  {
+    return create_table_message;
+  };
   message::Table::Field *current_proto_field;
   HA_CREATE_INFO create_info;
   AlterInfo alter_info;

=== modified file 'drizzled/statement/drop_index.cc'
--- drizzled/statement/drop_index.cc	2010-03-03 18:09:33 +0000
+++ drizzled/statement/drop_index.cc	2010-03-24 22:22:00 +0000
@@ -32,6 +32,18 @@
 {
   TableList *first_table= (TableList *) session->lex->select_lex.table_list.first;
   TableList *all_tables= session->lex->query_tables;
+
+  /* Chicken/Egg... we need to search for the table, to know if the table exists, so we can build a full identifier from it */
+  message::Table original_table_message;
+  {
+    TableIdentifier identifier(first_table->db, first_table->table_name);
+    if (plugin::StorageEngine::getTableDefinition(*session, identifier, original_table_message) != EEXIST)
+    {
+      my_error(ER_TABLE_EXISTS_ERROR, MYF(0), identifier.getSQLPath().c_str());
+      return true;
+    }
+  }
+
   /*
      CREATE INDEX and DROP INDEX are implemented by calling ALTER
      TABLE with proper arguments.
@@ -54,14 +66,37 @@
   create_info.row_type= ROW_TYPE_NOT_USED;
   create_info.default_table_charset= plugin::StorageEngine::getSchemaCollation(session->db.c_str());
 
-  bool res= alter_table(session, 
-                        first_table->db, 
-                        first_table->table_name,
-                        &create_info, 
-                        create_table_proto, 
-                        first_table,
-                        &alter_info,
-                        0, (order_st*) 0, 0);
+  bool res;
+  if (original_table_message.type() == message::Table::STANDARD )
+  {
+    TableIdentifier identifier(first_table->db, first_table->table_name);
+
+    res= alter_table(session, 
+                     identifier,
+                     identifier,
+                     &create_info, 
+                     create_table_proto, 
+                     first_table,
+                     &alter_info,
+                     0, (order_st*) 0, 0);
+  }
+  else
+  {
+    Table *table= session->find_temporary_table(first_table);
+    assert(table);
+    {
+      TableIdentifier identifier(first_table->db, first_table->table_name, table->s->path.str);
+
+      res= alter_table(session, 
+                       identifier,
+                       identifier,
+                       &create_info, 
+                       create_table_proto, 
+                       first_table,
+                       &alter_info,
+                       0, (order_st*) 0, 0);
+    }
+  }
   return res;
 }
 

=== modified file 'drizzled/statement/rename_table.cc'
--- drizzled/statement/rename_table.cc	2010-03-18 01:23:59 +0000
+++ drizzled/statement/rename_table.cc	2010-03-23 23:08:36 +0000
@@ -171,9 +171,7 @@
     return 1; // This can't be skipped
   }
 
-  rc= mysql_rename_table(engine,
-                         ren_table->db, old_alias,
-                         new_db, new_alias, 0);
+  rc= mysql_rename_table(engine, old_identifier, new_identifier, 0);
   if (rc && ! skip_error)
     return true;
 

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2010-03-26 17:24:57 +0000
+++ drizzled/table.cc	2010-03-26 19:25:23 +0000
@@ -512,7 +512,7 @@
       break;
     case DRIZZLE_TYPE_ENUM:
       {
-        message::Table::Field::SetFieldOptions field_options= pfield.set_options();
+        message::Table::Field::EnumerationValues field_options= pfield.enumeration_values();
 
         field_pack_length[fieldnr]=
           get_enum_pack_length(field_options.field_value_size());
@@ -614,7 +614,7 @@
     if (pfield.type() != message::Table::Field::ENUM)
       continue;
 
-    message::Table::Field::SetFieldOptions field_options= pfield.set_options();
+    message::Table::Field::EnumerationValues field_options= pfield.enumeration_values();
 
     const CHARSET_INFO *charset= get_charset(field_options.has_collation_id() ?
                                              field_options.collation_id() : 0);
@@ -761,7 +761,7 @@
 
     if (field_type == DRIZZLE_TYPE_ENUM)
     {
-      message::Table::Field::SetFieldOptions field_options= pfield.set_options();
+      message::Table::Field::EnumerationValues field_options= pfield.enumeration_values();
 
       charset= get_charset(field_options.has_collation_id()?
 			   field_options.collation_id() : 0);
@@ -873,19 +873,21 @@
     {
       field_length= 0;
 
-      message::Table::Field::SetFieldOptions fo= pfield.set_options();
+      message::Table::Field::EnumerationValues fo= pfield.enumeration_values();
 
-      for(int valnr= 0; valnr < fo.field_value_size(); valnr++)
+      for (int valnr= 0; valnr < fo.field_value_size(); valnr++)
       {
         if (fo.field_value(valnr).length() > field_length)
+        {
           field_length= charset->cset->numchars(charset,
                                                 fo.field_value(valnr).c_str(),
                                                 fo.field_value(valnr).c_str()
                                                 + fo.field_value(valnr).length())
             * charset->mbmaxlen;
+        }
       }
     }
-      break;
+    break;
     case DRIZZLE_TYPE_LONG:
       {
         uint32_t sign_len= pfield.constraints().is_unsigned() ? 0 : 1;
@@ -1237,13 +1239,11 @@
    6    Unknown .frm version
 */
 
-int open_table_def(Session& session, TableShare *share)
+int open_table_def(Session& session, TableIdentifier &identifier, TableShare *share)
 {
   int error;
   bool error_given;
 
-  TableIdentifier identifier(share->normalized_path.str);
-
   error= 1;
   error_given= 0;
 
@@ -3303,7 +3303,7 @@
       cursor->closeMarkForDelete(s->table_name.str);
 
     TableIdentifier identifier(s->table_name.str);
-    s->db_type()->doDropTable(*session, identifier, s->table_name.str);
+    s->db_type()->doDropTable(*session, identifier);
 
     delete cursor;
   }
@@ -3418,7 +3418,7 @@
  err1:
   {
     TableIdentifier identifier(new_table.s->table_name.str);
-    new_table.s->db_type()->doDropTable(*session, identifier, new_table.s->table_name.str);
+    new_table.s->db_type()->doDropTable(*session, identifier);
   }
 
  err2:
@@ -3679,16 +3679,16 @@
   session->slave_proxy_id, separated by '\0'.
 */
 
-bool Table::rename_temporary_table(const char *db, const char *table_name)
+bool Table::renameAlterTemporaryTable(TableIdentifier &identifier)
 {
   char *key;
   uint32_t key_length;
   TableShare *share= s;
 
-  if (!(key=(char*) alloc_root(&share->mem_root, MAX_DBKEY_LENGTH)))
+  if (not (key=(char*) alloc_root(&share->mem_root, MAX_DBKEY_LENGTH)))
     return true;
 
-  key_length= TableShare::createKey(key, db, table_name);
+  key_length= TableShare::createKey(key, identifier);
   share->set_table_cache_key(key, key_length);
 
   return false;

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2010-03-09 22:42:17 +0000
+++ drizzled/table.h	2010-03-20 01:22:46 +0000
@@ -440,7 +440,7 @@
     memset(null_flags, 255, s->null_bytes);
   }
 
-  bool rename_temporary_table(const char *db, const char *table_name);
+  bool renameAlterTemporaryTable(TableIdentifier &identifier);
   void free_io_cache();
   void filesort_free_buffers(bool full= false);
   void intern_close_table();
@@ -554,7 +554,7 @@
 
 TableShare *alloc_table_share(TableList *table_list, char *key,
                                uint32_t key_length);
-int open_table_def(Session& session, TableShare *share);
+int open_table_def(Session& session, TableIdentifier &identifier, TableShare *share);
 void open_table_error(TableShare *share, int error, int db_errno, int errarg);
 int open_table_from_share(Session *session, TableShare *share, const char *alias,
                           uint32_t db_stat, uint32_t ha_open_flags,

=== modified file 'drizzled/table_identifier.cc'
--- drizzled/table_identifier.cc	2010-03-19 04:54:45 +0000
+++ drizzled/table_identifier.cc	2010-03-24 19:52:38 +0000
@@ -298,4 +298,10 @@
   return path;
 }
 
+void TableIdentifier::copyToTableMessage(message::Table &message)
+{
+  message.set_name(table_name);
+  message.set_schema(db);
+}
+
 } /* namespace drizzled */

=== modified file 'drizzled/table_identifier.h'
--- drizzled/table_identifier.h	2010-03-19 04:54:45 +0000
+++ drizzled/table_identifier.h	2010-03-24 19:52:38 +0000
@@ -34,6 +34,7 @@
 
 #include <drizzled/enum.h>
 #include "drizzled/definitions.h"
+#include "drizzled/message/table.pb.h"
 #include <string.h>
 
 #include <assert.h>
@@ -87,9 +88,20 @@
     type(TEMP_TABLE),
     path(path_arg),
     db(path_arg),
-    table_name(path_arg),
-    sql_path(db)
-  { 
+    table_name(path_arg)
+  { 
+    sql_path.append("temporary");
+    sql_path.append(".");
+    sql_path.append(table_name);
+  }
+
+  TableIdentifier(const char *schema_name_arg, const char *table_name_arg, const char *path_arg ) :
+    type(TEMP_TABLE),
+    path(path_arg),
+    db(schema_name_arg),
+    table_name(table_name_arg)
+  { 
+    sql_path.append("temporary");
     sql_path.append(".");
     sql_path.append(table_name);
   }
@@ -121,6 +133,8 @@
     return table_name;
   }
 
+  void copyToTableMessage(message::Table &message);
+
   friend std::ostream& operator<<(std::ostream& output, const TableIdentifier &identifier)
   {
     const char *type_str;

=== modified file 'drizzled/table_proto.h'
--- drizzled/table_proto.h	2010-03-03 20:47:30 +0000
+++ drizzled/table_proto.h	2010-03-24 19:52:38 +0000
@@ -35,16 +35,14 @@
                       message::Table &table,
                       TableShare *share);
 
-int rename_table_proto_file(const char *from, const char* to);
-
 int delete_table_proto_file(const char *file_name);
 
-int rea_create_table(Session *session,
-                     TableIdentifier &identifier,
-                     message::Table &table_proto,
-                     HA_CREATE_INFO *create_info,
-                     List<CreateField> &create_field,
-                     uint32_t key_count,KEY *key_info);
+bool rea_create_table(Session *session,
+                      TableIdentifier &identifier,
+                      message::Table &table_proto,
+                      HA_CREATE_INFO *create_info,
+                      List<CreateField> &create_field,
+                      uint32_t key_count,KEY *key_info);
 
 } /* namespace drizzled */
 

=== modified file 'drizzled/table_proto_write.cc'
--- drizzled/table_proto_write.cc	2010-03-19 04:54:45 +0000
+++ drizzled/table_proto_write.cc	2010-03-25 01:22:58 +0000
@@ -78,7 +78,7 @@
       /* Other code paths still have to fill out the proto */
       attribute= table_proto.add_field();
 
-      if(field_arg->flags & NOT_NULL_FLAG)
+      if (field_arg->flags & NOT_NULL_FLAG)
       {
         message::Table::Field::FieldConstraints *constraints;
 
@@ -148,20 +148,20 @@
       }
     case message::Table::Field::ENUM:
       {
-        message::Table::Field::SetFieldOptions *set_field_options;
+        message::Table::Field::EnumerationValues *enumeration_options;
 
         assert(field_arg->interval);
 
-        set_field_options= attribute->mutable_set_options();
+        enumeration_options= attribute->mutable_enumeration_values();
 
         for (uint32_t pos= 0; pos < field_arg->interval->count; pos++)
         {
           const char *src= field_arg->interval->type_names[pos];
 
-          set_field_options->add_field_value(src);
+          enumeration_options->add_field_value(src);
         }
-	set_field_options->set_collation_id(field_arg->charset->number);
-        set_field_options->set_collation(field_arg->charset->name);
+	enumeration_options->set_collation_id(field_arg->charset->number);
+        enumeration_options->set_collation(field_arg->charset->name);
         break;
       }
     case message::Table::Field::BLOB:
@@ -223,14 +223,14 @@
       assert(strcmp(attribute->comment().c_str(), field_arg->comment.str)==0);
     }
 
-    if(field_arg->unireg_check == Field::NEXT_NUMBER)
+    if (field_arg->unireg_check == Field::NEXT_NUMBER)
     {
       message::Table::Field::NumericFieldOptions *field_options;
       field_options= attribute->mutable_numeric_options();
       field_options->set_is_autoincrement(true);
     }
 
-    if(field_arg->unireg_check == Field::TIMESTAMP_DN_FIELD
+    if (field_arg->unireg_check == Field::TIMESTAMP_DN_FIELD
        || field_arg->unireg_check == Field::TIMESTAMP_DNUN_FIELD)
     {
       message::Table::Field::FieldOptions *field_options;
@@ -238,7 +238,7 @@
       field_options->set_default_value("NOW()");
     }
 
-    if(field_arg->unireg_check == Field::TIMESTAMP_UN_FIELD
+    if (field_arg->unireg_check == Field::TIMESTAMP_UN_FIELD
        || field_arg->unireg_check == Field::TIMESTAMP_DNUN_FIELD)
     {
       message::Table::Field::FieldOptions *field_options;
@@ -253,12 +253,12 @@
 
       field_options->set_default_null(true);
     }
-    if(field_arg->def)
+    if (field_arg->def)
     {
       message::Table::Field::FieldOptions *field_options;
       field_options= attribute->mutable_options();
  
-      if(field_arg->def->is_null())
+      if (field_arg->def->is_null())
       {
 	field_options->set_default_null(true);
       }
@@ -269,7 +269,7 @@
 
 	assert(default_value);
 
-	if((field_arg->sql_type==DRIZZLE_TYPE_VARCHAR
+	if ((field_arg->sql_type==DRIZZLE_TYPE_VARCHAR
 	   || field_arg->sql_type==DRIZZLE_TYPE_BLOB)
 	   && ((field_arg->length / field_arg->charset->mbmaxlen)
 	   < default_value->length()))
@@ -278,7 +278,7 @@
 	  return 1;
 	}
 
-	if((field_arg->sql_type==DRIZZLE_TYPE_VARCHAR
+	if ((field_arg->sql_type==DRIZZLE_TYPE_VARCHAR
 	    && field_arg->charset==&my_charset_bin)
 	   || (field_arg->sql_type==DRIZZLE_TYPE_BLOB
 	    && field_arg->charset==&my_charset_bin))
@@ -305,33 +305,6 @@
 
   assert(! use_existing_fields || (field_number == table_proto.field_size()));
 
-  switch(create_info->row_type)
-  {
-  case ROW_TYPE_DEFAULT:
-    /* No use setting a default row type... just adds redundant info to message */
-    break;
-  case ROW_TYPE_FIXED:
-    table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_FIXED);
-    break;
-  case ROW_TYPE_DYNAMIC:
-    table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_DYNAMIC);
-    break;
-  case ROW_TYPE_COMPRESSED:
-    table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_COMPRESSED);
-    break;
-  case ROW_TYPE_REDUNDANT:
-    table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_REDUNDANT);
-    break;
-  case ROW_TYPE_COMPACT:
-    table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_COMPACT);
-    break;
-  case ROW_TYPE_PAGE:
-    table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_PAGE);
-    break;
-  default:
-    abort();
-  }
-
   if (create_info->table_options & HA_OPTION_PACK_RECORD)
     table_options->set_pack_record(true);
 
@@ -376,7 +349,7 @@
 
     idx->set_key_length(key_info[i].key_length);
 
-    if(is_primary_key_name(key_info[i].name))
+    if (is_primary_key_name(key_info[i].name))
       idx->set_is_primary(true);
     else
       idx->set_is_primary(false);
@@ -406,25 +379,25 @@
 
     message::Table::Index::IndexOptions *index_options= idx->mutable_options();
 
-    if(key_info[i].flags & HA_USES_BLOCK_SIZE)
+    if (key_info[i].flags & HA_USES_BLOCK_SIZE)
       index_options->set_key_block_size(key_info[i].block_size);
 
-    if(key_info[i].flags & HA_PACK_KEY)
+    if (key_info[i].flags & HA_PACK_KEY)
       index_options->set_pack_key(true);
 
-    if(key_info[i].flags & HA_BINARY_PACK_KEY)
+    if (key_info[i].flags & HA_BINARY_PACK_KEY)
       index_options->set_binary_pack_key(true);
 
-    if(key_info[i].flags & HA_VAR_LENGTH_PART)
+    if (key_info[i].flags & HA_VAR_LENGTH_PART)
       index_options->set_var_length_key(true);
 
-    if(key_info[i].flags & HA_NULL_PART_KEY)
+    if (key_info[i].flags & HA_NULL_PART_KEY)
       index_options->set_null_part_key(true);
 
-    if(key_info[i].flags & HA_KEY_HAS_PART_KEY_SEG)
+    if (key_info[i].flags & HA_KEY_HAS_PART_KEY_SEG)
       index_options->set_has_partial_segments(true);
 
-    if(key_info[i].flags & HA_GENERATED_KEY)
+    if (key_info[i].flags & HA_GENERATED_KEY)
       index_options->set_auto_generated_key(true);
 
     if (key_info[i].flags & HA_USES_COMMENT)
@@ -470,18 +443,6 @@
   return 0;
 }
 
-int rename_table_proto_file(const char *from, const char* to)
-{
-  string from_path(from);
-  string to_path(to);
-  string file_ext = ".dfe";
-
-  from_path.append(file_ext);
-  to_path.append(file_ext);
-
-  return internal::my_rename(from_path.c_str(),to_path.c_str(),MYF(MY_WME));
-}
-
 int delete_table_proto_file(const char *file_name)
 {
   string new_path(file_name);
@@ -510,25 +471,25 @@
     1  error
 */
 
-int rea_create_table(Session *session,
-                     TableIdentifier &identifier,
-		     message::Table &table_proto,
-                     HA_CREATE_INFO *create_info,
-                     List<CreateField> &create_fields,
-                     uint32_t keys, KEY *key_info)
+bool rea_create_table(Session *session,
+                      TableIdentifier &identifier,
+                      message::Table &table_proto,
+                      HA_CREATE_INFO *create_info,
+                      List<CreateField> &create_fields,
+                      uint32_t keys, KEY *key_info)
 {
   if (fill_table_proto(table_proto, identifier.getTableName(), create_fields, create_info,
-		      keys, key_info))
-    return 1;
+                       keys, key_info))
+    return false;
 
   if (plugin::StorageEngine::createTable(*session,
                                          identifier,
                                          false, table_proto))
   {
-    return 1;
+    return false;
   }
 
-  return 0;
+  return true;
 
 } /* rea_create_table */
 

=== modified file 'drizzled/table_share.cc'
--- drizzled/table_share.cc	2010-03-19 04:54:45 +0000
+++ drizzled/table_share.cc	2010-03-22 15:30:40 +0000
@@ -203,7 +203,7 @@
     return foundTableShare(share);
   }
 
-  if (!(share= alloc_table_share(table_list, key, key_length)))
+  if (not (share= alloc_table_share(table_list, key, key_length)))
   {
     return NULL;
   }
@@ -225,7 +225,8 @@
     return NULL;
   }
   
-  if (open_table_def(*session, share))
+  TableIdentifier identifier(share->getSchemaName(), share->getTableName());
+  if (open_table_def(*session, identifier, share))
   {
     *error= share->error;
     table_def_cache.erase(key_string);
@@ -234,8 +235,8 @@
   }
   share->ref_count++;				// Mark in use
   (void) pthread_mutex_unlock(&share->mutex);
+
   return share;
-
 }
 
 
@@ -253,18 +254,14 @@
 */
 TableShare *TableShare::getShare(TableIdentifier &identifier)
 {
-  return TableShare::getShare(identifier.getSchemaName().c_str(), identifier.getTableName().c_str());
-}
-
-TableShare *TableShare::getShare(const char *db, const char *table_name)
-{
-  char key[NAME_LEN*2+2];
+  char key[MAX_DBKEY_LENGTH];
   uint32_t key_length;
   safe_mutex_assert_owner(&LOCK_open);
 
-  key_length= TableShare::createKey(key, db, table_name);
+  key_length= TableShare::createKey(key, identifier);
 
   const string key_string(key, key_length);
+
   TableDefinitionCache::iterator iter= table_def_cache.find(key_string);
   if (iter != table_def_cache.end())
   {

=== modified file 'drizzled/table_share.h'
--- drizzled/table_share.h	2010-03-19 04:54:45 +0000
+++ drizzled/table_share.h	2010-03-20 01:00:13 +0000
@@ -584,13 +584,6 @@
     RETURN
     Length of key
   */
-
-  static inline uint32_t createKey(char *key, std::string& db_arg,
-                                   std::string& table_name_arg)
-  {
-    return createKey(key, db_arg.c_str(), table_name_arg.c_str());
-  }
-
   static inline uint32_t createKey(char *key, const char *db_arg, const char *table_name_arg)
   {
     uint32_t key_length;
@@ -604,13 +597,24 @@
     return key_length;
   }
 
+  static inline uint32_t createKey(char *key, TableIdentifier &identifier)
+  {
+    uint32_t key_length;
+    char *key_pos= key;
+
+    key_pos= strcpy(key_pos, identifier.getSchemaName().c_str()) + identifier.getSchemaName().length();
+    key_pos= strcpy(key_pos + 1, identifier.getTableName().c_str()) + identifier.getTableName().length();
+    key_length= (uint32_t)(key_pos-key)+1;
+
+    return key_length;
+  }
+
   static void cacheStart(void);
   static void cacheStop(void);
   static void release(TableShare *share);
   static void release(const char *key, uint32_t key_length);
   static TableDefinitionCache &getCache();
   static TableShare *getShare(TableIdentifier &identifier);
-  static TableShare *getShare(const char *db, const char *table_name);
   static TableShare *getShare(Session *session, 
                               TableList *table_list, char *key,
                               uint32_t key_length, uint32_t, int *error);

=== modified file 'drizzled/util/convert.cc'
--- drizzled/util/convert.cc	2010-02-04 08:14:46 +0000
+++ drizzled/util/convert.cc	2010-03-18 18:07:58 +0000
@@ -46,6 +46,29 @@
   return from_size * 2;
 }
 
+static inline char hex_char_value(char c)
+{
+  if (c >= '0' && c <= '9')
+    return c - '0';
+  else if (c >= 'A' && c <= 'F')
+    return c - 'A' + 10;
+  else if (c >= 'a' && c <= 'f')
+    return c - 'a' + 10;
+  return 0;
+}
+
+void drizzled_hex_to_string(char *to, const char *from, uint64_t from_size)
+{
+  const char *from_end = from + from_size;
+
+  while (from != from_end)
+  {
+    *to= hex_char_value(*from++) << 4;
+    if (from != from_end)
+      *to++|= hex_char_value(*from++);
+  }
+}
+
 void bytesToHexdumpFormat(string &to, const unsigned char *from, size_t from_length)
 {
   static const char hex_map[]= "0123456789abcdef";

=== modified file 'drizzled/util/convert.h'
--- drizzled/util/convert.h	2010-02-04 08:14:46 +0000
+++ drizzled/util/convert.h	2010-03-18 18:07:58 +0000
@@ -48,6 +48,7 @@
 
 uint64_t drizzled_string_to_hex(char *to, const char *from,
                                 uint64_t from_size);
+void drizzled_hex_to_string(char *to, const char *from, uint64_t from_size);
 
 } /* namespace drizzled */
 

=== modified file 'extra/my_print_defaults.cc'
--- extra/my_print_defaults.cc	2010-02-04 08:14:46 +0000
+++ extra/my_print_defaults.cc	2010-03-25 09:08:56 +0000
@@ -92,7 +92,7 @@
   printf("\nExample usage:\n%s --defaults-file=example.cnf client mysql\n", internal::my_progname);
 }
 
-static bool get_one_option(int optid, const struct my_option *, char *)
+static int get_one_option(int optid, const struct my_option *, char *)
 {
   switch (optid) {
     case 'c':

=== removed file 'm4/ax_boost_base.m4'
--- m4/ax_boost_base.m4	2010-03-10 20:43:47 +0000
+++ m4/ax_boost_base.m4	1970-01-01 00:00:00 +0000
@@ -1,219 +0,0 @@
-# ===========================================================================
-#             http://autoconf-archive.cryp.to/ax_boost_base.html
-# ===========================================================================
-#
-# SYNOPSIS
-#
-#   AX_BOOST_BASE([MINIMUM-VERSION])
-#
-# DESCRIPTION
-#
-#   Test for the Boost C++ libraries of a particular version (or newer)
-#
-#   If no path to the installed boost library is given the macro searchs
-#   under /usr, /usr/local, /opt and /opt/local and evaluates the
-#   $BOOST_ROOT environment variable. Further documentation is available at
-#   <http://randspringer.de/boost/index.html>.
-#
-#   This macro calls:
-#
-#     AC_SUBST(BOOST_CPPFLAGS) / AC_SUBST(BOOST_LDFLAGS)
-#
-#   And sets:
-#
-#     HAVE_BOOST
-#
-# LICENSE
-#
-#   Copyright (c) 2008 Thomas Porschberg <thomas@randspringer.de>
-#
-#   Copying and distribution of this file, with or without modification, are
-#   permitted in any medium without royalty provided the copyright notice
-#   and this notice are preserved.
-
-AC_DEFUN([AX_BOOST_BASE],
-[
-AC_ARG_WITH([boost],
-	AS_HELP_STRING([--with-boost@<:@=DIR@:>@], [use boost (default is yes) - it is possible to specify the root directory for boost (optional)]),
-	[
-    if test "$withval" = "no"; then
-		want_boost="no"
-    elif test "$withval" = "yes"; then
-        want_boost="yes"
-        ac_boost_path=""
-    else
-	    want_boost="yes"
-        ac_boost_path="$withval"
-	fi
-    ],
-    [want_boost="yes"])
-
-
-AC_ARG_WITH([boost-libdir],
-        AS_HELP_STRING([--with-boost-libdir=LIB_DIR],
-        [Force given directory for boost libraries. Note that this will overwrite library path detection, so use this parameter only if default library detection fails and you know exactly where your boost libraries are located.]),
-        [
-        if test -d $withval
-        then
-                ac_boost_lib_path="$withval"
-        else
-                AC_MSG_ERROR(--with-boost-libdir expected directory name)
-        fi
-        ],
-        [ac_boost_lib_path=""]
-)
-
-if test "x$want_boost" = "xyes"; then
-	boost_lib_version_req=ifelse([$1], ,1.20.0,$1)
-	boost_lib_version_req_shorten=`expr $boost_lib_version_req : '\([[0-9]]*\.[[0-9]]*\)'`
-	boost_lib_version_req_major=`expr $boost_lib_version_req : '\([[0-9]]*\)'`
-	boost_lib_version_req_minor=`expr $boost_lib_version_req : '[[0-9]]*\.\([[0-9]]*\)'`
-	boost_lib_version_req_sub_minor=`expr $boost_lib_version_req : '[[0-9]]*\.[[0-9]]*\.\([[0-9]]*\)'`
-	if test "x$boost_lib_version_req_sub_minor" = "x" ; then
-		boost_lib_version_req_sub_minor="0"
-    	fi
-	WANT_BOOST_VERSION=`expr $boost_lib_version_req_major \* 100000 \+  $boost_lib_version_req_minor \* 100 \+ $boost_lib_version_req_sub_minor`
-	AC_MSG_CHECKING(for boostlib >= $boost_lib_version_req)
-	succeeded=no
-
-	dnl first we check the system location for boost libraries
-	dnl this location ist chosen if boost libraries are installed with the --layout=system option
-	dnl or if you install boost with RPM
-	if test "$ac_boost_path" != ""; then
-		BOOST_LDFLAGS="-L$ac_boost_path/lib"
-		BOOST_CPPFLAGS="-I$ac_boost_path/include"
-	else
-		for ac_boost_path_tmp in /usr /usr/local /opt /opt/local ; do
-			if test -d "$ac_boost_path_tmp/include/boost" && test -r "$ac_boost_path_tmp/include/boost"; then
-				BOOST_LDFLAGS="-L$ac_boost_path_tmp/lib"
-				BOOST_CPPFLAGS="-I$ac_boost_path_tmp/include"
-				break;
-			fi
-		done
-	fi
-
-    dnl overwrite ld flags if we have required special directory with
-    dnl --with-boost-libdir parameter
-    if test "$ac_boost_lib_path" != ""; then
-       BOOST_LDFLAGS="-L$ac_boost_lib_path"
-    fi
-
-	CPPFLAGS_SAVED="$CPPFLAGS"
-	CPPFLAGS="$CPPFLAGS $BOOST_CPPFLAGS"
-	export CPPFLAGS
-
-	LDFLAGS_SAVED="$LDFLAGS"
-	LDFLAGS="$LDFLAGS $BOOST_LDFLAGS"
-	export LDFLAGS
-
-	AC_LANG_PUSH(C++)
-     	AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
-	@%:@include <boost/version.hpp>
-	]], [[
-	#if BOOST_VERSION >= $WANT_BOOST_VERSION
-	// Everything is okay
-	#else
-	#  error Boost version is too old
-	#endif
-	]])],[
-        AC_MSG_RESULT(yes)
-	succeeded=yes
-	found_system=yes
-       	],[
-       	])
-	AC_LANG_POP([C++])
-
-
-
-	dnl if we found no boost with system layout we search for boost libraries
-	dnl built and installed without the --layout=system option or for a staged(not installed) version
-	if test "x$succeeded" != "xyes"; then
-		_version=0
-		if test "$ac_boost_path" != ""; then
-			if test -d "$ac_boost_path" && test -r "$ac_boost_path"; then
-				for i in `ls -d $ac_boost_path/include/boost-* 2>/dev/null`; do
-					_version_tmp=`echo $i | sed "s#$ac_boost_path##" | sed 's/\/include\/boost-//' | sed 's/_/./'`
-					V_CHECK=`expr $_version_tmp \> $_version`
-					if test "$V_CHECK" = "1" ; then
-						_version=$_version_tmp
-					fi
-					VERSION_UNDERSCORE=`echo $_version | sed 's/\./_/'`
-					BOOST_CPPFLAGS="-I$ac_boost_path/include/boost-$VERSION_UNDERSCORE"
-				done
-			fi
-		else
-			for ac_boost_path in /usr /usr/local /opt /opt/local ; do
-				if test -d "$ac_boost_path" && test -r "$ac_boost_path"; then
-					for i in `ls -d $ac_boost_path/include/boost-* 2>/dev/null`; do
-						_version_tmp=`echo $i | sed "s#$ac_boost_path##" | sed 's/\/include\/boost-//' | sed 's/_/./'`
-						V_CHECK=`expr $_version_tmp \> $_version`
-						if test "$V_CHECK" = "1" ; then
-							_version=$_version_tmp
-	               					best_path=$ac_boost_path
-						fi
-					done
-				fi
-			done
-
-			VERSION_UNDERSCORE=`echo $_version | sed 's/\./_/'`
-			BOOST_CPPFLAGS="-I$best_path/include/boost-$VERSION_UNDERSCORE"
-            if test "$ac_boost_lib_path" = ""
-            then
-               BOOST_LDFLAGS="-L$best_path/lib"
-            fi
-
-	    		if test "x$BOOST_ROOT" != "x"; then
-				if test -d "$BOOST_ROOT" && test -r "$BOOST_ROOT" && test -d "$BOOST_ROOT/stage/lib" && test -r "$BOOST_ROOT/stage/lib"; then
-					version_dir=`expr //$BOOST_ROOT : '.*/\(.*\)'`
-					stage_version=`echo $version_dir | sed 's/boost_//' | sed 's/_/./g'`
-			        	stage_version_shorten=`expr $stage_version : '\([[0-9]]*\.[[0-9]]*\)'`
-					V_CHECK=`expr $stage_version_shorten \>\= $_version`
-                    if test "$V_CHECK" = "1" -a "$ac_boost_lib_path" = "" ; then
-						AC_MSG_NOTICE(We will use a staged boost library from $BOOST_ROOT)
-						BOOST_CPPFLAGS="-I$BOOST_ROOT"
-						BOOST_LDFLAGS="-L$BOOST_ROOT/stage/lib"
-					fi
-				fi
-	    		fi
-		fi
-
-		CPPFLAGS="$CPPFLAGS $BOOST_CPPFLAGS"
-		export CPPFLAGS
-		LDFLAGS="$LDFLAGS $BOOST_LDFLAGS"
-		export LDFLAGS
-
-		AC_LANG_PUSH(C++)
-	     	AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
-		@%:@include <boost/version.hpp>
-		]], [[
-		#if BOOST_VERSION >= $WANT_BOOST_VERSION
-		// Everything is okay
-		#else
-		#  error Boost version is too old
-		#endif
-		]])],[
-        	AC_MSG_RESULT(yes)
-		succeeded=yes
-		found_system=yes
-       		],[
-	       	])
-		AC_LANG_POP([C++])
-	fi
-
-	if test "$succeeded" != "yes" ; then
-		if test "$_version" = "0" ; then
-			AC_MSG_ERROR([[We could not detect the boost libraries (version $boost_lib_version_req_shorten or higher). If you have a staged boost library (still not installed) please specify \$BOOST_ROOT in your environment and do not give a PATH to --with-boost option.  If you are sure you have boost installed, then check your version number looking in <boost/version.hpp>. See http://randspringer.de/boost for more documentation.]])
-		else
-			AC_MSG_NOTICE([Your boost libraries seems to old (version $_version).])
-		fi
-	else
-		AC_SUBST(BOOST_CPPFLAGS)
-		AC_SUBST(BOOST_LDFLAGS)
-		AC_DEFINE(HAVE_BOOST,,[define if the Boost library is available])
-	fi
-
-        CPPFLAGS="$CPPFLAGS_SAVED"
-       	LDFLAGS="$LDFLAGS_SAVED"
-fi
-
-])

=== modified file 'm4/pandora_canonical.m4'
--- m4/pandora_canonical.m4	2010-03-18 18:14:24 +0000
+++ m4/pandora_canonical.m4	2010-03-25 22:03:21 +0000
@@ -4,7 +4,7 @@
 dnl with or without modifications, as long as this notice is preserved.
 
 dnl Which version of the canonical setup we're using
-AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.114])
+AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.116])
 
 AC_DEFUN([PANDORA_FORCE_DEPEND_TRACKING],[
   AC_ARG_ENABLE([fat-binaries],

=== modified file 'm4/pandora_drizzle_build.m4'
--- m4/pandora_drizzle_build.m4	2009-12-27 00:06:29 +0000
+++ m4/pandora_drizzle_build.m4	2010-03-22 21:30:21 +0000
@@ -70,6 +70,8 @@
   AC_CHECK_TYPES([uint, ulong])
 
   PANDORA_CXX_DEMANGLE
+  PANDORA_REQUIRE_BOOST([1.32])
+
 
   AH_TOP([
 #ifndef __CONFIG_H__

=== added file 'm4/pandora_have_boost.m4'
--- m4/pandora_have_boost.m4	1970-01-01 00:00:00 +0000
+++ m4/pandora_have_boost.m4	2010-03-23 08:22:38 +0000
@@ -0,0 +1,73 @@
+dnl Copyright (C) 2010 Monty Taylor
+dnl This file is free software; Monty Taylor
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
+AC_DEFUN([_PANDORA_SEARCH_BOOST],[
+  AC_REQUIRE([AC_LIB_PREFIX])
+
+  dnl --------------------------------------------------------------------
+  dnl  Check for boost
+  dnl --------------------------------------------------------------------
+
+  AC_ARG_ENABLE([boost],
+    [AS_HELP_STRING([--disable-boost],
+      [Build with boost support @<:@default=on@:>@])],
+    [ac_enable_boost="$enableval"],
+    [ac_enable_boost="yes"])
+
+  AS_IF([test "x$ac_enable_boost" = "xyes"],[
+    dnl link against libc because we're just looking for headers here
+    AC_LANG_PUSH(C++)
+    AC_LIB_HAVE_LINKFLAGS(c,,[
+      #include <boost/pool/pool.hpp>
+    ],[
+      boost::pool<> test_pool(1);
+    ])
+    AC_LANG_POP()
+  ],[
+    ac_cv_boost="no"
+  ])
+  
+
+  AS_IF([test "x$1" != "x"],[
+    AC_CACHE_CHECK([if boost is recent enough],
+      [pandora_cv_recent_boost],[
+      pandora_need_boost_version=`echo "$1" | perl -nle '/(\d+)\.(\d+)/; printf "%d%0.3d00", $[]1, $[]2 ;'`
+      AS_IF([test "x${pandora_need_boost_version}" = "x000000"],[
+        pandora_cv_recent_boost=yes
+      ],[
+        AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
+#include <boost/version.hpp>
+
+#if BOOST_VERSION < ${pandora_need_boost_version}
+# error boost too old!
+#endif
+          ]],[[]])
+        ],[
+          pandora_cv_recent_boost=yes
+        ],[
+          pandora_cv_recent_boost=no
+        ])
+      ])
+    ])
+    AS_IF([test "x${pandora_cv_recent_boost}" = "xno"],[
+      ac_cv_boost=no
+    ])
+  ])
+      
+
+  AM_CONDITIONAL(HAVE_BOOST, [test "x${ac_cv_boost}" = "xyes"])
+  
+])
+
+AC_DEFUN([PANDORA_HAVE_BOOST],[
+  _PANDORA_SEARCH_BOOST($1)
+])
+
+AC_DEFUN([PANDORA_REQUIRE_BOOST],[
+  PANDORA_HAVE_BOOST($1)
+  AS_IF([test x$ac_cv_boost = xno],
+      AC_MSG_ERROR([boost is required for ${PACKAGE}]))
+])
+

=== modified file 'm4/pandora_have_libdrizzle.m4'
--- m4/pandora_have_libdrizzle.m4	2009-07-29 18:27:28 +0000
+++ m4/pandora_have_libdrizzle.m4	2010-03-23 08:23:14 +0000
@@ -36,20 +36,26 @@
 
 AC_DEFUN([PANDORA_REQUIRE_LIBDRIZZLE],[
   AC_REQUIRE([PANDORA_HAVE_LIBDRIZZLE])
-  AS_IF([test "x${ac_cv_libdrizzle}" = "xno"],
-      AC_MSG_ERROR([libdrizzle is required for ${PACKAGE}]))
+  AS_IF([test "x${ac_cv_libdrizzle}" = "xno"],[
+    AC_MSG_ERROR([libdrizzle is required for ${PACKAGE}])
+  ],[
+    dnl We need at least 0.8 on Solaris non-sparc
+    AS_IF([test "$target_cpu" != "sparc" -a "x${TARGET_SOLARIS}" = "xtrue"],[
+      PANDORA_LIBDRIZZLE_RECENT
+    ])
+  ])
 ])
 
-AC_DEFUN([PANDORA_LIBDRIZZLE_NOVCOL],[
-  AC_CACHE_CHECK([if libdrizzle still has virtual columns],
-    [pandora_cv_libdrizzle_vcol],
+AC_DEFUN([PANDORA_LIBDRIZZLE_RECENT],[
+  AC_CACHE_CHECK([if libdrizzle is recent enough],
+    [pandora_cv_libdrizzle_recent],
     [AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
 #include <libdrizzle/drizzle.h>
-int foo= DRIZZLE_COLUMN_TYPE_DRIZZLE_VIRTUAL;
+drizzle_con_options_t foo= DRIZZLE_CON_EXPERIMENTAL;
     ]])],
-    [pandora_cv_libdrizzle_vcol=yes],
-    [pandora_cv_libdrizzle_vcol=no])])
-  AS_IF([test "$pandora_cv_libdrizzle_vcol" = "yes"],[
-    AC_MSG_ERROR([Your version of libdrizzle is too old. ${PACKAGE} requires at least version 0.4])
+    [pandora_cv_libdrizzle_recent=yes],
+    [pandora_cv_libdrizzle_recent=no])])
+  AS_IF([test "$pandora_cv_libdrizzle_recent" = "no"],[
+    AC_MSG_ERROR([Your version of libdrizzle is too old. ${PACKAGE} requires at least version 0.8])
   ])
 ])

=== modified file 'm4/pandora_have_libmemcached.m4'
--- m4/pandora_have_libmemcached.m4	2010-03-05 18:49:27 +0000
+++ m4/pandora_have_libmemcached.m4	2010-03-25 22:03:21 +0000
@@ -24,6 +24,11 @@
       memcached_dump_func *df;
       memcached_lib_version();
     ])
+  ],[
+    ac_cv_libmemcached="no"
+  ])
+
+  AS_IF([test "x$ac_enable_libmemcached" = "xyes"],[
     AC_LIB_HAVE_LINKFLAGS(memcachedprotocol,,[
       #include <libmemcached/protocol_handler.h>
     ],[
@@ -31,7 +36,6 @@
       protocol_handle= memcached_protocol_create_instance();
     ])
   ],[
-    ac_cv_libmemcached="no"
     ac_cv_libmemcachedprotocol="no"
   ])
   
@@ -43,49 +47,55 @@
     ]])],
     [pandora_cv_libmemcached_server_fn=yes],
     [pandora_cv_libmemcached_server_fn=no])])
+
   AS_IF([test "x$pandora_cv_libmemcached_server_fn" = "xyes"],[
     AC_DEFINE([HAVE_MEMCACHED_SERVER_FN],[1],[If we have the new memcached_server_fn typedef])
   ])
-
-  AS_IF([test "x$1" != "x"],[
-    AC_CACHE_CHECK([if libmemcached is recent enough],
-      [pandora_cv_recent_libmemcached],[
-      pandora_need_libmemcached_version=`echo "$1" | perl -nle '/(\d+)\.(\d+)/; printf "%d%0.3d000", $[]1, $[]2 ;'`
-      AS_IF([test "x${pandora_need_libmemcached_version}" = "x0000000"],[
-        pandora_cv_recent_libmemcached=yes
-      ],[
-        AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
+])
+
+AC_DEFUN([_PANDORA_RECENT_LIBMEMCACHED],[
+
+  AC_CACHE_CHECK([if libmemcached is recent enough],
+    [pandora_cv_recent_libmemcached],[
+    AS_IF([test "x${ac_cv_libmemcached}" = "xno"],[
+      pandora_cv_recent_libmemcached=no
+    ],[
+      AS_IF([test "x$1" != "x"],[
+        pandora_need_libmemcached_version=`echo "$1" | perl -nle '/(\d+)\.(\d+)/; printf "%d%0.3d000", $[]1, $[]2 ;'`
+        AS_IF([test "x${pandora_need_libmemcached_version}" = "x0000000"],[
+          pandora_cv_recent_libmemcached=yes
+        ],[
+          AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
 #include <libmemcached/configure.h>
 
 #if !defined(LIBMEMCACHED_VERSION_HEX) || LIBMEMCACHED_VERSION_HEX < 0x]]${pandora_need_libmemcached_version}[[
 # error libmemcached too old!
 #endif
-          ]],[[]])
-        ],[
-          pandora_cv_recent_libmemcached=yes
-        ],[
-          pandora_cv_recent_libmemcached=no
+            ]],[[]])
+          ],[
+            pandora_cv_recent_libmemcached=yes
+          ],[
+            pandora_cv_recent_libmemcached=no
+          ])
         ])
+      ],[
+        pandora_cv_recent_libmemcached=yes
       ])
     ])
-    AS_IF([test "x${pandora_cv_recent_libmemcached}" = "xno"],[
-      ac_cv_libmemcached=no
-      ac_cv_libmemcachedprotocol=no
-    ])
   ])
-      
 
-  AM_CONDITIONAL(HAVE_LIBMEMCACHED, [test "x${ac_cv_libmemcached}" = "xyes"])
+  AM_CONDITIONAL(HAVE_LIBMEMCACHED,[test "x${ac_cv_libmemcached}" = "xyes" -a "x${pandora_cv_recent_libmemcached}" = "xyes"])
   
 ])
 
 AC_DEFUN([PANDORA_HAVE_LIBMEMCACHED],[
-  _PANDORA_SEARCH_LIBMEMCACHED($1)
+  AC_REQUIRE([_PANDORA_SEARCH_LIBMEMCACHED])
+  _PANDORA_RECENT_LIBMEMCACHED($1)
 ])
 
 AC_DEFUN([PANDORA_REQUIRE_LIBMEMCACHED],[
   PANDORA_HAVE_LIBMEMCACHED($1)
-  AS_IF([test x$ac_cv_libmemcached = xno],
+  AS_IF([test "x{$pandora_cv_recent_libmemcached}" = "xno"],
       AC_MSG_ERROR([libmemcached is required for ${PACKAGE}]))
 ])
 

=== modified file 'plugin/archive/archive_engine.h'
--- plugin/archive/archive_engine.h	2010-03-19 01:17:11 +0000
+++ plugin/archive/archive_engine.h	2010-03-24 00:04:32 +0000
@@ -110,6 +110,7 @@
   }
 
   bool doDoesTableExist(drizzled::Session&, drizzled::TableIdentifier &identifier);
+  int doRenameTable(drizzled::Session&, drizzled::TableIdentifier &from, drizzled::TableIdentifier &to);
 };
 
 #endif /* PLUGIN_ARCHIVE_ARCHIVE_ENGINE_H */

=== modified file 'plugin/archive/archive_reader.cc'
--- plugin/archive/archive_reader.cc	2010-02-04 08:14:46 +0000
+++ plugin/archive/archive_reader.cc	2010-03-25 09:08:56 +0000
@@ -34,7 +34,7 @@
 
 using namespace drizzled;
 
-bool get_one_option(int optid, const struct my_option *opt, char *argument);
+int get_one_option(int optid, const struct my_option *opt, char *argument);
 
 static void get_options(int *argc,char * * *argv);
 static void print_version(void);
@@ -258,7 +258,7 @@
   return 0;
 }
 
-bool get_one_option(int optid, const struct my_option *opt, char *argument)
+int get_one_option(int optid, const struct my_option *opt, char *argument)
 {
   (void)opt;
   switch (optid) {

=== modified file 'plugin/archive/ha_archive.cc'
--- plugin/archive/ha_archive.cc	2010-03-19 04:54:45 +0000
+++ plugin/archive/ha_archive.cc	2010-03-24 00:04:32 +0000
@@ -285,6 +285,7 @@
   */
   if (archive_write_open == true)
     (void)azclose(&archive_write);
+  pthread_mutex_destroy(&archive_mutex);
 }
 
 bool ArchiveShare::prime(uint64_t *auto_increment)
@@ -1321,6 +1322,23 @@
   return;
 }
 
+int ArchiveEngine::doRenameTable(Session&, TableIdentifier &from, TableIdentifier &to)
+{
+  int error= 0;
+
+  for (const char **ext= bas_ext(); *ext ; ext++)
+  {
+    if (rename_file_ext(from.getPath().c_str(), to.getPath().c_str(), *ext))
+    {
+      if ((error=errno) != ENOENT)
+        break;
+      error= 0;
+    }
+  }
+
+  return error;
+}
+
 bool ArchiveEngine::doDoesTableExist(Session&,
                                      TableIdentifier &identifier)
 {

=== modified file 'plugin/archive/plugin.cc'
--- plugin/archive/plugin.cc	2010-02-18 04:43:04 +0000
+++ plugin/archive/plugin.cc	2010-03-06 02:08:13 +0000
@@ -33,38 +33,15 @@
   return archive_use_aio;
 }
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
 
   archive_engine= new ArchiveEngine();
-  registry.add(archive_engine);
+  context.add(archive_engine);
 
   return false;
 }
 
-/*
-  Release the archive Cursor.
-
-  SYNOPSIS
-    archive_db_done()
-    void
-
-  RETURN
-    false       OK
-*/
-
-extern pthread_mutex_t archive_mutex;
-
-static int done(drizzled::plugin::Registry &registry)
-{
-  registry.remove(archive_engine);
-  delete archive_engine;
-
-  pthread_mutex_destroy(&archive_mutex);
-
-  return 0;
-}
-
 
 static DRIZZLE_SYSVAR_BOOL(aio, archive_use_aio,
   PLUGIN_VAR_NOCMDOPT,
@@ -85,7 +62,6 @@
   "Archive storage engine",
   PLUGIN_LICENSE_GPL,
   init, /* Plugin Init */
-  done, /* Plugin Deinit */
   archive_system_variables,   /* system variables                */
   NULL                        /* config options                  */
 }

=== modified file 'plugin/ascii/ascii.cc'
--- plugin/ascii/ascii.cc	2010-02-18 04:43:04 +0000
+++ plugin/ascii/ascii.cc	2010-03-06 02:08:13 +0000
@@ -68,17 +68,10 @@
 
 plugin::Create_function<AsciiFunction> *asciiudf= NULL;
 
-static int initialize(plugin::Registry &registry)
+static int initialize(plugin::Context &context)
 {
   asciiudf= new plugin::Create_function<AsciiFunction>("ascii");
-  registry.add(asciiudf);
-  return 0;
-}
-
-static int finalize(plugin::Registry &registry)
-{
-  registry.remove(asciiudf);
-  delete asciiudf;
+  context.add(asciiudf);
   return 0;
 }
 
@@ -91,7 +84,6 @@
   "Return the ASCII value of a character",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/auth_http/auth_http.cc'
--- plugin/auth_http/auth_http.cc	2010-03-02 18:33:15 +0000
+++ plugin/auth_http/auth_http.cc	2010-03-06 02:08:13 +0000
@@ -70,6 +70,7 @@
   ~Auth_http()
   {
     curl_easy_cleanup(curl_handle);
+    curl_global_cleanup();
   }
 
   virtual bool authenticate(const SecurityContext &sctx, const string &password)
@@ -119,7 +120,7 @@
 
 Auth_http* auth= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   /* 
    * Per libcurl manual, in multi-threaded applications, curl_global_init() should
@@ -130,20 +131,7 @@
     return 1;
 
   auth= new Auth_http("auth_http");
-  registry.add(auth);
-
-  return 0;
-}
-
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  if (auth)
-  {
-    registry.remove(auth);
-    delete auth;
-
-    curl_global_cleanup();
-  }
+  context.add(auth);
 
   return 0;
 }
@@ -183,7 +171,6 @@
   "HTTP based authenication.",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize, /* Plugin Deinit */
   auth_http_system_variables,
   NULL    /* config options */
 }

=== modified file 'plugin/auth_pam/README'
--- plugin/auth_pam/README	2008-08-03 22:14:59 +0000
+++ plugin/auth_pam/README	2010-03-19 23:00:15 +0000
@@ -10,7 +10,7 @@
 account    required     pam_unix.so
 
 Into a file located here:
-/etc/pam.d/drizzled
+/etc/pam.d/drizzle
 
 Please send email to the drizzle mailing list on Launchpad if you would like
 to contribute.

=== modified file 'plugin/auth_pam/auth_pam.cc'
--- plugin/auth_pam/auth_pam.cc	2010-03-02 18:33:15 +0000
+++ plugin/auth_pam/auth_pam.cc	2010-03-25 19:28:37 +0000
@@ -117,7 +117,7 @@
     userinfo.name= sctx.getUser().c_str();
     userinfo.password= password.c_str();
 
-    retval= pam_start("check_user", userinfo.name, &conv_info, &pamh);
+    retval= pam_start("drizzle", userinfo.name, &conv_info, &pamh);
 
     if (retval == PAM_SUCCESS)
       retval= pam_authenticate(pamh, PAM_DISALLOW_NULL_AUTHTOK);
@@ -134,22 +134,10 @@
 
 static Auth_pam *auth= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   auth= new Auth_pam("auth_pam");
-  registry.add(auth);
-  return 0;
-}
-
-static int finalize(drizzled::plugin::Registry &registry)
-{
-
-  if (auth)
-  {
-    registry.remove(auth);
-    delete auth;
-  }
-
+  context.add(auth);
   return 0;
 }
 
@@ -162,7 +150,6 @@
   "PAM based authenication.",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize, /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== added directory 'plugin/auth_test'
=== added file 'plugin/auth_test/auth_test.cc'
--- plugin/auth_test/auth_test.cc	1970-01-01 00:00:00 +0000
+++ plugin/auth_test/auth_test.cc	2010-03-25 19:28:37 +0000
@@ -0,0 +1,109 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Rackspace
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <string>
+
+#include "drizzled/plugin/authentication.h"
+#include "drizzled/security_context.h"
+#include "drizzled/util/convert.h"
+#include "drizzled/algorithm/sha1.h"
+
+using namespace std;
+using namespace drizzled;
+
+namespace auth_test
+{
+
+/* This is the result of MYSQL_PASSWORD("scramble_password"). */
+static const char *scrambled_password= "2C5A870CEFF02BA3B0A927D7956B3FEB4D59CF21";
+
+class AuthTest: public plugin::Authentication
+{
+public:
+  AuthTest(string name_arg):
+    plugin::Authentication(name_arg)
+  { }
+
+  virtual bool authenticate(const SecurityContext &sctx, const string &password)
+  {
+    /* The "root" user always succeeds for drizzletest to get in. */
+    if (sctx.getUser() == "root" && password.empty())
+      return true;
+
+    /* Any password succeeds. */
+    if (sctx.getUser() == "password_ok" && !password.empty())
+      return true;
+
+    /* No password succeeds. */
+    if (sctx.getUser() == "no_password_ok" && password.empty())
+      return true;
+
+    /* Check if MySQL password scramble succeeds. */
+    if (sctx.getUser() == "scramble_ok" &&
+        sctx.getPasswordType() == SecurityContext::MYSQL_HASH &&
+        sctx.getPasswordContext().size() == SHA1_DIGEST_LENGTH &&
+        password.size() == SHA1_DIGEST_LENGTH)
+    {
+      SHA1_CTX ctx;
+      uint8_t scrambled_password_hash[SHA1_DIGEST_LENGTH];
+      uint8_t temp_hash[SHA1_DIGEST_LENGTH];
+      uint8_t scrambled_password_check[SHA1_DIGEST_LENGTH];
+
+      /* Get the double-hashed password from the stored hex string. */
+      drizzled_hex_to_string(reinterpret_cast<char*>(scrambled_password_hash),
+                             scrambled_password, SHA1_DIGEST_LENGTH * 2);
+
+      /* Hash the scramble that was sent to client with the stored password. */
+      SHA1Init(&ctx);
+      SHA1Update(&ctx, reinterpret_cast<const uint8_t*>(sctx.getPasswordContext().c_str()), SHA1_DIGEST_LENGTH);
+      SHA1Update(&ctx, scrambled_password_hash, SHA1_DIGEST_LENGTH);
+      SHA1Final(temp_hash, &ctx);
+
+      /* Next, XOR the result with what the client sent to get the original
+         single-hashed password. */
+      for (int x= 0; x < SHA1_DIGEST_LENGTH; x++)
+        temp_hash[x]= temp_hash[x] ^ password[x];
+
+      /* Hash this result once more to get the double-hashed password again. */
+      SHA1Init(&ctx);
+      SHA1Update(&ctx, temp_hash, SHA1_DIGEST_LENGTH);
+      SHA1Final(scrambled_password_check, &ctx);
+
+      /* These should match for a successful auth. */
+      return memcmp(scrambled_password_hash, scrambled_password_check, SHA1_DIGEST_LENGTH) == 0;
+    }
+
+    return false;
+  }
+};
+
+AuthTest *auth_test= NULL;
+
+static int init(plugin::Context &context)
+{
+  auth_test= new AuthTest("auth_test");
+  context.add(auth_test);
+  return 0;
+}
+
+} /* namespace auth_test */
+
+DRIZZLE_PLUGIN(auth_test::init, NULL);

=== added file 'plugin/auth_test/plugin.ini'
--- plugin/auth_test/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/auth_test/plugin.ini	2010-03-18 18:09:04 +0000
@@ -0,0 +1,6 @@
+[plugin]
+title=Authentication Test
+description=A hard-coded authentication test plugin
+version=0.1
+author=Eric Day <eday@oddments.org>
+license=PLUGIN_LICENSE_GPL

=== added directory 'plugin/auth_test/tests'
=== added directory 'plugin/auth_test/tests/r'
=== added file 'plugin/auth_test/tests/r/basic.result'
--- plugin/auth_test/tests/r/basic.result	1970-01-01 00:00:00 +0000
+++ plugin/auth_test/tests/r/basic.result	2010-03-18 18:09:04 +0000
@@ -0,0 +1,19 @@
+connect(localhost,,,test,MASTER_PORT,);
+ERROR 28000: Access denied for user ''@'LOCALHOST' (using password: NO)
+connect(localhost,password_ok,,test,MASTER_PORT,);
+ERROR 28000: Access denied for user 'password_ok'@'LOCALHOST' (using password: NO)
+SELECT 1;
+1
+1
+connect(localhost,no_password_ok,test,test,MASTER_PORT,);
+ERROR 28000: Access denied for user 'no_password_ok'@'LOCALHOST' (using password: YES)
+SELECT 1;
+1
+1
+connect(localhost,scramble_ok,,test,MASTER_PORT,);
+ERROR 28000: Access denied for user 'scramble_ok'@'LOCALHOST' (using password: NO)
+connect(localhost,scramble_ok,bad_scramble,test,MASTER_PORT,);
+ERROR 28000: Access denied for user 'scramble_ok'@'LOCALHOST' (using password: YES)
+SELECT 1;
+1
+1

=== added directory 'plugin/auth_test/tests/t'
=== added file 'plugin/auth_test/tests/t/basic-master.opt'
--- plugin/auth_test/tests/t/basic-master.opt	1970-01-01 00:00:00 +0000
+++ plugin/auth_test/tests/t/basic-master.opt	2010-03-18 18:09:04 +0000
@@ -0,0 +1,1 @@
+--plugin-add=auth_test

=== added file 'plugin/auth_test/tests/t/basic.test'
--- plugin/auth_test/tests/t/basic.test	1970-01-01 00:00:00 +0000
+++ plugin/auth_test/tests/t/basic.test	2010-03-18 18:09:04 +0000
@@ -0,0 +1,39 @@
+--replace_result $MASTER_MYSOCK MASTER_SOCKET $MASTER_MYPORT MASTER_PORT
+--replace_regex /@'.*?'/@'LOCALHOST'/
+--error ER_ACCESS_DENIED_ERROR
+connect (empty,localhost,,,,);
+
+--replace_result $MASTER_MYSOCK MASTER_SOCKET $MASTER_MYPORT MASTER_PORT
+--replace_regex /@'.*?'/@'LOCALHOST'/
+--error ER_ACCESS_DENIED_ERROR
+connect (password_ok,localhost,password_ok,,,);
+
+--replace_result $MASTER_MYSOCK MASTER_SOCKET $MASTER_MYPORT MASTER_PORT
+connect (password_ok,localhost,password_ok,test,,);
+connection password_ok;
+SELECT 1;
+
+--replace_result $MASTER_MYSOCK MASTER_SOCKET $MASTER_MYPORT MASTER_PORT
+--replace_regex /@'.*?'/@'LOCALHOST'/
+--error ER_ACCESS_DENIED_ERROR
+connect (no_password_ok,localhost,no_password_ok,test,,);
+
+--replace_result $MASTER_MYSOCK MASTER_SOCKET $MASTER_MYPORT MASTER_PORT
+connect (no_password_ok,localhost,no_password_ok,,,);
+connection no_password_ok;
+SELECT 1;
+
+--replace_result $MASTER_MYSOCK MASTER_SOCKET $MASTER_MYPORT MASTER_PORT
+--replace_regex /@'.*?'/@'LOCALHOST'/
+--error ER_ACCESS_DENIED_ERROR
+connect (scramble_ok,localhost,scramble_ok,,,);
+
+--replace_result $MASTER_MYSOCK MASTER_SOCKET $MASTER_MYPORT MASTER_PORT
+--replace_regex /@'.*?'/@'LOCALHOST'/
+--error ER_ACCESS_DENIED_ERROR
+connect (scramble_ok,localhost,scramble_ok,bad_scramble,,);
+
+--replace_result $MASTER_MYSOCK MASTER_SOCKET $MASTER_MYPORT MASTER_PORT
+connect (scramble_ok,localhost,scramble_ok,scramble_password,,);
+connection scramble_ok;
+SELECT 1;

=== modified file 'plugin/benchmark/benchmarkudf.cc'
--- plugin/benchmark/benchmarkudf.cc	2010-02-18 04:43:04 +0000
+++ plugin/benchmark/benchmarkudf.cc	2010-03-06 02:08:13 +0000
@@ -118,20 +118,13 @@
 
 plugin::Create_function<BenchmarkFunction> *benchmarkudf= NULL;
 
-static int initialize(plugin::Registry &registry)
+static int initialize(plugin::Context &context)
 {
   benchmarkudf= new plugin::Create_function<BenchmarkFunction>("benchmark");
-  registry.add(benchmarkudf);
+  context.add(benchmarkudf);
   return 0;
 }
 
-static int finalize(plugin::Registry &registry)
-{
-   registry.remove(benchmarkudf);
-   delete benchmarkudf;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -141,7 +134,6 @@
   "Measure time for repeated calls to a function.",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/blackhole/ha_blackhole.cc'
--- plugin/blackhole/ha_blackhole.cc	2010-03-19 01:17:11 +0000
+++ plugin/blackhole/ha_blackhole.cc	2010-03-24 00:04:32 +0000
@@ -38,6 +38,9 @@
 
 #define BLACKHOLE_EXT ".blk"
 
+static pthread_mutex_t blackhole_mutex;
+
+
 static const char *ha_blackhole_exts[] = {
   NULL
 };
@@ -60,6 +63,11 @@
     table_definition_ext= BLACKHOLE_EXT;
   }
 
+  virtual ~BlackholeEngine()
+  {
+    pthread_mutex_destroy(&blackhole_mutex);
+  }
+
   virtual Cursor *create(TableShare &table,
                          drizzled::memory::Root *mem_root)
   {
@@ -131,9 +139,26 @@
   }
 
   bool doDoesTableExist(Session& session, TableIdentifier &identifier);
+  int doRenameTable(Session&, TableIdentifier &from, TableIdentifier &to);
 };
 
 
+int BlackholeEngine::doRenameTable(Session&, TableIdentifier &from, TableIdentifier &to)
+{
+  int error= 0;
+
+  for (const char **ext= bas_ext(); *ext ; ext++)
+  {
+    if (rename_file_ext(from.getPath().c_str(), to.getPath().c_str(), *ext))
+    {
+      if ((error=errno) != ENOENT)
+        break;
+      error= 0;
+    }
+  }
+  return error;
+}
+
 BlackholeShare *BlackholeEngine::findOpenTable(const string table_name)
 {
   BlackholeMap::iterator find_iter=
@@ -156,10 +181,6 @@
 }
 
 
-/* Static declarations for shared structures */
-
-static pthread_mutex_t blackhole_mutex;
-
 
 /*****************************************************************************
 ** BLACKHOLE tables
@@ -425,26 +446,17 @@
 
 static drizzled::plugin::StorageEngine *blackhole_engine= NULL;
 
-static int blackhole_init(drizzled::plugin::Registry &registry)
+static int blackhole_init(drizzled::plugin::Context &context)
 {
 
   blackhole_engine= new BlackholeEngine("BLACKHOLE");
-  registry.add(blackhole_engine);
+  context.add(blackhole_engine);
   
   pthread_mutex_init(&blackhole_mutex, MY_MUTEX_INIT_FAST);
 
   return 0;
 }
 
-static int blackhole_fini(drizzled::plugin::Registry &registry)
-{
-  registry.remove(blackhole_engine);
-  delete blackhole_engine;
-
-  pthread_mutex_destroy(&blackhole_mutex);
-
-  return 0;
-}
 
 DRIZZLE_DECLARE_PLUGIN
 {
@@ -455,7 +467,6 @@
   "/dev/null storage engine (anything you write to it disappears)",
   PLUGIN_LICENSE_GPL,
   blackhole_init,     /* Plugin Init */
-  blackhole_fini,     /* Plugin Deinit */
   NULL,               /* system variables */
   NULL                /* config options   */
 }

=== modified file 'plugin/blackhole/plugin.ini'
--- plugin/blackhole/plugin.ini	2009-12-04 10:17:07 +0000
+++ plugin/blackhole/plugin.ini	2010-03-25 05:55:42 +0000
@@ -1,6 +1,6 @@
 [plugin]
 title=Blackhole Storage Engine
 description=Basic Write-only Read-never tables
-load_by_default=yes
 sources=ha_blackhole.cc
 headers=ha_blackhole.h
+load_by_default=yes

=== modified file 'plugin/blackhole/tests/r/blackhole.result'
--- plugin/blackhole/tests/r/blackhole.result	2009-12-04 20:51:25 +0000
+++ plugin/blackhole/tests/r/blackhole.result	2010-03-23 10:01:41 +0000
@@ -25,6 +25,7 @@
 INSERT INTO t1 VALUES (1, 1111, 11.111);
 INSERT INTO t1 VALUES (2, 2222, 22.222);
 INSERT INTO t1 VALUES (3, 3333, 33.333);
+drop table t1;
 CREATE TABLE t5 (a int) ENGINE=BLACKHOLE;
 INSERT INTO t5 VALUES (1);
 FLUSH TABLES WITH READ LOCK;

=== renamed file 'tests/r/create_max_fields.result' => 'plugin/blackhole/tests/r/create_max_fields.result'
--- tests/r/create_max_fields.result	2009-12-08 03:43:57 +0000
+++ plugin/blackhole/tests/r/create_max_fields.result	2010-03-23 10:01:41 +0000
@@ -1,3 +1,4 @@
+drop table if exists t1;
 One column less than MAX_FIELDS
 CREATE TABLE t1 (
 f1 int,

=== modified file 'plugin/blackhole/tests/t/blackhole.test'
--- plugin/blackhole/tests/t/blackhole.test	2009-12-04 20:51:25 +0000
+++ plugin/blackhole/tests/t/blackhole.test	2010-03-23 10:01:41 +0000
@@ -40,6 +40,7 @@
 INSERT INTO t1 VALUES (1, 1111, 11.111);
 INSERT INTO t1 VALUES (2, 2222, 22.222);
 INSERT INTO t1 VALUES (3, 3333, 33.333);
+drop table t1;
 
 # Double check that read locks are still being honored by the kernel.
 CREATE TABLE t5 (a int) ENGINE=BLACKHOLE;

=== added file 'plugin/blackhole/tests/t/create_max_fields-master.opt'
--- plugin/blackhole/tests/t/create_max_fields-master.opt	1970-01-01 00:00:00 +0000
+++ plugin/blackhole/tests/t/create_max_fields-master.opt	2010-03-23 09:43:55 +0000
@@ -0,0 +1,1 @@
+--plugin-add=blackhole

=== renamed file 'tests/t/create_max_fields.test' => 'plugin/blackhole/tests/t/create_max_fields.test'
--- tests/t/create_max_fields.test	2009-12-08 03:43:57 +0000
+++ plugin/blackhole/tests/t/create_max_fields.test	2010-03-23 10:01:41 +0000
@@ -1,3 +1,7 @@
+--disable_warnings
+drop table if exists t1;
+--enable_warnings
+
 --echo One column less than MAX_FIELDS
 CREATE TABLE t1 (
 f1 int,

=== modified file 'plugin/charlength/charlength.cc'
--- plugin/charlength/charlength.cc	2010-02-18 04:43:04 +0000
+++ plugin/charlength/charlength.cc	2010-03-06 02:08:13 +0000
@@ -66,24 +66,15 @@
 plugin::Create_function<CharLengthFunction> *charlengthudf= NULL;
 plugin::Create_function<CharLengthFunction> *characterlengthudf= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   charlengthudf= new plugin::Create_function<CharLengthFunction>("char_length");
   characterlengthudf= new plugin::Create_function<CharLengthFunction>("character_length");
-  registry.add(charlengthudf);
-  registry.add(characterlengthudf);
+  context.add(charlengthudf);
+  context.add(characterlengthudf);
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-   registry.remove(charlengthudf);
-   registry.remove(characterlengthudf);
-   delete charlengthudf;
-   delete characterlengthudf;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -93,7 +84,6 @@
   "Return the number of characters in a string",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/collation_dictionary/dictionary.cc'
--- plugin/collation_dictionary/dictionary.cc	2010-02-18 04:43:04 +0000
+++ plugin/collation_dictionary/dictionary.cc	2010-03-06 02:08:13 +0000
@@ -26,27 +26,17 @@
 static CharacterSetsTool *character_sets;
 static CollationsTool *collations;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   character_sets= new(std::nothrow)CharacterSetsTool;
   collations= new(std::nothrow)CollationsTool;
 
-  registry.add(character_sets);
-  registry.add(collations);
+  context.add(character_sets);
+  context.add(collations);
   
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(character_sets);
-  registry.remove(collations);
-  delete character_sets;
-  delete collations;
-
-  return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -56,7 +46,6 @@
   "Data Dictionary for schema, table, column, indexes, etc",
   PLUGIN_LICENSE_GPL,
   init,
-  finalize,
   NULL,
   NULL
 }

=== modified file 'plugin/compression/compressionudf.cc'
--- plugin/compression/compressionudf.cc	2010-02-18 04:43:04 +0000
+++ plugin/compression/compressionudf.cc	2010-03-06 02:08:13 +0000
@@ -28,27 +28,16 @@
 plugin::Create_function<Item_func_uncompressed_length>
   *uncompressed_lengthudf= NULL;
 
-static int compressionudf_plugin_init(plugin::Registry &registry)
+static int compressionudf_plugin_init(plugin::Context &context)
 {
   compressudf= new plugin::Create_function<Item_func_compress>("compress");
   uncompressudf=
     new plugin::Create_function<Item_func_uncompress>("uncompress");
   uncompressed_lengthudf=
     new plugin::Create_function<Item_func_uncompressed_length>("uncompressed_length");
-  registry.add(compressudf);
-  registry.add(uncompressudf);
-  registry.add(uncompressed_lengthudf);
-  return 0;
-}
-
-static int compressionudf_plugin_deinit(plugin::Registry &registry)
-{
-  registry.remove(compressudf);
-  registry.remove(uncompressudf);
-  registry.remove(uncompressed_lengthudf);
-  delete compressudf;
-  delete uncompressudf;
-  delete uncompressed_lengthudf;
+  context.add(compressudf);
+  context.add(uncompressudf);
+  context.add(uncompressed_lengthudf);
   return 0;
 }
 
@@ -61,7 +50,6 @@
   "UDFs for compression functions",
   PLUGIN_LICENSE_GPL,
   compressionudf_plugin_init, /* Plugin Init */
-  compressionudf_plugin_deinit, /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/connection_id/connection_id.cc'
--- plugin/connection_id/connection_id.cc	2010-02-18 04:43:04 +0000
+++ plugin/connection_id/connection_id.cc	2010-03-06 02:08:13 +0000
@@ -68,21 +68,14 @@
 
 plugin::Create_function<ConnectionIdFunction> *connection_idudf= NULL;
 
-static int initialize(plugin::Registry &registry)
+static int initialize(plugin::Context &context)
 {
   connection_idudf=
     new plugin::Create_function<ConnectionIdFunction>("connection_id");
-  registry.add(connection_idudf);
+  context.add(connection_idudf);
   return 0;
 }
 
-static int finalize(plugin::Registry &registry)
-{
-   registry.remove(connection_idudf);
-   delete connection_idudf;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -92,7 +85,6 @@
   "Return the current connection_id",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/console/console.cc'
--- plugin/console/console.cc	2010-03-04 17:11:27 +0000
+++ plugin/console/console.cc	2010-03-10 18:22:56 +0000
@@ -310,17 +310,10 @@
 
 static ListenConsole *listen_obj= NULL;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   listen_obj= new ListenConsole("console");
-  registry.add(listen_obj);
-  return 0;
-}
-
-static int deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(listen_obj);
-  delete listen_obj;
+  context.add(listen_obj);
   return 0;
 }
 
@@ -354,7 +347,6 @@
   "Console Client",
   PLUGIN_LICENSE_BSD,
   init,   /* Plugin Init */
-  deinit, /* Plugin Deinit */
   vars,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/crc32/crc32udf.cc'
--- plugin/crc32/crc32udf.cc	2010-02-18 04:43:04 +0000
+++ plugin/crc32/crc32udf.cc	2010-03-06 02:08:13 +0000
@@ -71,18 +71,11 @@
 
 plugin::Create_function<Crc32Function> *crc32udf= NULL;
 
-static int initialize(plugin::Registry &registry)
+static int initialize(plugin::Context &context)
 {
   crc32udf= new plugin::Create_function<Crc32Function>("crc32");
-  registry.add(crc32udf);
-  return 0;
-}
-
-static int finalize(plugin::Registry &registry)  
-{
-  registry.remove(crc32udf);
-  delete crc32udf;
-  return 0;
-}
-
-DRIZZLE_PLUGIN(initialize, finalize, NULL);
+  context.add(crc32udf);
+  return 0;
+}
+
+DRIZZLE_PLUGIN(initialize, NULL);

=== modified file 'plugin/crc32/plugin.ini'
--- plugin/crc32/plugin.ini	2009-12-09 19:43:59 +0000
+++ plugin/crc32/plugin.ini	2010-03-22 21:17:44 +0000
@@ -6,4 +6,5 @@
 author=Stewart Smith
 license=PLUGIN_LICENSE_GPL
 load_by_default=yes
+libs=${top_builddir}/drizzled/algorithm/libhash.la
 sources=crc32udf.cc

=== modified file 'plugin/csv/ha_tina.cc'
--- plugin/csv/ha_tina.cc	2010-03-19 04:54:45 +0000
+++ plugin/csv/ha_tina.cc	2010-03-24 19:52:38 +0000
@@ -124,6 +124,11 @@
                                      HTON_FILE_BASED),
     tina_open_tables()
   {}
+  virtual ~Tina()
+  {
+    pthread_mutex_destroy(&tina_mutex);
+  }
+
   virtual Cursor *create(TableShare &table,
                          drizzled::memory::Root *mem_root)
   {
@@ -156,33 +161,41 @@
   uint32_t max_key_parts()     const { return 0; }
   uint32_t max_key_length()    const { return 0; }
   bool doDoesTableExist(Session& session, TableIdentifier &identifier);
+  int doRenameTable(Session&, TableIdentifier &from, TableIdentifier &to);
 };
 
 
-bool Tina::doDoesTableExist(Session&, TableIdentifier &identifier)
+int Tina::doRenameTable(Session &session,
+                        TableIdentifier &from, TableIdentifier &to)
 {
-  ProtoCache::iterator iter;
-
-  pthread_mutex_lock(&proto_cache_mutex);
-  iter= proto_cache.find(identifier.getPath());
-
-  if (iter != proto_cache.end())
+  int error= 0;
+  for (const char **ext= bas_ext(); *ext ; ext++)
   {
-    return true;
+    if (rename_file_ext(from.getPath().c_str(), to.getPath().c_str(), *ext))
+    {
+      if ((error=errno) != ENOENT)
+        break;
+      error= 0;
+    }
   }
-  pthread_mutex_unlock(&proto_cache_mutex);
-
-  return false;
-}
-
-
-int Tina::doDropTable(Session&,
+
+  session.renameTableMessage(from, to);
+
+  return error;
+}
+
+bool Tina::doDoesTableExist(Session &session, TableIdentifier &identifier)
+{
+  return session.doesTableMessageExist(identifier);
+}
+
+
+int Tina::doDropTable(Session &session,
                       TableIdentifier &identifier)
 {
   int error= 0;
   int enoent_or_zero= ENOENT;                   // Error if no file was deleted
   char buff[FN_REFLEN];
-  ProtoCache::iterator iter;
 
   for (const char **ext= bas_ext(); *ext ; ext++)
   {
@@ -198,12 +211,7 @@
     error= enoent_or_zero;
   }
 
-  pthread_mutex_lock(&proto_cache_mutex);
-  iter= proto_cache.find(identifier.getPath());
-
-  if (iter!= proto_cache.end())
-    proto_cache.erase(iter);
-  pthread_mutex_unlock(&proto_cache_mutex);
+  session.removeTableMessage(identifier);
 
   return error;
 }
@@ -230,48 +238,29 @@
 }
 
 
-int Tina::doGetTableDefinition(Session&,
+int Tina::doGetTableDefinition(Session &session,
                                drizzled::TableIdentifier &identifier,
                                drizzled::message::Table &table_message)
 {
-  int error= ENOENT;
-  ProtoCache::iterator iter;
-
-  pthread_mutex_lock(&proto_cache_mutex);
-  iter= proto_cache.find(identifier.getPath());
-
-  if (iter!= proto_cache.end())
-  {
-    table_message.CopyFrom(((*iter).second));
-    error= EEXIST;
-  }
-  pthread_mutex_unlock(&proto_cache_mutex);
-
-  return error;
+  if (session.getTableMessage(identifier, table_message))
+    return EEXIST;
+
+  return ENOENT;
 }
 
 
 static Tina *tina_engine= NULL;
 
-static int tina_init_func(drizzled::plugin::Registry &registry)
+static int tina_init_func(drizzled::plugin::Context &context)
 {
 
   tina_engine= new Tina("CSV");
-  registry.add(tina_engine);
+  context.add(tina_engine);
 
   pthread_mutex_init(&tina_mutex,MY_MUTEX_INIT_FAST);
   return 0;
 }
 
-static int tina_done_func(drizzled::plugin::Registry &registry)
-{
-  registry.remove(tina_engine);
-  delete tina_engine;
-
-  pthread_mutex_destroy(&tina_mutex);
-
-  return 0;
-}
 
 
 TinaShare::TinaShare(const char *table_name_arg)
@@ -1397,10 +1386,10 @@
   this (the database will call ::open() if it needs to).
 */
 
-int Tina::doCreateTable(Session *,
+int Tina::doCreateTable(Session *session,
                         Table& table_arg,
                         drizzled::TableIdentifier &identifier,
-                        drizzled::message::Table& create_proto)
+                        drizzled::message::Table &create_proto)
 {
   char name_buff[FN_REFLEN];
   int create_file;
@@ -1433,9 +1422,7 @@
 
   internal::my_close(create_file, MYF(0));
 
-  pthread_mutex_lock(&proto_cache_mutex);
-  proto_cache.insert(make_pair(identifier.getPath(), create_proto));
-  pthread_mutex_unlock(&proto_cache_mutex);
+  session->storeTableMessage(identifier, create_proto);
 
   return 0;
 }
@@ -1450,7 +1437,6 @@
   "CSV storage engine",
   PLUGIN_LICENSE_GPL,
   tina_init_func, /* Plugin Init */
-  tina_done_func, /* Plugin Deinit */
   NULL,                       /* system variables                */
   NULL                        /* config options                  */
 }

=== modified file 'plugin/database_function/database_function.cc'
--- plugin/database_function/database_function.cc	2010-02-23 21:26:50 +0000
+++ plugin/database_function/database_function.cc	2010-03-06 02:08:13 +0000
@@ -55,20 +55,13 @@
 
 plugin::Create_function<DatabaseFunction> *database_function= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   database_function= new plugin::Create_function<DatabaseFunction>("database");
-  registry.add(database_function);
+  context.add(database_function);
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-   registry.remove(database_function);
-   delete database_function;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -78,7 +71,6 @@
   "returns the current database",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/default_replicator/default_replicator.cc'
--- plugin/default_replicator/default_replicator.cc	2010-02-18 04:43:04 +0000
+++ plugin/default_replicator/default_replicator.cc	2010-03-06 02:08:13 +0000
@@ -33,7 +33,6 @@
  */
 
 #include "config.h"
-#include <drizzled/plugin/registry.h>
 #include <drizzled/plugin.h>
 #include <drizzled/gettext.h>
 #include <drizzled/plugin/transaction_applier.h>
@@ -74,20 +73,10 @@
 
 static DefaultReplicator *default_replicator= NULL; /* The singleton replicator */
 
-static int init(plugin::Registry &registry)
+static int init(plugin::Context &context)
 {
   default_replicator= new DefaultReplicator("default_replicator");
-  registry.add(default_replicator);
-  return 0;
-}
-
-static int deinit(plugin::Registry &registry)
-{
-  if (default_replicator)
-  {
-    registry.remove(default_replicator);
-    delete default_replicator;
-  }
+  context.add(default_replicator);
   return 0;
 }
 
@@ -114,7 +103,6 @@
   N_("Default Replicator"),
   PLUGIN_LICENSE_GPL,
   init, /* Plugin Init */
-  deinit, /* Plugin Deinit */
   default_replicator_system_variables, /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/drizzle_protocol/drizzle_protocol.cc'
--- plugin/drizzle_protocol/drizzle_protocol.cc	2010-03-04 18:06:27 +0000
+++ plugin/drizzle_protocol/drizzle_protocol.cc	2010-03-10 18:22:56 +0000
@@ -814,17 +814,10 @@
 
 static ListenDrizzleProtocol *listen_obj= NULL;
 
-static int init(plugin::Registry &registry)
+static int init(plugin::Context &context)
 {
   listen_obj= new ListenDrizzleProtocol("drizzle_protocol", false);
-  registry.add(listen_obj); 
-  return 0;
-}
-
-static int deinit(plugin::Registry &registry)
-{
-  registry.remove(listen_obj);
-  delete listen_obj;
+  context.add(listen_obj); 
   return 0;
 }
 
@@ -862,4 +855,4 @@
 
 } /* namespace drizzle_protocol */
 
-DRIZZLE_PLUGIN(drizzle_protocol::init, drizzle_protocol::deinit, drizzle_protocol::sys_variables);
+DRIZZLE_PLUGIN(drizzle_protocol::init, drizzle_protocol::sys_variables);

=== modified file 'plugin/errmsg_notify/errmsg_notify.cc'
--- plugin/errmsg_notify/errmsg_notify.cc	2010-03-02 18:28:00 +0000
+++ plugin/errmsg_notify/errmsg_notify.cc	2010-03-06 02:08:13 +0000
@@ -30,7 +30,6 @@
 #include <drizzled/plugin/error_message.h>
 #include <drizzled/gettext.h>
 #include <drizzled/plugin.h>
-#include <drizzled/plugin/registry.h>
 
 
 /* todo, make this dynamic as needed */
@@ -95,24 +94,13 @@
 };
 
 static Error_message_notify *handler= NULL;
-static int plugin_init(plugin::Registry &registry)
+static int plugin_init(plugin::Context &context)
 {
   Notify::init("Drizzled");
   handler= new Error_message_notify();
-  registry.add(handler);
-
-  return 0;
-}
-
-static int plugin_deinit(plugin::Registry &registry)
-{
-
-  if (handler)
-  {
-    registry.remove(handler);
-    delete handler;
-  }
-  return 0;
-}
-
-DRIZZLE_PLUGIN(plugin_init, plugin_deinit, NULL);
+  context.add(handler);
+
+  return 0;
+}
+
+DRIZZLE_PLUGIN(plugin_init, NULL);

=== modified file 'plugin/errmsg_stderr/errmsg_stderr.cc'
--- plugin/errmsg_stderr/errmsg_stderr.cc	2010-02-18 04:43:04 +0000
+++ plugin/errmsg_stderr/errmsg_stderr.cc	2010-03-06 02:08:13 +0000
@@ -21,7 +21,6 @@
 #include <drizzled/plugin/error_message.h>
 #include <drizzled/gettext.h>
 #include <drizzled/plugin.h>
-#include <drizzled/plugin/registry.h>
 
 #include <stdio.h>  /* for vsnprintf */
 #include <stdarg.h>  /* for va_list */
@@ -56,22 +55,11 @@
 };
 
 static Error_message_stderr *handler= NULL;
-static int errmsg_stderr_plugin_init(plugin::Registry &registry)
+static int errmsg_stderr_plugin_init(plugin::Context &context)
 {
   handler= new Error_message_stderr();
-  registry.add(handler);
-
-  return 0;
-}
-
-static int errmsg_stderr_plugin_deinit(plugin::Registry &registry)
-{
-
-  if (handler)
-  {
-    registry.remove(handler);
-    delete handler;
-  }
+  context.add(handler);
+
   return 0;
 }
 
@@ -84,7 +72,6 @@
   N_("Error Messages to stderr"),
   PLUGIN_LICENSE_GPL,
   errmsg_stderr_plugin_init,
-  errmsg_stderr_plugin_deinit,
   NULL, /* system variables */
   NULL
 }

=== modified file 'plugin/filtered_replicator/filtered_replicator.cc'
--- plugin/filtered_replicator/filtered_replicator.cc	2010-02-18 04:43:04 +0000
+++ plugin/filtered_replicator/filtered_replicator.cc	2010-03-06 02:08:13 +0000
@@ -41,7 +41,6 @@
 #include <drizzled/plugin/transaction_applier.h>
 #include <drizzled/message/transaction.pb.h>
 #include <drizzled/plugin.h>
-#include <drizzled/plugin/registry.h>
 
 #include "filtered_replicator.h"
 
@@ -507,7 +506,7 @@
 
 static FilteredReplicator *filtered_replicator= NULL; /* The singleton replicator */
 
-static int init(plugin::Registry &registry)
+static int init(plugin::Context &context)
 {
   if (sysvar_filtered_replicator_enabled)
   {
@@ -519,17 +518,7 @@
     {
       return 1;
     }
-    registry.add(filtered_replicator);
-  }
-  return 0;
-}
-
-static int deinit(plugin::Registry &registry)
-{
-  if (filtered_replicator)
-  {
-    registry.remove(filtered_replicator);
-    delete filtered_replicator;
+    context.add(filtered_replicator);
   }
   return 0;
 }
@@ -654,7 +643,6 @@
   N_("Filtered Replicator"),
   PLUGIN_LICENSE_GPL,
   init, /* Plugin Init */
-  deinit, /* Plugin Deinit */
   filtered_replicator_system_variables, /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/function_engine/function.cc'
--- plugin/function_engine/function.cc	2010-03-19 04:54:45 +0000
+++ plugin/function_engine/function.cc	2010-03-20 07:56:53 +0000
@@ -126,7 +126,7 @@
 
 static drizzled::plugin::StorageEngine *function_plugin= NULL;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   function_plugin= new(std::nothrow) Function("FunctionEngine");
 
@@ -135,15 +135,7 @@
     return 1;
   }
 
-  registry.add(function_plugin);
-
-  return 0;
-}
-
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(function_plugin);
-  delete function_plugin;
+  context.add(function_plugin);
 
   return 0;
 }
@@ -157,7 +149,6 @@
   "Function Engine provides the infrastructure for Table Functions,etc.",
   PLUGIN_LICENSE_GPL,
   init,     /* Plugin Init */
-  finalize,     /* Plugin Deinit */
   NULL,               /* system variables */
   NULL                /* config options   */
 }

=== modified file 'plugin/function_engine/function.h'
--- plugin/function_engine/function.h	2010-03-19 01:17:11 +0000
+++ plugin/function_engine/function.h	2010-03-24 00:04:32 +0000
@@ -85,6 +85,11 @@
   bool doDoesTableExist(drizzled::Session& session, drizzled::TableIdentifier &identifier);
 
   bool doGetSchemaDefinition(const std::string &schema_name, drizzled::message::Schema &schema_message);
+
+  int doRenameTable(drizzled::Session&, drizzled::TableIdentifier &, drizzled::TableIdentifier &)
+  {
+    return EPERM;
+  }
 };
 
 #endif /* PLUGIN_FUNCTION_ENGINE_FUNCTION_H */

=== modified file 'plugin/gearman_udf/gearman_udf.cc'
--- plugin/gearman_udf/gearman_udf.cc	2010-02-18 04:43:04 +0000
+++ plugin/gearman_udf/gearman_udf.cc	2010-03-06 02:08:13 +0000
@@ -32,7 +32,7 @@
 plugin::Create_function<Item_func_gman_do_low_background>
   *gman_do_low_background= NULL;
 
-static int gearman_udf_plugin_init(drizzled::plugin::Registry &registry)
+static int gearman_udf_plugin_init(drizzled::plugin::Context &context)
 {
   gman_servers_set= new plugin::Create_function<Item_func_gman_servers_set>("gman_servers_set");
   gman_do= new plugin::Create_function<Item_func_gman_do>("gman_do");
@@ -41,32 +41,13 @@
   gman_do_background= new plugin::Create_function<Item_func_gman_do_background>("gman_do_background");
   gman_do_high_background= new plugin::Create_function<Item_func_gman_do_high_background>("gman_do_high_background");
   gman_do_low_background= new plugin::Create_function<Item_func_gman_do_low_background>("gman_do_low_background");
-  registry.add(gman_servers_set);
-  registry.add(gman_do);
-  registry.add(gman_do_high);
-  registry.add(gman_do_low);
-  registry.add(gman_do_background);
-  registry.add(gman_do_high_background);
-  registry.add(gman_do_low_background);
-  return 0;
-}
-
-static int gearman_udf_plugin_deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(gman_do_low_background);
-  registry.remove(gman_do_high_background);
-  registry.remove(gman_do_background);
-  registry.remove(gman_do_low);
-  registry.remove(gman_do_high);
-  registry.remove(gman_do);
-  registry.remove(gman_servers_set);
-  delete gman_do_low_background;
-  delete gman_do_high_background;
-  delete gman_do_background;
-  delete gman_do_low;
-  delete gman_do_high;
-  delete gman_do;
-  delete gman_servers_set;
+  context.add(gman_servers_set);
+  context.add(gman_do);
+  context.add(gman_do_high);
+  context.add(gman_do_low);
+  context.add(gman_do_background);
+  context.add(gman_do_high_background);
+  context.add(gman_do_low_background);
   return 0;
 }
 
@@ -79,7 +60,6 @@
   "Gearman Client UDFs",
   PLUGIN_LICENSE_BSD,
   gearman_udf_plugin_init, /* Plugin Init */
-  gearman_udf_plugin_deinit, /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/heap/ha_heap.cc'
--- plugin/heap/ha_heap.cc	2010-03-19 04:54:45 +0000
+++ plugin/heap/ha_heap.cc	2010-03-24 19:52:38 +0000
@@ -20,6 +20,7 @@
 #include <drizzled/current_session.h>
 #include <drizzled/field/timestamp.h>
 #include <drizzled/field/varstring.h>
+#include "drizzled/plugin/daemon.h"
 
 #include "heap.h"
 #include "ha_heap.h"
@@ -41,16 +42,26 @@
 class HeapEngine : public plugin::StorageEngine
 {
 public:
-  HeapEngine(string name_arg)
-   : plugin::StorageEngine(name_arg,
-                                     HTON_STATS_RECORDS_IS_EXACT |
-                                     HTON_NULL_IN_KEY |
-                                     HTON_FAST_KEY_READ |
-                                     HTON_NO_BLOBS |
-                                     HTON_HAS_RECORDS |
-                                     HTON_SKIP_STORE_LOCK |
-                                     HTON_TEMPORARY_ONLY)
-  { }
+  explicit HeapEngine(string name_arg) :
+    plugin::StorageEngine(name_arg,
+                          HTON_STATS_RECORDS_IS_EXACT |
+                          HTON_NULL_IN_KEY |
+                          HTON_FAST_KEY_READ |
+                          HTON_NO_BLOBS |
+                          HTON_HAS_RECORDS |
+                          HTON_HAS_DATA_DICTIONARY |
+                          HTON_SKIP_STORE_LOCK |
+                          HTON_TEMPORARY_ONLY)
+  {
+    pthread_mutex_init(&THR_LOCK_heap, MY_MUTEX_INIT_FAST);
+  }
+
+  virtual ~HeapEngine()
+  {
+    hp_panic(HA_PANIC_CLOSE);
+
+    pthread_mutex_destroy(&THR_LOCK_heap);
+  }
 
   virtual Cursor *create(TableShare &table,
                           memory::Root *mem_root)
@@ -78,7 +89,7 @@
                         message::Table &create_proto,
                         HP_SHARE **internal_share);
 
-  int doRenameTable(Session*, const char * from, const char * to);
+  int doRenameTable(Session&, TableIdentifier &from, TableIdentifier &to);
 
   int doDropTable(Session&, TableIdentifier &identifier);
 
@@ -103,68 +114,43 @@
             HA_KEY_SCAN_NOT_ROR);
   }
 
+  bool doDoesTableExist(Session& session, TableIdentifier &identifier);
 };
 
-int HeapEngine::doGetTableDefinition(Session&,
+bool HeapEngine::doDoesTableExist(Session& session, TableIdentifier &identifier)
+{
+  return session.doesTableMessageExist(identifier);
+}
+
+int HeapEngine::doGetTableDefinition(Session &session,
                                      TableIdentifier &identifier,
                                      message::Table &table_proto)
 {
-  int error= ENOENT;
-  ProtoCache::iterator iter;
-
-  pthread_mutex_lock(&proto_cache_mutex);
-  iter= proto_cache.find(identifier.getPath());
-
-  if (iter!= proto_cache.end())
-  {
-    table_proto.CopyFrom(((*iter).second));
-    error= EEXIST;
-  }
-  pthread_mutex_unlock(&proto_cache_mutex);
-
-  return error;
+  if (session.getTableMessage(identifier, table_proto))
+    return EEXIST;
+
+  return ENOENT;
 }
 /*
   We have to ignore ENOENT entries as the MEMORY table is created on open and
   not when doing a CREATE on the table.
 */
-int HeapEngine::doDropTable(Session&, TableIdentifier &identifier)
+int HeapEngine::doDropTable(Session &session, TableIdentifier &identifier)
 {
-  ProtoCache::iterator iter;
-
-  pthread_mutex_lock(&proto_cache_mutex);
-  iter= proto_cache.find(identifier.getPath());
-
-  if (iter!= proto_cache.end())
-    proto_cache.erase(iter);
-  pthread_mutex_unlock(&proto_cache_mutex);
+  session.removeTableMessage(identifier);
 
   return heap_delete_table(identifier.getPath().c_str());
 }
 
 static HeapEngine *heap_storage_engine= NULL;
 
-static int heap_init(plugin::Registry &registry)
+static int heap_init(plugin::Context &context)
 {
   heap_storage_engine= new HeapEngine(engine_name);
-  registry.add(heap_storage_engine);
-  pthread_mutex_init(&THR_LOCK_heap, MY_MUTEX_INIT_FAST);
+  context.add(heap_storage_engine);
   return 0;
 }
 
-static int heap_deinit(plugin::Registry &registry)
-{
-  registry.remove(heap_storage_engine);
-  delete heap_storage_engine;
-
-  int ret= hp_panic(HA_PANIC_CLOSE);
-
-  pthread_mutex_destroy(&THR_LOCK_heap);
-
-  return ret;
-}
-
-
 
 /*****************************************************************************
 ** MEMORY tables
@@ -653,10 +639,10 @@
 }
 
 
-int HeapEngine::doRenameTable(Session*,
-                              const char *from, const char *to)
+int HeapEngine::doRenameTable(Session &session, TableIdentifier &from, TableIdentifier &to)
 {
-  return heap_rename(from,to);
+  session.renameTableMessage(from, to);
+  return heap_rename(from.getPath().c_str(), to.getPath().c_str());
 }
 
 
@@ -698,9 +684,7 @@
 
   if (error == 0)
   {
-    pthread_mutex_lock(&proto_cache_mutex);
-    proto_cache.insert(make_pair(table_name, create_proto));
-    pthread_mutex_unlock(&proto_cache_mutex);
+    session->storeTableMessage(identifier, create_proto);
   }
 
   return error;
@@ -931,7 +915,6 @@
   "Hash based, stored in memory, useful for temporary tables",
   PLUGIN_LICENSE_GPL,
   heap_init,
-  heap_deinit,
   NULL,                       /* system variables                */
   NULL                        /* config options                  */
 }

=== modified file 'plugin/hello_world/hello_world.cc'
--- plugin/hello_world/hello_world.cc	2010-02-18 04:43:04 +0000
+++ plugin/hello_world/hello_world.cc	2010-03-06 02:08:13 +0000
@@ -43,22 +43,14 @@
 
 plugin::Create_function<Item_func_hello_world> *hello_world_udf= NULL;
 
-static int hello_world_plugin_init(drizzled::plugin::Registry &registry)
+static int hello_world_plugin_init(drizzled::plugin::Context &context)
 {
   hello_world_udf=
     new plugin::Create_function<Item_func_hello_world>("hello_world");
-  registry.add(hello_world_udf);
-
-  return 0;
-}
-
-static int hello_world_plugin_deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(hello_world_udf);
-  delete hello_world_udf;
-  return 0;
-}
-
+  context.add(hello_world_udf);
+
+  return 0;
+}
 
 DRIZZLE_DECLARE_PLUGIN
 {
@@ -69,7 +61,6 @@
   "Hello, world!",
   PLUGIN_LICENSE_GPL,
   hello_world_plugin_init, /* Plugin Init */
-  hello_world_plugin_deinit, /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/hex_functions/hex_functions.cc'
--- plugin/hex_functions/hex_functions.cc	2010-02-23 21:26:50 +0000
+++ plugin/hex_functions/hex_functions.cc	2010-03-06 02:08:13 +0000
@@ -165,24 +165,15 @@
 plugin::Create_function<HexFunction> *hex_function= NULL;
 plugin::Create_function<UnHexFunction> *unhex_function= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   hex_function= new plugin::Create_function<HexFunction>("hex");
   unhex_function= new plugin::Create_function<UnHexFunction>("unhex");
-  registry.add(hex_function);
-  registry.add(unhex_function);
+  context.add(hex_function);
+  context.add(unhex_function);
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-   registry.remove(hex_function);
-   registry.remove(unhex_function);
-   delete hex_function;
-   delete unhex_function;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -192,7 +183,6 @@
   "Convert a string to HEX() or from UNHEX()",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/information_schema_dictionary/dictionary.cc'
--- plugin/information_schema_dictionary/dictionary.cc	2010-03-17 19:18:40 +0000
+++ plugin/information_schema_dictionary/dictionary.cc	2010-03-20 08:22:31 +0000
@@ -44,7 +44,7 @@
 static ViewTableUsage *view_table_usage;
 static Views *views;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   check_constraints = new(std::nothrow)CheckConstraints;
   column_domain_usage = new(std::nothrow)ColumnDomainUsage;
@@ -67,73 +67,26 @@
   view_table_usage = new(std::nothrow)ViewTableUsage;
   views = new(std::nothrow)Views;
 
-  registry.add(check_constraints);
-  registry.add(column_domain_usage);
-  registry.add(column_privileges);
-  registry.add(columns);
-  registry.add(constraint_column_usage);
-  registry.add(constraint_table_usage);
-  registry.add(domain_constraints);
-  registry.add(domains);
-  registry.add(key_column_usage);
-  registry.add(parameters);
-  registry.add(referential_constraints);
-  registry.add(routines);
-  registry.add(routine_columns);
-  registry.add(schemata);
-  registry.add(table_constraints);
-  registry.add(table_privileges);
-  registry.add(tables);
-  registry.add(view_column_usage);
-  registry.add(view_table_usage);
-  registry.add(views);
-
-  return 0;
-}
-
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(check_constraints);
-  registry.remove(column_domain_usage);
-  registry.remove(column_privileges);
-  registry.remove(columns);
-  registry.remove(constraint_column_usage);
-  registry.remove(constraint_table_usage);
-  registry.remove(domain_constraints);
-  registry.remove(domains);
-  registry.remove(key_column_usage);
-  registry.remove(parameters);
-  registry.remove(referential_constraints);
-  registry.remove(routines);
-  registry.remove(routine_columns);
-  registry.remove(schemata);
-  registry.remove(table_constraints);
-  registry.remove(table_privileges);
-  registry.remove(tables);
-  registry.remove(view_column_usage);
-  registry.remove(view_table_usage);
-  registry.remove(views);
-
-  delete check_constraints;
-  delete column_domain_usage;
-  delete column_privileges;
-  delete columns;
-  delete constraint_column_usage;
-  delete constraint_table_usage;
-  delete domain_constraints;
-  delete domains;
-  delete key_column_usage;
-  delete parameters;
-  delete referential_constraints;
-  delete routines;
-  delete routine_columns;
-  delete schemata;
-  delete table_constraints;
-  delete table_privileges;
-  delete tables;
-  delete view_column_usage;
-  delete view_table_usage;
-  delete views;
+  context.add(check_constraints);
+  context.add(column_domain_usage);
+  context.add(column_privileges);
+  context.add(columns);
+  context.add(constraint_column_usage);
+  context.add(constraint_table_usage);
+  context.add(domain_constraints);
+  context.add(domains);
+  context.add(key_column_usage);
+  context.add(parameters);
+  context.add(referential_constraints);
+  context.add(routines);
+  context.add(routine_columns);
+  context.add(schemata);
+  context.add(table_constraints);
+  context.add(table_privileges);
+  context.add(tables);
+  context.add(view_column_usage);
+  context.add(view_table_usage);
+  context.add(views);
 
   return 0;
 }
@@ -147,7 +100,6 @@
   "Data Dictionary for ANSI information schema, etc",
   PLUGIN_LICENSE_GPL,
   init,
-  finalize,
   NULL,
   NULL
 }

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2010-03-19 04:54:45 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2010-03-25 00:11:02 +0000
@@ -80,6 +80,7 @@
 #include "drizzled/field/varstring.h"
 #include "drizzled/field/timestamp.h"
 #include "drizzled/plugin/xa_storage_engine.h"
+#include "drizzled/plugin/daemon.h"
 #include "drizzled/memory/multi_malloc.h"
 #include "drizzled/pthread_globals.h"
 #include "drizzled/named_savepoint.h"
@@ -260,19 +261,44 @@
 class InnobaseEngine : public plugin::XaStorageEngine
 {
 public:
-  InnobaseEngine(string name_arg) :
+  explicit InnobaseEngine(string name_arg) :
     plugin::XaStorageEngine(name_arg,
-                          HTON_NULL_IN_KEY |
-                          HTON_CAN_INDEX_BLOBS |
-                          HTON_PRIMARY_KEY_REQUIRED_FOR_POSITION |
-                          HTON_PRIMARY_KEY_IN_READ_INDEX |
-                          HTON_PARTIAL_COLUMN_READ |
-                          HTON_TABLE_SCAN_ON_INDEX |
-                          HTON_HAS_DOES_TRANSACTIONS)
+                            HTON_NULL_IN_KEY |
+                            HTON_CAN_INDEX_BLOBS |
+                            HTON_PRIMARY_KEY_REQUIRED_FOR_POSITION |
+                            HTON_PRIMARY_KEY_IN_READ_INDEX |
+                            HTON_PARTIAL_COLUMN_READ |
+                            HTON_TABLE_SCAN_ON_INDEX |
+                            HTON_HAS_FOREIGN_KEYS |
+                            HTON_HAS_DOES_TRANSACTIONS)
   {
     table_definition_ext= plugin::DEFAULT_DEFINITION_FILE_EXT;
     addAlias("INNOBASE");
   }
+
+  virtual ~InnobaseEngine()
+  {
+    int	err= 0;
+    if (innodb_inited) {
+
+      srv_fast_shutdown = (ulint) innobase_fast_shutdown;
+      innodb_inited = 0;
+      hash_table_free(innobase_open_tables);
+      innobase_open_tables = NULL;
+      if (innobase_shutdown_for_mysql() != DB_SUCCESS) {
+        err = 1;
+      }
+      srv_free_paths_and_sizes();
+      if (internal_innobase_data_file_path)
+        free(internal_innobase_data_file_path);
+      pthread_mutex_destroy(&innobase_share_mutex);
+      pthread_mutex_destroy(&prepare_commit_mutex);
+      pthread_mutex_destroy(&commit_threads_m);
+      pthread_mutex_destroy(&commit_cond_m);
+      pthread_cond_destroy(&commit_cond);
+    }
+  }
+
 private:
   virtual int doStartTransaction(Session *session, start_transaction_option_t options);
   virtual void doStartStatement(Session *session);
@@ -396,9 +422,7 @@
                                 Table& form,
                                 drizzled::TableIdentifier &identifier,
                                 message::Table&);
-  UNIV_INTERN int doRenameTable(Session* session,
-                                const char* from,
-                                const char* to);
+  UNIV_INTERN int doRenameTable(Session&, TableIdentifier &from, TableIdentifier &to);
   UNIV_INTERN int doDropTable(Session& session, TableIdentifier &identifier);
 
   UNIV_INTERN virtual bool get_error_message(int error, String *buf);
@@ -511,12 +535,6 @@
   NULL, NULL, 50, 1, 1024 * 1024 * 1024, 0);
 
 
-/***********************************************************************
-Closes an InnoDB database. */
-static
-int
-innobase_deinit(plugin::Registry &registry);
-
 /*****************************************************************//**
 Commits a transaction in an InnoDB database. */
 static
@@ -1680,7 +1698,7 @@
 int
 innobase_init(
 /*==========*/
-	plugin::Registry	&registry)	/*!< in: Drizzle Plugin Registry */
+	plugin::Context	&context)	/*!< in: Drizzle Plugin Context */
 {
 	static char	current_dir[3];		/*!< Set if using current lib */
 	int		err;
@@ -1690,7 +1708,6 @@
 
 	innodb_engine_ptr= new InnobaseEngine(innobase_engine_name);
 
-
 	ut_a(DATA_MYSQL_TRUE_VARCHAR == (ulint)DRIZZLE_TYPE_VARCHAR);
 
 #ifdef UNIV_DEBUG
@@ -1961,30 +1978,30 @@
 
         status_table_function_ptr= new InnodbStatusTool;
 
-	registry.add(innodb_engine_ptr);
+	context.add(innodb_engine_ptr);
 
-	registry.add(status_table_function_ptr);
+	context.add(status_table_function_ptr);
 
 	cmp_tool= new(std::nothrow)CmpTool(false);
-	registry.add(cmp_tool);
+	context.add(cmp_tool);
 
 	cmp_reset_tool= new(std::nothrow)CmpTool(true);
-	registry.add(cmp_reset_tool);
+	context.add(cmp_reset_tool);
 
 	cmp_mem_tool= new(std::nothrow)CmpmemTool(false);
-	registry.add(cmp_mem_tool);
+	context.add(cmp_mem_tool);
 
 	cmp_mem_reset_tool= new(std::nothrow)CmpmemTool(true);
-	registry.add(cmp_mem_reset_tool);
+	context.add(cmp_mem_reset_tool);
 
 	innodb_trx_tool= new(std::nothrow)InnodbTrxTool("INNODB_TRX");
-	registry.add(innodb_trx_tool);
+	context.add(innodb_trx_tool);
 
 	innodb_locks_tool= new(std::nothrow)InnodbTrxTool("INNODB_LOCKS");
-	registry.add(innodb_locks_tool);
+	context.add(innodb_locks_tool);
 
 	innodb_lock_waits_tool= new(std::nothrow)InnodbTrxTool("INNODB_LOCK_WAITS");
-	registry.add(innodb_lock_waits_tool);
+	context.add(innodb_lock_waits_tool);
 
 	/* Get the current high water mark format. */
 	innobase_file_format_check = (char*) trx_sys_file_format_max_get();
@@ -1994,63 +2011,6 @@
 	return(TRUE);
 }
 
-/*******************************************************************//**
-Closes an InnoDB database.
-@return	TRUE if error */
-static
-int
-innobase_deinit(plugin::Registry &registry)
-{
-	int	err= 0;
-
-	registry.remove(status_table_function_ptr);
- 	delete status_table_function_ptr;
-
-	registry.remove(cmp_tool);
-	delete cmp_tool;
-
-	registry.remove(cmp_reset_tool);
-	delete cmp_reset_tool;
-
- 	registry.remove(cmp_mem_tool);
-	delete cmp_mem_tool;
-
-	registry.remove(cmp_mem_reset_tool);
-	delete cmp_mem_reset_tool;
-
-	registry.remove(innodb_trx_tool);
-	delete innodb_trx_tool;
-
- 	registry.remove(innodb_locks_tool);
-	delete innodb_locks_tool;
-
-	registry.remove(innodb_lock_waits_tool);
-	delete innodb_lock_waits_tool;
-
-	registry.remove(innodb_engine_ptr);
- 	delete innodb_engine_ptr;
-
-	if (innodb_inited) {
-
-		srv_fast_shutdown = (ulint) innobase_fast_shutdown;
-		innodb_inited = 0;
-		hash_table_free(innobase_open_tables);
-		innobase_open_tables = NULL;
-		if (innobase_shutdown_for_mysql() != DB_SUCCESS) {
-			err = 1;
-		}
-		srv_free_paths_and_sizes();
-		if (internal_innobase_data_file_path)
-		  free(internal_innobase_data_file_path);
-		pthread_mutex_destroy(&innobase_share_mutex);
-		pthread_mutex_destroy(&prepare_commit_mutex);
-		pthread_mutex_destroy(&commit_threads_m);
-		pthread_mutex_destroy(&commit_cond_m);
-		pthread_cond_destroy(&commit_cond);
-	}
-
-	return(err);
-}
 
 /****************************************************************//**
 Flushes InnoDB logs to disk and makes a checkpoint. Really, a commit flushes
@@ -6081,13 +6041,7 @@
 /*********************************************************************//**
 Renames an InnoDB table.
 @return	0 or error code */
-UNIV_INTERN
-int
-InnobaseEngine::doRenameTable(
-/*======================*/
-	Session*	session,
-	const char*	from,	/*!< in: old name of the table */
-	const char*	to)	/*!< in: new name of the table */
+UNIV_INTERN int InnobaseEngine::doRenameTable(Session &session, TableIdentifier &from, TableIdentifier &to)
 {
 	trx_t*	trx;
 	int	error;
@@ -6096,16 +6050,16 @@
 	/* Get the transaction associated with the current session, or create one
 	if not yet created */
 
-	parent_trx = check_trx_exists(session);
+	parent_trx = check_trx_exists(&session);
 
 	/* In case MySQL calls this in the middle of a SELECT query, release
 	possible adaptive hash latch to avoid deadlocks of threads */
 
 	trx_search_latch_release_if_reserved(parent_trx);
 
-	trx = innobase_trx_allocate(session);
+	trx = innobase_trx_allocate(&session);
 
-	error = innobase_rename_table(trx, from, to, TRUE);
+	error = innobase_rename_table(trx, from.getPath().c_str(), to.getPath().c_str(), TRUE);
 
 	/* Tell the InnoDB server that there might be work for
 	utility threads: */
@@ -8839,7 +8793,6 @@
   "Supports transactions, row-level locking, and foreign keys",
   PLUGIN_LICENSE_GPL,
   innobase_init, /* Plugin Init */
-  innobase_deinit, /* Plugin Deinit */
   innobase_system_variables, /* system variables */
   NULL /* reserved */
 }

=== modified file 'plugin/innobase/tests/r/innodb_cmpmem.result'
--- plugin/innobase/tests/r/innodb_cmpmem.result	2010-03-01 02:11:17 +0000
+++ plugin/innobase/tests/r/innodb_cmpmem.result	2010-03-23 23:47:56 +0000
@@ -1,5 +1,5 @@
 use data_dictionary;
-select * from INNODB_CMPMEM;
+select * from INNODB_CMPMEM where PAGE_SIZE > 64;
 PAGE_SIZE	PAGES_USED	PAGES_FREE	RELOCATION_OPS	RELOCATION_TIME
 128	0	0	0	0
 256	0	0	0	0

=== modified file 'plugin/innobase/tests/r/innodb_cmpmem_reset.result'
--- plugin/innobase/tests/r/innodb_cmpmem_reset.result	2010-03-01 02:11:17 +0000
+++ plugin/innobase/tests/r/innodb_cmpmem_reset.result	2010-03-23 23:47:56 +0000
@@ -1,5 +1,5 @@
 use data_dictionary;
-select * from INNODB_CMPMEM_RESET;
+select * from INNODB_CMPMEM_RESET where PAGE_SIZE > 64;
 PAGE_SIZE	PAGES_USED	PAGES_FREE	RELOCATION_OPS	RELOCATION_TIME
 128	0	0	0	0
 256	0	0	0	0

=== modified file 'plugin/innobase/tests/t/innodb_cmpmem.test'
--- plugin/innobase/tests/t/innodb_cmpmem.test	2010-03-01 02:11:17 +0000
+++ plugin/innobase/tests/t/innodb_cmpmem.test	2010-03-23 23:47:56 +0000
@@ -1,5 +1,7 @@
 use data_dictionary;
 
-select * from INNODB_CMPMEM;
+# Add in the qualification because there is an extra row on 32-bit for
+#  PAGE_SIZE==64. But we don't care about that.
+select * from INNODB_CMPMEM where PAGE_SIZE > 64;
 
 show create table INNODB_CMPMEM;

=== modified file 'plugin/innobase/tests/t/innodb_cmpmem_reset.test'
--- plugin/innobase/tests/t/innodb_cmpmem_reset.test	2010-03-01 02:11:17 +0000
+++ plugin/innobase/tests/t/innodb_cmpmem_reset.test	2010-03-23 23:47:56 +0000
@@ -1,5 +1,7 @@
 use data_dictionary;
 
-select * from INNODB_CMPMEM_RESET;
+# Add in the qualification because there is an extra row on 32-bit for
+#  PAGE_SIZE==64. But we don't care about that.
+select * from INNODB_CMPMEM_RESET where PAGE_SIZE > 64;
 
 show create table INNODB_CMPMEM_RESET;

=== modified file 'plugin/length/length.cc'
--- plugin/length/length.cc	2010-02-18 04:43:04 +0000
+++ plugin/length/length.cc	2010-03-06 02:08:13 +0000
@@ -65,24 +65,15 @@
 plugin::Create_function<LengthFunction> *lengthudf= NULL;
 plugin::Create_function<LengthFunction> *octet_lengthudf= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   lengthudf= new plugin::Create_function<LengthFunction>("length");
   octet_lengthudf= new plugin::Create_function<LengthFunction>("octet_length");
-  registry.add(lengthudf);
-  registry.add(octet_lengthudf);
+  context.add(lengthudf);
+  context.add(octet_lengthudf);
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-   registry.remove(lengthudf);
-   registry.remove(octet_lengthudf);
-   delete lengthudf;
-   delete octet_lengthudf;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -92,7 +83,6 @@
   "Return the byte length of a string",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/logging_gearman/logging_gearman.cc'
--- plugin/logging_gearman/logging_gearman.cc	2010-03-02 19:11:45 +0000
+++ plugin/logging_gearman/logging_gearman.cc	2010-03-06 02:08:13 +0000
@@ -290,18 +290,10 @@
 
 static LoggingGearman *handler= NULL;
 
-static int logging_gearman_plugin_init(plugin::Registry &registry)
+static int logging_gearman_plugin_init(plugin::Context &context)
 {
   handler= new LoggingGearman();
-  registry.add(handler);
-
-  return 0;
-}
-
-static int logging_gearman_plugin_deinit(plugin::Registry &registry)
-{
-  registry.remove(handler);
-  delete handler;
+  context.add(handler);
 
   return 0;
 }
@@ -349,7 +341,6 @@
     N_("Log queries to a Gearman server"),
     PLUGIN_LICENSE_GPL,
     logging_gearman_plugin_init,
-    logging_gearman_plugin_deinit,
     logging_gearman_system_variables,
     NULL
 }

=== modified file 'plugin/logging_query/logging_query.cc'
--- plugin/logging_query/logging_query.cc	2010-02-22 16:14:47 +0000
+++ plugin/logging_query/logging_query.cc	2010-03-06 02:08:13 +0000
@@ -326,18 +326,10 @@
 
 static Logging_query *handler= NULL;
 
-static int logging_query_plugin_init(drizzled::plugin::Registry &registry)
+static int logging_query_plugin_init(drizzled::plugin::Context &context)
 {
   handler= new Logging_query();
-  registry.add(handler);
-
-  return 0;
-}
-
-static int logging_query_plugin_deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(handler);
-  delete handler;
+  context.add(handler);
 
   return 0;
 }
@@ -424,7 +416,6 @@
   N_("Log queries to a CSV file"),
   PLUGIN_LICENSE_GPL,
   logging_query_plugin_init,
-  logging_query_plugin_deinit,
   logging_query_system_variables,
   NULL
 }

=== added directory 'plugin/logging_stats'
=== added file 'plugin/logging_stats/logging_stats.cc'
--- plugin/logging_stats/logging_stats.cc	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/logging_stats.cc	2010-03-25 02:26:39 +0000
@@ -0,0 +1,348 @@
+/*
+ * Copyright (c) 2010, Joseph Daly <skinny.moey@gmail.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *   * Redistributions of source code must retain the above copyright notice,
+ *     this list of conditions and the following disclaimer.
+ *   * Redistributions in binary form must reproduce the above copyright notice,
+ *     this list of conditions and the following disclaimer in the documentation
+ *     and/or other materials provided with the distribution.
+ *   * Neither the name of Joseph Daly nor the names of its contributors
+ *     may be used to endorse or promote products derived from this software
+ *     without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/**
+ * @details
+ *
+ * This tracks current user commands. The commands are logged using
+ * the post() and postEnd() logging APIs. It uses a scoreboard
+ * approach that initializes the scoreboard size to the value set
+ * by logging_stats_scoreboard_size. Each ScoreBoardSlot wraps 
+ * a UserCommand object containing the statistics for a particular
+ * session. As other statistics are added they can then be added
+ * to the ScoreBoardSlot object. 
+ *
+ * Locking  
+ *
+ * A RW lock is taken to locate a open slot for a session or to locate the
+ * slot that the current session has claimed. 
+ * 
+ * A read lock is taken when the table is queried in the data_dictionary.
+ * 
+ * TODO 
+ *
+ * To improve as more statistics are added, a pointer to the scoreboard
+ * slot should be added to the Session object. This will avoid the session
+ * having to do multiple lookups in the scoreboard.  
+ *  
+ * Save the statistics off into a vector so you can query by user/ip and get
+ * commands run based on those keys over time. 
+ * 
+ */
+
+#include "config.h"
+#include "logging_stats.h"
+#include "stats_schema.h"
+#include <drizzled/session.h>
+
+using namespace drizzled;
+using namespace plugin;
+using namespace std;
+
+static bool sysvar_logging_stats_enabled= false;
+
+static uint32_t sysvar_logging_stats_scoreboard_size= 2000;
+
+pthread_rwlock_t LOCK_scoreboard;
+
+LoggingStats::LoggingStats(string name_arg) : Logging(name_arg)
+{
+  scoreboard_size= sysvar_logging_stats_scoreboard_size;
+  score_board_slots= new ScoreBoardSlot[scoreboard_size];
+  for (uint32_t j=0; j < scoreboard_size; j++)
+  { 
+    UserCommands *user_commands= new UserCommands();
+    ScoreBoardSlot *score_board_slot= &score_board_slots[j];
+    score_board_slot->setUserCommands(user_commands); 
+  } 
+}
+
+LoggingStats::~LoggingStats()
+{
+  delete[] score_board_slots;
+}
+
+bool LoggingStats::isBeingLogged(Session *session)
+{
+  enum_sql_command sql_command= session->lex->sql_command;
+
+  switch(sql_command)
+  {
+    case SQLCOM_UPDATE:
+    case SQLCOM_DELETE:
+    case SQLCOM_INSERT:
+    case SQLCOM_ROLLBACK:
+    case SQLCOM_COMMIT:
+    case SQLCOM_CREATE_TABLE:
+    case SQLCOM_ALTER_TABLE:
+    case SQLCOM_DROP_TABLE:
+    case SQLCOM_SELECT:
+      return true;
+    default:
+      return false;
+  }
+} 
+
+void LoggingStats::updateScoreBoard(ScoreBoardSlot *score_board_slot,
+                                    Session *session)
+{
+  enum_sql_command sql_command= session->lex->sql_command;
+
+  UserCommands *user_commands= score_board_slot->getUserCommands();
+
+  switch(sql_command)
+  {
+    case SQLCOM_UPDATE:
+      user_commands->incrementUpdateCount();
+      break;
+    case SQLCOM_DELETE:
+      user_commands->incrementDeleteCount();
+      break;
+    case SQLCOM_INSERT:
+      user_commands->incrementInsertCount();
+      break;
+    case SQLCOM_ROLLBACK:
+      user_commands->incrementRollbackCount();
+      break;
+    case SQLCOM_COMMIT:
+      user_commands->incrementCommitCount();
+      break;
+    case SQLCOM_CREATE_TABLE:
+      user_commands->incrementCreateCount();
+      break;
+    case SQLCOM_ALTER_TABLE:
+      user_commands->incrementAlterCount();
+      break;
+    case SQLCOM_DROP_TABLE:
+      user_commands->incrementDropCount();
+      break;
+    case SQLCOM_SELECT:
+      user_commands->incrementSelectCount();
+      break;
+    default:
+      return;
+  }
+}
+
+bool LoggingStats::post(Session *session)
+{
+  if (! isEnabled())
+  {
+    return false;
+  }
+
+  /* exit early if we are not logging this type of command */
+  if (isBeingLogged(session) == false)
+  {
+    return false;
+  }
+
+  /* Find a slot that is unused */
+
+  pthread_rwlock_wrlock(&LOCK_scoreboard);
+  ScoreBoardSlot *score_board_slot;
+  int our_slot= UNINITIALIZED; 
+  int open_slot= UNINITIALIZED;
+
+  for (uint32_t j=0; j < scoreboard_size; j++)
+  {
+    score_board_slot= &score_board_slots[j];
+
+    if (score_board_slot->isInUse() == true)
+    {
+      /* Check if this session is the one using this slot */
+      if (score_board_slot->getSessionId() == session->getSessionId())
+      {
+        our_slot= j;
+        break; 
+      } 
+      else 
+      {
+        continue; 
+      }
+    }
+    else 
+    {
+      /* save off the open slot */ 
+      if (open_slot == -1)
+      {
+        open_slot= j;
+      } 
+      continue;
+    }
+  }
+
+  if (our_slot != UNINITIALIZED)
+  {
+    pthread_rwlock_unlock(&LOCK_scoreboard); 
+  }
+  else if (open_slot != UNINITIALIZED)
+  {
+    score_board_slot= &score_board_slots[open_slot];
+    score_board_slot->setInUse(true);
+    score_board_slot->setSessionId(session->getSessionId());
+    score_board_slot->setUser(session->getSecurityContext().getUser());
+    score_board_slot->setIp(session->getSecurityContext().getIp());
+    pthread_rwlock_unlock(&LOCK_scoreboard);
+  }
+  else 
+  {
+    pthread_rwlock_unlock(&LOCK_scoreboard);
+    /* there was no available slot for this session */
+    return false;
+  }
+
+  updateScoreBoard(score_board_slot, session);
+
+  return false;
+}
+
+bool LoggingStats::postEnd(Session *session)
+{
+  if (! isEnabled())
+  {
+    return false;
+  }
+
+  ScoreBoardSlot *score_board_slot;
+
+  pthread_rwlock_wrlock(&LOCK_scoreboard);
+
+  for (uint32_t j=0; j < scoreboard_size; j++)
+  {
+    score_board_slot= &score_board_slots[j];
+
+    if (score_board_slot->getSessionId() == session->getSessionId())
+    {
+      score_board_slot->reset();
+      break;
+    }
+  }
+
+  pthread_rwlock_unlock(&LOCK_scoreboard);
+
+  return false;
+}
+
+/* Plugin initialization and system variables */
+
+static LoggingStats *logging_stats= NULL;
+
+static CommandsTool *commands_tool= NULL;
+
+static void enable(Session *,
+                   drizzle_sys_var *,
+                   void *var_ptr,
+                   const void *save)
+{
+  if (logging_stats)
+  {
+    if (*(bool *)save != false)
+    {
+      logging_stats->enable();
+      *(bool *) var_ptr= (bool) true;
+    }
+    else
+    {
+      logging_stats->disable();
+      *(bool *) var_ptr= (bool) false;
+    }
+  }
+}
+
+static bool initTable()
+{
+  commands_tool= new(nothrow)CommandsTool(logging_stats);
+
+  if (! commands_tool)
+  {
+    return true;
+  }
+
+  return false;
+}
+
+static int init(drizzled::plugin::Context &context)
+{
+  logging_stats= new LoggingStats("logging_stats");
+
+  if (initTable())
+  {
+    return 1;
+  }
+
+  context.add(logging_stats);
+  context.add(commands_tool);
+
+  if (sysvar_logging_stats_enabled)
+  {
+    logging_stats->enable();
+  }
+
+  return 0;
+}
+
+static DRIZZLE_SYSVAR_UINT(scoreboard_size,
+                           sysvar_logging_stats_scoreboard_size,
+                           PLUGIN_VAR_RQCMDARG,
+                           N_("Max number of concurrent sessions that will be logged"),
+                           NULL, /* check func */
+                           NULL, /* update func */
+                           2000, /* default */
+                           1000, /* minimum */
+                           50000, 
+                           0);
+
+static DRIZZLE_SYSVAR_BOOL(enable,
+                           sysvar_logging_stats_enabled,
+                           PLUGIN_VAR_NOCMDARG,
+                           N_("Enable Logging Statistics Collection"),
+                           NULL, /* check func */
+                           enable, /* update func */
+                           false /* default */);
+
+static drizzle_sys_var* system_var[]= {
+  DRIZZLE_SYSVAR(scoreboard_size),
+  DRIZZLE_SYSVAR(enable),
+  NULL
+};
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "logging_stats",
+  "0.1",
+  "Joseph Daly",
+  N_("User Statistics as DATA_DICTIONARY tables"),
+  PLUGIN_LICENSE_BSD,
+  init,   /* Plugin Init      */
+  system_var, /* system variables */
+  NULL    /* config options   */
+}
+DRIZZLE_DECLARE_PLUGIN_END;

=== added file 'plugin/logging_stats/logging_stats.h'
--- plugin/logging_stats/logging_stats.h	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/logging_stats.h	2010-03-15 01:39:08 +0000
@@ -0,0 +1,94 @@
+/*
+ * Copyright (c) 2010, Joseph Daly <skinny.moey@gmail.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *   * Redistributions of source code must retain the above copyright notice,
+ *     this list of conditions and the following disclaimer.
+ *   * Redistributions in binary form must reproduce the above copyright notice,
+ *     this list of conditions and the following disclaimer in the documentation
+ *     and/or other materials provided with the distribution.
+ *   * Neither the name of Joseph Daly nor the names of its contributors
+ *     may be used to endorse or promote products derived from this software
+ *     without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef PLUGIN_LOGGING_STATS_LOGGING_STATS_H
+#define PLUGIN_LOGGING_STATS_LOGGING_STATS_H
+
+#include "score_board_slot.h"
+
+#include <drizzled/atomics.h>
+#include <drizzled/enum.h>
+#include <drizzled/session.h>
+#include <drizzled/plugin/logging.h>
+
+#include <string>
+
+extern pthread_rwlock_t LOCK_scoreboard;
+
+class LoggingStats: public drizzled::plugin::Logging
+{
+public:
+
+  LoggingStats(std::string name_arg);
+
+  ~LoggingStats();
+
+  virtual bool post(drizzled::Session *session);
+
+  virtual bool postEnd(drizzled::Session *session);
+
+  bool isEnabled() const
+  {
+    return is_enabled;
+  }
+
+  void enable()
+  {
+    is_enabled= true;
+  }
+
+  void disable()
+  {
+    is_enabled= false;
+  }
+
+  uint32_t getScoreBoardSize()
+  {
+    return scoreboard_size;
+  }
+
+  ScoreBoardSlot *getScoreBoardSlots()
+  {
+    return score_board_slots;
+  }
+
+private:
+  static const int32_t UNINITIALIZED= -1;
+
+  bool isBeingLogged(drizzled::Session *session);
+
+  void updateScoreBoard(ScoreBoardSlot *score_board_slot, drizzled::Session *session);
+
+  drizzled::atomic<bool> is_enabled;
+
+  ScoreBoardSlot *score_board_slots;
+
+  uint32_t scoreboard_size;
+};
+#endif /* PLUGIN_LOGGING_STATS_LOGGING_STATS_H */

=== added file 'plugin/logging_stats/plugin.ini'
--- plugin/logging_stats/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/plugin.ini	2010-03-20 20:33:18 +0000
@@ -0,0 +1,7 @@
+[plugin]
+name=logging_stats
+title=Statistics Plugin for Drizzle
+description=Statistics Plugin for Drizzle
+load_by_default=no
+sources=logging_stats.cc user_commands.cc stats_schema.cc
+headers=logging_stats.h user_commands.h score_board_slot.h stats_schema.h

=== added file 'plugin/logging_stats/score_board_slot.h'
--- plugin/logging_stats/score_board_slot.h	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/score_board_slot.h	2010-03-25 02:26:39 +0000
@@ -0,0 +1,120 @@
+/*
+ * Copyright (c) 2010, Joseph Daly <skinny.moey@gmail.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *   * Redistributions of source code must retain the above copyright notice,
+ *     this list of conditions and the following disclaimer.
+ *   * Redistributions in binary form must reproduce the above copyright notice,
+ *     this list of conditions and the following disclaimer in the documentation
+ *     and/or other materials provided with the distribution.
+ *   * Neither the name of Joseph Daly nor the names of its contributors
+ *     may be used to endorse or promote products derived from this software
+ *     without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ */
+
+#ifndef PLUGIN_LOGGING_STATS_SCORE_BOARD_SLOT_H
+#define PLUGIN_LOGGING_STATS_SCORE_BOARD_SLOT_H
+
+#include "user_commands.h"
+
+#include <string>
+
+class ScoreBoardSlot
+{
+public:
+  ScoreBoardSlot() 
+    :
+      in_use(false),
+      session_id(0)
+  {}
+
+  ~ScoreBoardSlot() 
+  {
+    delete user_commands;
+  }
+
+  void setUserCommands(UserCommands *in_user_commands)
+  {
+    user_commands= in_user_commands;
+  }
+
+  UserCommands* getUserCommands()
+  {
+    return user_commands;
+  }
+
+  void setSessionId(uint64_t in_session_id)
+  {
+    session_id= in_session_id;
+  }
+
+  uint64_t getSessionId()
+  {
+    return session_id;
+  }
+
+  void setInUse(bool in_in_use)
+  {
+    in_use= in_in_use;
+  }
+
+  bool isInUse()
+  {
+    return in_use;
+  }
+
+  void setUser(std::string in_user)
+  {
+    user= in_user;
+  }
+
+  const std::string& getUser()
+  {
+    return user; 
+  }
+
+  void setIp(std::string in_ip)
+  {
+    ip= in_ip;
+  }
+
+  const std::string& getIp()
+  {
+    return ip;
+  }
+
+  void reset()
+  {
+    in_use= false;
+    session_id= 0;
+    if (user_commands)
+    {
+      user_commands->reset();
+    }
+  }
+
+private:
+  UserCommands *user_commands;
+  std::string user;
+  std::string ip;
+  bool in_use;
+  uint64_t session_id;
+};
+ 
+#endif /* PLUGIN_LOGGING_STATS_SCORE_BOARD_SLOT_H */

=== added file 'plugin/logging_stats/stats_schema.cc'
--- plugin/logging_stats/stats_schema.cc	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/stats_schema.cc	2010-03-15 01:39:08 +0000
@@ -0,0 +1,114 @@
+/*
+ * Copyright (c) 2010, Joseph Daly <skinny.moey@gmail.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *   * Redistributions of source code must retain the above copyright notice,
+ *     this list of conditions and the following disclaimer.
+ *   * Redistributions in binary form must reproduce the above copyright notice,
+ *     this list of conditions and the following disclaimer in the documentation
+ *     and/or other materials provided with the distribution.
+ *   * Neither the name of Joseph Daly nor the names of its contributors
+ *     may be used to endorse or promote products derived from this software
+ *     without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <config.h>          
+#include "stats_schema.h"
+
+using namespace drizzled;
+using namespace plugin;
+using namespace std;
+
+CommandsTool::CommandsTool(LoggingStats *logging_stats) :
+  plugin::TableFunction("DATA_DICTIONARY", "SQL_COMMANDS_BY_USER")
+{
+  outer_logging_stats= logging_stats;  
+
+  add_field("USER");
+  add_field("IP");
+  add_field("COUNT_SELECT", TableFunction::NUMBER);
+  add_field("COUNT_DELETE", TableFunction::NUMBER);
+  add_field("COUNT_UPDATE", TableFunction::NUMBER);
+  add_field("COUNT_INSERT", TableFunction::NUMBER);
+  add_field("COUNT_ROLLBACK", TableFunction::NUMBER);
+  add_field("COUNT_COMMIT", TableFunction::NUMBER);
+  add_field("COUNT_CREATE", TableFunction::NUMBER);
+  add_field("COUNT_ALTER", TableFunction::NUMBER);
+  add_field("COUNT_DROP", TableFunction::NUMBER);
+  add_field("COUNT_ADMIN", TableFunction::NUMBER);
+}
+
+CommandsTool::Generator::Generator(Field **arg, LoggingStats *in_logging_stats) :
+  plugin::TableFunction::Generator(arg)
+{
+  pthread_rwlock_rdlock(&LOCK_scoreboard);
+  logging_stats= in_logging_stats;
+
+  if (logging_stats->isEnabled())
+  {
+    record_number= 0;
+  } 
+  else 
+  {
+    record_number= logging_stats->getScoreBoardSize(); 
+  }
+}
+
+CommandsTool::Generator::~Generator()
+{
+  pthread_rwlock_unlock(&LOCK_scoreboard);
+}
+
+bool CommandsTool::Generator::populate()
+{
+  if (record_number == logging_stats->getScoreBoardSize())
+  {
+    return false;
+  }
+  
+  ScoreBoardSlot *score_board_slots= logging_stats->getScoreBoardSlots();
+
+  while (record_number < logging_stats->getScoreBoardSize())
+  {
+    ScoreBoardSlot *score_board_slot= &score_board_slots[record_number];
+    if (score_board_slot->isInUse())
+    {
+      UserCommands *user_commands= score_board_slot->getUserCommands();
+      push(score_board_slot->getUser());
+      push(score_board_slot->getIp());
+      push(user_commands->getSelectCount());
+      push(user_commands->getDeleteCount());
+      push(user_commands->getUpdateCount());
+      push(user_commands->getInsertCount());
+      push(user_commands->getRollbackCount());
+      push(user_commands->getCommitCount());
+      push(user_commands->getCreateCount());
+      push(user_commands->getAlterCount());
+      push(user_commands->getDropCount());
+      push(user_commands->getAdminCount());
+      record_number++;
+      return true;
+    }
+    else 
+    {
+      record_number++;
+    }
+  }
+
+  return false;
+}

=== added file 'plugin/logging_stats/stats_schema.h'
--- plugin/logging_stats/stats_schema.h	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/stats_schema.h	2010-03-08 04:23:54 +0000
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2010, Joseph Daly <skinny.moey@gmail.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *   * Redistributions of source code must retain the above copyright notice,
+ *     this list of conditions and the following disclaimer.
+ *   * Redistributions in binary form must reproduce the above copyright notice,
+ *     this list of conditions and the following disclaimer in the documentation
+ *     and/or other materials provided with the distribution.
+ *   * Neither the name of Joseph Daly nor the names of its contributors
+ *     may be used to endorse or promote products derived from this software
+ *     without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef PLUGIN_LOGGING_STATS_STATS_SCHEMA_H
+#define PLUGIN_LOGGING_STATS_STATS_SCHEMA_H
+
+#include <drizzled/plugin/table_function.h>
+#include <drizzled/field.h>
+
+#include "logging_stats.h"
+
+class CommandsTool : public drizzled::plugin::TableFunction
+{
+private:
+  LoggingStats *outer_logging_stats;
+
+public:
+
+  CommandsTool(LoggingStats *logging_stats);
+
+  class Generator : public drizzled::plugin::TableFunction::Generator
+  {
+  public:
+    Generator(drizzled::Field **arg, LoggingStats *logging_stats);
+
+    ~Generator();
+
+    bool populate();
+  private:
+    LoggingStats *logging_stats;
+    uint32_t record_number;
+  };
+
+  Generator *generator(drizzled::Field **arg)
+  {
+    return new Generator(arg, outer_logging_stats);
+  }
+};
+
+#endif /* PLUGIN_LOGGING_STATS_STATS_SCHEMA_H */

=== added directory 'plugin/logging_stats/tests'
=== added directory 'plugin/logging_stats/tests/r'
=== added file 'plugin/logging_stats/tests/r/command.result'
--- plugin/logging_stats/tests/r/command.result	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/tests/r/command.result	2010-03-13 01:43:03 +0000
@@ -0,0 +1,28 @@
+DROP TABLE IF EXISTS a;
+CREATE TABLE a (i int,  PRIMARY KEY (i));
+ALTER TABLE a ADD COLUMN j int;
+DROP TABLE A;
+CREATE TABLE a (i int,  PRIMARY KEY (i));
+INSERT INTO a VALUES (1);
+DELETE FROM a WHERE i=1;
+START TRANSACTION;
+INSERT INTO a VALUES (1);
+ROLLBACK;
+START TRANSACTION;
+INSERT INTO a VALUES (1);
+COMMIT;
+SELECT USER, COUNT_SELECT, COUNT_DELETE, COUNT_UPDATE, COUNT_INSERT, COUNT_ROLLBACK, COUNT_COMMIT, COUNT_CREATE, COUNT_ALTER, COUNT_DROP, COUNT_ADMIN  FROM DATA_DICTIONARY.SQL_COMMANDS_BY_USER;
+USER	COUNT_SELECT	COUNT_DELETE	COUNT_UPDATE	COUNT_INSERT	COUNT_ROLLBACK	COUNT_COMMIT	COUNT_CREATE	COUNT_ALTER	COUNT_DROP	COUNT_ADMIN
+root	0	1	0	3	1	1	2	1	2	0
+set global logging_stats_enable=false;
+SELECT USER, COUNT_SELECT, COUNT_DELETE, COUNT_UPDATE, COUNT_INSERT, COUNT_ROLLBACK, COUNT_COMMIT, COUNT_CREATE, COUNT_ALTER, COUNT_DROP, COUNT_ADMIN FROM DATA_DICTIONARY.SQL_COMMANDS_BY_USER;
+USER	COUNT_SELECT	COUNT_DELETE	COUNT_UPDATE	COUNT_INSERT	COUNT_ROLLBACK	COUNT_COMMIT	COUNT_CREATE	COUNT_ALTER	COUNT_DROP	COUNT_ADMIN
+set global logging_stats_enable=true;
+CREATE TABLE b (i int,  PRIMARY KEY (i));
+INSERT INTO b VALUES (1);
+INSERT INTO b VALUES (2);
+SELECT USER, COUNT_SELECT, COUNT_DELETE, COUNT_UPDATE, COUNT_INSERT, COUNT_ROLLBACK, COUNT_COMMIT, COUNT_CREATE, COUNT_ALTER, COUNT_DROP, COUNT_ADMIN FROM DATA_DICTIONARY.SQL_COMMANDS_BY_USER;
+USER	COUNT_SELECT	COUNT_DELETE	COUNT_UPDATE	COUNT_INSERT	COUNT_ROLLBACK	COUNT_COMMIT	COUNT_CREATE	COUNT_ALTER	COUNT_DROP	COUNT_ADMIN
+root	1	1	0	3	1	1	2	1	2	0
+root	0	0	0	1	0	0	1	0	0	0
+drizzle	0	0	0	1	0	0	0	0	0	0

=== added file 'plugin/logging_stats/tests/r/slap.result'
--- plugin/logging_stats/tests/r/slap.result	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/tests/r/slap.result	2010-03-25 06:01:38 +0000
@@ -0,0 +1,3 @@
+SELECT count(*) FROM DATA_DICTIONARY.SQL_COMMANDS_BY_USER;
+count(*)
+#

=== added directory 'plugin/logging_stats/tests/t'
=== added file 'plugin/logging_stats/tests/t/command-master.opt'
--- plugin/logging_stats/tests/t/command-master.opt	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/tests/t/command-master.opt	2010-03-20 23:56:48 +0000
@@ -0,0 +1,1 @@
+--plugin-add=logging_stats --logging_stats_enable

=== added file 'plugin/logging_stats/tests/t/command.test'
--- plugin/logging_stats/tests/t/command.test	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/tests/t/command.test	2010-03-13 01:43:03 +0000
@@ -0,0 +1,35 @@
+--disable_warnings
+DROP TABLE IF EXISTS a;
+--enable_warnings
+CREATE TABLE a (i int,  PRIMARY KEY (i));
+ALTER TABLE a ADD COLUMN j int;
+DROP TABLE A;
+CREATE TABLE a (i int,  PRIMARY KEY (i));
+INSERT INTO a VALUES (1);
+DELETE FROM a WHERE i=1;
+START TRANSACTION;
+INSERT INTO a VALUES (1);
+ROLLBACK;
+START TRANSACTION;
+INSERT INTO a VALUES (1);
+COMMIT;
+
+# The statistics are incremented after the statements have already returned
+# so its possible a query could be missed if we do not wait
+--sleep 1 
+SELECT USER, COUNT_SELECT, COUNT_DELETE, COUNT_UPDATE, COUNT_INSERT, COUNT_ROLLBACK, COUNT_COMMIT, COUNT_CREATE, COUNT_ALTER, COUNT_DROP, COUNT_ADMIN  FROM DATA_DICTIONARY.SQL_COMMANDS_BY_USER;
+
+# disable the plugin
+set global logging_stats_enable=false;
+SELECT USER, COUNT_SELECT, COUNT_DELETE, COUNT_UPDATE, COUNT_INSERT, COUNT_ROLLBACK, COUNT_COMMIT, COUNT_CREATE, COUNT_ALTER, COUNT_DROP, COUNT_ADMIN FROM DATA_DICTIONARY.SQL_COMMANDS_BY_USER;
+# renable it
+set global logging_stats_enable=true;
+
+connect (con1, localhost, root,,);
+CREATE TABLE b (i int,  PRIMARY KEY (i));
+INSERT INTO b VALUES (1);
+connect (con2, localhost, drizzle,,);
+INSERT INTO b VALUES (2);
+
+--sleep 1
+SELECT USER, COUNT_SELECT, COUNT_DELETE, COUNT_UPDATE, COUNT_INSERT, COUNT_ROLLBACK, COUNT_COMMIT, COUNT_CREATE, COUNT_ALTER, COUNT_DROP, COUNT_ADMIN FROM DATA_DICTIONARY.SQL_COMMANDS_BY_USER;

=== added file 'plugin/logging_stats/tests/t/slap-master.opt'
--- plugin/logging_stats/tests/t/slap-master.opt	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/tests/t/slap-master.opt	2010-03-25 01:14:18 +0000
@@ -0,0 +1,1 @@
+--plugin-add=logging_stats --logging_stats_enable

=== added file 'plugin/logging_stats/tests/t/slap.test'
--- plugin/logging_stats/tests/t/slap.test	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/tests/t/slap.test	2010-03-25 06:01:38 +0000
@@ -0,0 +1,6 @@
+
+--exec $DRIZZLE_SLAP --silent --concurrency=10 --iterations=20 --query="SELECT * FROM t1" --create="CREATE TABLE t1 (id int, name varchar(64)); INSERT INTO t1 VALUES (1, 'This is a test')" --delimiter=";" --commit=10
+
+
+--replace_column 1 #
+SELECT count(*) FROM DATA_DICTIONARY.SQL_COMMANDS_BY_USER;

=== added file 'plugin/logging_stats/user_commands.cc'
--- plugin/logging_stats/user_commands.cc	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/user_commands.cc	2010-03-08 04:23:54 +0000
@@ -0,0 +1,158 @@
+/*
+ * Copyright (c) 2010, Joseph Daly <skinny.moey@gmail.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *   * Redistributions of source code must retain the above copyright notice,
+ *     this list of conditions and the following disclaimer.
+ *   * Redistributions in binary form must reproduce the above copyright notice,
+ *     this list of conditions and the following disclaimer in the documentation
+ *     and/or other materials provided with the distribution.
+ *   * Neither the name of Joseph Daly nor the names of its contributors
+ *     may be used to endorse or promote products derived from this software
+ *     without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include "user_commands.h"
+
+UserCommands::UserCommands()
+    :
+      update_count(0),
+      delete_count(0),
+      insert_count(0),
+      select_count(0),
+      rollback_count(0),
+      commit_count(0),
+      create_count(0),
+      alter_count(0),
+      drop_count(0),
+      admin_count(0)
+{}
+
+void UserCommands::reset()
+{
+  update_count= 0;
+  delete_count= 0;
+  insert_count= 0;
+  select_count= 0;
+  rollback_count= 0;
+  commit_count= 0;
+  create_count= 0;
+  alter_count= 0;
+  drop_count= 0;
+  admin_count= 0;
+}
+
+uint64_t UserCommands::getSelectCount()
+{
+  return select_count;
+}
+
+void UserCommands::incrementSelectCount(int i)
+{
+  select_count= select_count + i;
+}
+
+uint64_t UserCommands::getUpdateCount()
+{
+  return update_count;
+}
+
+void UserCommands::incrementUpdateCount(int i)
+{
+  update_count= update_count + i;
+}
+
+uint64_t UserCommands::getDeleteCount()
+{
+  return delete_count;
+}
+
+void UserCommands::incrementDeleteCount(int i)
+{
+  delete_count= delete_count + i;
+}
+
+uint64_t UserCommands::getInsertCount()
+{
+  return insert_count;
+}
+
+void UserCommands::incrementInsertCount(int i)
+{
+  insert_count= insert_count + i;
+}
+
+uint64_t UserCommands::getRollbackCount()
+{
+  return rollback_count;
+}
+
+void UserCommands::incrementRollbackCount(int i)
+{
+  rollback_count= rollback_count + i;
+}
+
+uint64_t UserCommands::getCommitCount()
+{
+  return commit_count;
+}
+
+void UserCommands::incrementCommitCount(int i)
+{
+  commit_count= commit_count + i;
+}
+
+uint64_t UserCommands::getCreateCount()
+{
+  return create_count;
+}
+
+void UserCommands::incrementCreateCount(int i)
+{
+  create_count= create_count + i;
+}
+
+uint64_t UserCommands::getAlterCount()
+{
+  return alter_count;
+}
+
+void UserCommands::incrementAlterCount(int i)
+{
+  alter_count= alter_count + i;
+}
+
+uint64_t UserCommands::getDropCount()
+{
+  return drop_count;
+}
+
+void UserCommands::incrementDropCount(int i)
+{
+  drop_count= drop_count + i;
+}
+
+uint64_t UserCommands::getAdminCount()
+{
+  return admin_count;
+}
+
+void UserCommands::incrementAdminCount(int i)
+{
+  admin_count= admin_count + i;
+}

=== added file 'plugin/logging_stats/user_commands.h'
--- plugin/logging_stats/user_commands.h	1970-01-01 00:00:00 +0000
+++ plugin/logging_stats/user_commands.h	2010-03-08 04:23:54 +0000
@@ -0,0 +1,107 @@
+/*
+ * Copyright (c) 2010, Joseph Daly <skinny.moey@gmail.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *   * Redistributions of source code must retain the above copyright notice,
+ *     this list of conditions and the following disclaimer.
+ *   * Redistributions in binary form must reproduce the above copyright notice,
+ *     this list of conditions and the following disclaimer in the documentation
+ *     and/or other materials provided with the distribution.
+ *   * Neither the name of Joseph Daly nor the names of its contributors
+ *     may be used to endorse or promote products derived from this software
+ *     without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef PLUGIN_LOGGING_STATS_USER_COMMANDS_H
+#define PLUGIN_LOGGING_STATS_USER_COMMANDS_H
+
+#include <drizzled/common.h>
+
+#include <string>
+
+class UserCommands
+{
+public:
+
+  UserCommands();
+
+  uint64_t getSelectCount();
+
+  void incrementSelectCount(int i= 1);
+
+
+  uint64_t getUpdateCount();
+
+  void incrementUpdateCount(int i= 1);
+
+
+  uint64_t getDeleteCount();
+
+  void incrementDeleteCount(int i= 1);
+
+
+  uint64_t getInsertCount();
+
+  void incrementInsertCount(int i= 1);
+
+
+  uint64_t getRollbackCount();
+
+  void incrementRollbackCount(int i= 1);
+
+
+  uint64_t getCommitCount();
+
+  void incrementCommitCount(int i= 1);
+
+
+  uint64_t getCreateCount();
+
+  void incrementCreateCount(int i= 1);
+
+
+  uint64_t getAlterCount();
+
+  void incrementAlterCount(int i= 1);
+
+
+  uint64_t getDropCount();
+
+  void incrementDropCount(int i= 1);
+
+
+  uint64_t getAdminCount();
+
+  void incrementAdminCount(int i= 1);
+
+  void reset();
+
+private:
+  uint64_t update_count;
+  uint64_t delete_count;
+  uint64_t insert_count;
+  uint64_t select_count;
+  uint64_t rollback_count;
+  uint64_t commit_count;
+  uint64_t create_count;
+  uint64_t alter_count;
+  uint64_t drop_count;
+  uint64_t admin_count;
+};
+
+#endif /* PLUGIN_LOGGING_STATS_USER_COMMANDS_H */

=== modified file 'plugin/logging_syslog/logging_syslog.cc'
--- plugin/logging_syslog/logging_syslog.cc	2010-02-22 16:14:47 +0000
+++ plugin/logging_syslog/logging_syslog.cc	2010-03-06 02:08:13 +0000
@@ -178,18 +178,10 @@
 
 static Logging_syslog *handler= NULL;
 
-static int logging_syslog_plugin_init(drizzled::plugin::Registry &registry)
+static int logging_syslog_plugin_init(drizzled::plugin::Context &context)
 {
   handler= new Logging_syslog();
-  registry.add(handler);
-
-  return 0;
-}
-
-static int logging_syslog_plugin_deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(handler);
-  delete handler;
+  context.add(handler);
 
   return 0;
 }
@@ -286,7 +278,6 @@
   N_("Log to syslog"),
   PLUGIN_LICENSE_GPL,
   logging_syslog_plugin_init,
-  logging_syslog_plugin_deinit,
   logging_syslog_system_variables,
   NULL
 }

=== modified file 'plugin/md5/md5.cc'
--- plugin/md5/md5.cc	2010-02-18 04:43:04 +0000
+++ plugin/md5/md5.cc	2010-03-24 19:45:37 +0000
@@ -16,15 +16,10 @@
 
 #include "config.h"
 
-/* Include these before the openssl headers, because they are BROKEN AS CRAP */
 #include <cstdio>
 #include <cstddef>
 
-#if defined(HAVE_LIBGNUTLS_OPENSSL)
-# include <gnutls/openssl.h>
-#else
-# include <openssl/md5.h>
-#endif /* HAVE_GNUTLS_OPENSSL */
+#include <gcrypt.h>
 
 #include <drizzled/plugin/function.h>
 #include <drizzled/item/func.h>
@@ -75,10 +70,8 @@
 
   unsigned char digest[16];
   str->set_charset(&my_charset_bin);
-  MD5_CTX context;
-  MD5_Init(&context);
-  MD5_Update(&context, (unsigned char *) sptr->ptr(), sptr->length());
-  MD5_Final(digest, &context);
+
+  gcry_md_hash_buffer(GCRY_MD_MD5, digest, sptr->ptr(), sptr->length());
 
   snprintf((char *) str->ptr(), 33,
     "%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
@@ -94,17 +87,10 @@
 
 plugin::Create_function<Md5Function> *md5udf= NULL;
 
-static int initialize(plugin::Registry &registry)
+static int initialize(plugin::Context &context)
 {
   md5udf= new plugin::Create_function<Md5Function>("md5");
-  registry.add(md5udf);
-  return 0;
-}
-
-static int finalize(plugin::Registry &registry)
-{
-  registry.remove(md5udf);
-  delete md5udf;
+  context.add(md5udf);
   return 0;
 }
 
@@ -117,7 +103,6 @@
   "UDF for computing md5sum",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/md5/plugin.ac'
--- plugin/md5/plugin.ac	2009-07-27 22:24:20 +0000
+++ plugin/md5/plugin.ac	2010-03-23 10:34:12 +0000
@@ -1,26 +1,9 @@
-AC_LIB_HAVE_LINKFLAGS(gnutls-openssl,,[
-    #include <string.h>
-    #include <gnutls/openssl.h>
-  ],[
-    MD5_CTX context;
-    MD5_Init (&context);
-  ])
-AS_IF([test "x$ac_cv_libgnutls_openssl" = "xyes"],[
-  ac_cv_build_md5=yes
-  LTMD5PLUGINDEP=${LTLIBGNUTLS_OPENSSL}
-],[
-  AC_LIB_HAVE_LINKFLAGS(crypto,,[
-    #include <string.h>
-    #include <openssl/md5.h>
-  ],[
-    MD5_CTX context;
-    MD5_Init (&context);
-  ])
-  AS_IF([test "x$ac_cv_libcrypto" = "xyes"],[
-    ac_cv_build_md5=yes
-    LTMD5PLUGINDEP=${LTLIBCRYPTO}
-  ],[
-    AC_MSG_WARN([MD5 not found in either gnutls or crypto lib not building md5 plugin. On Debian this is found in libgnutls-dev. On RedHat it is in gnutls-devel.])
-  ])
+AC_LIB_HAVE_LINKFLAGS(gcrypt,,[
+    #include <gcrypt.h>
+  ],[
+    void *digest, *source;
+    gcry_md_hash_buffer(GCRY_MD_MD5, digest, source, 0);
+  ])
+AS_IF([test "x$ac_cv_libgcrypt" = "xno"],[
+    AC_MSG_WARN([MD5 not found in libgcrypt: not building md5 plugin. On Debian this is found in libgcrypt11-dev. On RedHat it is in libgcrypt-devel.])
 ])
-AC_SUBST(LTMD5PLUGINDEP)

=== modified file 'plugin/md5/plugin.ini'
--- plugin/md5/plugin.ini	2009-12-04 18:50:04 +0000
+++ plugin/md5/plugin.ini	2010-03-23 10:28:09 +0000
@@ -2,5 +2,5 @@
 title=UDF Plugin for MD5
 description=UDF Plugin for MD5
 load_by_default=yes
-ldflags=${LTMD5PLUGINDEP}
-build_conditional="${ac_cv_build_md5}" = "yes"
+ldflags=${LTLIBGCRYPT}
+build_conditional="${ac_cv_libgcrypt}" = "yes"

=== modified file 'plugin/memcached_functions/memcached_functions.cc'
--- plugin/memcached_functions/memcached_functions.cc	2010-02-18 04:43:04 +0000
+++ plugin/memcached_functions/memcached_functions.cc	2010-03-05 21:10:20 +0000
@@ -275,7 +275,7 @@
   delete memc_decrement;
 }
 
-static int memcachedInit(drizzled::plugin::Registry &registry)
+static int memcachedInit(drizzled::plugin::Context &context)
 {
   if (initMemcUDF())
   {
@@ -284,63 +284,63 @@
 
   memc= memcached_create(NULL);
 
-  registry.add(memc_servers_set);
-  registry.add(memc_behavior_set);
-  registry.add(memc_behavior_get);
-  registry.add(memc_stats);
-  registry.add(memc_get);
-  registry.add(memc_get_by_key);
-  registry.add(memc_set);
-  registry.add(memc_set_by_key);
-  registry.add(memc_add);
-  registry.add(memc_add_by_key);
-  registry.add(memc_replace);
-  registry.add(memc_replace_by_key);
-  registry.add(memc_delete);
-  registry.add(memc_delete_by_key);
-  registry.add(memc_append);
-  registry.add(memc_append_by_key);
-  registry.add(memc_prepend);
-  registry.add(memc_prepend_by_key);
-  registry.add(memc_cas);
-  registry.add(memc_cas_by_key);
-  registry.add(memc_serv_count);
-  registry.add(memc_version);
-  registry.add(memc_increment);
-  registry.add(memc_decrement);
+  context.add(memc_servers_set);
+  context.add(memc_behavior_set);
+  context.add(memc_behavior_get);
+  context.add(memc_stats);
+  context.add(memc_get);
+  context.add(memc_get_by_key);
+  context.add(memc_set);
+  context.add(memc_set_by_key);
+  context.add(memc_add);
+  context.add(memc_add_by_key);
+  context.add(memc_replace);
+  context.add(memc_replace_by_key);
+  context.add(memc_delete);
+  context.add(memc_delete_by_key);
+  context.add(memc_append);
+  context.add(memc_append_by_key);
+  context.add(memc_prepend);
+  context.add(memc_prepend_by_key);
+  context.add(memc_cas);
+  context.add(memc_cas_by_key);
+  context.add(memc_serv_count);
+  context.add(memc_version);
+  context.add(memc_increment);
+  context.add(memc_decrement);
 
   return 0;
 }
 
-static int memcachedDone(drizzled::plugin::Registry &registry)
+static int memcachedDone(drizzled::plugin::Context &context)
 {
 
   memcached_free(memc);
 
-  registry.remove(memc_servers_set);
-  registry.remove(memc_behavior_set);
-  registry.remove(memc_behavior_get);
-  registry.remove(memc_stats);
-  registry.remove(memc_get);
-  registry.remove(memc_get_by_key);
-  registry.remove(memc_set);
-  registry.remove(memc_set_by_key);
-  registry.remove(memc_add);
-  registry.remove(memc_add_by_key);
-  registry.remove(memc_replace);
-  registry.remove(memc_replace_by_key);
-  registry.remove(memc_delete);
-  registry.remove(memc_delete_by_key);
-  registry.remove(memc_append);
-  registry.remove(memc_append_by_key);
-  registry.remove(memc_prepend);
-  registry.remove(memc_prepend_by_key);
-  registry.remove(memc_cas);
-  registry.remove(memc_cas_by_key);
-  registry.remove(memc_serv_count);
-  registry.remove(memc_version);
-  registry.remove(memc_increment);
-  registry.remove(memc_decrement);
+  context.remove(memc_servers_set);
+  context.remove(memc_behavior_set);
+  context.remove(memc_behavior_get);
+  context.remove(memc_stats);
+  context.remove(memc_get);
+  context.remove(memc_get_by_key);
+  context.remove(memc_set);
+  context.remove(memc_set_by_key);
+  context.remove(memc_add);
+  context.remove(memc_add_by_key);
+  context.remove(memc_replace);
+  context.remove(memc_replace_by_key);
+  context.remove(memc_delete);
+  context.remove(memc_delete_by_key);
+  context.remove(memc_append);
+  context.remove(memc_append_by_key);
+  context.remove(memc_prepend);
+  context.remove(memc_prepend_by_key);
+  context.remove(memc_cas);
+  context.remove(memc_cas_by_key);
+  context.remove(memc_serv_count);
+  context.remove(memc_version);
+  context.remove(memc_increment);
+  context.remove(memc_decrement);
 
   cleanupMemcUDF();
 

=== modified file 'plugin/memcached_functions/plugin.ini'
--- plugin/memcached_functions/plugin.ini	2010-02-12 02:56:22 +0000
+++ plugin/memcached_functions/plugin.ini	2010-03-25 22:03:21 +0000
@@ -29,5 +29,5 @@
         memc_behavior_set.cc memc_behavior_get.cc 
         memc_increment.cc memc_decrement.cc
         memc_stats.cc
-build_conditional="${ac_cv_libmemcached}" = "yes" -a "x${MEMCACHED_BINARY}" != "xno"
+build_conditional="${pandora_cv_recent_libmemcached}" = "yes" -a "x${MEMCACHED_BINARY}" != "xno"
 ldflags=${LTLIBMEMCACHED}

=== renamed file 'plugin/memcached_functions/tests/t/memc.test' => 'plugin/memcached_functions/tests/t/memc.disabled'
=== modified file 'plugin/memcached_stats/analysis_table.cc'
--- plugin/memcached_stats/analysis_table.cc	2010-02-20 01:43:59 +0000
+++ plugin/memcached_stats/analysis_table.cc	2010-03-19 22:31:53 +0000
@@ -91,14 +91,14 @@
   {
     memcached_analysis_st *report= memcached_analyze(serv, stats, &rc);
 
-    push(server_count);
-    push(report->average_item_size);
+    push(static_cast<uint64_t>(server_count));
+    push(static_cast<uint64_t>(report->average_item_size));
     push(memcached_server_name(serv, servers[report->most_consumed_server]));
     push(report->most_used_bytes);
     push(memcached_server_name(serv, servers[report->least_free_server]));
     push(report->least_remaining_bytes);
     push(memcached_server_name(serv, servers[report->oldest_server]));
-    push(report->longest_uptime);
+    push(static_cast<uint64_t>(report->longest_uptime));
     push(static_cast<int64_t>(report->pool_hit_ratio));
     free(report);
   } 

=== modified file 'plugin/memcached_stats/memcached_stats.cc'
--- plugin/memcached_stats/memcached_stats.cc	2010-02-19 22:18:37 +0000
+++ plugin/memcached_stats/memcached_stats.cc	2010-03-22 17:38:58 +0000
@@ -30,7 +30,6 @@
 #include "config.h"
 #include "drizzled/show.h"
 #include "drizzled/gettext.h"
-#include "drizzled/plugin/info_schema_table.h"
 
 #include "stats_table.h"
 #include "analysis_table.h"
@@ -60,7 +59,7 @@
  * @param[in] registry the drizzled::plugin::Registry singleton
  * @return false on success; true on failure.
  */
-static int init(plugin::Registry &registry)
+static int init(plugin::Context &context)
 {
 
   SysvarHolder &sysvar_holder= SysvarHolder::singleton();
@@ -68,26 +67,11 @@
 
   /* we are good to go */
   stats_table_tool= new(std::nothrow)StatsTableTool; 
-  registry.add(stats_table_tool);
+  context.add(stats_table_tool);
 
   analysis_table_tool= new(std::nothrow)AnalysisTableTool;
-  registry.add(analysis_table_tool);
-
-  return 0;
-}
-
-/**
- * Clean up the memcached stats plugin.
- *
- * @param[in] registry the drizzled::plugin::Registry singleton
- * @return false on success; true on failure
- */
-static int deinit(plugin::Registry &registry)
-{
-  registry.remove(stats_table_tool);
-  delete stats_table_tool;
-  registry.remove(analysis_table_tool);
-  delete analysis_table_tool;
+  context.add(analysis_table_tool);
+
   return 0;
 }
 
@@ -147,7 +131,6 @@
   N_("Memcached Stats as I_S tables"),
   PLUGIN_LICENSE_BSD,
   init,   /* Plugin Init      */
-  deinit, /* Plugin Deinit    */
   system_variables, /* system variables */
   NULL    /* config options   */
 }

=== modified file 'plugin/memcached_stats/plugin.ini'
--- plugin/memcached_stats/plugin.ini	2010-03-03 22:16:39 +0000
+++ plugin/memcached_stats/plugin.ini	2010-03-25 22:03:21 +0000
@@ -4,5 +4,5 @@
 load_by_default=no
 headers=stats_table.h analysis_table.h sysvar_holder.h
 sources=memcached_stats.cc stats_table.cc analysis_table.cc
-build_conditional="${ac_cv_libmemcached}" = "yes" -a "x${MEMCACHED_BINARY}" != "xno"
+build_conditional="${pandora_cv_recent_libmemcached}" = "yes" -a "x${MEMCACHED_BINARY}" != "xno"
 ldflags=${LTLIBMEMCACHED}

=== modified file 'plugin/memcached_stats/stats_table.cc'
--- plugin/memcached_stats/stats_table.cc	2010-02-20 01:43:59 +0000
+++ plugin/memcached_stats/stats_table.cc	2010-03-19 22:31:53 +0000
@@ -80,7 +80,7 @@
   char **ptr= NULL;
  
   ctx->generator->push(server_name);
-  ctx->generator->push(server_port);
+  ctx->generator->push(static_cast<uint64_t>(server_port));
 
   for (ptr= list; *ptr; ptr++)
   {

=== renamed file 'plugin/memcached_stats/tests/t/describe.test' => 'plugin/memcached_stats/tests/t/describe.disabled'
=== renamed file 'plugin/memcached_stats/tests/t/query.test' => 'plugin/memcached_stats/tests/t/query.disabled'
=== modified file 'plugin/multi_thread/multi_thread.cc'
--- plugin/multi_thread/multi_thread.cc	2010-02-18 04:43:04 +0000
+++ plugin/multi_thread/multi_thread.cc	2010-03-06 02:08:13 +0000
@@ -87,18 +87,10 @@
 }
 
   
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   scheduler= new MultiThreadScheduler("multi_thread");
-  registry.add(scheduler);
-
-  return 0;
-}
-
-static int deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(scheduler);
-  delete scheduler;
+  context.add(scheduler);
 
   return 0;
 }
@@ -122,7 +114,6 @@
   "One Thread Per Session Scheduler",
   PLUGIN_LICENSE_GPL,
   init, /* Plugin Init */
-  deinit, /* Plugin Deinit */
   sys_variables,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2010-03-19 04:54:45 +0000
+++ plugin/myisam/ha_myisam.cc	2010-03-24 19:52:38 +0000
@@ -34,6 +34,7 @@
 #include "drizzled/table.h"
 #include "drizzled/field/timestamp.h"
 #include "drizzled/memory/multi_malloc.h"
+#include "drizzled/plugin/daemon.h"
 
 #include <string>
 #include <sstream>
@@ -68,22 +69,33 @@
 
 class MyisamEngine : public plugin::StorageEngine
 {
+  MyisamEngine();
+  MyisamEngine(const MyisamEngine&);
+  MyisamEngine& operator=(const MyisamEngine&);
 public:
-  MyisamEngine(string name_arg)
-    : plugin::StorageEngine(name_arg,
-                            HTON_HAS_DATA_DICTIONARY |
-                            HTON_CAN_INDEX_BLOBS |
-                            HTON_STATS_RECORDS_IS_EXACT |
-                            HTON_TEMPORARY_ONLY |
-                            HTON_NULL_IN_KEY |
-                            HTON_HAS_RECORDS |
-                            HTON_DUPLICATE_POS |
-                            HTON_AUTO_PART_KEY |
-                            HTON_SKIP_STORE_LOCK |
-                            HTON_FILE_BASED ) {}
-
-  ~MyisamEngine()
-  { }
+  explicit MyisamEngine(string name_arg) :
+    plugin::StorageEngine(name_arg,
+                          HTON_HAS_DATA_DICTIONARY |
+                          HTON_CAN_INDEX_BLOBS |
+                          HTON_STATS_RECORDS_IS_EXACT |
+                          HTON_TEMPORARY_ONLY |
+                          HTON_NULL_IN_KEY |
+                          HTON_HAS_RECORDS |
+                          HTON_DUPLICATE_POS |
+                          HTON_AUTO_PART_KEY |
+                          HTON_SKIP_STORE_LOCK |
+                          HTON_FILE_BASED )
+  {
+    pthread_mutex_init(&THR_LOCK_myisam,MY_MUTEX_INIT_FAST);
+  }
+
+  virtual ~MyisamEngine()
+  { 
+    pthread_mutex_destroy(&THR_LOCK_myisam);
+    end_key_cache(dflt_key_cache, 1);		// Can never fail
+
+    mi_panic(HA_PANIC_CLOSE);
+  }
 
   virtual Cursor *create(TableShare &table,
                          memory::Root *mem_root)
@@ -100,7 +112,7 @@
                     drizzled::TableIdentifier &identifier,
                     message::Table&);
 
-  int doRenameTable(Session*, const char *from, const char *to);
+  int doRenameTable(Session&, TableIdentifier &from, TableIdentifier &to);
 
   int doDropTable(Session&, drizzled::TableIdentifier &identifier);
 
@@ -126,40 +138,18 @@
   bool doDoesTableExist(Session& session, TableIdentifier &identifier);
 };
 
-bool MyisamEngine::doDoesTableExist(Session&, TableIdentifier &identifier)
+bool MyisamEngine::doDoesTableExist(Session &session, TableIdentifier &identifier)
 {
-  ProtoCache::iterator iter;
-
-  pthread_mutex_lock(&proto_cache_mutex);
-  iter= proto_cache.find(identifier.getPath());
-
-  if (iter != proto_cache.end())
-  {
-    return true;
-  }
-  pthread_mutex_unlock(&proto_cache_mutex);
-
-  return false;
+  return session.doesTableMessageExist(identifier);
 }
 
-int MyisamEngine::doGetTableDefinition(Session&,
+int MyisamEngine::doGetTableDefinition(Session &session,
                                        drizzled::TableIdentifier &identifier,
-                                       message::Table &table_proto)
+                                       message::Table &table_message)
 {
-  int error= ENOENT;
-  ProtoCache::iterator iter;
-
-  pthread_mutex_lock(&proto_cache_mutex);
-  iter= proto_cache.find(identifier.getPath());
-
-  if (iter != proto_cache.end())
-  {
-    table_proto.CopyFrom(((*iter).second));
-    error= EEXIST;
-  }
-  pthread_mutex_unlock(&proto_cache_mutex);
-
-  return error;
+  if (session.getTableMessage(identifier, table_message))
+    return EEXIST;
+  return ENOENT;
 }
 
 /* 
@@ -1341,18 +1331,10 @@
   return mi_delete_all_rows(file);
 }
 
-int MyisamEngine::doDropTable(Session&,
+int MyisamEngine::doDropTable(Session &session,
                               drizzled::TableIdentifier &identifier)
 {
-  ProtoCache::iterator iter;
-
-  pthread_mutex_lock(&proto_cache_mutex);
-  iter= proto_cache.find(identifier.getPath());
-
-  if (iter!= proto_cache.end())
-    proto_cache.erase(iter);
-
-  pthread_mutex_unlock(&proto_cache_mutex);
+  session.removeTableMessage(identifier);
 
   return mi_delete_table(identifier.getPath().c_str());
 }
@@ -1366,7 +1348,7 @@
 				       F_UNLCK : F_EXTRA_LCK));
 }
 
-int MyisamEngine::doCreateTable(Session *,
+int MyisamEngine::doCreateTable(Session *session,
                                 Table& table_arg,
                                 drizzled::TableIdentifier &identifier,
                                 message::Table& create_proto)
@@ -1408,18 +1390,17 @@
                    &create_info, create_flags);
   free((unsigned char*) recinfo);
 
-  pthread_mutex_lock(&proto_cache_mutex);
-  proto_cache.insert(make_pair(identifier.getPath(), create_proto));
-  pthread_mutex_unlock(&proto_cache_mutex);
+  session->storeTableMessage(identifier, create_proto);
 
   return error;
 }
 
 
-int MyisamEngine::doRenameTable(Session*,
-                                const char *from, const char *to)
+int MyisamEngine::doRenameTable(Session &session, TableIdentifier &from, TableIdentifier &to)
 {
-  return mi_rename(from,to);
+  session.renameTableMessage(from, to);
+
+  return mi_rename(from.getPath().c_str(), to.getPath().c_str());
 }
 
 
@@ -1511,20 +1492,17 @@
 
 static MyisamEngine *engine= NULL;
 
-static int myisam_init(plugin::Registry &registry)
+static int myisam_init(plugin::Context &context)
 {
-  int error;
   engine= new MyisamEngine(engine_name);
-  registry.add(engine);
-
-  pthread_mutex_init(&THR_LOCK_myisam,MY_MUTEX_INIT_FAST);
+  context.add(engine);
 
   /* call ha_init_key_cache() on all key caches to init them */
-  error= init_key_cache(dflt_key_cache,
-                        myisam_key_cache_block_size,
-                        myisam_key_cache_size,
-                        myisam_key_cache_division_limit, 
-                        myisam_key_cache_age_threshold);
+  int error= init_key_cache(dflt_key_cache,
+                            myisam_key_cache_block_size,
+                            myisam_key_cache_size,
+                            myisam_key_cache_division_limit, 
+                            myisam_key_cache_age_threshold);
 
   if (error == 0)
     exit(1); /* Memory Allocation Failure */
@@ -1532,16 +1510,6 @@
   return 0;
 }
 
-static int myisam_deinit(plugin::Registry &registry)
-{
-  registry.remove(engine);
-  delete engine;
-
-  pthread_mutex_destroy(&THR_LOCK_myisam);
-  end_key_cache(dflt_key_cache, 1);		// Can never fail
-
-  return mi_panic(HA_PANIC_CLOSE);
-}
 
 static void sys_var_key_cache_size_update(Session *session, drizzle_sys_var *var, void *, const void *save)
 {
@@ -1734,7 +1702,6 @@
   "Default engine as of MySQL 3.23 with great performance",
   PLUGIN_LICENSE_GPL,
   myisam_init, /* Plugin Init */
-  myisam_deinit, /* Plugin Deinit */
   sys_variables,           /* system variables */
   NULL                        /* config options                  */
 }

=== added file 'plugin/mysql_protocol/mysql_password.cc'
--- plugin/mysql_protocol/mysql_password.cc	1970-01-01 00:00:00 +0000
+++ plugin/mysql_protocol/mysql_password.cc	2010-03-19 22:06:24 +0000
@@ -0,0 +1,68 @@
+/* Copyright (C) 2010 Rackspace
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
+
+#include "config.h"
+#include "mysql_password.h"
+#include "drizzled/algorithm/sha1.h"
+#include "drizzled/util/convert.h"
+
+using namespace std;
+using namespace drizzled;
+
+const char* MySQLPasswordName = "mysql_password";
+
+MySQLPassword::MySQLPassword(void):
+  Item_str_func()
+{ }
+
+const char *MySQLPassword::func_name() const
+{
+  return MySQLPasswordName;
+}
+  
+void MySQLPassword::fix_length_and_dec()
+{
+  max_length= args[0]->max_length;
+}
+
+bool MySQLPassword::check_argument_count(int n)
+{
+  return (n == 1);
+}
+
+String *MySQLPassword::val_str(String *str)
+{
+  String argument;
+  String *password= args[0]->val_str(&argument);
+  SHA1_CTX ctx;
+  uint8_t hash_tmp1[SHA1_DIGEST_LENGTH];
+  uint8_t hash_tmp2[SHA1_DIGEST_LENGTH];
+
+  SHA1Init(&ctx);
+  SHA1Update(&ctx, reinterpret_cast<uint8_t *>(password->ptr()),
+             password->length());
+  SHA1Final(hash_tmp1, &ctx);
+
+  SHA1Init(&ctx);
+  SHA1Update(&ctx, hash_tmp1, SHA1_DIGEST_LENGTH);
+  SHA1Final(hash_tmp2, &ctx);
+
+  str->realloc(SHA1_DIGEST_LENGTH * 2);
+  drizzled_string_to_hex(str->ptr(), reinterpret_cast<const char*>(hash_tmp2),
+                         SHA1_DIGEST_LENGTH);
+  str->length(SHA1_DIGEST_LENGTH * 2);
+
+  return str;
+}

=== added file 'plugin/mysql_protocol/mysql_password.h'
--- plugin/mysql_protocol/mysql_password.h	1970-01-01 00:00:00 +0000
+++ plugin/mysql_protocol/mysql_password.h	2010-03-18 01:07:53 +0000
@@ -0,0 +1,39 @@
+/* Copyright (C) 2010 Rackspace
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
+
+#ifndef PLUGIN_MYSQL_PROTOCOL_MYSQL_PASSWORD_H
+#define PLUGIN_MYSQL_PROTOCOL_MYSQL_PASSWORD_H
+
+#include <drizzled/item/func.h>
+#include <drizzled/function/str/strfunc.h>
+
+namespace drizzled
+{
+
+extern "C" const char* MySQLPasswordName;
+
+class MySQLPassword: public drizzled::Item_str_func
+{
+public:
+  MySQLPassword(void);
+  const char *func_name(void) const;
+  void fix_length_and_dec(void);
+  bool check_argument_count(int n);
+  drizzled::String *val_str(drizzled::String *);
+};
+
+} /* namespace drizzled */
+
+#endif /* PLUGIN_MYSQL_PROTOCOL_MYSQL_PASSWORD_H */

=== modified file 'plugin/mysql_protocol/mysql_protocol.cc'
--- plugin/mysql_protocol/mysql_protocol.cc	2010-03-18 07:23:36 +0000
+++ plugin/mysql_protocol/mysql_protocol.cc	2010-03-25 19:28:37 +0000
@@ -28,6 +28,7 @@
 
 #include "errmsg.h"
 #include "mysql_protocol.h"
+#include "mysql_password.h"
 #include "options.h"
 
 using namespace std;
@@ -48,6 +49,10 @@
 static uint32_t retry_count;
 static uint32_t buffer_length;
 static char* bind_address;
+static uint32_t random_seed1;
+static uint32_t random_seed2;
+static const uint32_t random_max= 0x3FFFFFFF;
+static const double random_max_double= (double)0x3FFFFFFF;
 
 const char* ListenMySQLProtocol::getHost(void) const
 {
@@ -614,6 +619,9 @@
 {
   uint32_t pkt_len= 0;
   char *end;
+  char scramble[SCRAMBLE_LENGTH];
+
+  makeScramble(scramble);
 
   // TCP/IP connection
   {
@@ -655,7 +663,7 @@
     end+= 4;
 
     /* We don't use scramble anymore. */
-    memset(end, 'X', SCRAMBLE_LENGTH_323);
+    memcpy(end, scramble, SCRAMBLE_LENGTH_323);
     end+= SCRAMBLE_LENGTH_323;
     *end++= 0; /* an empty byte for some reason */
 
@@ -667,7 +675,7 @@
     end+= 18;
 
     /* Write scramble tail. */
-    memset(end, 'X', SCRAMBLE_LENGTH - SCRAMBLE_LENGTH_323);
+    memcpy(end, scramble + SCRAMBLE_LENGTH_323, SCRAMBLE_LENGTH - SCRAMBLE_LENGTH_323);
     end+= (SCRAMBLE_LENGTH - SCRAMBLE_LENGTH_323);
     *end++= 0; /* an empty byte for some reason */
 
@@ -719,18 +727,32 @@
   char *l_db= passwd;
 
   /*
-    Old clients send null-terminated string as password; new clients send
-    the size (1 byte) + string (not null-terminated). Hence in case of empty
-    password both send '\0'.
-
-    This strlen() can't be easily deleted without changing client.
+    Only support new password format.
 
     Cast *passwd to an unsigned char, so that it doesn't extend the sign for
     *passwd > 127 and become 2**32-127+ after casting to uint.
   */
-  uint32_t passwd_len= client_capabilities & CLIENT_SECURE_CONNECTION ?
-    (unsigned char)(*passwd++) : strlen(passwd);
-  l_db= client_capabilities & CLIENT_CONNECT_WITH_DB ? l_db + passwd_len + 1 : 0;
+  uint32_t passwd_len;
+  if (client_capabilities & CLIENT_SECURE_CONNECTION &&
+      passwd < (char *) net.read_pos + pkt_len)
+  {
+    passwd_len= (unsigned char)(*passwd++);
+    if (passwd_len > 0)
+    {
+      session->getSecurityContext().setPasswordType(SecurityContext::MYSQL_HASH);
+      session->getSecurityContext().setPasswordContext(scramble, SCRAMBLE_LENGTH);
+    }
+  }
+  else
+    passwd_len= 0;
+
+  if (client_capabilities & CLIENT_CONNECT_WITH_DB &&
+      passwd < (char *) net.read_pos + pkt_len)
+  {
+    l_db= l_db + passwd_len + 1;
+  }
+  else
+    l_db= NULL;
 
   /* strlen() can't be easily deleted without changing client */
   uint32_t db_len= l_db ? strlen(l_db) : 0;
@@ -835,19 +857,43 @@
   return buffer+8;
 }
 
+void ClientMySQLProtocol::makeScramble(char *scramble)
+{
+  /* This is the MySQL algorithm with minimal changes. */
+  random_seed1= (random_seed1 * 3 + random_seed2) % random_max;
+  random_seed2= (random_seed1 + random_seed2 + 33) % random_max;
+  uint32_t seed= static_cast<uint32_t>((static_cast<double>(random_seed1) / random_max_double) * 0xffffffff);
+
+  void *pointer= this;
+  uint32_t pointer_seed;
+  memcpy(&pointer_seed, &pointer, 4);
+  uint32_t random1= (seed + pointer_seed) % random_max;
+  uint32_t random2= (seed + global_thread_id + net.vio->sd) % random_max;
+
+  for (char *end= scramble + SCRAMBLE_LENGTH; scramble != end; scramble++)
+  {
+    random1= (random1 * 3 + random2) % random_max;
+    random2= (random1 + random2 + 33) % random_max;
+    *scramble= static_cast<char>((static_cast<double>(random1) / random_max_double) * 94 + 33);
+  }
+}
+
 static ListenMySQLProtocol *listen_obj= NULL;
+plugin::Create_function<MySQLPassword> *mysql_password= NULL;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
+  /* Initialize random seeds for the MySQL algorithm with minimal changes. */
+  time_t seed_time= time(NULL);
+  random_seed1= seed_time % random_max;
+  random_seed2= (seed_time / 2) % random_max;
+
+  mysql_password= new plugin::Create_function<MySQLPassword>(MySQLPasswordName);
+  context.add(mysql_password);
+
   listen_obj= new ListenMySQLProtocol("mysql_protocol", true);
-  registry.add(listen_obj); 
-  return 0;
-}
+  context.add(listen_obj); 
 
-static int deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(listen_obj);
-  delete listen_obj;
   return 0;
 }
 
@@ -890,7 +936,6 @@
   "MySQL Protocol Module",
   PLUGIN_LICENSE_GPL,
   init,             /* Plugin Init */
-  deinit,           /* Plugin Deinit */
   sys_variables, /* system variables */
   NULL              /* config options */
 }

=== modified file 'plugin/mysql_protocol/mysql_protocol.h'
--- plugin/mysql_protocol/mysql_protocol.h	2010-03-16 08:18:07 +0000
+++ plugin/mysql_protocol/mysql_protocol.h	2010-03-18 18:08:25 +0000
@@ -52,6 +52,7 @@
   bool netStoreData(const unsigned char *from, size_t length);
   void writeEOFPacket(uint32_t server_status, uint32_t total_warn_count);
   unsigned char *storeLength(unsigned char *packet, uint64_t length);
+  void makeScramble(char *scramble);
 
 public:
   ClientMySQLProtocol(int fd, bool using_mysql41_protocol_arg);

=== modified file 'plugin/mysql_protocol/plugin.ini'
--- plugin/mysql_protocol/plugin.ini	2010-03-16 08:18:07 +0000
+++ plugin/mysql_protocol/plugin.ini	2010-03-18 01:07:53 +0000
@@ -3,6 +3,6 @@
 description=MySQL protocol module that is based on the old libmysql code.
 load_by_default=yes
 ldlfags=$(LIBZ)
-headers=mysql_protocol.h errmsg.h net_serv.h options.h vio.h
-sources=mysql_protocol.cc net_serv.cc vio.cc
+headers=mysql_protocol.h errmsg.h net_serv.h options.h vio.h mysql_password.h
+sources=mysql_protocol.cc net_serv.cc vio.cc mysql_password.cc
 static=yes

=== added file 'plugin/mysql_protocol/tests/r/mysql_password.result'
--- plugin/mysql_protocol/tests/r/mysql_password.result	1970-01-01 00:00:00 +0000
+++ plugin/mysql_protocol/tests/r/mysql_password.result	2010-03-19 21:21:10 +0000
@@ -0,0 +1,10 @@
+SELECT MYSQL_PASSWORD("test");
+MYSQL_PASSWORD("test")
+94BDCEBE19083CE2A1F959FD02F964C7AF4CFC29
+SELECT MYSQL_PASSWORD("This is a much longer test than the previous one.");
+MYSQL_PASSWORD("This is a much longer test than the previous one.")
+652D14F2155B64124B2EEA4C1CFFE4E638BB913D
+SELECT MYSQL_PASSWORD();
+ERROR 42000: Incorrect parameter count in the call to native function 'mysql_password'
+SELECT MYSQL_PASSWORD('one', 'two', 'three');
+ERROR 42000: Incorrect parameter count in the call to native function 'mysql_password'

=== added file 'plugin/mysql_protocol/tests/t/mysql_password.test'
--- plugin/mysql_protocol/tests/t/mysql_password.test	1970-01-01 00:00:00 +0000
+++ plugin/mysql_protocol/tests/t/mysql_password.test	2010-03-19 21:21:10 +0000
@@ -0,0 +1,6 @@
+SELECT MYSQL_PASSWORD("test");
+SELECT MYSQL_PASSWORD("This is a much longer test than the previous one.");
+--error ER_WRONG_PARAMCOUNT_TO_FUNCTION
+SELECT MYSQL_PASSWORD();
+--error ER_WRONG_PARAMCOUNT_TO_FUNCTION
+SELECT MYSQL_PASSWORD('one', 'two', 'three');

=== modified file 'plugin/pool_of_threads/pool_of_threads.cc'
--- plugin/pool_of_threads/pool_of_threads.cc	2010-02-18 04:43:04 +0000
+++ plugin/pool_of_threads/pool_of_threads.cc	2010-03-06 02:08:13 +0000
@@ -36,7 +36,6 @@
 static volatile bool kill_pool_threads= false;
 
 static volatile uint32_t created_threads= 0;
-static int deinit(drizzled::plugin::Registry &registry);
 
 static struct event session_add_event;
 static struct event session_kill_event;
@@ -637,24 +636,12 @@
  * 
  * @param[in] registry holding the record of the plugins
  */
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   assert(size != 0);
 
   scheduler= new PoolOfThreadsScheduler("pool_of_threads");
-  registry.add(scheduler);
-
-  return 0;
-}
-
-/**
- * @brief
- *  Waits until all pool threads have been deleted for clean shutdown
- */
-static int deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(scheduler);
-  delete scheduler;
+  context.add(scheduler);
 
   return 0;
 }
@@ -682,7 +669,6 @@
   "Pool of Threads Scheduler",
   PLUGIN_LICENSE_GPL,
   init, /* Plugin Init */
-  deinit, /* Plugin Deinit */
   sys_variables,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/registry_dictionary/dictionary.cc'
--- plugin/registry_dictionary/dictionary.cc	2010-02-18 04:43:04 +0000
+++ plugin/registry_dictionary/dictionary.cc	2010-03-06 02:08:13 +0000
@@ -26,27 +26,17 @@
 static ModulesTool *modules;
 static PluginsTool *plugins;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   modules= new(std::nothrow)ModulesTool;
   plugins= new(std::nothrow)PluginsTool;
 
-  registry.add(modules);
-  registry.add(plugins);
+  context.add(modules);
+  context.add(plugins);
   
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(modules);
-  registry.remove(plugins);
-  delete modules;
-  delete plugins;
-
-  return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -56,7 +46,6 @@
   "Provides dictionary for plugin registry system.",
   PLUGIN_LICENSE_GPL,
   init,     /* Plugin Init */
-  finalize,     /* Plugin Deinit */
   NULL,               /* system variables */
   NULL                /* config options   */
 }

=== modified file 'plugin/registry_dictionary/plugins.cc'
--- plugin/registry_dictionary/plugins.cc	2010-02-10 09:10:08 +0000
+++ plugin/registry_dictionary/plugins.cc	2010-03-24 03:02:19 +0000
@@ -38,7 +38,7 @@
   plugin::TableFunction::Generator(arg)
 {
   plugin::Registry &registry= plugin::Registry::singleton();
-  const map<string, const plugin::Plugin *> &plugin_map=
+  const map<string, plugin::Plugin *> &plugin_map=
     registry.getPluginsMap();
 
   it= plugin_map.begin();
@@ -47,11 +47,11 @@
 
 bool PluginsTool::Generator::populate()
 {
-  const plugin::Plugin *plugin= (*it).second;
-
   if (it == end)
     return false;
 
+  const plugin::Plugin *plugin= (*it).second;
+
   /* PLUGIN_NAME */
   push(plugin->getName());
 
@@ -62,7 +62,7 @@
   push(plugin->isActive());
 
   /* MODULE_NAME */
-  push();
+  push(plugin->getModuleName());
 
   it++;
 

=== modified file 'plugin/registry_dictionary/plugins.h'
--- plugin/registry_dictionary/plugins.h	2010-02-16 00:36:58 +0000
+++ plugin/registry_dictionary/plugins.h	2010-03-06 02:08:13 +0000
@@ -29,8 +29,8 @@
 
   class Generator : public drizzled::plugin::TableFunction::Generator 
   {
-    std::map<std::string, const drizzled::plugin::Plugin *>::const_iterator it;
-    std::map<std::string, const drizzled::plugin::Plugin *>::const_iterator end;
+    std::map<std::string, drizzled::plugin::Plugin *>::const_iterator it;
+    std::map<std::string, drizzled::plugin::Plugin *>::const_iterator end;
 
   public:
     Generator(drizzled::Field **arg);

=== modified file 'plugin/reverse_function/reverse_function.cc'
--- plugin/reverse_function/reverse_function.cc	2010-02-23 21:26:50 +0000
+++ plugin/reverse_function/reverse_function.cc	2010-03-06 02:08:13 +0000
@@ -93,20 +93,13 @@
 
 plugin::Create_function<ReverseFunction> *reverse_function= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   reverse_function= new plugin::Create_function<ReverseFunction>("reverse");
-  registry.add(reverse_function);
+  context.add(reverse_function);
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-   registry.remove(reverse_function);
-   delete reverse_function;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -116,7 +109,6 @@
   "reverses a string",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/rot13/rot13.cc'
--- plugin/rot13/rot13.cc	2010-02-18 04:43:04 +0000
+++ plugin/rot13/rot13.cc	2010-03-06 02:08:13 +0000
@@ -80,24 +80,17 @@
 };
 
 using plugin::Create_function;
-using plugin::Registry;
+using plugin::Context;
 typedef Create_function<Function> PluginFunction;
 PluginFunction *rot13_func= NULL;
 
-static int init(Registry &registry)
+static int init(Context &context)
 {
   rot13_func= new PluginFunction(rot13::name);
-  registry.add(rot13_func);
-  return 0;
-}
-
-static int deinit(Registry &registry)
-{
-  registry.remove(rot13_func);
-  delete rot13_func;
+  context.add(rot13_func);
   return 0;
 }
 
 } /* namespace rot13 */
 
-DRIZZLE_PLUGIN(rot13::init, rot13::deinit, NULL);
+DRIZZLE_PLUGIN(rot13::init, NULL);

=== modified file 'plugin/schema_dictionary/columns.cc'
--- plugin/schema_dictionary/columns.cc	2010-03-17 12:11:42 +0000
+++ plugin/schema_dictionary/columns.cc	2010-03-23 04:40:43 +0000
@@ -62,11 +62,6 @@
   column_iterator(0),
   is_columns_primed(false)
 {
-  Session *session= current_session;
-  drizzled::statement::Select *select= static_cast<statement::Select *>(session->lex->statement);
-
-  setSchemaPredicate(select->getShowSchema());
-  setTablePredicate(select->getShowTable());
 }
 
 

=== modified file 'plugin/schema_dictionary/dictionary.cc'
--- plugin/schema_dictionary/dictionary.cc	2010-03-05 22:56:46 +0000
+++ plugin/schema_dictionary/dictionary.cc	2010-03-10 18:22:56 +0000
@@ -38,7 +38,7 @@
 static ShowTemporaryTables *show_temporary_tables;
 
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   columns= new(std::nothrow)ColumnsTool;
   index_parts= new(std::nothrow)IndexPartsTool;
@@ -54,55 +54,23 @@
   table_status= new(std::nothrow)ShowTableStatus;
   tables= new(std::nothrow)TablesTool;
 
-  registry.add(columns);
-  registry.add(index_parts);
-  registry.add(indexes);
-  registry.add(local_tables);
-  registry.add(referential_constraints);
-  registry.add(schema_names);
-  registry.add(schemas);
-  registry.add(show_columns);
-  registry.add(show_indexes);
-  registry.add(show_temporary_tables);
-  registry.add(table_constraints);
-  registry.add(table_status);
-  registry.add(tables);
+  context.add(columns);
+  context.add(index_parts);
+  context.add(indexes);
+  context.add(local_tables);
+  context.add(referential_constraints);
+  context.add(schema_names);
+  context.add(schemas);
+  context.add(show_columns);
+  context.add(show_indexes);
+  context.add(show_temporary_tables);
+  context.add(table_constraints);
+  context.add(table_status);
+  context.add(tables);
   
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(columns);
-  registry.remove(index_parts);
-  registry.remove(indexes);
-  registry.remove(local_tables);
-  registry.remove(referential_constraints);
-  registry.remove(schema_names);
-  registry.remove(schemas);
-  registry.remove(show_columns);
-  registry.remove(show_indexes);
-  registry.remove(show_temporary_tables);
-  registry.remove(table_constraints);
-  registry.remove(table_status);
-  registry.remove(tables);
-  delete columns;
-  delete index_parts;
-  delete indexes;
-  delete local_tables;
-  delete referential_constraints;
-  delete schema_names;
-  delete schemas;
-  delete show_columns;
-  delete show_indexes;
-  delete show_temporary_tables;
-  delete table_constraints;
-  delete table_status;
-  delete tables;
-
-  return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -112,7 +80,6 @@
   "Data Dictionary for schema, table, column, indexes, etc",
   PLUGIN_LICENSE_GPL,
   init,
-  finalize,
   NULL,
   NULL
 }

=== modified file 'plugin/schema_dictionary/index_parts.cc'
--- plugin/schema_dictionary/index_parts.cc	2010-03-02 17:58:59 +0000
+++ plugin/schema_dictionary/index_parts.cc	2010-03-23 04:40:43 +0000
@@ -46,11 +46,6 @@
   index_part_iterator(0),
   is_index_part_primed(false)
 {
-  Session *session= current_session;
-  drizzled::statement::Select *select= static_cast<statement::Select *>(session->lex->statement);
-
-  setSchemaPredicate(select->getShowSchema());
-  setTablePredicate(select->getShowTable());
 }
 
 

=== modified file 'plugin/schema_dictionary/plugin.ini'
--- plugin/schema_dictionary/plugin.ini	2010-03-09 22:42:17 +0000
+++ plugin/schema_dictionary/plugin.ini	2010-03-23 03:07:21 +0000
@@ -12,6 +12,7 @@
   show_columns.cc
   show_indexes.cc
   show_table_status.cc
+  show_tables.cc
   show_temporary_tables.cc
   table_constraints.cc
   tables.cc

=== modified file 'plugin/schema_dictionary/schemas.cc'
--- plugin/schema_dictionary/schemas.cc	2010-03-16 23:42:10 +0000
+++ plugin/schema_dictionary/schemas.cc	2010-03-23 23:51:16 +0000
@@ -48,9 +48,6 @@
   if (isWild(schema_name()))
     return true;
 
-  if (not schema_predicate.empty() && schema_predicate.compare(schema_name()))
-    return true;
-
   return false;
 }
 

=== modified file 'plugin/schema_dictionary/schemas.h'
--- plugin/schema_dictionary/schemas.h	2010-02-19 00:48:09 +0000
+++ plugin/schema_dictionary/schemas.h	2010-03-23 23:51:16 +0000
@@ -40,7 +40,6 @@
     drizzled::message::Schema schema;
     std::set<std::string> schema_names;
     std::set<std::string>::const_iterator schema_iterator;
-    std::string schema_predicate;
     bool is_schema_primed;
     bool is_schema_parsed;
 
@@ -56,11 +55,6 @@
       return is_schema_parsed ? schema.name() : (*schema_iterator);
     }
 
-    void setSchemaPredicate(const std::string &arg)
-    {
-      schema_predicate= arg;
-    }
-
     bool populate();
     bool nextSchemaCore();
     bool nextSchema();

=== added file 'plugin/schema_dictionary/show_tables.cc'
--- plugin/schema_dictionary/show_tables.cc	1970-01-01 00:00:00 +0000
+++ plugin/schema_dictionary/show_tables.cc	2010-03-23 03:07:21 +0000
@@ -0,0 +1,108 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#include "config.h"
+#include "plugin/schema_dictionary/dictionary.h"
+#include "drizzled/table_identifier.h"
+
+using namespace std;
+using namespace drizzled;
+
+ShowTables::ShowTables() :
+  plugin::TableFunction("DATA_DICTIONARY", "SHOW_TABLES")
+{
+  add_field("TABLE_NAME");
+}
+
+ShowTables::Generator::Generator(drizzled::Field **arg) :
+  drizzled::plugin::TableFunction::Generator(arg),
+  is_primed(false)
+{
+  Session *session= current_session;
+  statement::Select *select= static_cast<statement::Select *>(session->lex->statement);
+
+  schema_name.append(select->getShowSchema());
+  assert(not schema_name.empty());
+}
+
+bool ShowTables::Generator::nextCore()
+{
+  if (is_primed)
+  {
+    table_iterator++;
+  }
+  else
+  {
+    plugin::StorageEngine::getTableNames(schema_name, table_names);
+    table_iterator= table_names.begin();
+    is_primed= true;
+  }
+
+  if (table_iterator == table_names.end())
+    return false;
+
+  table_message.Clear();
+  {
+    Session *session= current_session;
+    TableIdentifier identifier(schema_name, *table_iterator);
+
+    if (not plugin::StorageEngine::getTableDefinition(*session,
+                                                      identifier,
+                                                      table_message))
+    {
+      return false;
+    }
+  }
+
+  if (isWild(*table_iterator))
+    return false;
+
+  return true;
+}
+
+bool ShowTables::Generator::next()
+{
+  while (not nextCore())
+  {
+    if (table_iterator != table_names.end())
+      continue;
+
+    return false;
+  }
+
+  return true;
+}
+
+bool ShowTables::Generator::populate()
+{
+  if (not next())
+    return false;
+  
+  fill();
+
+  return true;
+}
+
+void ShowTables::Generator::fill()
+{
+  /* TABLE_NAME */
+  push(*table_iterator);
+}

=== modified file 'plugin/schema_dictionary/show_tables.h'
--- plugin/schema_dictionary/show_tables.h	2010-03-02 02:07:48 +0000
+++ plugin/schema_dictionary/show_tables.h	2010-03-23 03:07:21 +0000
@@ -22,33 +22,27 @@
 #define PLUGIN_SCHEMA_DICTIONARY_SHOW_TABLES_H
 
 
-class ShowTables : public TablesTool
+class ShowTables : public drizzled::plugin::TableFunction
 {
 public:
-  ShowTables(const char *table_arg) :
-    TablesTool(table_arg)
-  { }
-
-  ShowTables() :
-    TablesTool("SHOW_TABLES")
-  {
-    add_field("TABLE_NAME");
-  }
-
-  class Generator : public TablesTool::Generator 
-  {
-    void fill()
-    {
-      /* TABLE_NAME */
-      push(table_name());
-    }
-
-    bool checkSchema();
+  ShowTables();
+
+  class Generator : public drizzled::plugin::TableFunction::Generator
+  {
+    bool is_primed;
+    drizzled::message::Table table_message;
+    std::set<std::string> table_names;
+    std::set<std::string>::iterator table_iterator;
+    std::string schema_name;
+
+    void fill();
+    bool next();
+    bool nextCore();
 
   public:
-    Generator(drizzled::Field **arg) :
-      TablesTool::Generator(arg)
-    { }
+    Generator(drizzled::Field **arg);
+
+    bool populate();
   };
 
   Generator *generator(drizzled::Field **arg)

=== modified file 'plugin/schema_dictionary/tables.cc'
--- plugin/schema_dictionary/tables.cc	2010-03-19 01:45:39 +0000
+++ plugin/schema_dictionary/tables.cc	2010-03-23 04:40:43 +0000
@@ -100,9 +100,6 @@
                                              table_proto);
   }
 
-  if (checkTableName())
-    return false;
-
   return true;
 }
 
@@ -116,23 +113,13 @@
 
     if (not nextSchema())
       return false;
+
     is_tables_primed= false;
   }
 
   return true;
 }
 
-bool TablesTool::Generator::checkTableName()
-{
-  if (isWild(table_name()))
-    return true;
-
-  if (not table_predicate.empty() && table_predicate.compare(table_name()))
-    return true;
-
-  return false;
-}
-
 bool TablesTool::Generator::populate()
 {
   if (not nextTable())
@@ -270,14 +257,3 @@
   /* TABLE_COMMENT */
   push(table_proto.options().comment());
 }
-
-bool ShowTables::Generator::checkSchema()
-{
-  Session *session= current_session;
-
-  if (session->lex->select_lex.db)
-  {
-    return schema_name().compare(session->lex->select_lex.db);
-  }
-  return session->db.compare(schema_name());
-}

=== modified file 'plugin/schema_dictionary/tables.h'
--- plugin/schema_dictionary/tables.h	2010-03-02 02:07:48 +0000
+++ plugin/schema_dictionary/tables.h	2010-03-23 04:40:43 +0000
@@ -40,7 +40,6 @@
     drizzled::message::Table table_proto;
     std::set<std::string> table_names;
     std::set<std::string>::iterator table_iterator;
-    std::string table_predicate;
     bool is_tables_primed;
 
     virtual void fill();
@@ -67,14 +66,8 @@
       return is_tables_primed;
     }
 
-    void setTablePredicate(const std::string &arg)
-    {
-      table_predicate= arg;
-    }
-
     bool populate();
     bool nextTable();
-    bool checkTableName();
   };
 
   Generator *generator(drizzled::Field **arg)

=== modified file 'plugin/schema_engine/plugin.cc'
--- plugin/schema_engine/plugin.cc	2010-02-19 23:42:02 +0000
+++ plugin/schema_engine/plugin.cc	2010-03-06 02:08:13 +0000
@@ -29,7 +29,7 @@
 
 static drizzled::plugin::StorageEngine *schema_plugin= NULL;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   schema_plugin= new(std::nothrow) Schema();
 
@@ -38,15 +38,7 @@
     return 1;
   }
 
-  registry.add(schema_plugin);
-
-  return 0;
-}
-
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(schema_plugin);
-  delete schema_plugin;
+  context.add(schema_plugin);
 
   return 0;
 }
@@ -60,7 +52,6 @@
   "This implements the default file based Schema engine.",
   PLUGIN_LICENSE_GPL,
   init,     /* Plugin Init */
-  finalize,     /* Plugin Deinit */
   NULL,               /* system variables */
   NULL                /* config options   */
 }

=== modified file 'plugin/schema_engine/schema.cc'
--- plugin/schema_engine/schema.cc	2010-03-19 04:54:45 +0000
+++ plugin/schema_engine/schema.cc	2010-03-23 23:08:36 +0000
@@ -253,10 +253,17 @@
   }
 
   if (unlink(schema_file.c_str()))
+  {
     perror(schema_file.c_str());
+    return false;
+  }
 
   if (rmdir(path.c_str()))
+  {
     perror(path.c_str());
+    CachedDirectory dir(path);
+    cerr << dir;
+  }
 
   if (not pthread_rwlock_wrlock(&schema_lock))
   {
@@ -328,12 +335,15 @@
   int fd= mkstemp(schema_file_tmp);
 
   if (fd == -1)
+  {
+    perror(schema_file_tmp);
     return false;
+  }
 
   if (not db.SerializeToFileDescriptor(fd))
   {
+    cerr << "Couldn't write " << path << "\n";
     close(fd);
-    unlink(schema_file_tmp);
 
     return false;
   }
@@ -405,7 +415,7 @@
 
 bool Schema::doCanCreateTable(const drizzled::TableIdentifier &identifier)
 {
-  if (not strcasecmp(identifier.getSchemaName().c_str(), "temporary_tables"))
+  if (not strcasecmp(identifier.getSchemaName().c_str(), "temporary"))
   {
     return false;
   }

=== modified file 'plugin/schema_engine/schema.h'
--- plugin/schema_engine/schema.h	2010-03-19 01:17:11 +0000
+++ plugin/schema_engine/schema.h	2010-03-24 00:04:32 +0000
@@ -90,6 +90,11 @@
 
   bool doDoesTableExist(drizzled::Session& session, drizzled::TableIdentifier &identifier);
 
+  int doRenameTable(drizzled::Session&, drizzled::TableIdentifier &, drizzled::TableIdentifier &)
+  {
+    return EPERM;
+  }
+
   const char **bas_ext() const 
   {
     return schema_exts;

=== modified file 'plugin/schema_engine/tests/r/exists.result'
--- plugin/schema_engine/tests/r/exists.result	2010-02-19 23:42:02 +0000
+++ plugin/schema_engine/tests/r/exists.result	2010-03-24 05:40:58 +0000
@@ -1,3 +1,3 @@
 select * from data_dictionary.plugins WHERE PLUGIN_TYPE="storageengine" AND PLUGIN_NAME="schema";
 PLUGIN_NAME	PLUGIN_TYPE	IS_ACTIVE	MODULE_NAME
-schema	StorageEngine	TRUE	
+schema	StorageEngine	TRUE	SchemaEngine

=== modified file 'plugin/session_dictionary/dictionary.cc'
--- plugin/session_dictionary/dictionary.cc	2010-02-18 04:43:04 +0000
+++ plugin/session_dictionary/dictionary.cc	2010-03-06 02:08:13 +0000
@@ -25,22 +25,14 @@
 
 static ProcesslistTool *processlist;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   processlist= new(std::nothrow)ProcesslistTool;
-  registry.add(processlist);
+  context.add(processlist);
   
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(processlist);
-  delete processlist;
-
-  return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -50,7 +42,6 @@
   "Dictionary for session information, aka proccesslist, etc.",
   PLUGIN_LICENSE_GPL,
   init,
-  finalize,
   NULL,
   NULL
 }

=== modified file 'plugin/show_schema_proto/show_schema_proto.cc'
--- plugin/show_schema_proto/show_schema_proto.cc	2010-02-24 18:40:29 +0000
+++ plugin/show_schema_proto/show_schema_proto.cc	2010-03-06 02:08:13 +0000
@@ -105,17 +105,10 @@
 
 plugin::Create_function<ShowSchemaProtoFunction> *show_schema_proto_func= NULL;
 
-static int initialize(plugin::Registry &registry)
+static int initialize(plugin::Context &context)
 {
   show_schema_proto_func= new plugin::Create_function<ShowSchemaProtoFunction>("show_schema_proto");
-  registry.add(show_schema_proto_func);
-  return 0;
-}
-
-static int finalize(plugin::Registry &registry)
-{
-  registry.remove(show_schema_proto_func);
-  delete show_schema_proto_func;
+  context.add(show_schema_proto_func);
   return 0;
 }
 
@@ -128,7 +121,6 @@
   "Shows text representation of schema definition proto",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/signal_handler/signal_handler.cc'
--- plugin/signal_handler/signal_handler.cc	2010-02-18 04:43:04 +0000
+++ plugin/signal_handler/signal_handler.cc	2010-03-06 02:08:13 +0000
@@ -22,6 +22,7 @@
 #include "drizzled/pthread_globals.h"
 #include "drizzled/internal/my_pthread.h"
 #include "drizzled/internal/my_sys.h"
+#include "drizzled/plugin/daemon.h"
 
 #include <sys/stat.h>
 #include <fcntl.h>
@@ -199,69 +200,82 @@
   }
 }
 
-
-static int init(drizzled::plugin::Registry&)
+class SignalHandler :
+  public drizzled::plugin::Daemon
 {
-  int error;
-  pthread_attr_t thr_attr;
-  size_t my_thread_stack_size= 65536;
-
-  (void) pthread_attr_init(&thr_attr);
-  pthread_attr_setscope(&thr_attr, PTHREAD_SCOPE_SYSTEM);
-  (void) pthread_attr_setdetachstate(&thr_attr, PTHREAD_CREATE_DETACHED);
+  SignalHandler(const SignalHandler &);
+  SignalHandler& operator=(const SignalHandler &);
+public:
+  SignalHandler()
+    : drizzled::plugin::Daemon("Signal Handler")
   {
-    struct sched_param tmp_sched_param;
-
-    memset(&tmp_sched_param, 0, sizeof(tmp_sched_param));
-    tmp_sched_param.sched_priority= INTERRUPT_PRIOR;
-    (void)pthread_attr_setschedparam(&thr_attr, &tmp_sched_param);
-  }
+    int error;
+    pthread_attr_t thr_attr;
+    size_t my_thread_stack_size= 65536;
+
+    (void) pthread_attr_init(&thr_attr);
+    pthread_attr_setscope(&thr_attr, PTHREAD_SCOPE_SYSTEM);
+    (void) pthread_attr_setdetachstate(&thr_attr, PTHREAD_CREATE_DETACHED);
+    {
+      struct sched_param tmp_sched_param;
+
+      memset(&tmp_sched_param, 0, sizeof(tmp_sched_param));
+      tmp_sched_param.sched_priority= INTERRUPT_PRIOR;
+      (void)pthread_attr_setschedparam(&thr_attr, &tmp_sched_param);
+    }
 #if defined(__ia64__) || defined(__ia64)
-  /*
-    Peculiar things with ia64 platforms - it seems we only have half the
-    stack size in reality, so we have to double it here
-  */
-  pthread_attr_setstacksize(&thr_attr, my_thread_stack_size*2);
+    /*
+      Peculiar things with ia64 platforms - it seems we only have half the
+      stack size in reality, so we have to double it here
+    */
+    pthread_attr_setstacksize(&thr_attr, my_thread_stack_size*2);
 # else
-  pthread_attr_setstacksize(&thr_attr, my_thread_stack_size);
+    pthread_attr_setstacksize(&thr_attr, my_thread_stack_size);
 #endif
 
-  (void) pthread_mutex_lock(&LOCK_thread_count);
-  if ((error=pthread_create(&signal_thread, &thr_attr, signal_hand, 0)))
-  {
-      errmsg_printf(ERRMSG_LVL_ERROR, _("Can't create interrupt-thread (error %d, errno: %d)"),
+    (void) pthread_mutex_lock(&LOCK_thread_count);
+    if ((error=pthread_create(&signal_thread, &thr_attr, signal_hand, 0)))
+    {
+      errmsg_printf(ERRMSG_LVL_ERROR,
+                    _("Can't create interrupt-thread (error %d, errno: %d)"),
                     error,errno);
-    exit(1);
+      exit(1);
+    }
+    (void) pthread_cond_wait(&COND_thread_count,&LOCK_thread_count);
+    pthread_mutex_unlock(&LOCK_thread_count);
+
+    (void) pthread_attr_destroy(&thr_attr);
   }
-  (void) pthread_cond_wait(&COND_thread_count,&LOCK_thread_count);
-  pthread_mutex_unlock(&LOCK_thread_count);
-
-  (void) pthread_attr_destroy(&thr_attr);
-
-  return 0;
-}
-
-/**
-  This is mainly needed when running with purify, but it's still nice to
-  know that all child threads have died when drizzled exits.
-*/
-static int deinit(drizzled::plugin::Registry&)
-{
-  uint32_t i;
-  /*
-    Wait up to 10 seconds for signal thread to die. We use this mainly to
-    avoid getting warnings that internal::my_thread_end has not been called
+
+  /**
+    This is mainly needed when running with purify, but it's still nice to
+    know that all child threads have died when drizzled exits.
   */
-  for (i= 0 ; i < 100 && signal_thread_in_use; i++)
+  ~SignalHandler()
   {
-    if (pthread_kill(signal_thread, SIGTERM) != ESRCH)
-      break;
-    usleep(100);				// Give it time to die
+    uint32_t i;
+    /*
+      Wait up to 10 seconds for signal thread to die. We use this mainly to
+      avoid getting warnings that internal::my_thread_end has not been called
+    */
+    for (i= 0 ; i < 100 && signal_thread_in_use; i++)
+    {
+      if (pthread_kill(signal_thread, SIGTERM) != ESRCH)
+        break;
+      usleep(100);				// Give it time to die
+    }
+
   }
+};
 
+static int init(drizzled::plugin::Context& context)
+{
+  SignalHandler *handler= new SignalHandler;
+  context.add(handler);
   return 0;
 }
 
+
 static drizzle_sys_var* system_variables[]= {
   NULL
 };
@@ -275,7 +289,6 @@
   "Default Signal Handler",
   PLUGIN_LICENSE_GPL,
   init, /* Plugin Init */
-  deinit, /* Plugin Deinit */
   system_variables,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/single_thread/single_thread.cc'
--- plugin/single_thread/single_thread.cc	2010-02-18 04:43:04 +0000
+++ plugin/single_thread/single_thread.cc	2010-03-06 02:08:13 +0000
@@ -24,18 +24,10 @@
 static SingleThreadScheduler *scheduler= NULL;
 
 
-static int init(plugin::Registry &registry)
+static int init(plugin::Context &context)
 {
   scheduler= new SingleThreadScheduler("single_thread");
-  registry.add(scheduler);
-  return 0;
-}
-
-static int deinit(plugin::Registry &registry)
-{
-  registry.remove(scheduler);
-  delete scheduler;
-
+  context.add(scheduler);
   return 0;
 }
 
@@ -48,7 +40,6 @@
   "Single Thread Scheduler",
   PLUGIN_LICENSE_GPL,
   init, /* Plugin Init */
-  deinit, /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/sleep/sleep.cc'
--- plugin/sleep/sleep.cc	2010-02-18 04:43:04 +0000
+++ plugin/sleep/sleep.cc	2010-03-06 02:08:13 +0000
@@ -128,21 +128,12 @@
 
 plugin::Create_function<Item_func_sleep> *sleep_udf= NULL;
 
-static int sleep_plugin_init(drizzled::plugin::Registry &registry)
+static int sleep_plugin_init(drizzled::plugin::Context &context)
 {
   sleep_udf= new plugin::Create_function<Item_func_sleep>("sleep");
-  registry.add(sleep_udf);
-
-  return 0;
-}
-
-static int sleep_plugin_deinit(drizzled::plugin::Registry &registry)
-{
-  registry.remove(sleep_udf);
-  delete sleep_udf;
-
-  return 0;
-}
-
-
-DRIZZLE_PLUGIN(sleep_plugin_init, sleep_plugin_deinit, NULL);
+  context.add(sleep_udf);
+
+  return 0;
+}
+
+DRIZZLE_PLUGIN(sleep_plugin_init, NULL);

=== modified file 'plugin/status_dictionary/dictionary.cc'
--- plugin/status_dictionary/dictionary.cc	2010-02-18 04:43:04 +0000
+++ plugin/status_dictionary/dictionary.cc	2010-03-06 02:08:13 +0000
@@ -31,7 +31,7 @@
 static VariablesTool *session_variables;
 
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   global_statements= new(std::nothrow)StatementsTool(true);
   global_status= new(std::nothrow)StatusTool(true);
@@ -40,35 +40,16 @@
   global_variables= new(std::nothrow)VariablesTool(true);
   session_variables= new(std::nothrow)VariablesTool(false);
 
-  registry.add(global_statements);
-  registry.add(global_status);
-  registry.add(global_variables);
-  registry.add(session_statements);
-  registry.add(session_status);
-  registry.add(session_variables);
+  context.add(global_statements);
+  context.add(global_status);
+  context.add(global_variables);
+  context.add(session_statements);
+  context.add(session_status);
+  context.add(session_variables);
   
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(global_statements);
-  registry.remove(global_status);
-  registry.remove(global_variables);
-  registry.remove(session_statements);
-  registry.remove(session_status);
-  registry.remove(session_variables);
-
-  delete global_statements;
-  delete global_status;
-  delete global_variables;
-  delete session_statements;
-  delete session_status;
-  delete session_variables;
-
-  return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -78,7 +59,6 @@
   "Dictionary for status, statement, and variable information.",
   PLUGIN_LICENSE_GPL,
   init,
-  finalize,
   NULL,
   NULL
 }

=== modified file 'plugin/status_dictionary/status.cc'
--- plugin/status_dictionary/status.cc	2010-02-18 02:09:52 +0000
+++ plugin/status_dictionary/status.cc	2010-03-23 23:47:38 +0000
@@ -154,7 +154,7 @@
     value= ((char *) status_var + (ulong) value);
     /* fall through */
   case SHOW_LONG:
-    oss << *(int64_t*) value;
+    oss << *(long*) value;
     return_value= oss.str();
     break;
   case SHOW_LONGLONG_STATUS:

=== modified file 'plugin/substr_functions/substr_functions.cc'
--- plugin/substr_functions/substr_functions.cc	2010-02-23 21:26:50 +0000
+++ plugin/substr_functions/substr_functions.cc	2010-03-06 02:08:13 +0000
@@ -258,24 +258,15 @@
 plugin::Create_function<SubstrFunction> *substr_function= NULL;
 plugin::Create_function<SubstrIndexFunction> *substr_index_function= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   substr_function= new plugin::Create_function<SubstrFunction>("substr");
   substr_index_function= new plugin::Create_function<SubstrIndexFunction>("substring_index");
-  registry.add(substr_function);
-  registry.add(substr_index_function);
+  context.add(substr_function);
+  context.add(substr_index_function);
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-   registry.remove(substr_function);
-   registry.remove(substr_index_function);
-   delete substr_function;
-   delete substr_index_function;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -285,7 +276,6 @@
   "SUBSTR and SUBSTR",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/table_cache_dictionary/dictionary.cc'
--- plugin/table_cache_dictionary/dictionary.cc	2010-03-15 21:50:05 +0000
+++ plugin/table_cache_dictionary/dictionary.cc	2010-03-16 20:32:51 +0000
@@ -27,28 +27,17 @@
 static table_cache_dictionary::TableDefinitionCache *table_definitions;
 
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   table_definitions= new(std::nothrow)table_cache_dictionary::TableDefinitionCache;
   tables_in_cache= new(std::nothrow)table_cache_dictionary::TableCache;
 
-  registry.add(table_definitions);
-  registry.add(tables_in_cache);
+  context.add(table_definitions);
+  context.add(tables_in_cache);
   
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-  registry.remove(table_definitions);
-  registry.remove(tables_in_cache);
-
-  delete table_definitions;
-  delete tables_in_cache;
-
-  return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -58,7 +47,6 @@
   "Data Dictionary for table and table definition cache.",
   PLUGIN_LICENSE_GPL,
   init,
-  finalize,
   NULL,
   NULL
 }

=== modified file 'plugin/tableprototester/tableprototester.cc'
--- plugin/tableprototester/tableprototester.cc	2010-03-19 04:54:45 +0000
+++ plugin/tableprototester/tableprototester.cc	2010-03-24 00:04:32 +0000
@@ -102,6 +102,11 @@
   }
 
   bool doDoesTableExist(Session& session, TableIdentifier &identifier);
+
+  int doRenameTable(Session&, TableIdentifier &, TableIdentifier &)
+  {
+    return EPERM;
+  }
 };
 
 
@@ -262,19 +267,11 @@
 
 static drizzled::plugin::StorageEngine *tableprototester_engine= NULL;
 
-static int tableprototester_init(drizzled::plugin::Registry &registry)
+static int tableprototester_init(drizzled::plugin::Context &context)
 {
 
   tableprototester_engine= new TableProtoTesterEngine("TABLEPROTOTESTER");
-  registry.add(tableprototester_engine);
-
-  return 0;
-}
-
-static int tableprototester_fini(drizzled::plugin::Registry &registry)
-{
-  registry.remove(tableprototester_engine);
-  delete tableprototester_engine;
+  context.add(tableprototester_engine);
 
   return 0;
 }
@@ -288,7 +285,6 @@
   "Used to test rest of server with various table proto messages",
   PLUGIN_LICENSE_GPL,
   tableprototester_init,     /* Plugin Init */
-  tableprototester_fini,     /* Plugin Deinit */
   NULL,               /* system variables */
   NULL                /* config options   */
 }

=== modified file 'plugin/test_authz/test_authz.cc'
--- plugin/test_authz/test_authz.cc	2010-03-02 18:59:12 +0000
+++ plugin/test_authz/test_authz.cc	2010-03-06 02:08:13 +0000
@@ -63,20 +63,13 @@
 
 Authz *authz= NULL;
 
-static int init(plugin::Registry &registry)
+static int init(plugin::Context &context)
 {
   authz= new Authz();
-  registry.add(authz);
-  return 0;
-}
-
-static int deinit(plugin::Registry &registry)
-{
-  registry.remove(authz);
-  delete authz;
+  context.add(authz);
   return 0;
 }
 
 } /* namespace authz */
 
-DRIZZLE_PLUGIN(authz::init, authz::deinit, NULL);
+DRIZZLE_PLUGIN(authz::init, NULL);

=== modified file 'plugin/transaction_log/module.cc'
--- plugin/transaction_log/module.cc	2010-03-11 01:20:28 +0000
+++ plugin/transaction_log/module.cc	2010-03-15 22:27:00 +0000
@@ -93,7 +93,7 @@
 extern plugin::Create_function<PrintTransactionMessageFunction> *print_transaction_message_func_factory;
 extern plugin::Create_function<HexdumpTransactionMessageFunction> *hexdump_transaction_message_func_factory;
 
-static int init(drizzled::plugin::Registry &registry)
+static int init(drizzled::plugin::Context &context)
 {
   /* Create and initialize the transaction log itself */
   if (sysvar_transaction_log_enabled)
@@ -127,25 +127,25 @@
                     strerror(errno));
       return 1;
     }
-    registry.add(transaction_log_applier);
+    context.add(transaction_log_applier);
 
     /* Setup DATA_DICTIONARY views */
 
     transaction_log_tool= new (nothrow) TransactionLogTool;
-    registry.add(transaction_log_tool);
+    context.add(transaction_log_tool);
     transaction_log_entries_tool= new (nothrow) TransactionLogEntriesTool;
-    registry.add(transaction_log_entries_tool);
+    context.add(transaction_log_entries_tool);
     transaction_log_transactions_tool= new (nothrow) TransactionLogTransactionsTool;
-    registry.add(transaction_log_transactions_tool);
+    context.add(transaction_log_transactions_tool);
 
     /* Setup the module's UDFs */
     print_transaction_message_func_factory=
       new plugin::Create_function<PrintTransactionMessageFunction>("print_transaction_message");
-    registry.add(print_transaction_message_func_factory);
+    context.add(print_transaction_message_func_factory);
 
     hexdump_transaction_message_func_factory=
       new plugin::Create_function<HexdumpTransactionMessageFunction>("hexdump_transaction_message");
-    registry.add(hexdump_transaction_message_func_factory);
+    context.add(hexdump_transaction_message_func_factory);
 
     /* Create and initialize the transaction log index */
     transaction_log_index= new (nothrow) TransactionLogIndex(*transaction_log);
@@ -176,33 +176,6 @@
   return 0;
 }
 
-static int deinit(drizzled::plugin::Registry &registry)
-{
-  /* Cleanup the transaction log itself */
-  if (transaction_log)
-  {
-    registry.remove(transaction_log_applier);
-    delete transaction_log_applier;
-    delete transaction_log;
-    delete transaction_log_index;
-
-    /* Cleanup the DATA_DICTIONARY views */
-    registry.remove(transaction_log_tool);
-    delete transaction_log_tool;
-    registry.remove(transaction_log_entries_tool);
-    delete transaction_log_entries_tool;
-    registry.remove(transaction_log_transactions_tool);
-    delete transaction_log_transactions_tool;
-
-    /* Cleanup module UDFs */
-    registry.remove(print_transaction_message_func_factory);
-    delete print_transaction_message_func_factory;
-    registry.remove(hexdump_transaction_message_func_factory);
-    delete hexdump_transaction_message_func_factory;
-  }
-
-  return 0;
-}
 
 static void set_truncate_debug(Session *,
                                drizzle_sys_var *, 
@@ -277,4 +250,4 @@
   NULL
 };
 
-DRIZZLE_PLUGIN(init, deinit, sys_variables);
+DRIZZLE_PLUGIN(init, sys_variables);

=== modified file 'plugin/user_function/user_function.cc'
--- plugin/user_function/user_function.cc	2010-03-18 11:20:28 +0000
+++ plugin/user_function/user_function.cc	2010-03-20 08:22:31 +0000
@@ -97,20 +97,13 @@
 
 plugin::Create_function<UserFunction> *user_function= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   user_function= new plugin::Create_function<UserFunction>("user");
-  registry.add(user_function);
+  context.add(user_function);
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-   registry.remove(user_function);
-   delete user_function;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -120,7 +113,6 @@
   "USER() and CURRENT_USER()",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/uuid_function/uuid_function.cc'
--- plugin/uuid_function/uuid_function.cc	2010-02-23 21:26:50 +0000
+++ plugin/uuid_function/uuid_function.cc	2010-03-06 02:08:13 +0000
@@ -63,20 +63,13 @@
 
 plugin::Create_function<UuidFunction> *uuid_function= NULL;
 
-static int initialize(drizzled::plugin::Registry &registry)
+static int initialize(drizzled::plugin::Context &context)
 {
   uuid_function= new plugin::Create_function<UuidFunction>("uuid");
-  registry.add(uuid_function);
+  context.add(uuid_function);
   return 0;
 }
 
-static int finalize(drizzled::plugin::Registry &registry)
-{
-   registry.remove(uuid_function);
-   delete uuid_function;
-   return 0;
-}
-
 DRIZZLE_DECLARE_PLUGIN
 {
   DRIZZLE_VERSION_ID,
@@ -86,7 +79,6 @@
   "UUID() function using libuuid",
   PLUGIN_LICENSE_GPL,
   initialize, /* Plugin Init */
-  finalize,   /* Plugin Deinit */
   NULL,   /* system variables */
   NULL    /* config options */
 }

=== modified file 'plugin/version/versionudf.cc'
--- plugin/version/versionudf.cc	2010-02-18 04:43:04 +0000
+++ plugin/version/versionudf.cc	2010-03-06 02:08:13 +0000
@@ -53,18 +53,11 @@
 
 plugin::Create_function<VersionFunction> *versionudf= NULL;
 
-static int initialize(plugin::Registry &registry)
+static int initialize(plugin::Context &context)
 {
   versionudf= new plugin::Create_function<VersionFunction>("version");
-  registry.add(versionudf);
+  context.add(versionudf);
   return 0;
 }
 
-static int finalize(plugin::Registry &registry)
-{
-   registry.remove(versionudf);
-   delete versionudf;
-   return 0;
-}
-
-DRIZZLE_PLUGIN(initialize, finalize, NULL);
+DRIZZLE_PLUGIN(initialize, NULL);

=== modified file 'tests/lib/mtr_report.pl'
--- tests/lib/mtr_report.pl	2009-08-04 19:06:17 +0000
+++ tests/lib/mtr_report.pl	2010-03-23 12:13:39 +0000
@@ -59,7 +59,7 @@
   if ($::opt_subunit) {
     printf "test: $tname\n";
   } else {
-    printf "%-30s ", $tname;
+    printf "%-60s ", $tname;
   }
 }
 
@@ -121,14 +121,14 @@
   {
     $timer= mtr_fromfile("$::opt_vardir/log/timer");
     $tot_real_time += ($timer/1000);
-    $timer= sprintf "%12s", $timer;
+    $timer= sprintf "%7s", $timer;
     ### XXX: How to format this as iso6801 datetime?
   }
   $tinfo->{'result'}= 'MTR_RES_PASSED';
   if ($::opt_subunit) {
     mtr_report("success: $tname");
   } else {
-    mtr_report("[ pass ]   $timer");
+    mtr_report("[ pass ] $timer");
   }
 }
 
@@ -164,7 +164,7 @@
   if ($::opt_subunit) {
     mtr_report("failure: $tname [\n$comment\n]");
   } else {
-    mtr_report("[ fail ]   $comment");
+    mtr_report("[ fail ]\n$comment");
   }
 }
 
@@ -538,18 +538,18 @@
 ##############################################################################
 
 sub mtr_print_line () {
-  print '-' x 55, "\n";
+  print '-' x 80, "\n";
 }
 
 sub mtr_print_thick_line () {
-  print '=' x 55, "\n";
+  print '=' x 80, "\n";
 }
 
 sub mtr_print_header () {
   print "DEFAULT STORAGE ENGINE: $::opt_engine\n";
   if ( $::opt_timer )
   {
-    print "TEST                           RESULT         TIME (ms)\n";
+    printf "%-61s%-9s%10s\n","TEST","RESULT","TIME (ms)";
   }
   else
   {

=== modified file 'tests/r/alter_table.result'
--- tests/r/alter_table.result	2010-03-17 13:39:11 +0000
+++ tests/r/alter_table.result	2010-03-24 22:22:00 +0000
@@ -99,7 +99,7 @@
 name
 mysqltest
 alter table t1 rename mysqltest.t1;
-ERROR 42S01: Table 't1' already exists
+ERROR 42S01: Table 'mysqltest.t1' already exists
 select * from t1;
 name
 current
@@ -789,13 +789,13 @@
 ALTER TABLE  `t+1` RENAME `t+2`;
 CREATE TABLE `t+1` (c1 INT);
 ALTER TABLE  `t+1` RENAME `t+2`;
-ERROR 42S01: Table 't+2' already exists
+ERROR 42S01: Table 'test.t+2' already exists
 DROP TABLE   `t+1`, `t+2`;
 CREATE TEMPORARY TABLE `tt+1` (c1 INT);
 ALTER TABLE  `tt+1` RENAME `tt+2`;
 CREATE TEMPORARY TABLE `tt+1` (c1 INT);
 ALTER TABLE  `tt+1` RENAME `tt+2`;
-ERROR 42S01: Table 'tt+2' already exists
+ERROR 42S01: Table 'temporary.tt+2' already exists
 SHOW CREATE TABLE `tt+1`;
 Table	Create Table
 tt+1	CREATE TEMPORARY TABLE `tt+1` (

=== modified file 'tests/r/case.result'
--- tests/r/case.result	2009-03-25 09:18:25 +0000
+++ tests/r/case.result	2010-03-22 19:44:37 +0000
@@ -106,8 +106,8 @@
 SHOW CREATE TABLE t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `c1` varchar(1) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
-  `c2` varchar(1) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
+  `c1` varchar(1) COLLATE utf8_bin DEFAULT NULL,
+  `c2` varchar(1) COLLATE utf8_bin DEFAULT NULL,
   `c3` varbinary(4) NOT NULL,
   `c4` varbinary(4) NOT NULL,
   `c5` varbinary(4) NOT NULL,
@@ -162,7 +162,7 @@
   `COALESCE(1,1.0)` decimal(2,1) NOT NULL,
   `COALESCE(1,'1')` varbinary(4) NOT NULL,
   `COALESCE(1.1,'1')` varbinary(4) NOT NULL,
-  `COALESCE('a' COLLATE utf8_bin,'b')` varchar(1) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL
+  `COALESCE('a' COLLATE utf8_bin,'b')` varchar(1) COLLATE utf8_bin DEFAULT NULL
 ) ENGINE=DEFAULT
 DROP TABLE t1;
 SELECT 'case+union+test'

=== modified file 'tests/r/cast.result'
--- tests/r/cast.result	2009-11-13 00:56:59 +0000
+++ tests/r/cast.result	2010-03-22 23:04:11 +0000
@@ -72,17 +72,6 @@
 cast('a  ' AS char(2)) as c4,
 cast('a'   AS char(2)) as c5;
 ERROR 22007: Truncated incorrect CHAR(2) value: 'abc'
-select
-cast(''  AS char)    as c1,
-cast(' '  AS char)    as c2,
-cast('' AS char(2)) as c3,
-cast('  ' AS char(2)) as c4,
-cast(''   AS char(2)) as c5;
-c1	c2	c3	c4	c5
-	 		 	
-Warnings:
-Warning	1292	Truncated incorrect CHAR(2) value: ''
-Warning	1292	Truncated incorrect CHAR(2) value: '  '
 select cast("2001-1-1" as date) = "2001-01-01";
 cast("2001-1-1" as date) = "2001-01-01"
 1

=== modified file 'tests/r/create.result'
--- tests/r/create.result	2010-03-18 01:23:59 +0000
+++ tests/r/create.result	2010-03-22 19:44:37 +0000
@@ -556,7 +556,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `a` varchar(112) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
+  `a` varchar(112) COLLATE utf8_bin NOT NULL,
   PRIMARY KEY (`a`)
 ) ENGINE=DEFAULT
 drop table t1;
@@ -571,7 +571,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `a` varchar(12) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
+  `a` varchar(12) COLLATE utf8_bin NOT NULL,
   `b` int NOT NULL,
   PRIMARY KEY (`a`)
 ) ENGINE=DEFAULT
@@ -589,7 +589,7 @@
 Table	Create Table
 t1	CREATE TABLE `t1` (
   `b` int DEFAULT NULL,
-  `a` varchar(12) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
+  `a` varchar(12) COLLATE utf8_bin NOT NULL,
   `c` int NOT NULL,
   PRIMARY KEY (`a`)
 ) ENGINE=DEFAULT
@@ -601,7 +601,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `a` varchar(12) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
+  `a` varchar(12) COLLATE utf8_bin NOT NULL,
   `b` int NOT NULL,
   PRIMARY KEY (`a`)
 ) ENGINE=DEFAULT
@@ -613,7 +613,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `a` varchar(12) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
+  `a` varchar(12) COLLATE utf8_bin NOT NULL,
   `b` int NOT NULL,
   PRIMARY KEY (`a`)
 ) ENGINE=DEFAULT
@@ -1490,7 +1490,7 @@
   `c2` int DEFAULT NULL COMMENT 'column2',
   `c3` int NOT NULL COMMENT 'column3',
   `c4` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT 'a',
-  `c5` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT 'b',
+  `c5` varchar(255) COLLATE utf8_unicode_ci DEFAULT 'b',
   `c6` varchar(255) COLLATE utf8_bin DEFAULT NULL
 ) ENGINE=DEFAULT
 
@@ -1502,9 +1502,9 @@
   `c1` int DEFAULT '12' COMMENT 'column1',
   `c2` int DEFAULT NULL COMMENT 'column2',
   `c3` int NOT NULL COMMENT 'column3',
-  `c4` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'a',
-  `c5` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT 'b',
-  `c6` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL
+  `c4` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT 'a',
+  `c5` varchar(255) COLLATE utf8_unicode_ci DEFAULT 'b',
+  `c6` varchar(255) COLLATE utf8_bin DEFAULT NULL
 ) ENGINE=DEFAULT
 
 DROP TABLE t2;

=== added file 'tests/r/information_schema.result'
Binary files tests/r/information_schema.result and tests/r/information_schema.result differ
=== removed file 'tests/r/information_schema.result'
Binary files tests/r/information_schema.result and tests/r/information_schema.result differ
=== modified file 'tests/r/innodb.result'
--- tests/r/innodb.result	2010-03-02 21:16:40 +0000
+++ tests/r/innodb.result	2010-03-23 23:08:36 +0000
@@ -2736,7 +2736,7 @@
 INSERT INTO t2 VALUES (1);
 ALTER TABLE t2 ADD FOREIGN KEY (a) REFERENCES t1 (a) ON DELETE SET NULL;
 ALTER TABLE t2 MODIFY a INT NOT NULL;
-ERROR HY000: Error on rename of '#sql-temporary' to './test/t2' (errno: 150)
+ERROR HY000: Error on rename of '#sql-temporary' to 'test.t2' (errno: 150)
 DELETE FROM t1;
 DROP TABLE t2,t1;
 CREATE TABLE t1 (a VARCHAR(5) COLLATE utf8_unicode_ci PRIMARY KEY)

=== modified file 'tests/r/show_check.result'
--- tests/r/show_check.result	2010-03-17 13:39:11 +0000
+++ tests/r/show_check.result	2010-03-23 04:40:43 +0000
@@ -26,11 +26,11 @@
 test.t1	check	status	OK
 show index from t1;
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def	data_dictionary	show_indexes	show_indexes	Table	Table	8	256	2	N	1	0	45
-def	data_dictionary	show_indexes	show_indexes	Unique	Unique	8	20	5	N	1	0	45
-def	data_dictionary	show_indexes	show_indexes	Key_name	Key_name	8	256	7	N	1	0	45
-def	data_dictionary	show_indexes	show_indexes	Seq_in_index	Seq_in_index	5	20	1	N	32769	0	63
-def	data_dictionary	show_indexes	show_indexes	Column_name	Column_name	8	256	1	N	1	0	45
+def	data_dictionary	show_indexes	SHOW_INDEXES	Table	Table	8	256	2	N	1	0	45
+def	data_dictionary	show_indexes	SHOW_INDEXES	Unique	Unique	8	20	5	N	1	0	45
+def	data_dictionary	show_indexes	SHOW_INDEXES	Key_name	Key_name	8	256	7	N	1	0	45
+def	data_dictionary	show_indexes	SHOW_INDEXES	Seq_in_index	Seq_in_index	5	20	1	N	32769	0	63
+def	data_dictionary	show_indexes	SHOW_INDEXES	Column_name	Column_name	8	256	1	N	1	0	45
 Table	Unique	Key_name	Seq_in_index	Column_name
 t1	TRUE	PRIMARY	1	a
 t1	FALSE	b	1	b
@@ -446,11 +446,11 @@
 );
 show index from t1;
 Catalog	Database	Table	Table_alias	Column	Column_alias	Type	Length	Max length	Is_null	Flags	Decimals	Charsetnr
-def	data_dictionary	show_indexes	show_indexes	Table	Table	8	256	2	N	1	0	45
-def	data_dictionary	show_indexes	show_indexes	Unique	Unique	8	20	4	N	1	0	45
-def	data_dictionary	show_indexes	show_indexes	Key_name	Key_name	8	256	7	N	1	0	45
-def	data_dictionary	show_indexes	show_indexes	Seq_in_index	Seq_in_index	5	20	1	N	32769	0	63
-def	data_dictionary	show_indexes	show_indexes	Column_name	Column_name	8	256	6	N	1	0	45
+def	data_dictionary	show_indexes	SHOW_INDEXES	Table	Table	8	256	2	N	1	0	45
+def	data_dictionary	show_indexes	SHOW_INDEXES	Unique	Unique	8	20	4	N	1	0	45
+def	data_dictionary	show_indexes	SHOW_INDEXES	Key_name	Key_name	8	256	7	N	1	0	45
+def	data_dictionary	show_indexes	SHOW_INDEXES	Seq_in_index	Seq_in_index	5	20	1	N	32769	0	63
+def	data_dictionary	show_indexes	SHOW_INDEXES	Column_name	Column_name	8	256	6	N	1	0	45
 Table	Unique	Key_name	Seq_in_index	Column_name
 t1	TRUE	PRIMARY	1	field1
 drop table t1;

=== modified file 'tests/r/temp_table.result'
--- tests/r/temp_table.result	2010-02-15 18:29:31 +0000
+++ tests/r/temp_table.result	2010-03-24 22:22:00 +0000
@@ -28,7 +28,7 @@
 CREATE TEMPORARY TABLE t1 (a int not null, b char (10) not null);
 ERROR 42S01: Table 't1' already exists
 ALTER TABLE t1 RENAME t2;
-ERROR 42S01: Table 't2' already exists
+ERROR 42S01: Table 'temporary.t2' already exists
 select * from t2;
 a	b
 4	e

=== modified file 'tests/r/union.result'
--- tests/r/union.result	2010-03-02 16:42:01 +0000
+++ tests/r/union.result	2010-03-22 19:44:37 +0000
@@ -1027,7 +1027,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `'test' collate utf8_bin` varchar(4) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL
+  `'test' collate utf8_bin` varchar(4) COLLATE utf8_bin DEFAULT NULL
 ) ENGINE=DEFAULT
 select count(*) from t1;
 count(*)
@@ -1040,7 +1040,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `test` varchar(4) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL
+  `test` varchar(4) COLLATE utf8_bin DEFAULT NULL
 ) ENGINE=DEFAULT
 select count(*) from t1;
 count(*)
@@ -1053,7 +1053,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `test` varchar(4) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL
+  `test` varchar(4) COLLATE utf8_bin DEFAULT NULL
 ) ENGINE=DEFAULT
 select count(*) from t1;
 count(*)
@@ -1081,7 +1081,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `a` varchar(1) CHARACTER SET utf8 COLLATE utf8_swedish_ci DEFAULT NULL
+  `a` varchar(1) COLLATE utf8_swedish_ci DEFAULT NULL
 ) ENGINE=DEFAULT
 drop table t1;
 create table t1 as
@@ -1091,7 +1091,7 @@
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `a` varchar(1) CHARACTER SET utf8 COLLATE utf8_spanish_ci DEFAULT NULL
+  `a` varchar(1) COLLATE utf8_spanish_ci DEFAULT NULL
 ) ENGINE=DEFAULT
 drop table t1;
 drop table t2;

=== modified file 'tests/resolve_stack_dump.cc'
--- tests/resolve_stack_dump.cc	2010-02-04 08:14:46 +0000
+++ tests/resolve_stack_dump.cc	2010-03-25 09:08:56 +0000
@@ -98,7 +98,7 @@
 }
 
 
-static bool get_one_option(int optid, const struct my_option *, char *)
+static int get_one_option(int optid, const struct my_option *, char *)
 {
   switch(optid) {
   case 'V':

=== modified file 'tests/t/cast.test'
--- tests/t/cast.test	2009-11-13 00:56:59 +0000
+++ tests/t/cast.test	2010-03-22 23:04:11 +0000
@@ -45,15 +45,15 @@
   cast('a  ' AS char(2)) as c4,
   cast('a'   AS char(2)) as c5;
 
-#
-# CAST to NCHAR with/without length
-#
-select
-  cast(''  AS char)    as c1,
-  cast(' '  AS char)    as c2,
-  cast('' AS char(2)) as c3,
-  cast('  ' AS char(2)) as c4,
-  cast(''   AS char(2)) as c5;
+##
+## CAST to NCHAR with/without length
+##
+#select
+#  cast(''  AS char)    as c1,
+#  cast(' '  AS char)    as c2,
+#  cast('' AS char(2)) as c3,
+#  cast('  ' AS char(2)) as c4,
+#  cast(''   AS char(2)) as c5;
 
 # BUG in drizzletest - can't handle these chars right
 # # Should throw an error about incorrect

=== modified file 'tests/test-run.pl'
--- tests/test-run.pl	2010-03-05 18:36:33 +0000
+++ tests/test-run.pl	2010-03-23 23:50:56 +0000
@@ -1043,6 +1043,28 @@
   }
 }
 
+sub gimme_a_good_port($)
+{
+  my $port_to_test= shift;
+  my $is_port_bad= 1;
+  while ($is_port_bad) {
+    my $sock = new IO::Socket::INET( PeerAddr => 'localhost',
+                                     PeerPort => $port_to_test,
+                                     Proto => 'tcp' );
+    if ($sock) {
+      close($sock);
+      $port_to_test += 1;
+      if ($port_to_test >= 32767) {
+        $port_to_test = 5001;
+      }
+
+    } else {
+      $is_port_bad= 0;
+    }
+  }
+  return $port_to_test;
+
+}
 #
 # To make it easier for different devs to work on the same host,
 # an environment variable can be used to control all ports. A small
@@ -1072,9 +1094,11 @@
 
   # Up to two masters, up to three slaves
   # A magic value in command_line_setup depends on these equations.
-  $opt_master_myport=         $mtr_build_thread + 9000; # and 1
-  $opt_slave_myport=          $opt_master_myport + 2;  # and 3 4
-  $opt_memc_myport= $opt_master_myport + 10;
+  $opt_master_myport=         gimme_a_good_port($mtr_build_thread + 9000); # and 1
+
+
+  $opt_slave_myport=          gimme_a_good_port($opt_master_myport + 2);  # and 3 4
+  $opt_memc_myport= gimme_a_good_port($opt_master_myport + 10);
 
   if ( $opt_master_myport < 5001 or $opt_master_myport + 10 >= 32767 )
   {

=== modified file 'tests/valgrind.supp'
--- tests/valgrind.supp	2010-02-13 00:05:34 +0000
+++ tests/valgrind.supp	2010-03-24 19:45:37 +0000
@@ -743,6 +743,17 @@
    fun:rw_lock_x_lock_func
 }
 
+{
+  Yet another InnoDB leak
+  Memcheck:Leak
+  fun:malloc
+  fun:mem_heap_create_block
+  fun:thr_local_create
+  fun:srv_master_thread
+  fun:start_thread
+  fun:clone
+}
+
 #
 # Innodb initialize two main memory areas in static space: thr_local_hash and mem_comm_pool.
 #
@@ -763,8 +774,8 @@
    fun:srv_general_init
    fun:srv_boot
    fun:innobase_start_or_create_for_mysql
-   fun:_ZL13innobase_initR14PluginRegistry
-   fun:_ZL17plugin_initializeP13st_plugin_int
+   fun:_ZL13innobase_initRN8drizzled6plugin7ContextE
+   fun:_ZN8drizzledL17plugin_initializeERNS_6plugin8RegistryEPNS0_6ModuleE
    fun:_Z11plugin_initPiPPci
    fun:_ZL22init_server_componentsv
    fun:main
@@ -875,7 +886,7 @@
    Memcheck:Leak
    ...
    fun:innobase_start_or_create_for_mysql
-   fun:_ZL13innobase_initRN8drizzled6plugin8RegistryE
+   fun:_ZL13innobase_initRN8drizzled6plugin7ContextE
    fun:plugin_init
    fun:main
 }
@@ -907,8 +918,8 @@
    fun:srv_general_init
    fun:srv_boot
    fun:innobase_start_or_create_for_mysql
-   fun:_ZL13innobase_initR14PluginRegistry
-   fun:_ZL17plugin_initializeP13st_plugin_int
+   fun:_ZL13innobase_initRN8drizzled6plugin7ContextE
+   fun:_ZN8drizzledL17plugin_initializeERNS_6plugin8RegistryEPNS0_6ModuleE
    fun:_Z11plugin_initPiPPci
    fun:_ZL22init_server_componentsv
    fun:main
@@ -1028,55 +1039,55 @@
    fun:dlopen
    ...
    fun:plugin_init
-   fun:_ZL22init_server_componentsRN8drizzled6plugin8RegistryE
-   fun:main
-}
-
-{
-   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
-   Memcheck:Leak
-   fun:dlopen
-   ...
-   fun:plugin_init
-}
-
-{
-   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
-   Memcheck:Leak
-   fun:dlopen
-   ...
-   fun:plugin_init
-   fun:main
-}
-
-{
-   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
-   Memcheck:Leak
-   fun:malloc
-   ...
-   fun:dlopen
-   ...
-   fun:plugin_init
-}
-
-{
-   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
-   Memcheck:Leak
-   fun:malloc
-   ...
-   fun:dlopen
-   ...
-   fun:plugin_init
-   fun:main
-}
-
-{
-   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
-   Memcheck:Leak
-   fun:dlopen
-   ...
-   fun:plugin_init
-   fun:_ZL22init_server_componentsRN8drizzled6plugin8RegistryE
+   fun:_ZL22init_server_componentsRN8drizzled6plugin7ContextE
+   fun:main
+}
+
+{
+   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
+   Memcheck:Leak
+   fun:dlopen
+   ...
+   fun:plugin_init
+}
+
+{
+   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
+   Memcheck:Leak
+   fun:dlopen
+   ...
+   fun:plugin_init
+   fun:main
+}
+
+{
+   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
+   Memcheck:Leak
+   fun:malloc
+   ...
+   fun:dlopen
+   ...
+   fun:plugin_init
+}
+
+{
+   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
+   Memcheck:Leak
+   fun:malloc
+   ...
+   fun:dlopen
+   ...
+   fun:plugin_init
+   fun:main
+}
+
+{
+   Leak in dlopen from glibc (it's not a growing leak) see ./elf/dl-open.c
+   Memcheck:Leak
+   fun:dlopen
+   ...
+   fun:plugin_init
+   fun:_ZL22init_server_componentsRN8drizzled6plugin7ContextE
    fun:main
 }
 
@@ -1092,23 +1103,72 @@
 
 
 {
-   Valgrind has issues tracking the deallocation of plugin objects.
-   Memcheck:Leak
-   fun:malloc
-   ...
-   fun:_ZL17plugin_initializeRN8drizzled6plugin8RegistryEPNS0_6ModuleE
-   fun:plugin_init
-   fun:_ZL22init_server_componentsRN8drizzled6plugin8RegistryE
-   fun:main
-}
-
-{
-   Valgrind has issues tracking the deallocation of plugin objects.
-   Memcheck:Leak
-   fun:malloc
-   ...
-   fun:_ZL17plugin_initializeRN8drizzled6plugin8RegistryEPNS0_6ModuleE
-   fun:plugin_init
+   Leak in dlopen()
+   Memcheck:Leak
+   fun:malloc
+   fun:add_to_global
+   ...
+   fun:_ZN8drizzled6plugin7Library11loadLibraryERKSs
+   fun:_ZN8drizzled6plugin8Registry10addLibraryERKSs
+   fun:plugin_init
+   fun:main
+}
+
+
+{
+   Valgrind has issues tracking the deallocation of plugin objects.
+   Memcheck:Leak
+   fun:malloc
+   ...
+   fun:_ZN8drizzledL17plugin_initializeERNS_6plugin8RegistryEPNS0_6ModuleE
+   fun:plugin_init
+   fun:_ZL22init_server_componentsRN8drizzled6plugin8RegistryE
+   fun:main
+}
+
+{
+   Valgrind has issues tracking the deallocation of plugin objects.
+   Memcheck:Leak
+   fun:new
+   ...
+   fun:_ZN8drizzledL17plugin_initializeERNS_6plugin8RegistryEPNS0_6ModuleE
+   fun:plugin_init
+   fun:_ZL22init_server_componentsRN8drizzled6plugin8RegistryE
+   fun:main
+}
+
+{
+   Weird std::String leak errors.
+   Memcheck:Leak
+   fun:_Znwm
+   fun:_ZNSs4_Rep9_S_createEmmRKSaIcE
+   obj:/usr/lib/libstdc++.so.6.0.10
+   fun:_ZNSsC1EPKcRKSaIcE
+   obj:*
+   fun:_ZN8drizzledL17plugin_initializeERNS_6plugin8RegistryEPNS0_6ModuleE
+   fun:plugin_init
+   fun:_ZN8drizzledL22init_server_componentsERNS_6plugin8RegistryE
+   fun:main
+}
+
+{
+   Valgrind has issues tracking the deallocation of plugin objects.
+   Memcheck:Leak
+   fun:malloc
+   ...
+   fun:_ZN8drizzledL17plugin_initializeERNS_6plugin8RegistryEPNS0_6ModuleE
+   fun:plugin_init
+   fun:main
+}
+
+{
+   Valgrind has issues tracking the deallocation of plugin objects.
+   Memcheck:Leak
+   fun:_ZnwmRKSt9nothrow_t
+   ...
+   fun:_ZN8drizzledL17plugin_initializeERNS_6plugin8RegistryEPNS0_6ModuleE
+   fun:plugin_init
+   fun:_ZN8drizzledL22init_server_componentsERNS_6plugin8RegistryE
    fun:main
 }
 
@@ -1256,15 +1316,10 @@
    Heap Engine panic issue
    Memcheck:Addr8
    fun:_Z8hp_panicN8drizzled17ha_panic_functionE
-   fun:_ZL11heap_deinitRN8drizzled6plugin8RegistryE
-   fun:_ZN8drizzledL13delete_moduleERNS_6plugin8RegistryEPNS0_6ModuleE
-   fun:plugin_shutdown
-   fun:_ZN8drizzledL8clean_upEb
-   fun:_ZN8drizzled10unireg_endEv
-   fun:_ZL11kill_serverPv
-   fun:signal_hand
-   fun:start_thread
-   fun:clone
+   fun:_ZN10HeapEngineD0Ev
+   fun:_ZN8drizzled6plugin8RegistryD1Ev
+   fun:_ZN8drizzled6plugin8Registry8shutdownEv
+   fun:main
 }
 
 {

